SET QUOTED_IDENTIFIER ON
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[GenerateEventsMeetingRequestResponse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure GenerateEventsMeetingRequestResponse'
		DROP PROCEDURE [dbo].[GenerateEventsMeetingRequestResponse]
	END
GO

PRINT 'Creating procedure GenerateEventsMeetingRequestResponse'
GO

/******************************************************************************
**		File: GenerateEventsMeetingRequestResponse.sql
**		Name: GenerateEventsMeetingRequestResponse
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/12/2006
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [GenerateEventsMeetingRequestResponse]
	@FromID TIdentifier,
	@EventType TName,
	@DocumentClass TClass,
	@DocumentID TIdentifier,
	@Data XML
AS
	SET NOCOUNT ON;

	INSERT INTO [MailItem]
		([State], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	SELECT
		1,
		[MeetingRequest].[FileAs],
		@EventType,
		@FromID,
		[Employee].[UserID],
		@DocumentClass,
		@DocumentID,
		0,
		@Data,
		NULL
	FROM
		[MeetingRequest] INNER JOIN [Employee]
			ON ([MeetingRequest].[OriginatorEmployeeID] = [Employee].[ID])
	WHERE
		[MeetingRequest].[ID] = @DocumentID 
	RETURN 0
GO

