IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfPrivateContactCreate')
	BEGIN
		PRINT 'Dropping Procedure adfPrivateContactCreate'
		DROP  Procedure  adfPrivateContactCreate
	END

GO

PRINT 'Creating Procedure adfPrivateContactCreate'
GO
/******************************************************************************
**		File: 
**		Name: adfPrivateContactCreate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfPrivateContactCreate
	@BusinessCardClass			TClass,
	@BusinessCardID				TIdentifier
AS
	DECLARE @UserID TIdentifier
	
	SET NOCOUNT ON

	SET @UserID = dbo.adfGetCurrentUserID()
	IF NOT EXISTS(SELECT * FROM [UserContact] WHERE [UserID]=@UserID 
		AND [BusinessCardClass]=@BusinessCardClass AND [BusinessCardID]=@BusinessCardID)
	BEGIN
		INSERT INTO [UserContact] ([UserID], [BusinessCardClass], [BusinessCardID])
		VALUES(@UserID, @BusinessCardClass, @BusinessCardID)
	END
	
	RETURN 0
GO

GRANT EXECUTE ON [adfPrivateContactCreate] TO PUBLIC
GO 