IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfDocumentUDFCopy')
	BEGIN
		PRINT 'Dropping Procedure adfDocumentUDFCopy'
		DROP  Procedure  adfDocumentUDFCopy
	END

GO

PRINT 'Creating Procedure adfDocumentUDFCopy'
GO
/******************************************************************************
**		File: 
**		Name: adfDocumentUDFCopy
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfDocumentUDFCopy
	@DocumentClass TClass,
	@SourceDocumentID TIdentifier,
	@DestDocumentID TIdentifier
AS
	SET NOCOUNT ON
	INSERT INTO [PropertyValue] ([DocumentClass], [DocumentID], [PropertyID], [Value])
	SELECT
		@DocumentClass,
		@DestDocumentID,
		[PropertyValue].[PropertyID],
		[PropertyValue].[Value]
	FROM
		[PropertyValue]
	WHERE
		[PropertyValue].[DocumentClass] = @DocumentClass AND
		[PropertyValue].[DocumentID] = @SourceDocumentID
		
	IF @@error != 0
		RETURN 1
		
	RETURN 0
GO

GRANT EXEC ON adfDocumentUDFCopy TO PUBLIC
GO
