IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfPropertyValueBrowse')
	BEGIN
		PRINT 'Dropping Procedure adfPropertyValueBrowse'
		DROP  Procedure  adfPropertyValueBrowse
	END

GO

PRINT 'Creating Procedure adfPropertyValueBrowse'
GO
/******************************************************************************
**		File: 
**		Name: adfPropertyValueBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**     ----------							-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfPropertyValueBrowse
	@Class TClass,
	@ID TIdentifier
AS

	SET NOCOUNT ON
	
	SELECT
		[PropertyValue].[PropertyID],
		ISNULL([PropertyGlobal].[Name], [Property].[Name]),
		[PropertyValue].[Value]
	FROM
		[PropertyValue] INNER JOIN [Property]
			ON ([PropertyValue].[PropertyID] = [Property].[ID])
		LEFT OUTER JOIN [PropertyGlobal]
			ON ([Property].[ID] = [PropertyGlobal].[ID] AND [PropertyGlobal].[Language] = dbo.adfGetLanguage())
	WHERE
		[PropertyValue].[DocumentClass] = @Class 
	AND
		[PropertyValue].[DocumentID] = @ID

	RETURN 0

GO

GRANT EXEC ON adfPropertyValueBrowse TO PUBLIC

GO
