IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'adftrNoteInsert')
	BEGIN
		PRINT 'Dropping Trigger adftrNoteInsert'
		DROP  Trigger adftrNoteInsert
	END
GO

/******************************************************************************
**		File: 
**		Name: adftrNoteInsert
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger adftrNoteInsert'
GO
CREATE Trigger adftrNoteInsert ON [Note] FOR INSERT
AS
	SET NOCOUNT ON
	
	UPDATE [Document]
	SET
		[NoteCount] = [NoteCount] + [I].[Count]
	FROM
		[Document] INNER JOIN (SELECT [DocumentClass], [DocumentID], COUNT(*) as [Count] FROM inserted GROUP BY [DocumentClass], [DocumentID]) as [I]
			ON ([Document].[ID] = [I].[DocumentID] AND [Document].[Class] = [I].[DocumentClass])

GO

