IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCompanyFilling]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCompanyFilling'
		DROP PROCEDURE [dbo].[adfCompanyFilling]
	END
GO

PRINT 'Creating procedure adfCompanyFilling'
GO
/******************************************************************************
**		File: adfCompanyFilling.sql
**		Name: adfCompanyFilling
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Nikita.Golyshev
**		Date: 27/03/2014 16:43:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		11.06.14	GNV				Исправление ошибки с флагом
*******************************************************************************/
CREATE PROCEDURE [dbo].[adfCompanyFilling]
	@Xml XML,
	@ExtendedProperties XML,
	@CompanyID TIdentifier
AS
	DECLARE	@result INT,			
			@State TState,
			@ID TIdentifier,
			@FileAs TName,
			@FoundationDate TDate,
			@LegalName TName,
			@KPP TCode,
			@LegalCode TCode,
			@BankAccountID TIdentifier,
			@ExecutiveEmployeeID TIdentifier,
			@AccountantEmployeeID TIdentifier,
			@Own TBool,
			@ManagerEmployeeID TIdentifier,
			@Comments TNotes,
			@Class TClass,
			@CurrentEmployeeID TIdentifier,
			@CurrentUserID TIdentifier,
			@ExternalID TExternalIdentifier,
			@Flag TFlag,
			@Private TBool,
			@CompanyStatusID TIdentifier,
			@value TVariant,
			@ApplyVAT TBool,
			@PaymentCurrencyPoint TBool,
			@ExchangeBanned TBool,
			@ExportFinanceOnce TBool,
			@Number TCode,
			@PlanProfitability TPercent,
			@PlanPurchases TBool = 0,
			@BIN TCode

	SET NOCOUNT ON
	
	SET @ID = @CompanyID
	
	SET @State = dbo.adfwfGetInitialState('5206f98c-4e57-44ea-8dc9-0ab6b81fd9c2')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	EXEC adfParameterGet @Name='ApplyVAT', @Group='CommonBusiness', @Value = @value OUTPUT
		SET @ApplyVAT = ISNULL(CAST(@value as bit),	1)
	
	EXEC adfParameterGet @Name='PaymentCurrencyPoint', @Group='CommonBusiness', @Value = @value OUTPUT
		SET @PaymentCurrencyPoint = ISNULL(CAST(@value as bit),1)
	
	EXEC adfParameterGet @Name='ExportFinanceOnce', @Group='Pjm6', @Value = @value OUTPUT
		SET @ExportFinanceOnce = ISNULL(CAST(@value as bit),0)	
	
	EXEC adfParameterGet @Name='ExchangeBanned', @Group='Pjm6', @Value = @value OUTPUT
		SET @ExchangeBanned = ISNULL(CAST(@value as bit),1)

	SET @CurrentUserID = dbo.adfGetCurrentUserID()
	SELECT @value = [Value] FROM [UserParameter] WHERE [Name] = 'SetPrivatePropertyOnCreate' AND [UserID] = @CurrentUserID
	SET @Private = ISNULL(CAST(@value as bit), 1)

	SELECT
		@FileAs = T.c.value('FileAs[1]','nvarchar(256)'),
		@FoundationDate = CONVERT(datetime, T.c.value('FoundationDate[1]','varchar(19)'), 126),
		@LegalName = T.c.value('LegalName[1]','nvarchar(256)'),
		@KPP = T.c.value('KPP[1]','varchar(32)'),
		@LegalCode = CASE 
						WHEN T.c.value('LegalCode[1]','varchar(32)') = '' THEN NULL 
						ELSE T.c.value('LegalCode[1]','varchar(32)') 
					END,
		@BankAccountID = T.c.value('BankAccountID[1]','int'),
		@ExecutiveEmployeeID = T.c.value('ExecutiveEmployeeID[1]','int'),
		@AccountantEmployeeID = T.c.value('AccountantEmployeeID[1]','int'),
		@Own = (CASE T.c.value('Own[1]','varchar(5)') 
					WHEN 'false' THEN 0 
					ELSE 1 
				END),
		@ManagerEmployeeID = T.c.value('ManagerEmployeeID[1]','int'),
		@Comments = T.c.value('Comments[1]','nvarchar(max)'),
		@ExternalID = T.c.value('ExternalID[1]','nvarchar(256)'),
		@Flag = T.c.value('Flag[1]','int'),
		@CompanyStatusID = T.c.value('CompanyStatusID[1]','int'),
		@Number = T.c.value('Number[1]','varchar(32)'),
		@BIN = T.c.value('BIN[1]','varchar(32)')
	FROM
		@Xml.nodes('/adfCompanyGet/Company') AS T(c)
		
	BEGIN TRANSACTION
	
	IF @ManagerEmployeeID IS NULL
	BEGIN
		SET @ManagerEmployeeID = dbo.adfGetCurrentEmployeeID()
	END
	
	IF @Flag IS NULL
	BEGIN
		SET @Flag = 0
	END
	
	
	DECLARE @budgetPlanning bit
		SELECT
			@budgetPlanning = CONVERT(bit,[Value])
		FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53]
		WHERE [Name] = 'UseBudgetPlanning' AND [Group] = 'Pjm6'
		
	--При заполнении компании параметры планирования задаются согласно глобальным настройкам	
	IF @budgetPlanning = 1 AND @Own = 0
	BEGIN
		SELECT
			@PlanProfitability = CONVERT(decimal(18,4),[Value])
		FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53]
		WHERE [Name] = 'PlanProfitability' AND [Group] = 'Pjm7'
		
		SELECT
			@PlanPurchases = CONVERT(bit,[Value])
		FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53]
		WHERE [Name] = 'PlanPurchases' AND [Group] = 'Pjm7'					
	END

	UPDATE [Company]
	SET 
		[Flag] = 					
			CASE 
				WHEN @Flag IS NOT NULL THEN @Flag 
				ELSE [Flag]
			END,
		[State] = 					
			CASE 
				WHEN [State] IS NULL THEN @State 
				ELSE [State] 
			END,
		[FileAs] = 					
			CASE 
				WHEN [FileAs] IS NULL OR [FileAs] = '' THEN @FileAs 
				ELSE [FileAs] 
			END,
		[FoundationDate] = 			
			CASE 
				WHEN [FoundationDate] IS NULL THEN @FoundationDate 
				ELSE [FoundationDate] 
			END,
		[LegalName] = 				
			CASE 
				WHEN [LegalName] IS NULL OR [LegalName] = '' THEN @LegalName 
				ELSE [LegalName] 
			END,
		[LegalCode] = 				
			CASE 
				WHEN [LegalCode] IS NULL OR [LegalCode] = '' THEN @LegalCode 
				ELSE [LegalCode] 
			END,
		[KPP] = 					
			CASE 
				WHEN [KPP] IS NULL OR [KPP] = '' THEN @KPP 
				ELSE [KPP] 
			END,
		[BIN] = 					
			CASE 
				WHEN [BIN] IS NULL OR [BIN] = '' THEN @BIN 
				ELSE [BIN] 
			END,
		[BankAccountID] = 			
			CASE 
				WHEN [BankAccountID] IS NULL THEN @BankAccountID 
				ELSE [BankAccountID] 
			END,
		[ExecutiveEmployeeID] = 	
			CASE 
				WHEN [ExecutiveEmployeeID] IS NULL THEN @ExecutiveEmployeeID 
				ELSE [ExecutiveEmployeeID] 
			END,
		[AccountantEmployeeID] = 	
			CASE 
				WHEN [AccountantEmployeeID] IS NULL THEN @AccountantEmployeeID 
				ELSE [AccountantEmployeeID] 
			END,
		[Own] = 					
			CASE 
				WHEN [Own] IS NULL THEN @Own 
				ELSE [Own] 
			END,
		[ManagerEmployeeID] = 		
			CASE 
				WHEN [ManagerEmployeeID] IS NULL THEN @ManagerEmployeeID 
				ELSE [ManagerEmployeeID] 
			END,
		[Comments] = 				
			CASE 
				WHEN [Comments] IS NULL OR [Comments] = '' THEN @Comments 
				ELSE [Comments] 
			END,
		[CompanyStatusID] = 		
			CASE 
				WHEN [CompanyStatusID] IS NULL THEN @CompanyStatusID 
				ELSE [CompanyStatusID] 
			END,
		[ApplyVAT] = 				
			CASE 
				WHEN [ApplyVAT] IS NULL THEN @ApplyVAT 
				ELSE [ApplyVAT] 
			END,
		[PaymentCurrencyPoint] = 	
			CASE 
				WHEN [PaymentCurrencyPoint] IS NULL THEN @PaymentCurrencyPoint 
				ELSE [PaymentCurrencyPoint] 
			END,
		[ExchangeBanned] = 			
			CASE 
				WHEN [ExchangeBanned] IS NULL THEN @ExchangeBanned 
				ELSE [ExchangeBanned] 
			END,
		[ExportFinanceOnce] = 		
			CASE 
				WHEN [ExportFinanceOnce] IS NULL THEN @ExportFinanceOnce 
				ELSE [ExportFinanceOnce] 
			END,
		[Number] = 					
			CASE 
				WHEN [Number] IS NULL OR [Number] = '' THEN @Number 
				ELSE [Number] 
			END,
		[PlanProfitability] = 		
			CASE 
				WHEN [PlanProfitability] IS NULL THEN @PlanProfitability 
				ELSE [PlanProfitability] 
			END,
		[PlanPurchases] = 			
			CASE 
				WHEN [PlanPurchases] IS NULL THEN @PlanPurchases 
				ELSE [PlanPurchases] 
			END
	WHERE 
		[ID] = @CompanyID
		
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	
	SELECT @Class = [Class] FROM [Company] WHERE [Company].[ID] = @ID

	IF EXISTS (SELECT * FROM [ExtendedProperties] WHERE [ID] = @ID AND [Class] = @Class)
	BEGIN
		UPDATE [ExtendedProperties]
		SET	
			[ExtendedProperties] = @ExtendedProperties
		WHERE
			[ID] = @ID AND [Class] = @Class
	END
	ELSE
	BEGIN
		INSERT INTO [ExtendedProperties] ([ID], [Class], [ExtendedProperties])
		VALUES(@ID, @Class, @ExtendedProperties)	
	END
	
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	
	IF EXISTS (SELECT * FROM [BusinessCard] WHERE [ID] = @ID)
	BEGIN
		EXEC @result = adfBusinessCardFilling @doc = @Xml, @XPathRoot = '/adfCompanyGet', @ID = @ID, 
			@Class = @Class, @FileAs = @FileAs, @Comments = @Comments,
			@CompanyID = @ID, @PositionID = NULL
	END
	ELSE 
	BEGIN
		EXEC @result = adfBusinessCardCreate @doc = @Xml, @XPathRoot = '/adfCompanyGet', @ID = @ID, 
			@Class = @Class, @State = @State, @FileAs = @FileAs, @Comments = @Comments,
			@CompanyID = @ID, @PositionID = NULL, @ExternalID = @ExternalID
			
		IF @Private = 1
		BEGIN
			INSERT INTO UserContact ([UserID], [BusinessCardClass], [BusinessCardID])
				VALUES(dbo.adfGetCurrentUserID(), @Class, @ID)
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
	END
	
	IF @@error != 0 OR @result != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	IF NOT EXISTS (SELECT * FROM [CompanyIndustryBranch] WHERE [CompanyID] = @ID)
	BEGIN
		INSERT INTO [CompanyIndustryBranch] ([CompanyID], [IndustryBranchID])
		SELECT 
			@ID, 
			T.c.value('IndustryBranchID[1]','int') 
		FROM
			@Xml.nodes('/adfCompanyGet/CompanyIndustryBranch') AS T(c)

		IF @@error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	COMMIT TRANSACTION	
	
	EXEC adfCompanyGet @ID
	
	RETURN 0
GO

GRANT EXECUTE ON adfCompanyFilling TO PUBLIC
GO