 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfDivisionEmployeeBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfDivisionEmployeeBrowse'
		DROP PROCEDURE [dbo].[adfDivisionEmployeeBrowse]
	END
GO

PRINT 'Creating procedure adfDivisionEmployeeBrowse'
GO

/******************************************************************************
**		File: adfDivisionEmployeeBrowse.sql
**		Name: adfDivisionEmployeeBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/05/2004 18:09:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfDivisionEmployeeBrowse]
	@DivisionID TIdentifier,
	@StateSelector INT
AS
	DECLARE @CurrencyCode TCode3

	SET NOCOUNT ON

	SET @CurrencyCode = dbo.fnPjm5GetAccountingCurrency()

	SELECT
		[Employee].[ID],
		[Employee].[Class],
		[Employee].[State],
		[Employee].[Flag],
		[Employee].[FileAs],
		[Employee].[CompanyID],
		[Employee].[PositionID],
		[Employee].[QualificationID],
		[Employee].[DivisionID],
		[Employee].[HireDate],
		[Employee].[FireDate],
		[QualificationRate].[Standard],
		[QualificationRate].[Overtime],
		@CurrencyCode as [CurrencyCode],
		[Employee].[UserID],
		[User].[NtLogin] as [WindowsLogin],
		[User].[SQLLogin] as [SqlLogin],
		[Employee].[Comments],
		[Employee].[Created],
		[Employee].[CreatedBy],
		[Employee].[Modified],
		[Employee].[ModifiedBy],
		[Employee].[Timestamp],
		[Employee].[Title],
		[Employee].[FirstName],
		[Employee].[MiddleName],
		[Employee].[LastName],
		[Employee].[Suffix],
		[Employee].[Initials],
		[Employee].[BirthDate],
		[Employee].[BirthPlace],
		[Employee].[LegalCode],
		[Employee].[Number],
		[#PhoneType#1] as Phone1,
		[#PhoneType#2] as Phone2,
		(SELECT [Street] FROM [Address] WHERE [Address].[BusinessCardID] = [Employee].[ID] AND [Address].[BusinessCardClass] = [Employee].[Class] AND [Address].[AddressTypeID] = 1) as [Street],
		(SELECT [Email] FROM [Email] WHERE [Email].[BusinessCardID] = [Employee].[ID] AND [Email].[BusinessCardClass] = [Employee].[Class] AND [Email].[EmailTypeID] = 1) as Email,
		(SELECT [Email] FROM [Email] WHERE [Email].[BusinessCardID] = [Employee].[ID] AND [Email].[BusinessCardClass] = [Employee].[Class] AND [Email].[EmailTypeID] = 4) as WebPage,
		[#PhoneType#1],
		[#PhoneType#2],
		[#PhoneType#3],
		[#PhoneType#4],
		[#PhoneType#5],
		[#PhoneType#6],
		[#PhoneType#7],
		[#PhoneType#8],
		[#PhoneType#9],
		[#PhoneType#10],
		[#PhoneType#11]
	FROM
		[Employee] 
		LEFT OUTER JOIN [vwPhone]
			ON ([Employee].[ID] = [vwPhone].[BusinessCardID] AND [Employee].[Class] = [vwPhone].[BusinessCardClass])
		LEFT OUTER JOIN [QualificationRate]
			ON ([Employee].[QualificationID] = [QualificationRate].[QualificationID]
				AND [QualificationRate].[CurrencyCode] = @CurrencyCode)
		LEFT OUTER JOIN [User]
			ON ([Employee].[UserID] = [User].[ID])
	WHERE
		[Employee].[DivisionID] = @DivisionID
	AND
		((@StateSelector = 0) OR (@StateSelector != 0 AND [Employee].[State] = @StateSelector))
		
	RETURN 0
GO

GRANT EXECUTE ON [adfDivisionEmployeeBrowse] TO PUBLIC
GO
  