IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6MasterCreateSystemObjects]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6MasterCreateSystemObjects'
		DROP PROCEDURE [dbo].[pjm6MasterCreateSystemObjects]
	END
GO

PRINT 'Creating procedure pjm6MasterCreateSystemObjects'
GO

/******************************************************************************
**		File: pjm6MasterCreateSystemObjects.sql
**		Name: pjm6MasterCreateSystemObjects
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: marat.akzhigitov, yuriy.soldatkin
**		Date: 07/07/2011 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		03.08.11	SYV				  
**		24.08.11	SAM
**		24.08.11	SYV				    BankAccount
**		07.09.11	SYV				 SQL  Windows 
**		13.09.11	SYV				AccountantEmployeeID  ExecutiveEmployeeID
**		15.09.11	SYV				   
**		16.09.11	SYV				  
**		23.09.11	SYV				   , , 
**		05.10.11	PAM				    (, )
**		07.10.11	PAM				  Windows 
**		31.10.12	SOV				     
**		04.12.12	SOV				       
**		12.12.12	SOV				  , 
**									       , 
**									     
**		25.12.12	SOV				  , .   -
**									  Xml-       
**		23.01.13	SOV				     ,   
**		07.02.13	SOV				   " "
**		08.02.13	SOV				   " "
**		12.02.13	SOV				" "        
**									 " "
**		28.02.13	SOV				    BIN 
**		19.07.13	SOV				      
**		24.09.13	SOV				     Azure SQL Server
**		09.03.14	GNV 			  
** 		12.03.14	GNV 			    " "  "   "  
**		13.03.14	GNV				         @XML
**		20.03.14	GNV				       
**									       
**		20.03.14	GNV				    -   
**									 -
**		27.03.14	GNV 			     Merge    
**									   
**		27.03.14	GNV				      
**		03.04.14	GNV 			         
**		03.04.14	GNV				     
**		03.04.14	TMS				        
**		07.05.14	GNV				        
**		13.05.14	GNV				   -      -  
**		11.06.14	GNV				      
*******************************************************************************/
CREATE PROCEDURE [pjm6MasterCreateSystemObjects]
	@Xml Xml,
	@ImportMode INT = NULL 
AS
	SET NOCOUNT ON
	SET XACT_ABORT ON
	SET QUOTED_IDENTIFIER ON
	
	BEGIN TRANSACTION
	
	DECLARE @IsAzureSQL bit
	SELECT @IsAzureSQL = CASE SERVERPROPERTY('EngineEdition')
							WHEN 5 THEN 1
							ELSE 0
						END 

	DECLARE @rv INT
	
	
	--  
	IF @Xml.exist('(/MasterInfo/Parameters)[1]') = 1
	BEGIN
		-- 
		DECLARE @NationalCurrency TCode3
		SET @NationalCurrency = @Xml.value('(/MasterInfo/Parameters/NationalCurrency)[1]','TCode3')	
		--SELECT @NationalCurrency AS ' '
		EXEC @rv = adfParameterSet @Name='NationalCurrency',@Group='CommonBusiness',@Value=@NationalCurrency
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		--  
		DECLARE @CurrencyID TIdentifier
		SET @CurrencyID = (SELECT [ID] FROM [Currency] WHERE [Code] = @NationalCurrency AND [State] = 2)
		IF @CurrencyID IS NOT NULL
		BEGIN
			EXEC @rv = adfCurrencyChangeState @CurrencyID, 1
			IF @rv != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		
		-- 
		DECLARE @BaseCurrency TCode3
		SET @BaseCurrency = @Xml.value('(/MasterInfo/Parameters/BaseCurrency)[1]','TCode3')
		--SELECT @BaseCurrency AS ' '
		EXEC @rv = adfParameterSet @Name='BaseCurrency',@Group='CommonBusiness',@Value=@BaseCurrency
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		--  
		SET @CurrencyID = (SELECT [ID] FROM [Currency] WHERE [Code] = @BaseCurrency AND [State] = 2)
		IF @CurrencyID IS NOT NULL
		BEGIN
			EXEC @rv = adfCurrencyChangeState @CurrencyID, 1
			IF @rv != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END

		-- 
		DECLARE @VATRate TPercent
		SET @VatRate = @Xml.value('(/MasterInfo/Parameters/VATRate)[1]','TPercent')/100
		--SELECT @VATRate AS ' '
		EXEC @rv = adfParameterSet @Name='VATRate',@Group='CommonBusiness',@Value=@VATRate
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		-- 
		DECLARE @ApplyVAT TBool
		SET @ApplyVAT = @Xml.value('(/MasterInfo/Parameters/ApplyVAT)[1]','TBool')
		--SELECT @ApplyVAT AS ' '
		EXEC @rv = adfParameterSet 'ApplyVAT', 'CommonBusiness', @ApplyVAT
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		-- 
		DECLARE 
			@AutoFillingLanguage		TName,
			@AutofillingLanguageID		TIdentifier,
			@AutoFillingLanguageCode	TCode,
			@AutofillingLanguageState	TState

		SET @AutoFillingLanguage = @Xml.value('(/MasterInfo/Parameters/AutofillingLanguage)[1]','TName')
		
		SELECT
			@AutofillingLanguageID	= [ID],
			@AutoFillingLanguageCode = [Code],
			@AutofillingLanguageState = [State]
		FROM
			[LanguageCode]
		WHERE
			[FileAs] = @AutoFillingLanguage
		
		IF @AutofillingLanguageID IS NULL
		BEGIN
			SELECT
				@AutofillingLanguageID	= [ID],
				@AutoFillingLanguageCode = [Code],
				@AutofillingLanguageState = [State]
			FROM
				[LanguageCode]
			WHERE
				[Code] = 'ru'
		END

		IF @AutofillingLanguageID IS NOT NULL
		BEGIN
			IF @AutofillingLanguageState = 2
				EXEC @rv = pjm6LanguageCodeChangeState @AutofillingLanguageID, 1
				IF @rv != 0
				BEGIN
					ROLLBACK TRANSACTION
					RETURN 1
				END
			EXEC adfParameterSet 'ProjectLanguageCode', 'Pjm6', @AutoFillingLanguageCode
			IF @rv != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END	
			
		--        
		DECLARE @HasRightCreateUser bit
		SET @HasRightCreateUser = @Xml.value('(/MasterInfo/ExtraValues/HasRightCreateUser)[1]','TBool')
		
		--   
		DECLARE @CalendarDate TDate, @CalendarDescription TNotes
		DECLARE calendar_cursor CURSOR FOR 
		SELECT 
			Calendar.value('./@Day','TDate'),
			Calendar.value('./@Description','TNotes')
		FROM
			@Xml.nodes('/MasterInfo/Parameters/CalendarList/Calendar') as List(Calendar)

		OPEN calendar_cursor

		FETCH NEXT FROM calendar_cursor INTO @CalendarDate,@CalendarDescription
		WHILE @@FETCH_STATUS = 0
		BEGIN
			--SELECT ':', @CalendarDate,@CalendarDescription 
			EXEC @rv = pjm5CalendarCreate @Date=@CalendarDate,@NonWorkingTime=1,@Recurrent=1,@Description=@CalendarDescription
			IF @rv != 0
			BEGIN
				ROLLBACK TRANSACTION
				CLOSE calendar_cursor
				DEALLOCATE calendar_cursor
				RETURN 1
			END
			FETCH NEXT FROM calendar_cursor INTO @CalendarDate,@CalendarDescription
		END
		CLOSE calendar_cursor
		DEALLOCATE calendar_cursor

		-- 
		--  
		DECLARE @HasManageIndustryBranchDictionary TBool,
				@ManageIndustryBranchDictionary TSysname
		SET @ManageIndustryBranchDictionary = dbo.adfwfGetInitialRight('241f8cf7-5524-4ca3-a27c-82e85f8328ec')
		SET @HasManageIndustryBranchDictionary = dbo.adfHasAccessRightByName(@ManageIndustryBranchDictionary)
		IF (@HasManageIndustryBranchDictionary = 0)
		BEGIN
			EXEC pjm6SetRightForMasters @ManageIndustryBranchDictionary
		END

		DECLARE @IndustryBranch TName,
				@IndustryBranchID TIdentifier
		SET @IndustryBranch = @Xml.value('(/MasterInfo/Parameters/IndustryBranch)[1]','TName')
		EXEC adfIndustryBranchCreate @Code=@IndustryBranch,@FileAs=@IndustryBranch,@Comments=NULL
		
		if (@IndustryBranch = ' ')
		begin
		--       " ".
			UPDATE [ProjectType] SET [State] = 2 WHERE [FileAs] = '  '
			UPDATE [ProjectType] SET [State] = 2 WHERE [FileAs] = ' '
			
		--     ,    . 
		--   :
			--a. ;
			--b.;
			--c. ;
			--d.;
			--e.  ;
			--f. .
			--g.  ;
			--h. ;
			--i. .
		    UPDATE [Trustee] SET [Active] = 0 WHERE [Name] = 'FinancialManager'
		    UPDATE [Trustee] SET [Active] = 0 WHERE [Name] = 'CRManager'
		    UPDATE [Trustee] SET [Active] = 0 WHERE [Name] = 'CRCreator'
		    UPDATE [Trustee] SET [Active] = 0 WHERE [Name] = 'SalesManager'
		    UPDATE [Trustee] SET [Active] = 0 WHERE [Name] = 'CRExecutor'
		    UPDATE [Trustee] SET [Active] = 0 WHERE [Name] = 'CRCoordinator'
		    UPDATE [Trustee] SET [Active] = 0 WHERE [Name] = 'ChiefSalesManager'
		    UPDATE [Trustee] SET [Active] = 0 WHERE [Name] = 'NewsModerator'
		    UPDATE [Trustee] SET [Active] = 0 WHERE [Name] = 'BillingPerson'
		    UPDATE [Trustee] SET [Active] = 0 WHERE [Name] = 'FileClerk'
		    UPDATE [Trustee] SET [Active] = 0 WHERE [Name] = 'FileClerkManager'
		    UPDATE [Trustee] SET [Active] = 0 WHERE [Name] = 'FinancialManagerAssistant'
		    UPDATE [Trustee] SET [Active] = 0 WHERE [Name] = 'DocumentActor'
		    
	    --      (DisableViewBilling)   " "
			exec adfAccessRightCreate @RightName=N'DisableViewBilling',@TrusteeName=N'EveryOne'
			exec adfParameterSet @Name=N'DefaultProjectType',@Group=N'Pjm5',@Value=3
		end 

		SELECT
			@IndustryBranchID = [ID]
		FROM
			[IndustryBranch]
		WHERE
			[FileAs] = @IndustryBranch

		--  
		IF (@HasManageIndustryBranchDictionary = 0)
		BEGIN
			EXEC pjm6DelRightForMasters @ManageIndustryBranchDictionary
		END
	END



	--   
	IF @Xml.exist('(/MasterInfo/Company)[1]') = 1
	BEGIN	
		DECLARE
			@CompanyXML XML,
			@CompanyID TIdentifier,
			@CompanyFileAs TName,
			@CompanyLegalName TName,
			@CompanyKPP TCode,
			@CompanyLegalCode TCode,
			@CompanyBIN TCode,
			@CompanyLegalAddressStreet TName,
			@CompanyLegalAddressCity TCity,
			@CompanyLegalAddressRegion TName,
			@CompanyLegalAddressPostalCode TPostalCode,
			@CompanyLegalAddressCountry TName,
			@CompanyActualAddressStreet TName,
			@CompanyActualAddressCity TCity,
			@CompanyActualAddressRegion TName,
			@CompanyActualAddressPostalCode TPostalCode,
			@CompanyActualAddressCountry TName,
			@CompanyPhone TPhone,
			@CompanyFax TPhone,
			@CompanyWeb THref,
			@CompanyEmail THref

		SET @CompanyFileAs = @Xml.query('/MasterInfo/Company/FileAs').value('.', 'TName')
		SET @CompanyLegalName = @Xml.query('/MasterInfo/Company/LegalName').value('.', 'TName')
		SET @CompanyKPP = @Xml.query('/MasterInfo/Company/KPP').value('.', 'TCode')
		SET @CompanyLegalCode = @Xml.query('/MasterInfo/Company/LegalCode').value('.', 'TCode')
		SET @CompanyBIN = @Xml.query('/MasterInfo/Company/BIN').value('.', 'TCode')
		SET @CompanyLegalAddressStreet = @Xml.query('/MasterInfo/LegalAddress/Street').value('.', 'TName')	
		SET @CompanyLegalAddressCity = @Xml.query('/MasterInfo/LegalAddress/City').value('.', 'TCity')
		SET @CompanyLegalAddressRegion = @Xml.query('/MasterInfo/LegalAddress/Region').value('.', 'TName')
		SET @CompanyLegalAddressPostalCode = @Xml.query('/MasterInfo/LegalAddress/PostalCode').value('.', 'TPostalCode')
		SET @CompanyLegalAddressCountry = @Xml.query('/MasterInfo/LegalAddress/Country').value('.', 'TName')
		SET @CompanyActualAddressStreet = @Xml.query('/MasterInfo/ActualAddress/Street').value('.', 'TName')
		SET @CompanyActualAddressCity = @Xml.query('/MasterInfo/ActualAddress/City').value('.', 'TName')
		SET @CompanyActualAddressRegion = @Xml.query('/MasterInfo/ActualAddress/Region').value('.', 'TName')
		SET @CompanyActualAddressPostalCode = @Xml.query('/MasterInfo/ActualAddress/PostalCode').value('.', 'TPostalCode')
		SET @CompanyActualAddressCountry = @Xml.query('/MasterInfo/ActualAddress/Country').value('.', 'TName')
		SET @CompanyPhone = @Xml.query('/MasterInfo/CompanyContact/Phone').value('.', 'TPhone')
		SET @CompanyFax = @Xml.query('/MasterInfo/CompanyContact/Fax').value('.', 'TPhone')
		SET @CompanyWeb = @Xml.query('/MasterInfo/CompanyContact/Web').value('.', 'THref')
		SET @CompanyEmail = @Xml.query('/MasterInfo/CompanyContact/Email').value('.', 'THref')

		SET @CompanyXML = '
		<adfCompanyGet>
			<Company>
				<ID>-1</ID>
				<State>0</State>
				<Flag>0</Flag>
				<Own>true</Own>
				<Guid>5206f98c-4e57-44ea-8dc9-0ab6b81fd9c2</Guid>
				<Private>true</Private>
				<PaymentCurrencyPoint>1</PaymentCurrencyPoint>
				<PlanPurchases>0</PlanPurchases>
			</Company>
		</adfCompanyGet>
		'
		-- 
		SET @CompanyXML.modify('
		insert <FileAs>{sql:variable("@CompanyFileAs")}</FileAs>
		into (/adfCompanyGet/Company)[1]')

		SET @CompanyXML.modify('
		insert <LegalName>{sql:variable("@CompanyLegalName")}</LegalName>
		into (/adfCompanyGet/Company)[1]')	

		SET @CompanyXML.modify('
		insert <KPP>{sql:variable("@CompanyKPP")}</KPP>
		into (/adfCompanyGet/Company)[1]')	

		SET @CompanyXML.modify('
		insert <LegalCode>{sql:variable("@CompanyLegalCode")}</LegalCode>
		into (/adfCompanyGet/Company)[1]')	

		SET @CompanyXML.modify('
		insert <BIN>{sql:variable("@CompanyBIN")}</BIN>
		into (/adfCompanyGet/Company)[1]')

		SET @CompanyXML.modify('
		insert <ApplyVAT>{sql:variable("@ApplyVAT")}</ApplyVAT>
		into (/adfCompanyGet/Company)[1]')

		SET @CompanyXML.modify('
		insert <CompanyIndustryBranch>
				 <IndustryBranchID>{sql:variable("@IndustryBranchID")}</IndustryBranchID>
			   </CompanyIndustryBranch>
		into (/adfCompanyGet)[1]')

		--IF (@CompanyLegalAddressStreet IS NOT NULL AND @CompanyLegalAddressStreet != ''
		--	AND @CompanyLegalAddressCity IS NOT NULL AND @CompanyLegalAddressCity != ''
		--	AND @CompanyLegalAddressRegion IS NOT NULL AND @CompanyLegalAddressRegion != ''
		--	AND @CompanyLegalAddressPostalCode IS NOT NULL AND @CompanyLegalAddressPostalCode != '')
		--BEGIN
			SET @CompanyXML.modify('
			insert <Address>
					<AddressTypeID>1</AddressTypeID>
					<Street>{sql:variable("@CompanyLegalAddressStreet")}</Street>
					<City>{sql:variable("@CompanyLegalAddressCity")}</City>
					<Region>{sql:variable("@CompanyLegalAddressRegion")}</Region>
					<PostalCode>{sql:variable("@CompanyLegalAddressPostalCode")}</PostalCode>
					<Country>{sql:variable("@CompanyLegalAddressCountry")}</Country>
					<Mail>false</Mail>
				</Address>
			into (/adfCompanyGet)[1]')	
		--END

		--IF (@CompanyActualAddressStreet IS NOT NULL AND @CompanyActualAddressStreet != ''
		--	AND @CompanyActualAddressCity IS NOT NULL AND @CompanyActualAddressCity != ''
		--	AND @CompanyActualAddressRegion IS NOT NULL AND @CompanyActualAddressRegion != ''
		--	AND @CompanyActualAddressPostalCode IS NOT NULL AND @CompanyActualAddressPostalCode != '')
		--BEGIN
			SET @CompanyXML.modify('
			insert <Address>
					<AddressTypeID>3</AddressTypeID>
					<Street>{sql:variable("@CompanyActualAddressStreet")}</Street>
					<City>{sql:variable("@CompanyActualAddressCity")}</City>
					<Region>{sql:variable("@CompanyActualAddressRegion")}</Region>
					<PostalCode>{sql:variable("@CompanyActualAddressPostalCode")}</PostalCode>
					<Country>{sql:variable("@CompanyActualAddressCountry")}</Country>
					<Mail>true</Mail>
				</Address>
			into (/adfCompanyGet)[1]')	
		--END

		SET @CompanyXML.modify('
		insert <Phone>
				<PhoneTypeID>8</PhoneTypeID>
				<Phone>{sql:variable("@CompanyFax")}</Phone>
			</Phone>
		into (/adfCompanyGet)[1]')	

		SET @CompanyXML.modify('
		insert <Phone>
				<PhoneTypeID>7</PhoneTypeID>
				<Phone>{sql:variable("@CompanyPhone")}</Phone>
			</Phone>
		into (/adfCompanyGet)[1]')	

		SET @CompanyXML.modify('
		insert <Email>
				<EmailTypeID>4</EmailTypeID>
				<Email>{sql:variable("@CompanyWeb")}</Email>
			</Email>
		into (/adfCompanyGet)[1]')

		SET @CompanyXML.modify('
		insert <Email>
				<EmailTypeID>1</EmailTypeID>
				<Email>{sql:variable("@CompanyEmail")}</Email>
			</Email>
		into (/adfCompanyGet)[1]')	

		--SELECT @CompanyXML
		DECLARE @CompanyExtendedProperties XML
		SET @CompanyExtendedProperties = convert(xml,N'
			<ExtendedProperties>
				<Values>
					<PhoneSelector1>7</PhoneSelector1>
					<PhoneSelector2>11</PhoneSelector2>
					<PhoneSelector3>8</PhoneSelector3>
					<PhoneSelector4>4</PhoneSelector4>
					<AddressSelector>3</AddressSelector>
					<EmailSelector>1</EmailSelector>
					<WebPageSelector>4</WebPageSelector>
				</Values>
			</ExtendedProperties>')

		EXEC @rv = adfCompanyCreate @Xml=@CompanyXML,@ExtendedProperties=@CompanyExtendedProperties
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		SELECT 
			@CompanyID = [Company].[ID]
		FROM 
			[Company] 
		WHERE 
			[Company].[FileAs] = @CompanyFileAs
	END

	
	
	-- 
	IF @Xml.exist('(/MasterInfo/Company)[1]') = 1
	BEGIN	
		DECLARE @DivisionFileAs TName
		DECLARE division_cursor CURSOR FOR 
		SELECT
			Division.value('(./@Description)','TName')
		FROM
			@Xml.nodes('/MasterInfo/DivisionList/Division') as List(Division)
		OPEN division_cursor
		FETCH NEXT FROM division_cursor INTO @DivisionFileAs
		WHILE @@FETCH_STATUS = 0
		BEGIN
			IF @DivisionFileAs IS NOT NULL AND @DivisionFileAs != ''
			BEGIN
				EXEC @rv = adfDivisionCreate @CompanyID,@Code = @DivisionFileAs,@FileAS = @DivisionFileAs,@Comments=NULL
				IF @rv != 0
				BEGIN
					ROLLBACK TRANSACTION
					CLOSE division_cursor
					DEALLOCATE division_cursor
					RETURN 1
				END
			END
			FETCH NEXT FROM division_cursor INTO @DivisionFileAs
		END
		CLOSE division_cursor
		DEALLOCATE division_cursor
	END
	
	
	
	--  
	IF @Xml.exist('(/MasterInfo/PositionList)[1]') = 1
	BEGIN	
		--  
		DECLARE @HasManageDictionary TBool,
				@ManageDictionary TSysname
		SET @ManageDictionary = dbo.adfwfGetInitialRight('1da4d0a6-ed0f-4840-9d29-3090013ba2fb')
		SET @HasManageDictionary = dbo.adfHasAccessRightByName(@ManageDictionary)
		IF (@HasManageDictionary = 0)
		BEGIN
			EXEC pjm6SetRightForMasters @ManageDictionary
		END

		DECLARE @PositionFileAs TName
		DECLARE position_cursor CURSOR FOR 
		SELECT
			Position.value('./@Description','TName')
		FROM
			@Xml.nodes('/MasterInfo/PositionList/Position') as List(Position)
			
		OPEN position_cursor
		FETCH NEXT FROM position_cursor INTO @PositionFileAs
		WHILE @@FETCH_STATUS = 0
		BEGIN
		
			DECLARE @RES INT = 0
			SELECT @RES = 1
			WHERE EXISTS(SELECT * FROM [Position] WHERE FileAs = @PositionFileAs)
			
			IF @PositionFileAs IS NOT NULL AND @PositionFileAs != '' AND @RES != 1
			BEGIN
				EXEC @rv = adfPositionCreate @Code=@PositionFileAs,@FileAs=@PositionFileAs, @Comments=NULL
				IF @rv != 0
				BEGIN
					ROLLBACK TRANSACTION
					CLOSE position_cursor
					DEALLOCATE position_cursor
					RETURN 1
				END
			END
			
			FETCH NEXT FROM position_cursor INTO @PositionFileAs
			
		END
		CLOSE position_cursor
		DEALLOCATE position_cursor

		--  
		IF (@HasManageDictionary = 0)
		BEGIN
			EXEC pjm6DelRightForMasters @ManageDictionary
		END
	END
	
	
	
	-- 
	IF @Xml.exist('(/MasterInfo/Company)[1]') = 1
	BEGIN	
		--  
		SET @ManageDictionary = dbo.adfwfGetInitialRight('a93253fa-ea27-48ac-9620-10ee3421b69d')
		SET @HasManageDictionary = dbo.adfHasAccessRightByName(@ManageDictionary)
		IF (@HasManageDictionary = 0)
		BEGIN
			EXEC pjm6SetRightForMasters @ManageDictionary
		END

		DECLARE @QualificationXML XML,
				@QualificationFileAs TName,
				@QualificationRatesXML XML
			
		DECLARE qualification_cursor CURSOR FOR 
		SELECT
			Qualification.value('./@Description','TName'),
			Qualification.query('QualificationRate')
		FROM
			@Xml.nodes('/MasterInfo/QualificationList/Qualification') as List(Qualification)
		OPEN qualification_cursor
		FETCH NEXT FROM qualification_cursor INTO @QualificationFileAs,@QualificationRatesXML
		WHILE @@FETCH_STATUS = 0
		BEGIN
			IF @QualificationFileAs IS NOT NULL AND @QualificationFileAs != ''
			BEGIN
				SET @QualificationXML = 
				'<pjm5QualificationGet>
					<Qualification>
						<ID>-1</ID>
						<State>0</State>
						<Flag>0</Flag>
						<Guid>a93253fa-ea27-48ac-9620-10ee3421b69d</Guid>
					</Qualification>
				</pjm5QualificationGet>'

				--  Code  FileAs
				SET @QualificationXML.modify('
				insert <Code>{sql:variable("@QualificationFileAs")}</Code>
				into (/pjm5QualificationGet/Qualification)[1]       
				')  
				SET @QualificationXML.modify('
				insert <FileAs>{sql:variable("@QualificationFileAs")}</FileAs>            
				into (/pjm5QualificationGet/Qualification)[1]       
				')  
				DECLARE 
					@QualificationStandard TMoney,
					@QualificationCurrencyCode TCode3
				DECLARE qualificationRate_cursor CURSOR FOR 
				SELECT
					QualificationRate.value('./@Standard','TMoney'),
					QualificationRate.value('./@CurrencyCode','TCode3')
				FROM
					@QualificationRatesXML.nodes('/QualificationRate') as List(QualificationRate)
				OPEN qualificationRate_cursor
				FETCH NEXT FROM qualificationRate_cursor INTO @QualificationStandard, @QualificationCurrencyCode
				WHILE @@FETCH_STATUS = 0
				BEGIN
					--  FileAs
					SET @QualificationXML.modify('
						insert 
						<QualificationRate>
							<Standard>{sql:variable("@QualificationStandard")}</Standard>
							<Overtime>{sql:variable("@QualificationStandard")}</Overtime>
							<CurrencyCode>{sql:variable("@QualificationCurrencyCode")}</CurrencyCode>
							</QualificationRate>            
						into (/pjm5QualificationGet)[1]       
						')
					FETCH NEXT FROM qualificationRate_cursor INTO @QualificationStandard,@QualificationCurrencyCode
				END
				CLOSE qualificationRate_cursor
				DEALLOCATE qualificationRate_cursor

				--SELECT @QualificationXML
				EXEC @rv = pjm5QualificationCreate @Xml=@QualificationXML, @RunningFromMaster=1
				IF @rv != 0
				BEGIN
					ROLLBACK TRANSACTION
					CLOSE qualification_cursor
					DEALLOCATE qualification_cursor
					RETURN 1
				END
			END
			FETCH NEXT FROM qualification_cursor INTO @QualificationFileAs,@QualificationRatesXML
		END
		CLOSE qualification_cursor
		DEALLOCATE qualification_cursor
		
		--  
		IF (@HasManageDictionary = 0)
		BEGIN
			EXEC pjm6DelRightForMasters @ManageDictionary
		END
	END
	
	
	
	--  
	IF @Xml.exist('(/MasterInfo/ExpenseCodeList)[1]') = 1
	BEGIN
		--  
		SET @ManageDictionary = dbo.adfwfGetInitialRight('53eae288-1403-4cdb-8f57-f2ab107352d5')
		SET @HasManageDictionary = dbo.adfHasAccessRightByName(@ManageDictionary)
		IF (@HasManageDictionary = 0)
		BEGIN
			EXEC pjm6SetRightForMasters @ManageDictionary
		END
		
		DECLARE @ExpenseCodeXML XML,
				@ExpenseCodeCode TName,
				@ExpenseCodeFileAs TName
						
		DECLARE expenseCode_cursor CURSOR FOR 
		SELECT
			ExpenseCode.value('./@Code','TName'),
			ExpenseCode.value('./@Description','TName')
		FROM
			@Xml.nodes('/MasterInfo/ExpenseCodeList/ExpenseCode') as List(ExpenseCode)
		OPEN expenseCode_cursor
		FETCH NEXT FROM expenseCode_cursor INTO @ExpenseCodeCode, @ExpenseCodeFileAs
		WHILE @@FETCH_STATUS = 0
		BEGIN
			IF (@ExpenseCodeFileAs IS NOT NULL AND @ExpenseCodeFileAs != '')
				AND (@ExpenseCodeCode IS NOT NULL AND @ExpenseCodeCode != '')
			BEGIN
				SET @ExpenseCodeXML = 
				'<pjm5ExpenseCodeGet>
					<ExpenseCode>
						<ID>-1</ID>
						<State>0</State>
						<Flag>0</Flag>
						<Guid>53eae288-1403-4cdb-8f57-f2ab107352d5</Guid>
						<AddToNewProject>true</AddToNewProject>
						<Billable>true</Billable>
						<VATIsIncluded>true</VATIsIncluded>
					</ExpenseCode>
				</pjm5ExpenseCodeGet>'

				--  Code, FileAs    (VATRate)	
				SET @ExpenseCodeXML.modify('
				insert <Code>{sql:variable("@ExpenseCodeCode")}</Code>
				into (/pjm5ExpenseCodeGet/ExpenseCode)[1]       
				')  
				SET @ExpenseCodeXML.modify('
				insert <FileAs>{sql:variable("@ExpenseCodeFileAs")}</FileAs>            
				into (/pjm5ExpenseCodeGet/ExpenseCode)[1]       
				')  
				SET @ExpenseCodeXML.modify('
				insert <VATRate>{sql:variable("@VATRate")}</VATRate>            
				into (/pjm5ExpenseCodeGet/ExpenseCode)[1]       
				')
				
				EXEC @rv = pjm5ExpenseCodeCreate @Xml=@ExpenseCodeXML
				IF @rv != 0
				BEGIN
					ROLLBACK TRANSACTION
					CLOSE expenseCode_cursor
					DEALLOCATE expenseCode_cursor
					RETURN 1
				END
			END
			FETCH NEXT FROM expenseCode_cursor INTO @ExpenseCodeCode, @ExpenseCodeFileAs
		END
		CLOSE expenseCode_cursor
		DEALLOCATE expenseCode_cursor
		
		--  
		IF (@HasManageDictionary = 0)
		BEGIN
			EXEC pjm6DelRightForMasters @ManageDictionary
		END
	END

	
	
	--  
	IF @Xml.exist('(/MasterInfo/ActivityTypeList)[1]') = 1
	BEGIN
		--  
		SET @ManageDictionary = dbo.adfwfGetInitialRight('efe70cde-a81b-41b9-b01d-2b3f1b1c821a')
		SET @HasManageDictionary = dbo.adfHasAccessRightByName(@ManageDictionary)
		IF (@HasManageDictionary = 0)
		BEGIN
			EXEC pjm6SetRightForMasters @ManageDictionary
		END

		DECLARE @ActivityTypeCode TName,
				@ActivityTypeFileAs TName,
				@ActivityTypeProjectTypeID TName,
				@ActivityTypeBillable TBool
						
		DECLARE activityType_cursor CURSOR FOR 
		SELECT
			ActivityType.value('./@Code','TName'),
			ActivityType.value('./@Description','TName'),
			ActivityType.value('./@ProjectTypeID','TName'),
			Convert(bit, ActivityType.value('./@Billable','TBool'))
		FROM
			@Xml.nodes('/MasterInfo/ActivityTypeList/ActivityType') as List(ActivityType)
		OPEN activityType_cursor
		FETCH NEXT FROM activityType_cursor INTO @ActivityTypeCode, @ActivityTypeFileAs, @ActivityTypeProjectTypeID,
			@ActivityTypeBillable
		WHILE @@FETCH_STATUS = 0
		BEGIN
			IF (@ActivityTypeFileAs IS NOT NULL AND @ActivityTypeFileAs != '')
				AND (@ActivityTypeCode IS NOT NULL AND @ActivityTypeCode != '')
			BEGIN
				SET @ActivityTypeProjectTypeID=
					CASE
						WHEN @ActivityTypeProjectTypeID=0 THEN NULL
						ELSE @ActivityTypeProjectTypeID
					END
				EXEC @rv = adfActivityTypeCreate @Code=@ActivityTypeCode, @FileAs=@ActivityTypeFileAs,
					@ProjectTypeID=@ActivityTypeProjectTypeID, @AddToNewProject=1, @Billable=@ActivityTypeBillable,
					@PhoneCallAccessible=0, @Comments=NULL 
				IF @rv != 0
				BEGIN
					ROLLBACK TRANSACTION
					CLOSE activityType_cursor
					DEALLOCATE activityType_cursor
					RETURN 1
				END
			END
					
			FETCH NEXT FROM activityType_cursor INTO @ActivityTypeCode, @ActivityTypeFileAs, 
				@ActivityTypeProjectTypeID, @ActivityTypeBillable
		END
		CLOSE activityType_cursor
		DEALLOCATE activityType_cursor
		
		--  
		IF (@HasManageDictionary = 0)
		BEGIN
			EXEC pjm6DelRightForMasters @ManageDictionary
		END
	END
		
	

	--  
	IF @Xml.exist('(/MasterInfo/Company)[1]') = 1 AND @Xml.exist('(/MasterInfo/EmployeeList)[1]') = 1
	BEGIN
		DECLARE
			@EmployeeXML	XML,
			@EmployeeLastName TPersonName,
			@EmployeeFirstName TPersonName,
			@EmployeeMiddleName TPersonName,
			@EmployeeFileAs TName,
			@EmployeePositionID TIdentifier,
			@EmployeeQualificationID TIdentifier,
			@EmployeeDivisionID TIdentifier,
			@EmployeePhoneWork TPhone,
			@EmployeePhoneMobile TPhone,
			@EmployeeEmail THref,
			@EmployeeExtendedProperties XML,
			@WindowsAuthentication TBool,
			@WindowsGroup TSysName,
			@SQLAuthentication TBool,
			@WindowsLogin TSysName,
			@SqlLogin TSysName,
			@Password nvarchar(50),
			@IsManager TBool,
			@IsChiefAccountant TBool,
			@IsAdministrator TBool,
			@AccountantEmployeeID TIdentifier,
			@ExecutiveEmployeeID TIdentifier
			
		SET @EmployeeExtendedProperties = convert(xml,N'
			<ExtendedProperties>
				<Values>
					<PhoneSelector1>1</PhoneSelector1>
					<PhoneSelector2>2</PhoneSelector2>
					<PhoneSelector3>3</PhoneSelector3>
					<PhoneSelector4>4</PhoneSelector4>
					<AddressSelector>2</AddressSelector>
					<EmailSelector>1</EmailSelector>
					<WebPageSelector>4</WebPageSelector>
					<IdentityCardType>1</IdentityCardType>
					<Gender>0</Gender>
				</Values>
			</ExtendedProperties>')
		
		SET @WindowsGroup = @Xml.value('(/MasterInfo/UserIdentification/WindowsGroup)[1]','TSysName')
		SET @WindowsAuthentication = @Xml.value('(/MasterInfo/UserIdentification/WindowsAuthentication)[1]','TBool')
		SET @SQLAuthentication = @Xml.value('(/MasterInfo/UserIdentification/SQLAuthentication)[1]','TBool')
		
		DECLARE employee_cursor CURSOR FOR 
		SELECT
			Employee.value('./@LastName','TPersonName'),
			Employee.value('./@FirstName','TPersonName'),
			Employee.value('./@MiddleName','TPersonName'),
			Employee.value('./@FileAs','TName'),
			(SELECT 
				TOP(1) [Position].[ID] 
			FROM 
				[Position]
			WHERE 
				[Position].[FileAs] = Employee.value('./@Position','TName')),
			(SELECT 
				TOP(1) [Qualification].[ID] 
			FROM 
				[Qualification]
			WHERE 
				[Qualification].[FileAs] = Employee.value('./@Qualification','TName')),
			(SELECT 
				TOP(1) [Division].[ID] 
			FROM 
				[Division]
			WHERE 
				[Division].[FileAs] = Employee.value('./@Division','TName')),
			Employee.value('./@WorkPhone','TPhone'),
			Employee.value('./@MobilePhone','TPhone'),
			Employee.value('./@Email','THref'),
			Employee.value('./@WindowsAccount','TSysName'),
			Employee.value('./@SQLAccount','TSysName'),
			Employee.value('./@SQLPassword','nvarchar(50)'),
			Employee.value('./@IsManager','TBool'),
			Employee.value('./@IsChiefAccountant','TBool'),
			Employee.value('./@IsAdministrator','TBool')
		FROM
			@Xml.nodes('/MasterInfo/EmployeeList/Employee') as List(Employee)
		
		OPEN employee_cursor
		FETCH NEXT FROM employee_cursor INTO 
			@EmployeeLastName,
			@EmployeeFirstName,
			@EmployeeMiddleName,
			@EmployeeFileAs,
			@EmployeePositionID,
			@EmployeeQualificationID, 
			@EmployeeDivisionID, 
			@EmployeePhoneWork, 
			@EmployeePhoneMobile, 
			@EmployeeEmail,
			@WindowsLogin,
			@SqlLogin,
			@Password,
			@IsManager,
			@IsChiefAccountant,
			@IsAdministrator
		WHILE @@FETCH_STATUS = 0
		BEGIN		
			SET @EmployeeXML = 
			'<adfEmployeeGet>
				<Employee>
					<ID>-1</ID>
					<State>0</State>
					<Flag>0</Flag>
					<Guid>219e9b7e-153a-4e93-ab63-0b3785d67c8a</Guid>
					<Own>false</Own>
					<Private>true</Private>
					<ReminderState>false</ReminderState>
				</Employee>
			</adfEmployeeGet>'
			
			-- 
			SET @EmployeeXML.modify('
			insert <FileAs>{sql:variable("@EmployeeFileAs")}</FileAs>
			into (/adfEmployeeGet/Employee)[1]')
			--ID 
			SET @EmployeeXML.modify('
			insert <CompanyID>{sql:variable("@CompanyID")}</CompanyID>
			into (/adfEmployeeGet/Employee)[1]')
			--ID  
			IF @EmployeePositionID IS NOT NULL
			BEGIN
				SET @EmployeeXML.modify('
				insert <PositionID>{sql:variable("@EmployeePositionID")}</PositionID>
				into (/adfEmployeeGet/Employee)[1]')
			END
			IF @EmployeeQualificationID IS NOT NULL
			BEGIN
				--ID 
				SET @EmployeeXML.modify('
				insert <QualificationID>{sql:variable("@EmployeeQualificationID")}</QualificationID>
				into (/adfEmployeeGet/Employee)[1]')
			END
			IF @EmployeeDivisionID IS NOT NULL
			BEGIN
				--ID 
				SET @EmployeeXML.modify('
				insert <DivisionID>{sql:variable("@EmployeeDivisionID")}</DivisionID>
				into (/adfEmployeeGet/Employee)[1]')
			END
			--
			SET @EmployeeXML.modify('
			insert <FirstName>{sql:variable("@EmployeeFirstName")}</FirstName>
			into (/adfEmployeeGet/Employee)[1]')
			--
			SET @EmployeeXML.modify('
			insert <MiddleName>{sql:variable("@EmployeeMiddleName")}</MiddleName>
			into (/adfEmployeeGet/Employee)[1]')
			--
			SET @EmployeeXML.modify('
			insert <LastName>{sql:variable("@EmployeeLastName")}</LastName>
			into (/adfEmployeeGet/Employee)[1]')
			--Windows 
			IF @WindowsAuthentication = 1 AND @WindowsLogin != '' AND @HasRightCreateUser = 1
			BEGIN
				SET @EmployeeXML.modify('
				insert <WindowsLogin>{sql:variable("@WindowsLogin")}</WindowsLogin>
				into (/adfEmployeeGet/Employee)[1]')

				IF (@WindowsGroup IS NULL OR @WindowsGroup = '')
				BEGIN
					IF NOT EXISTS(SELECT * FROM sys.server_principals WHERE [name] = @WindowsLogin)
					BEGIN
						EXEC ('CREATE LOGIN [' + @WindowsLogin + '] FROM WINDOWS')
						IF @@ERROR != 0
						BEGIN
							ROLLBACK TRANSACTION
							CLOSE employee_cursor
							DEALLOCATE employee_cursor
							RETURN 1
						END
					END

					IF NOT EXISTS(SELECT * FROM sys.database_principals WHERE [name] = @WindowsLogin)
					BEGIN
						EXEC ('CREATE USER [' + @WindowsLogin + '] FOR LOGIN [' + @WindowsLogin + '];')
						IF @@ERROR != 0
						BEGIN
							ROLLBACK TRANSACTION
							CLOSE employee_cursor
							DEALLOCATE employee_cursor
							RETURN 1
						END
					END
				END
			END
			--SQL 
			IF @SQLAuthentication = 1 AND @SqlLogin != '' AND @HasRightCreateUser = 1
			BEGIN
				SET @EmployeeXML.modify('
				insert <SqlLogin>{sql:variable("@SqlLogin")}</SqlLogin>
				into (/adfEmployeeGet/Employee)[1]')
							
				--  Azure SQL       ,
				-- ..   \    
				IF @IsAzureSQL = 0
				BEGIN
					IF NOT EXISTS(SELECT * FROM sys.server_principals WHERE [name] = @SqlLogin)
						BEGIN
						EXEC ('CREATE LOGIN [' + @SqlLogin + '] WITH PASSWORD = ''' + @Password + '''')
						IF @@ERROR != 0
						BEGIN
							ROLLBACK TRANSACTION
							CLOSE employee_cursor
							DEALLOCATE employee_cursor
							RETURN 1
						END
					END
					ELSE
					BEGIN
						EXEC ('ALTER LOGIN [' + @SqlLogin + '] WITH PASSWORD = ''' + @Password + '''')
						IF @@ERROR != 0
						BEGIN
							ROLLBACK TRANSACTION
							CLOSE employee_cursor
							DEALLOCATE employee_cursor
							RETURN 1
						END
					END

					IF NOT EXISTS(SELECT * FROM sys.database_principals WHERE [name] = @SqlLogin)
					BEGIN
						EXEC ('CREATE USER [' + @SqlLogin + '] FOR LOGIN [' + @SqlLogin + '];')
						IF @@ERROR != 0
						BEGIN
							ROLLBACK TRANSACTION
							CLOSE employee_cursor
							DEALLOCATE employee_cursor
							RETURN 1
						END
					END
				END
			
			END
			-- 
			SET @EmployeeXML.modify('
			insert
			<Phone>
				<PhoneTypeID>1</PhoneTypeID>
				<Phone>{sql:variable("@EmployeePhoneWork")}</Phone>
			</Phone>
			into (/adfEmployeeGet)[1]')
			-- 
			SET @EmployeeXML.modify('
			insert
			<Phone>
				<PhoneTypeID>3</PhoneTypeID>
				<Phone>{sql:variable("@EmployeePhoneMobile")}</Phone>
			</Phone>
			into (/adfEmployeeGet)[1]')
			--Email
			SET @EmployeeXML.modify('insert
			<Email>
				<EmailTypeID>1</EmailTypeID>
				<Email>{sql:variable("@EmployeeEmail")}</Email></Email>
			into (/adfEmployeeGet)[1]')

			SET @EmployeeXML.modify('
			insert <IsManager>{sql:variable("@IsManager")}</IsManager>
			into (/adfEmployeeGet)[1]')
		
			SET @EmployeeXML.modify('
			insert <IsChiefAccountant>{sql:variable("@IsChiefAccountant")}</IsChiefAccountant>
			into (/adfEmployeeGet)[1]')
		
			SET @EmployeeXML.modify('
			insert <IsAdministrator>{sql:variable("@IsAdministrator")}</IsAdministrator>
			into (/adfEmployeeGet)[1]')

			--SELECT @EmployeeXML
			EXEC @rv = adfEmployeeCreate @Xml = @EmployeeXML, @ExtendedProperties = @EmployeeExtendedProperties,
				@RunningFromMaster = 1
			IF @rv != 0
			BEGIN
				ROLLBACK TRANSACTION
				CLOSE employee_cursor
				DEALLOCATE employee_cursor
				RETURN 1
			END
			
			IF @IsManager = 1
				SET @ExecutiveEmployeeID = (SELECT TOP (1) [ID] FROM [Employee] WHERE [FileAs] = @EmployeeFileAs)
			IF @IsChiefAccountant = 1
				SET @AccountantEmployeeID = (SELECT TOP (1) [ID] FROM [Employee] WHERE [FileAs] = @EmployeeFileAs)

			FETCH NEXT FROM employee_cursor INTO 
			@EmployeeLastName,
			@EmployeeFirstName,
			@EmployeeMiddleName,
			@EmployeeFileAs,
			@EmployeePositionID, 
			@EmployeeQualificationID, 
			@EmployeeDivisionID, 
			@EmployeePhoneWork, 
			@EmployeePhoneMobile, 
			@EmployeeEmail,
			@WindowsLogin,
			@SqlLogin,
			@Password,
			@IsManager,
			@IsChiefAccountant,
			@IsAdministrator
		END
		CLOSE employee_cursor
		DEALLOCATE employee_cursor

		--   SQLServer  windows 
		IF @WindowsAuthentication = 1 AND @WindowsGroup IS NOT NULL AND @WindowsGroup != '' AND @HasRightCreateUser = 1
			BEGIN
				IF NOT EXISTS(SELECT * FROM sys.server_principals WHERE [name] = @WindowsGroup)
				BEGIN
					EXEC ('CREATE LOGIN [' + @WindowsGroup + '] FROM WINDOWS')
					IF @@ERROR != 0
					BEGIN
						ROLLBACK TRANSACTION
						RETURN 1
					END
				END

				IF NOT EXISTS(SELECT * FROM sys.database_principals WHERE [name] = @WindowsGroup)
				BEGIN
					EXEC ('CREATE USER [' + @WindowsGroup + '] FOR LOGIN [' + @WindowsGroup + '];')
					IF @@ERROR != 0
					BEGIN
						ROLLBACK TRANSACTION
						RETURN 1
					END
				END
			END
	END
		
		
		
	--  
	IF @Xml.exist('(/MasterInfo/CompanyList)[1]') = 1
	BEGIN
		DECLARE
			@CreateCompanyXML	XML,
			@CreateManagerXML	XML,
			@CreateChiefAccountantXML	XML,
			@CreateCompanyLegalName TName,
			@CreateCompanyFileAs TName,
			@CreateCompanyLegalCode TCode,
			@CreateCompanyKPP TCode,
			@CreateCompanyBIN TCode,
			@CreateCompanyPhone TPhone,
			@CreateCompanyFax TPhone,
			@CreateCompanyStreet TName,
			@CreateCompanyCity TCity,
			@CreateCompanyRegion TName,
			@CreateCompanyPostalCode TPostalCode,
			@CreateCompanyCountry TName,
			
			@CreateCompanyManagerID TIdentifier,
			@CreateCompanyManagerName TName,
			@CreateCompanyManagerFirstName TName,
			@CreateCompanyManagerMiddleName TName,
			@CreateCompanyManagerLastName TName,
			@CreateCompanyManagerPositionID TIdentifier,
			
			@CreateCompanyChiefAccountantID TIdentifier,
			@CreateCompanyChiefAccountantName TName,
			@CreateCompanyChiefAccountantFirstName TName,
			@CreateCompanyChiefAccountantMiddleName TName,
			@CreateCompanyChiefAccountantLastName TName,
			@CreateCompanyChiefAccountantPositionID TIdentifier,
			
			@CreateCompanyEmail THref,
			@CreateCompanyWeb THref,
			
			@CreatedCompanyID TIdentifier,
			
			@CreateCompanyFlagOnCreate TIdentifier,
			@CreateCompanyFlagOnUpdate TIdentifier,
			
			@CreateCompanyExtendedProperties XML,
			@CreateEmployeeExtendedProperties XML,
			
			@IsCreated TIdentifier
				
		IF @Xml.exist('(/MasterInfo/CompanyListPageDescription/CompanyListPageDescriptionCombo1Complex)[1]') = 1
		BEGIN
			SET @CreateCompanyFlagOnCreate = @Xml.value('(/MasterInfo/CompanyListPageDescription/CompanyListPageDescriptionCombo1Complex)[1]','TCode3')	
			SET @CreateCompanyFlagOnUpdate = @Xml.value('(/MasterInfo/CompanyListPageDescription/CompanyListPageDescriptionCombo2Complex)[1]','TCode3')			
		END
		ELSE
		BEGIN
			SET @CreateCompanyFlagOnCreate = 0
			SET @CreateCompanyFlagOnUpdate = 0		
		END
				
		SET @CreateCompanyExtendedProperties = convert(xml,N'
			<ExtendedProperties>
				<Values>
					<PhoneSelector1>7</PhoneSelector1>
					<PhoneSelector2>11</PhoneSelector2>
					<PhoneSelector3>8</PhoneSelector3>
					<PhoneSelector4>4</PhoneSelector4>
					<AddressSelector>3</AddressSelector>
					<EmailSelector>1</EmailSelector>
					<WebPageSelector>4</WebPageSelector>
				</Values>
			</ExtendedProperties>')
		
		SET @CreateEmployeeExtendedProperties = convert(xml,N'
			<ExtendedProperties>
				<Values>
					<PhoneSelector1>1</PhoneSelector1>
					<PhoneSelector2>2</PhoneSelector2>
					<PhoneSelector3>3</PhoneSelector3>
					<PhoneSelector4>4</PhoneSelector4>
					<AddressSelector>2</AddressSelector>
					<EmailSelector>1</EmailSelector>
					<WebPageSelector>4</WebPageSelector>
					<IdentityCardType>1</IdentityCardType>
					<Gender>0</Gender>
				</Values>
			</ExtendedProperties>')
			

		DECLARE company_cursor CURSOR FOR 
		SELECT
			Company.value('./@CompanyName','TName'),
			Company.value('./@FileAs','TName'),
			Company.value('./@LegalCode','TCode'),
			Company.value('./@KPP','TCode'),
			Company.value('./@BIN','TCode'),
			Company.value('./@CompanyPhone','TPhone'),
			Company.value('./@Fax','TPhone'),
			Company.value('./@Street','TName'),
			Company.value('./@City','TCity'),
			Company.value('./@Region','TName'),
			Company.value('./@PostalCode','TPostalCode'),
			Company.value('./@Country','TName'),
			Company.value('./@ManagerName','TName'),
			(SELECT 
				TOP(1) [Position].[ID] 
			FROM 
				[Position]
			WHERE 
				[Position].[FileAs] = Company.value('./@ManagerPosition','TName')), 
			Company.value('./@ChiefAccountantName','TName'),
			Company.value('./@Email','THref'),
			Company.value('./@Web','THref')
		FROM
			@Xml.nodes('/MasterInfo/CompanyList/Company') as List(Company)
		
		OPEN company_cursor
		FETCH NEXT FROM company_cursor INTO 
			@CreateCompanyLegalName,
			@CreateCompanyFileAs,
			@CreateCompanyLegalCode,
			@CreateCompanyKPP,
			@CreateCompanyBIN,
			@CreateCompanyPhone, 
			@CreateCompanyFax, 
			@CreateCompanyStreet, 
			@CreateCompanyCity, 
			@CreateCompanyRegion,
			@CreateCompanyPostalCode,
			@CreateCompanyCountry,
			@CreateCompanyManagerName,
			@CreateCompanyManagerPositionID,
			@CreateCompanyChiefAccountantName,
			@CreateCompanyEmail,
			@CreateCompanyWeb
		WHILE @@FETCH_STATUS = 0
		BEGIN		
			SET @CreateCompanyXML = 
			'<adfCompanyGet>
				<Company>
					<ID>-1</ID>
					<State>0</State>
					<Own>false</Own>
					<Guid>5206f98c-4e57-44ea-8dc9-0ab6b81fd9c2</Guid>
					<Private>false</Private>
					<PaymentCurrencyPoint>1</PaymentCurrencyPoint>
					<PlanPurchases>0</PlanPurchases>
				</Company>
			</adfCompanyGet>'
			
			SET @CreateManagerXML = 
			'<adfEmployeeGet>
				<Employee>
					<ID>-1</ID>
					<State>0</State>
					<Flag>0</Flag>
					<Guid>219e9b7e-153a-4e93-ab63-0b3785d67c8a</Guid>
					<Own>false</Own>
					<Private>false</Private>
					<ReminderState>false</ReminderState>
				</Employee>
			</adfEmployeeGet>'
			
			SET @CreateChiefAccountantXML = 
			'<adfEmployeeGet>
				<Employee>
					<ID>-1</ID>
					<State>0</State>
					<Flag>0</Flag>
					<Guid>219e9b7e-153a-4e93-ab63-0b3785d67c8a</Guid>
					<Own>false</Own>
					<Private>false</Private>
					<ReminderState>false</ReminderState>
				</Employee>
			</adfEmployeeGet>'
			
			-- 
			SET @CreateCompanyXML.modify('
			insert <LegalName>{sql:variable("@CreateCompanyLegalName")}</LegalName>
			into (/adfCompanyGet/Company)[1]')
			-- 
			SET @CreateCompanyXML.modify('
			insert <FileAs>{sql:variable("@CreateCompanyFileAs")}</FileAs>
			into (/adfCompanyGet/Company)[1]')
			--
			SET @CreateCompanyXML.modify('
			insert <LegalCode>{sql:variable("@CreateCompanyLegalCode")}</LegalCode>
			into (/adfCompanyGet/Company)[1]')
			--
			SET @CreateCompanyXML.modify('
			insert <KPP>{sql:variable("@CreateCompanyKPP")}</KPP>
			into (/adfCompanyGet/Company)[1]')
			--
			SET @CreateCompanyXML.modify('
			insert <BIN>{sql:variable("@CreateCompanyBIN")}</BIN>
			into (/adfCompanyGet/Company)[1]')
			--
			SET @CreateCompanyXML.modify('
			insert
			<Phone>
				<PhoneTypeID>7</PhoneTypeID>
				<Phone>{sql:variable("@CreateCompanyPhone")}</Phone>
			</Phone>
			into (/adfCompanyGet)[1]')
			--
			SET @CreateCompanyXML.modify('
			insert
			<Phone>
				<PhoneTypeID>8</PhoneTypeID>
				<Phone>{sql:variable("@CreateCompanyFax")}</Phone>
			</Phone>
			into (/adfCompanyGet)[1]')
			--
			SET @CreateCompanyXML.modify('
			insert <Address>
					<AddressTypeID>1</AddressTypeID>
					<Street>{sql:variable("@CreateCompanyStreet")}</Street>
					<City>{sql:variable("@CreateCompanyCity")}</City>
					<Region>{sql:variable("@CreateCompanyRegion")}</Region>
					<PostalCode>{sql:variable("@CreateCompanyPostalCode")}</PostalCode>
					<Country>{sql:variable("@CreateCompanyCountry")}</Country>
					<Mail>true</Mail>
				</Address>
			into (/adfCompanyGet)[1]')	
			SET @CreateCompanyXML.modify('
			insert <Address>
					<AddressTypeID>3</AddressTypeID>
					<Street>{sql:variable("@CreateCompanyStreet")}</Street>
					<City>{sql:variable("@CreateCompanyCity")}</City>
					<Region>{sql:variable("@CreateCompanyRegion")}</Region>
					<PostalCode>{sql:variable("@CreateCompanyPostalCode")}</PostalCode>
					<Country>{sql:variable("@CreateCompanyCountry")}</Country>
					<Mail>true</Mail>
				</Address>
			into (/adfCompanyGet)[1]')
			--Email
			SET @CreateCompanyXML.modify('insert
			<Email>
				<EmailTypeID>1</EmailTypeID>
				<Email>{sql:variable("@CreateCompanyEmail")}</Email>
			</Email>
			into (/adfCompanyGet)[1]')
			--Web
			SET @CreateCompanyXML.modify('insert
			<Email>
				<EmailTypeID>4</EmailTypeID>
				<Email>{sql:variable("@CreateCompanyWeb")}</Email>
			</Email>
			into (/adfCompanyGet)[1]')

			EXEC @rv = adfCompanySmartSearch @LegalName = @CreateCompanyLegalName, @LegalCode = @CreateCompanyLegalCode,
				@CompanyReturnID = @CreatedCompanyID OUTPUT
			IF @rv != 0
			BEGIN
				ROLLBACK TRANSACTION
				CLOSE company_cursor
				DEALLOCATE company_cursor
				RETURN 1
			END
			
			IF @CreatedCompanyID IS NOT NULL
			BEGIN
				SET @IsCreated = 0

				EXEC @rv = adfCompanyFilling @Xml = @CreateCompanyXML, @ExtendedProperties = @CreateCompanyExtendedProperties,
					@CompanyID = @CreatedCompanyID
				IF @rv != 0
				BEGIN
					ROLLBACK TRANSACTION
					CLOSE company_cursor
					DEALLOCATE company_cursor
					RETURN 1
				END
			END
			ELSE
			BEGIN
				SET @IsCreated = 1

				EXEC @rv = adfCompanyCreate @Xml = @CreateCompanyXML, @ExtendedProperties = @CreateCompanyExtendedProperties,
					@CompanyReturnID = @CreatedCompanyID OUTPUT
				IF @rv != 0
				BEGIN
					ROLLBACK TRANSACTION
					CLOSE company_cursor
					DEALLOCATE company_cursor
					RETURN 1
				END
			END
			
			--      
			SET @CreateCompanyXML = 
				'<adfCompanyGet>
					<Company>
						<ID>-1</ID>
						<State>0</State>
						<Own>false</Own>
						<Guid>5206f98c-4e57-44ea-8dc9-0ab6b81fd9c2</Guid>
						<Private>false</Private>
						<PaymentCurrencyPoint>1</PaymentCurrencyPoint>
						<PlanPurchases>0</PlanPurchases>
					</Company>
				</adfCompanyGet>'
			
			DECLARE @P int
			DECLARE @BadChars Varchar(16)
			
			IF @CreateCompanyManagerName IS NOT NULL AND @CreateCompanyManagerName != ''
			BEGIN
				SET @CreateCompanyManagerName = LTRIM(RTRIM(REPLACE(@CreateCompanyManagerName,'.',' ')))
				WHILE @CreateCompanyManagerName like '%  %'
					SET @CreateCompanyManagerName =  REPLACE(@CreateCompanyManagerName,'  ',' ')
				--  ,    ,  
				SELECT @BadChars = N'%[^a-z-0-9 ]%'

				SET @P = PATINDEX(@BadChars, @CreateCompanyManagerName)
				WHILE @P > 0 BEGIN
					SELECT @CreateCompanyManagerName = Left(@CreateCompanyManagerName, @P-1) + SUBSTRING(@CreateCompanyManagerName, @P+1, 250)
					SET @P = PATINDEX(@BadChars, @CreateCompanyManagerName)
					END
					
				-- BEFORE: LEFT(@where_to_search, CHARINDEX(@what_to_search,@where_to_search)-1 )
				--	AFTER: RIGHT(@where_to_search, len(@where_to_search)-charindex(@what_to_search,@where_to_search) )

				DECLARE @SpaceCount INT
				SET @SpaceCount = (DATALENGTH(@CreateCompanyManagerName) - DATALENGTH(REPLACE(@CreateCompanyManagerName,' ','')))/2
				
				IF @SpaceCount = 0
				BEGIN
					SET @CreateCompanyManagerLastName = @CreateCompanyManagerName
					SET @CreateCompanyManagerFirstName = NULL
					SET @CreateCompanyManagerMiddleName = NULL
				END
				ELSE
					IF @SpaceCount = 1
					BEGIN
						SET @CreateCompanyManagerLastName = LEFT(@CreateCompanyManagerName, CHARINDEX(' ',@CreateCompanyManagerName)-1 )
						SET @CreateCompanyManagerFirstName = RIGHT(@CreateCompanyManagerName, len(@CreateCompanyManagerName)-charindex(' ',@CreateCompanyManagerName) )
						SET @CreateCompanyManagerMiddleName = NULL
					END
					ELSE
					BEGIN
						SET @CreateCompanyManagerLastName = LEFT(@CreateCompanyManagerName, CHARINDEX(' ',@CreateCompanyManagerName)-1 )
						SET @CreateCompanyManagerFirstName = LEFT(RIGHT(@CreateCompanyManagerName, len(@CreateCompanyManagerName)-charindex(' ',@CreateCompanyManagerName) ), CHARINDEX(' ',RIGHT(@CreateCompanyManagerName, len(@CreateCompanyManagerName)-charindex(' ',@CreateCompanyManagerName) ))-1 )
						SET @CreateCompanyManagerMiddleName = RIGHT(RIGHT(@CreateCompanyManagerName, len(@CreateCompanyManagerName)-charindex(' ',@CreateCompanyManagerName) ), len(RIGHT(@CreateCompanyManagerName, len(@CreateCompanyManagerName)-charindex(' ',@CreateCompanyManagerName) ))-charindex(' ',RIGHT(@CreateCompanyManagerName, len(@CreateCompanyManagerName)-charindex(' ',@CreateCompanyManagerName) )) )
					END
					
				IF (   (@SpaceCount = 0 AND NOT EXISTS 
						(	SELECT * FROM [Employee]
							WHERE [LastName] = @CreateCompanyManagerLastName
								AND [CompanyID] = @CreatedCompanyID	)	)
					OR (@SpaceCount = 1 AND NOT EXISTS 
						(	SELECT * FROM [Employee]
							WHERE [LastName] = @CreateCompanyManagerLastName
								AND [FirstName] = @CreateCompanyManagerFirstName 
								AND [CompanyID] = @CreatedCompanyID	)	)
					OR (@SpaceCount > 1 AND NOT EXISTS 
						(	SELECT * FROM [Employee]
							WHERE [LastName] = @CreateCompanyManagerLastName
								AND [FirstName] = @CreateCompanyManagerFirstName 
								AND [MiddleName] = @CreateCompanyManagerMiddleName
								AND [CompanyID] = @CreatedCompanyID	)	)
					)
				BEGIN
					-- ()
					SET @CreateManagerXML.modify('
					insert <LastName>{ sql:variable("@CreateCompanyManagerLastName") }</LastName>
					into (/adfEmployeeGet/Employee)[1]')
					-- ()
					SET @CreateManagerXML.modify('
					insert <FirstName>{ sql:variable("@CreateCompanyManagerFirstName") }</FirstName>
					into (/adfEmployeeGet/Employee)[1]')
					-- ()
					SET @CreateManagerXML.modify('
					insert <MiddleName>{ sql:variable("@CreateCompanyManagerMiddleName") }</MiddleName>
					into (/adfEmployeeGet/Employee)[1]')
					-- (FileAs)
					SET @CreateManagerXML.modify('
					insert <FileAs>{ sql:variable("@CreateCompanyManagerName")}</FileAs>
					into (/adfEmployeeGet/Employee)[1]')
					-- ()
					IF @CreateCompanyManagerPositionID IS NOT NULL AND @CreateCompanyManagerPositionID != ''
					BEGIN
						SET @CreateManagerXML.modify('
						insert <PositionID>{sql:variable("@CreateCompanyManagerPositionID")}</PositionID>
						into (/adfEmployeeGet/Employee)[1]') 
					END
					-- ()
					SET @CreateManagerXML.modify('
					insert <CompanyID>{ sql:variable("@CreatedCompanyID")}</CompanyID>
					into (/adfEmployeeGet/Employee)[1]')

					EXEC @rv = adfEmployeeCreate @Xml = @CreateManagerXML, @ExtendedProperties = @CreateEmployeeExtendedProperties,
						@RunningFromMaster = 0
						
					IF @rv != 0
					BEGIN
						ROLLBACK TRANSACTION
						CLOSE company_cursor
						DEALLOCATE company_cursor
						RETURN 1
					END
				END
				
				IF @SpaceCount = 0
				BEGIN
					SET @CreateCompanyManagerID = 
					(	SELECT TOP (1) [ID] 
						FROM [Employee] 
						WHERE [LastName] = @CreateCompanyManagerLastName
							AND [CompanyID] = @CreatedCompanyID )
				END
				ELSE 
					IF @SpaceCount = 1
					BEGIN
						SET @CreateCompanyManagerID = 
						(	SELECT TOP (1) [ID] 
							FROM [Employee] 
							WHERE [FirstName] = @CreateCompanyManagerFirstName 
								AND [LastName] = @CreateCompanyManagerLastName
								AND [CompanyID] = @CreatedCompanyID )
					END
					ELSE
					BEGIN
						SET @CreateCompanyManagerID = 
						(	SELECT TOP (1) [ID] 
							FROM [Employee] 
							WHERE [LastName] = @CreateCompanyManagerLastName
								AND [FirstName] = @CreateCompanyManagerFirstName 
								AND [MiddleName] = @CreateCompanyManagerMiddleName
								AND [CompanyID] = @CreatedCompanyID )
					END
					
				IF EXISTS 
					(	SELECT * FROM [Company] 
						WHERE [ID] = @CreatedCompanyID
							AND [ExecutiveEmployeeID] IS NULL	)
				BEGIN
					SET @CreateCompanyXML.modify('
					insert <ExecutiveEmployeeID>{ sql:variable("@CreateCompanyManagerID") }</ExecutiveEmployeeID>
					into (/adfCompanyGet/Company)[1]')
				END
				
				SET @CreateCompanyManagerName = NULL
			END	

			IF @CreateCompanyChiefAccountantName IS NOT NULL AND @CreateCompanyChiefAccountantName != ''
			BEGIN		
				SET @CreateCompanyChiefAccountantName = LTRIM(RTRIM(REPLACE(@CreateCompanyChiefAccountantName,'.',' ')))
				WHILE @CreateCompanyChiefAccountantName like '%  %'
					SET @CreateCompanyChiefAccountantName =  REPLACE(@CreateCompanyChiefAccountantName,'  ',' ')
				--  ,    ,  
				SELECT @BadChars = N'%[^a-z-0-9 ]%'

				SET @P = PATINDEX(@BadChars, @CreateCompanyChiefAccountantName)
				WHILE @P > 0 BEGIN
					SELECT @CreateCompanyChiefAccountantName = Left(@CreateCompanyChiefAccountantName, @P-1) + SUBSTRING(@CreateCompanyChiefAccountantName, @P+1, 250)
					SET @P = PATINDEX(@BadChars, @CreateCompanyChiefAccountantName)
					END
								
				SET @SpaceCount = (DATALENGTH(@CreateCompanyChiefAccountantName) - DATALENGTH(REPLACE(@CreateCompanyChiefAccountantName,' ','')))/2
				
				IF @SpaceCount = 0
				BEGIN
					SET @CreateCompanyChiefAccountantLastName = @CreateCompanyChiefAccountantName
					SET @CreateCompanyChiefAccountantFirstName = NULL
					SET @CreateCompanyChiefAccountantMiddleName = NULL
				END
				ELSE
					IF @SpaceCount = 1
					BEGIN
						SET @CreateCompanyChiefAccountantLastName = LEFT(@CreateCompanyChiefAccountantName, CHARINDEX(' ',@CreateCompanyChiefAccountantName)-1 )
						SET @CreateCompanyChiefAccountantFirstName = RIGHT(@CreateCompanyChiefAccountantName, len(@CreateCompanyChiefAccountantName)-charindex(' ',@CreateCompanyChiefAccountantName) )
						SET @CreateCompanyChiefAccountantMiddleName = NULL
					END
					ELSE
					BEGIN
						SET @CreateCompanyChiefAccountantLastName = LEFT(@CreateCompanyChiefAccountantName, CHARINDEX(' ',@CreateCompanyChiefAccountantName)-1 )
						SET @CreateCompanyChiefAccountantFirstName = LEFT(RIGHT(@CreateCompanyChiefAccountantName, len(@CreateCompanyChiefAccountantName)-charindex(' ',@CreateCompanyChiefAccountantName) ), CHARINDEX(' ',RIGHT(@CreateCompanyChiefAccountantName, len(@CreateCompanyChiefAccountantName)-charindex(' ',@CreateCompanyChiefAccountantName) ))-1 )
						SET @CreateCompanyChiefAccountantMiddleName = RIGHT(RIGHT(@CreateCompanyChiefAccountantName, len(@CreateCompanyChiefAccountantName)-charindex(' ',@CreateCompanyChiefAccountantName) ), len(RIGHT(@CreateCompanyChiefAccountantName, len(@CreateCompanyChiefAccountantName)-charindex(' ',@CreateCompanyChiefAccountantName) ))-charindex(' ',RIGHT(@CreateCompanyChiefAccountantName, len(@CreateCompanyChiefAccountantName)-charindex(' ',@CreateCompanyChiefAccountantName) )) )
					END		
					
				IF NOT EXISTS 
					(	SELECT * FROM [Employee]
						WHERE [FirstName] = @CreateCompanyChiefAccountantFirstName 
							AND [LastName] = @CreateCompanyChiefAccountantLastName
							AND [CompanyID] = @CreatedCompanyID)
							
				IF (   (@SpaceCount = 0 AND NOT EXISTS 
						(	SELECT * FROM [Employee]
							WHERE [LastName] = @CreateCompanyChiefAccountantLastName
								AND [CompanyID] = @CreatedCompanyID	)	)
					OR (@SpaceCount = 1 AND NOT EXISTS 
						(	SELECT * FROM [Employee]
							WHERE [LastName] = @CreateCompanyChiefAccountantLastName
								AND [FirstName] = @CreateCompanyChiefAccountantFirstName 
								AND [CompanyID] = @CreatedCompanyID	)	)
					OR (@SpaceCount > 1 AND NOT EXISTS 
						(	SELECT * FROM [Employee]
							WHERE [LastName] = @CreateCompanyChiefAccountantLastName
								AND [FirstName] = @CreateCompanyChiefAccountantFirstName 
								AND [MiddleName] = @CreateCompanyChiefAccountantMiddleName
								AND [CompanyID] = @CreatedCompanyID	)	)
					)			
				BEGIN
					--  ()
					SET @CreateChiefAccountantXML.modify('
					insert <LastName>{ sql:variable("@CreateCompanyChiefAccountantLastName") }</LastName>
					into (/adfEmployeeGet/Employee)[1]')
					--  ()
					SET @CreateChiefAccountantXML.modify('
					insert <FirstName>{ sql:variable("@CreateCompanyChiefAccountantFirstName") }</FirstName>
					into (/adfEmployeeGet/Employee)[1]')
					--  ()
					SET @CreateChiefAccountantXML.modify('
					insert <MiddleName>{ sql:variable("@CreateCompanyChiefAccountantMiddleName") }</MiddleName>
					into (/adfEmployeeGet/Employee)[1]')
					--  (FileAs)
					SET @CreateChiefAccountantXML.modify('
					insert <FileAs>{ sql:variable("@CreateCompanyChiefAccountantName")}</FileAs>
					into (/adfEmployeeGet/Employee)[1]')
					
					--  ()
					
						--  
						SET @ManageDictionary = dbo.adfwfGetInitialRight('1da4d0a6-ed0f-4840-9d29-3090013ba2fb')
						SET @HasManageDictionary = dbo.adfHasAccessRightByName(@ManageDictionary)
						IF (@HasManageDictionary = 0)
						BEGIN
							EXEC pjm6SetRightForMasters @ManageDictionary
						END
					
						DECLARE @CreateCompanyChiefAccountantPositionFileAs TName
						SET @CreateCompanyChiefAccountantPositionFileAs = ' '
						
						SET @RES = 0
						SELECT @RES = 1
						WHERE EXISTS(SELECT * FROM [Position] WHERE FileAs = @CreateCompanyChiefAccountantPositionFileAs)
						
						IF @CreateCompanyChiefAccountantPositionFileAs IS NOT NULL AND @CreateCompanyChiefAccountantPositionFileAs != '' AND @RES != 1
						BEGIN
							EXEC @rv = adfPositionCreate @Code=@CreateCompanyChiefAccountantPositionFileAs,
								@FileAs=@CreateCompanyChiefAccountantPositionFileAs, @Comments=NULL
							IF @rv != 0
							BEGIN
								ROLLBACK TRANSACTION
								RETURN 1
							END
						END
						
						SELECT @CreateCompanyChiefAccountantPositionID = [ID]
						FROM [Position]
						WHERE [FileAs] = @CreateCompanyChiefAccountantPositionFileAs
						
						IF @CreateCompanyChiefAccountantPositionID IS NOT NULL AND @CreateCompanyChiefAccountantPositionID != ''
						BEGIN
							SET @CreateChiefAccountantXML.modify('
							insert <PositionID>{sql:variable("@CreateCompanyChiefAccountantPositionID")}</PositionID>
							into (/adfEmployeeGet/Employee)[1]') 
						END

						--  
						IF (@HasManageDictionary = 0)
						BEGIN
							EXEC pjm6DelRightForMasters @ManageDictionary
						END
					
					--  ()
					SET @CreateChiefAccountantXML.modify('
					insert <CompanyID>{ sql:variable("@CreatedCompanyID") }</CompanyID>
					into (/adfEmployeeGet/Employee)[1]')

					EXEC @rv = adfEmployeeCreate @Xml = @CreateChiefAccountantXML, @ExtendedProperties = @CreateEmployeeExtendedProperties,
						@RunningFromMaster = 0
						
					IF @rv != 0
					BEGIN
						ROLLBACK TRANSACTION
						CLOSE company_cursor
						DEALLOCATE company_cursor
						RETURN 1
					END
				END
				
				IF @SpaceCount = 0
				BEGIN
					SET @CreateCompanyChiefAccountantID = 
					(	SELECT TOP (1) [ID] 
						FROM [Employee] 
						WHERE [LastName] = @CreateCompanyChiefAccountantLastName
							AND [CompanyID] = @CreatedCompanyID )
				END
				ELSE 
					IF @SpaceCount = 1
					BEGIN
						SET @CreateCompanyChiefAccountantID = 
						(	SELECT TOP (1) [ID] 
							FROM [Employee] 
							WHERE [FirstName] = @CreateCompanyChiefAccountantFirstName 
								AND [LastName] = @CreateCompanyChiefAccountantLastName
								AND [CompanyID] = @CreatedCompanyID )
					END
					ELSE
					BEGIN
						SET @CreateCompanyChiefAccountantID = 
						(	SELECT TOP (1) [ID] 
							FROM [Employee] 
							WHERE [LastName] = @CreateCompanyChiefAccountantLastName
								AND [FirstName] = @CreateCompanyChiefAccountantFirstName 
								AND [MiddleName] = @CreateCompanyChiefAccountantMiddleName
								AND [CompanyID] = @CreatedCompanyID )
					END
				
				IF EXISTS 
					(	SELECT * FROM [Company] 
						WHERE [ID] = @CreatedCompanyID
							AND [AccountantEmployeeID] IS NULL	)
				BEGIN
					SET @CreateCompanyXML.modify('
					insert <AccountantEmployeeID>{ sql:variable("@CreateCompanyChiefAccountantID") }</AccountantEmployeeID>
					into (/adfCompanyGet/Company)[1]')
				END
				
				SET @CreateCompanyChiefAccountantName = NULL
			END
			
			--     
			DECLARE @CreatedCompanyExportFinanceOnce TBool,
					@CreatedCompanyExchangeBanned TBool,
					@CreatedCompanyState TCode,
					@CreatedCompanyClass TCode
			SELECT 
				@CreatedCompanyExportFinanceOnce = [Company].[ExportFinanceOnce],
				@CreatedCompanyExchangeBanned = [Company].[ExchangeBanned],
				@CreatedCompanyState = [Company].[State]
			FROM
				[Company] 
			WHERE 
				[Company].[ID] = @CreatedCompanyID
			
			SET @CreateCompanyXML.modify('
			insert <ExportFinanceOnce>{sql:variable("@CreatedCompanyExportFinanceOnce")}</ExportFinanceOnce>
			into (/adfCompanyGet/Company)[1]')

			SET @CreateCompanyXML.modify('
			insert <ExchangeBanned>{sql:variable("@CreatedCompanyExchangeBanned")}</ExchangeBanned>
			into (/adfCompanyGet/Company)[1]')
			
			SET @CreateCompanyXML.modify('
			replace value of (/adfCompanyGet/Company[1]/State/text())[1]
			with sql:variable("@CreatedCompanyState")')
			
			SET @CreateCompanyXML.modify('
			replace value of (/adfCompanyGet/Company[1]/ID/text())[1]
			with sql:variable("@CreatedCompanyID")')
			
			SET @CreatedCompanyClass = dbo.adfGetClassByName('Adf.Company')
			SET @CreateCompanyXML.modify('
			insert <Class>{sql:variable("@CreatedCompanyClass")}</Class>
			into (/adfCompanyGet/Company)[1]')
			
			IF ((@ImportMode IS NOT NULL) AND (@IsCreated = 1))
			BEGIN
				DECLARE @CreatedCompanyComment TName
				SET @CreatedCompanyComment = '  ' + CONVERT (NVARCHAR(25), GETDATE(), 4) 
					+ '  ' + CONVERT (NVARCHAR(25), GETDATE(), 108) + '     "' 
					+ (
					SELECT TOP(1) [Login] = 
						CASE [UserID]
							WHEN 1 THEN ''
							ELSE [FileAs]
						END
					FROM [Employee]
					WHERE [UserID] = dbo.adfGetCurrentUserID()
					) + '"';
				SET @CreateCompanyXML.modify('
				insert <Comments>{sql:variable("@CreatedCompanyComment")}</Comments>
				into (/adfCompanyGet/Company)[1]')
			END 
			

			IF @IsCreated = 0
			BEGIN
				SET @CreateCompanyXML.modify('
				insert <Flag>{sql:variable("@CreateCompanyFlagOnUpdate")}</Flag>
				into (/adfCompanyGet/Company)[1]')
			END
			ELSE IF @IsCreated = 1
			BEGIN
				SET @CreateCompanyXML.modify('
				insert <Flag>{sql:variable("@CreateCompanyFlagOnCreate")}</Flag>
				into (/adfCompanyGet/Company)[1]')
			END

			EXEC @rv = adfCompanyFilling @Xml=@CreateCompanyXML, @ExtendedProperties=@CreateCompanyExtendedProperties,
					@CompanyID = @CreatedCompanyID
			IF @rv != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
			
			FETCH NEXT FROM company_cursor INTO 
			@CreateCompanyLegalName,
			@CreateCompanyFileAs,
			@CreateCompanyLegalCode,
			@CreateCompanyKPP,
			@CreateCompanyBIN,
			@CreateCompanyPhone, 
			@CreateCompanyFax, 
			@CreateCompanyStreet, 
			@CreateCompanyCity, 
			@CreateCompanyRegion,
			@CreateCompanyPostalCode,
			@CreateCompanyCountry,
			@CreateCompanyManagerName,
			@CreateCompanyManagerPositionID,
			@CreateCompanyChiefAccountantName,
			@CreateCompanyEmail,
			@CreateCompanyWeb
		END
		CLOSE company_cursor
		DEALLOCATE company_cursor
	END	
		
		
		
	--    
	IF @Xml.exist('(/MasterInfo/BankAccount)[1]') = 1 AND @Xml.exist('(/MasterInfo/Company)[1]') = 1
	BEGIN
		DECLARE @BankAccountFileAs TName		

		SET @BankAccountFileAs = @Xml.query('/MasterInfo/BankAccount/FileAs').value('.', 'TName')
		
		IF @BankAccountFileAs IS NOT NULL AND @BankAccountFileAs != ''
		BEGIN
			DECLARE
				@BankAccountID TIdentifier,
				@BankAccountCurrencyCode TCode3,
				@BankAccountBankName TName,
				@BankAccountBankCode TCode,
				@BankAccountCountry TName,
				@BankAccountCity TCity,
				@BankAccountAddress TName,
				@BankAccountSWIFT TCode,
				@BankAccountABA TCode,
				@BankAccountIBAN TCode,
				@BankAccountAccount TAccount,
				@BankAccountIntermediaryBank TName,
				@BankAccountIntermediaryAddress TName,
				@BankAccountIntermediarySWIFT TCode,
				@BankAccountIntermediaryABA TCode,
				@BankAccountIntermediaryAccount TAccount

			SET @BankAccountCurrencyCode = @Xml.query('/MasterInfo/BankAccount/CurrencyCode').value('.', 'TCode3')
			SET @BankAccountBankName = @Xml.query('/MasterInfo/BankAccount/BankName').value('.', 'TName')
			SET @BankAccountBankCode = @Xml.query('/MasterInfo/BankAccount/BankCode').value('.', 'TCode')
			SET @BankAccountCountry = @Xml.query('/MasterInfo/BankAccount/Country').value('.', 'TName')
			SET @BankAccountCity = @Xml.query('/MasterInfo/BankAccount/City').value('.', 'TCity')
			SET @BankAccountAddress = @Xml.query('/MasterInfo/BankAccount/Address').value('.', 'TName')
			SET @BankAccountSWIFT = @Xml.query('/MasterInfo/BankAccount/SWIFT').value('.', 'TCode')
			SET	@BankAccountABA = @Xml.query('/MasterInfo/BankAccount/ABA').value('.', 'TCode')
			SET @BankAccountIBAN = @Xml.query('/MasterInfo/BankAccount/IBAN').value('.', 'TCode')
			SET @BankAccountAccount = @Xml.query('/MasterInfo/BankAccount/Account').value('.', 'TAccount')
			SET @BankAccountIntermediaryBank = @Xml.query('/MasterInfo/BankAccount/IntermediaryBank').value('.', 'TName')
			SET @BankAccountIntermediaryAddress = @Xml.query('/MasterInfo/BankAccount/IntermediaryAddress').value('.', 'TName')
			SET @BankAccountIntermediarySWIFT = @Xml.query('/MasterInfo/BankAccount/IntermediarySWIFT').value('.', 'TCode')
			SET @BankAccountIntermediaryABA = @Xml.query('/MasterInfo/BankAccount/IntermediaryABA').value('.', 'TCode')
			SET @BankAccountIntermediaryAccount = @Xml.query('/MasterInfo/BankAccount/IntermediaryAccount').value('.', 'TAccount')

			EXEC @rv = adfBankAccountCreate 
				@CompanyID,
				@FileAs=@BankAccountFileAs,
				@CurrencyCode=@BankAccountCurrencyCode,
				@BankName=@BankAccountBankName,
				@BankCode=@BankAccountBankCode,
				@Country=@BankAccountCountry,
				@City=@BankAccountCity,
				@Address=@BankAccountAddress,
				@SWIFT=@BankAccountSWIFT,
				@ABA=@BankAccountABA,
				@IBAN=@BankAccountIBAN,
				@Account=@BankAccountAccount,
				@IntermediaryBank=@BankAccountIntermediaryBank,
				@IntermediaryAddress=@BankAccountIntermediaryAddress,
				@IntermediarySWIFT=@BankAccountIntermediarySWIFT,
				@IntermediaryABA=@BankAccountIntermediaryABA,
				@IntermediaryAccount=@BankAccountIntermediaryAccount,
				@AdditionalAccounts=NULL
			IF @rv != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
			
			SELECT 
				@BankAccountID = [BankAccount].[ID] 
			FROM 
				[BankAccount] 
			WHERE 
				[BankAccount].[FileAs] = @BankAccountFileAs

			SET @CompanyXML.modify('
			insert <BankAccountID>{sql:variable("@BankAccountID")}</BankAccountID>
			into (/adfCompanyGet/Company)[1]')
		END

		DECLARE @Class TCode,
				@ExportFinanceOnce TBool,
				@ExchangeBanned TBool,
				@State TCode
		
		SELECT 
			@ExportFinanceOnce = [Company].[ExportFinanceOnce],
			@ExchangeBanned = [Company].[ExchangeBanned],
			@State = [Company].[State]
		FROM
			[Company] 
		WHERE 
			[Company].[ID] = @CompanyID

		SET @Class = dbo.adfGetClassByName('Adf.Company')
		SET @CompanyXML.modify('
		insert <Class>{sql:variable("@Class")}</Class>
		into (/adfCompanyGet/Company)[1]')

		SET @CompanyXML.modify('
		insert <ExportFinanceOnce>{sql:variable("@ExportFinanceOnce")}</ExportFinanceOnce>
		into (/adfCompanyGet/Company)[1]')

			
		SET @CompanyXML.modify('
		insert <ExchangeBanned>{sql:variable("@ExchangeBanned")}</ExchangeBanned>
		into (/adfCompanyGet/Company)[1]')

		SET @CompanyXML.modify('
		replace value of (/adfCompanyGet/Company[1]/ID/text())[1]
		with sql:variable("@CompanyID")
		')

		SET @CompanyXML.modify('
		replace value of (/adfCompanyGet/Company[1]/State/text())[1]
		with sql:variable("@State")
		')
	
		IF @ExecutiveEmployeeID IS NOT NULL
		BEGIN
			SET @CompanyXML.modify('
			insert <ExecutiveEmployeeID>{sql:variable("@ExecutiveEmployeeID")}</ExecutiveEmployeeID>
			into (/adfCompanyGet/Company)[1]')
		END

		IF @AccountantEmployeeID IS NOT NULL
		BEGIN
			SET @CompanyXML.modify('
			insert <AccountantEmployeeID>{sql:variable("@AccountantEmployeeID")}</AccountantEmployeeID>
			into (/adfCompanyGet/Company)[1]')
		END

		EXEC @rv = adfCompanyUpdate @Xml=@CompanyXML, @ExtendedProperties=@CompanyExtendedProperties
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	COMMIT TRANSACTION
	
	RETURN 0
	
	
GO

GRANT EXEC ON pjm6MasterCreateSystemObjects TO PUBLIC
GO