IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCostCenterBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCostCenterBrowse'
		DROP PROCEDURE [dbo].[adfCostCenterBrowse]
	END
GO

PRINT 'Creating procedure adfCostCenterBrowse'
GO

/******************************************************************************
**		File: adfCostCenterBrowse.sql
**		Name: adfCostCenterBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/07/2004 12:32:27
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfCostCenterBrowse]
	@StateSelector INT
AS
	SET NOCOUNT ON
	SELECT
		[CostCenter].[ID],
		[CostCenter].[Class],
		[CostCenter].[State],
		[CostCenter].[Flag],
		[CostCenter].[Code],
		[CostCenter].[FileAs],
		[CostCenter].[Comments],
		[CostCenter].[Created],
		[CostCenter].[CreatedBy],
		[CostCenter].[Modified],
		[CostCenter].[ModifiedBy],
		[CostCenter].[Timestamp]
	FROM
		[CostCenter]
	WHERE
		((@StateSelector = 0) OR (@StateSelector != 0 AND [CostCenter].[State] = @StateSelector))
		
	RETURN 0
GO

GRANT EXECUTE ON [adfCostCenterBrowse] TO PUBLIC
GO
 
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCostCenterGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCostCenterGet'
		DROP PROCEDURE [dbo].[adfCostCenterGet]
	END
GO

PRINT 'Creating procedure adfCostCenterGet'
GO

/******************************************************************************
**		File: adfCostCenterGet.sql
**		Name: adfCostCenterGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/07/2004 12:32:27
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfCostCenterGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[CostCenter].[ID],
		[CostCenter].[Class],
		[CostCenter].[State],
		[CostCenter].[Flag],
		[CostCenter].[Code],
		[CostCenter].[FileAs],
		[CostCenter].[Comments],
		[CostCenter].[Created],
		[CostCenter].[CreatedBy],
		[CostCenter].[Modified],
		[CostCenter].[ModifiedBy],
		[CostCenter].[Timestamp]
	FROM
		[CostCenter]
	WHERE
		[CostCenter].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [adfCostCenterGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCostCenterCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCostCenterCreate'
		DROP PROCEDURE [dbo].[adfCostCenterCreate]
	END
GO

PRINT 'Creating procedure adfCostCenterCreate'
GO

/******************************************************************************
**		File: adfCostCenterCreate.sql
**		Name: adfCostCenterCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/07/2004 12:32:27
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfCostCenterCreate]
	@Code TCode,
	@FileAs TName,
	@Comments TNotes
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('9132d5cd-abbd-4181-8abb-27379394af12')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	INSERT INTO [CostCenter]
		([Flag], [State], [Code], [FileAs], [Comments])
	VALUES
		(0, @State, @Code, @FileAs, @Comments)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	EXEC adfCostCenterGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfCostCenterCreate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCostCenterUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCostCenterUpdate'
		DROP PROCEDURE [dbo].[adfCostCenterUpdate]
	END
GO

PRINT 'Creating procedure adfCostCenterUpdate'
GO

/******************************************************************************
**		File: adfCostCenterUpdate.sql
**		Name: adfCostCenterUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/07/2004 12:32:27
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfCostCenterUpdate
	@ID TIdentifier,
	@Code TCode,
	@FileAs TName,
	@Comments TNotes
AS
	
	SET NOCOUNT ON
	
	UPDATE 
		[CostCenter]
	SET
		[CostCenter].[Code] = @Code,
		[CostCenter].[FileAs] = @FileAs,
		[CostCenter].[Comments] = @Comments,
		[CostCenter].[Modified] = GETDATE(),
		[CostCenter].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[CostCenter].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	EXEC adfCostCenterGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfCostCenterUpdate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCostCenterDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCostCenterDelete'
		DROP PROCEDURE [dbo].[adfCostCenterDelete]
	END
GO

PRINT 'Creating procedure adfCostCenterDelete'
GO

/******************************************************************************
**		File: adfCostCenterDelete.sql
**		Name: adfCostCenterDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/07/2004 12:32:27
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfCostCenterDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DELETE FROM [CostCenter] WHERE [CostCenter].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON adfCostCenterDelete TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCostCenterChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCostCenterChangeState'
		DROP PROCEDURE [dbo].[adfCostCenterChangeState]
	END
GO

PRINT 'Creating procedure adfCostCenterChangeState'
GO

/******************************************************************************
**		File: adfCostCenterChangeState.sql
**		Name: adfCostCenterChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/07/2004 12:32:27
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfCostCenterChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [CostCenter].[Class],
		@FromState = [CostCenter].[State]
	FROM
		[CostCenter]
	WHERE
		[CostCenter].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE
		[CostCenter]
	SET
		[CostCenter].[State] = @ToState,
		[CostCenter].[Modified] = GETDATE(),
		[CostCenter].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[CostCenter].[ID] = @ID
	AND
		[CostCenter].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON adfCostCenterChangeState TO PUBLIC
GO
