IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].fnPjm7GetDaysBeforeEvent') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm7GetDaysBeforeEvent'
		DROP FUNCTION [dbo].fnPjm7GetDaysBeforeEvent
	END

GO

PRINT 'Creating Function fnPjm7GetDaysBeforeEvent'
GO
/******************************************************************************
**		File:	fnPjm7GetDaysBeforeEvent.sql
**		Name: 	fnPjm7GetDaysBeforeEvent
**		Desc:	returns 
*******************************************************************************
**		Date:		Author:		Description:
**		-----		-------		-------------
**    	23.11.11		ASA		first version
*******************************************************************************/

CREATE FUNCTION fnPjm7GetDaysBeforeEvent(@Eventdate datetime)
RETURNS varchar(3)
BEGIN
	DECLARE
		@Today datetime,
		@EventDay datetime,
		@Days int,
		@Result varchar(3)

	IF(@Eventdate IS NULL)
		RETURN NULL

	SET @Today = GETDATE()
	IF(isdate(datename(year,@Eventdate)+'0229') = 1 AND Datepart(month, @Eventdate) > 2)
	BEGIN
		SET @EventDay = Dateadd(day,datepart(dayofyear,@Eventdate)-2, datename(year,@Today))
	END
	ELSE
	BEGIN
		SET @EventDay = Dateadd(day,datepart(dayofyear,@Eventdate)-1, datename(year,@Today))
	END
	SET @Days = DATEDIFF(DAY,@Today,@EventDay)

	IF(@Days < 0)
	BEGIN
		SET @Days = @Days + 365
	END

	SET @Result = right('000' + CAST(@Days AS varchar(3)),3)

	RETURN @Result
END
GO

GRANT EXEC ON fnPjm7GetDaysBeforeEvent TO PUBLIC
GO
