IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].fnPjm7GetEmployeeBirthdayFormatted') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm7GetEmployeeBirthdayFormatted'
		DROP FUNCTION [dbo].fnPjm7GetEmployeeBirthdayFormatted
	END

GO

PRINT 'Creating Function fnPjm7GetEmployeeBirthdayFormatted'
GO
/******************************************************************************
**		File:	fnPjm7GetEmployeeBirthdayFormatted.sql
**		Name: 	fnPjm7GetEmployeeBirthdayFormatted
**		Desc:	returns 
*******************************************************************************
**		Date:		Author:		Description:
**		-----		-------		-------------
**    	23.11.11	ASA			first version
**		24.05.13	SAI			   
*******************************************************************************/

CREATE FUNCTION fnPjm7GetEmployeeBirthdayFormatted(@Birthdate datetime, @TimeframeSelector int)
RETURNS varchar(64)
BEGIN
DECLARE
		@Language TCode, 
		@CurrentWeek int,
		@NextWeek int,
		@CurrentMonth int,
		@NextMonth int,
		@IsNext2Weeks bit,
		@DateFirstBefore int,
		@Today int,
		@Tomorrow int,
		@JanuaryFirstBirthDate int,
		@JanuaryFirstThisYear int,
		@Adjust int,
		@Result varchar(64),
		@DateThisYear datetime,
		@DateNextYear datetime

	IF(@Birthdate IS NULL)
		RETURN NULL

	SET @CurrentWeek = DATEPART(week, GetDate())
	SET @NextWeek = DATEPART(week, DATEADD(week, 1, GetDate()))
	SET @CurrentMonth = DATEPART(month, GetDate())
	SET @NextMonth = DATEPART(month, DATEADD(month, 1, GetDate()))
	SET @Today = DATEPART(day, GetDate())
	SET @Tomorrow = DATEPART(day, DATEADD(day, 1, GetDate()))
	SET @JanuaryFirstBirthDate = Datepart(dw, CAST(convert(varchar(4),YEAR(@Birthdate))+'-01-01 00:00:00.000' AS datetime))
	SET @JanuaryFirstThisYear = Datepart(dw, CAST(convert(varchar(4),YEAR(GetDate()))+'-01-01 00:00:00.000' AS datetime))
	SET @DateThisYear = DATEADD(year,YEAR(GetDate())-YEAR(@Birthdate),@Birthdate)
	SET @DateNextYear = DATEADD(year,YEAR(GetDate())-YEAR(@Birthdate)+1,@Birthdate)

	--       
	SET @Adjust = @JanuaryFirstThisYear - @JanuaryFirstBirthDate
	--   
	IF(isdate(datename(year,@Birthdate)+'0229') = 1 AND Datepart(month, @Birthdate) > 2)
	BEGIN
		SET @Adjust = @Adjust - 1
	END

	SET @Result = ''
	SET @language = dbo.adfGetLanguage()

	IF(@Language = 'en')
	BEGIN
		IF(DATEPART(day,@Birthdate) = @Today AND DATEPART(month,@Birthdate) = @CurrentMonth)
		BEGIN
			SET @Result = '7Today'
			RETURN @Result
		END
		IF(DATEPART(day,@Birthdate) = @Tomorrow AND DATEPART(month,@Birthdate) = DATEPART(month, DATEADD(day, 1, GetDate())))
		BEGIN
			SET @Result = '6Tomorrow'
			RETURN @Result
		END
		-->
		IF	(
				(DATEPART(week,@DateThisYear) = @CurrentWeek) 
			OR
				(
					MONTH(DATEADD(month,1,GetDate())) = 1
					AND
					(DATEPART(week,@DateNextYear) = 1)
					AND
					(datepart(week,DATEADD(week,1,GetDate())) = 2 )
				)
			)
		BEGIN
			--return ' =>' + cast(datepart(week,@DateThisYear) as varchar)
			--return ' => ***********'
			IF (DATEPART(month,@Birthdate) = @CurrentMonth AND DATEPART(day,@Birthdate) < DATEPART(day,GetDate()) 
			OR 
				(
					DATEPART(month,@Birthdate) < @CurrentMonth
					AND
					MONTH(DATEADD(month,1,GETDATE())) <> 1
				)
			)
			BEGIN
				IF (@TimeframeSelector = 1)
				BEGIN
					RETURN '0Earlier This Week'
				END
				ELSE IF (@TimeframeSelector = 3)
				BEGIN
					RETURN '0Earlier This Month'
				END
				BEGIN
					RETURN '1Later'
				END
			END
			ELSE
			BEGIN
				SET @Result = '5This week'
				RETURN @Result
			END
		END
		-->
		IF	(
				(DATEPART(week,@DateThisYear) = @NextWeek AND datepart(month,DATEADD(month,1,GetDate())) <> 1)
				OR
				(
					MONTH(DATEADD(month,1,GetDate())) = 1
					AND
					(DATEPART(week,@DateNextYear) = 2)
					AND
					(datepart(week,DATEADD(week,1,GetDate())) = 2 )
				)
			)
		BEGIN
			SET @Result = '4Next week'
			RETURN @Result
		END
		IF(DATEPART(month,@Birthdate) = @CurrentMonth)
		BEGIN
			IF(DATEPART(day,@Birthdate) >= DATEPART(day,GetDate()))
			BEGIN
				SET @Result = '3This month'
			END
			ELSE IF(DATEPART(day,@Birthdate) < DATEPART(day,GetDate()))
			BEGIN
				IF (@TimeframeSelector = 3)
				BEGIN
					RETURN '0Earlier This Month'
				END
				ELSE
				BEGIN
					RETURN '1Later'
				END
			END
			RETURN @Result
		END
		IF(DATEPART(month,@Birthdate) = @NextMonth)
		BEGIN
			SET @Result = '2Next month'
			RETURN @Result
		END
		ELSE
		BEGIN
			SET @Result = '1Later'
			RETURN @Result
		END
	END
	ELSE IF(@Language = 'ru')
	BEGIN
		IF(DATEPART(day,@Birthdate) = @Today AND DATEPART(month,@Birthdate) = @CurrentMonth)
		BEGIN
			SET @Result = '7'
			RETURN @Result
		END
		IF(DATEPART(day,@Birthdate) = @Tomorrow AND DATEPART(month,@Birthdate) = DATEPART(month, DATEADD(day, 1, GetDate())) 
			AND DATEPART(year,@Birthdate) = DATEPART(year, DATEADD(day, 1, GetDate())))
		BEGIN
			SET @Result = '6'
			RETURN @Result
		END
		
		-->fixed
		IF	(
				(DATEPART(week,@DateThisYear) = @CurrentWeek) 
			OR
				(
					MONTH(DATEADD(month,1,GetDate())) = 1
					AND
					(DATEPART(week,@DateNextYear) = 1)
					AND
					(datepart(week,DATEADD(week,1,GetDate())) = 2 )
				)
			)
		BEGIN
			--return ' =>' + cast(datepart(week,@DateThisYear) as varchar)
			--return ' => ***********'
			IF (DATEPART(month,@Birthdate) = @CurrentMonth AND DATEPART(day,@Birthdate) < DATEPART(day,GetDate()) 
			OR 
				(
					DATEPART(month,@Birthdate) < @CurrentMonth
					AND
					MONTH(DATEADD(month,1,GETDATE())) <> 1
				)
			)
			BEGIN
				IF (@TimeframeSelector = 1)
				BEGIN
					RETURN '0   '
				END
				ELSE IF (@TimeframeSelector = 3)
				BEGIN
					RETURN '0   '
				END
				BEGIN
					RETURN '1'
				END
			END
			ELSE IF(DATEPART(year,@Birthdate) > DATEPART(year, DATEADD(day, 1, GetDate())))
			BEGIN
				RETURN '1'
			END
			ELSE IF(DATEPART(year,@Birthdate) > DATEPART(year, DATEADD(day, 1, GetDate())))
			BEGIN
				RETURN '1'
			END
			ELSE
			BEGIN
				SET @Result = '5  '
				RETURN @Result
			END
		END

		-->fixed
		IF	(
				(DATEPART(week,@DateThisYear) = @NextWeek AND datepart(month,DATEADD(month,1,GetDate())) <> 1
				AND DATEPART(year,@Birthdate) = DATEPART(year, DATEADD(day, 1, GetDate())))
				OR
				(
					MONTH(DATEADD(month,1,GetDate())) = 1
					AND
					(DATEPART(week,@DateNextYear) = 2)
					AND
					(datepart(week,DATEADD(week,1,GetDate())) = 2 )
				)
			)
		BEGIN
		--return ' =>' + cast(DATEPART(week,@DateNextYear) as varchar)
			SET @Result = '4  '
			RETURN @Result
		END

		IF(DATEPART(month,@Birthdate) = @CurrentMonth)
		BEGIN
			IF(DATEPART(day,@Birthdate) >= DATEPART(day,GetDate()))
			BEGIN
				SET @Result = '3  '
			END
			ELSE IF(DATEPART(day,@Birthdate) < DATEPART(day,GetDate()))
			BEGIN
				IF (@TimeframeSelector = 3)
				BEGIN
					RETURN '0   '
				END
				ELSE
				BEGIN
					RETURN '1'
				END
			END
			RETURN @Result
		END
		IF(DATEPART(month,@Birthdate) = @NextMonth)
		BEGIN
			--return ' =>' + cast(DATEPART(week,@DateNextYear) as varchar)
			SET @Result = '2  '
			RETURN @Result
		END
		ELSE
		BEGIN
			SET @Result = '1'
			RETURN @Result
		END
	END	
	RETURN @Result
END
GO

GRANT EXEC ON fnPjm7GetEmployeeBirthdayFormatted TO PUBLIC
GO
