IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfClassList')
	BEGIN
		PRINT 'Dropping Procedure adfClassList'
		DROP  Procedure  adfClassList
	END

GO

PRINT 'Creating Procedure adfClassList'
GO
/******************************************************************************
**		File: 
**		Name: adfClassList
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfClassList
AS
	SET NOCOUNT ON

	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SELECT
		[Class].[Class],
		[Class].[Code],
		ISNULL([ClassGlobal].[Name], [Class].[Name]) as [Name]
	FROM
		[Class] LEFT OUTER JOIN [ClassGlobal]
			ON ([Class].[Class] = [ClassGlobal].[Class] AND [ClassGlobal].[Language] = @Lang)
	RETURN 0
GO

GRANT EXEC ON adfClassList TO PUBLIC
GO

IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmClassList')
	BEGIN
		PRINT 'Dropping Procedure lmClassList'
		DROP  Procedure  lmClassList
	END
GO
PRINT 'Creating Procedure lmClassList'
GO
/******************************************************************************
**		File: 
**		Name: lmClassList
**		Desc: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure lmClassList
AS
	SET NOCOUNT ON

	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SELECT
		[Class].[Class],
		[Class].[Code],
		ISNULL([ClassGlobal].[Name], [Class].[Name]) as [Name],
		[Class].[Guid]
	FROM
		[Class]
		LEFT OUTER JOIN [ClassGlobal]
			ON ([Class].[Class] = [ClassGlobal].[Class] AND [ClassGlobal].[Language] = @Lang)

	RETURN 0
GO

GRANT EXEC ON lmClassList TO PUBLIC
GO
