IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfTransitionList')
	BEGIN
		PRINT 'Dropping Procedure adfTransitionList'
		DROP  Procedure  adfTransitionList
	END

GO

PRINT 'Creating Procedure adfTransitionList'
GO
/******************************************************************************
**		File: 
**		Name: adfTransitionList
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfTransitionList
AS
	SET NOCOUNT ON
	SELECT
		[tt].[ID],
		[c].[Name] + ': ' +
			ISNULL(dbo.adfGetStateName(tt.[Class], tt.[FromState]), '( )') +
			' -> ' +
			ISNULL(dbo.adfGetStateName(tt.[Class], tt.[ToState]), '( )') as [TransitionName],
		[c].[Name] as [ClassName],
		[tt].[FromState],
		[tt].[ToState],
		[tt].[Name]
	FROM
		[adfvwTransitionTemplate] tt INNER JOIN [adfvwClass] c
			ON ([tt].[Class] = [c].[Class])
	RETURN 0
GO

GRANT EXEC ON adfTransitionList TO PUBLIC
GO
