IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfClassBrowse')
	BEGIN
		PRINT 'Dropping Procedure adfClassBrowse'
		DROP  Procedure  adfClassBrowse
	END

GO

PRINT 'Creating Procedure adfClassBrowse'
GO
/******************************************************************************
**		File: 
**		Name: adfClassBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfClassBrowse
AS
	DECLARE @Class TClass
	SET NOCOUNT ON
	
	SET @Class = dbo.adfGetClassByName('Adf.Class')
	
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SELECT
		[Class].[Class] as [ClassID],
		@Class as [Class],
		[Class].[CreatedBy],
		[Class].[ModifiedBy],
		[Class].[Created],
		[Class].[Modified],
		[Class].[Code],
		ISNULL([ClassGlobal].[Name], [Class].[Name]) as [Name],
		[Class].[TableName],
		[Class].[Guid] as [ClassGuid],
		ISNULL([ClassGlobal].[Comments], [Class].[Comments]) as [Comments],
		CAST(1 as INT) as [State]
	FROM
		[Class] LEFT OUTER JOIN [ClassGlobal]
			ON ([Class].[Class] = [ClassGlobal].[Class] AND [ClassGlobal].[Language] = @Lang)
		
	RETURN 0
GO

GRANT EXEC ON adfClassBrowse TO PUBLIC
GO
