IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfClassGet')
	BEGIN
		PRINT 'Dropping Procedure adfClassGet'
		DROP  Procedure  adfClassGet
	END

GO

PRINT 'Creating Procedure adfClassGet'
GO
/******************************************************************************
**		File: 
**		Name: adfClassGet
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfClassGet
	@Class TClass
AS
	DECLARE @C as TClass
	
	SET NOCOUNT ON
	
	SET @C = dbo.adfGetClassByName('Adf.Class')
	
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SELECT
		[Class].[Class] as [ClassID],
		@C as [Class],
		[Class].[CreatedBy],
		[Class].[ModifiedBy],
		[Class].[Created],
		[Class].[Modified],
		[Class].[Code],
		ISNULL([ClassGlobal].[Name], [Class].[Name]) as [Name],
		[Class].[CodeIsUnique],
		[Class].[CodeIsNullable],
		[Class].[TableName],
		[Class].[Guid] as [ClassGuid],
		ISNULL([ClassGlobal].[Comments], [Class].[Comments]) as [Comments],
		[Class].[SmallImage],
		[Class].[LargeImage],
		[Class].[SPBrowse], 
		[Class].[SPGet], 
		[Class].[SPCreate], 
		[Class].[SPUpdate], 
		[Class].[SPChangeState], 
		[Class].[SPDelete],
		CAST(1 as INT) as [State]
	FROM
		[Class] LEFT OUTER JOIN [ClassGlobal]
			ON ([Class].[Class] = [ClassGlobal].[Class] AND [ClassGlobal].[Language] = @Lang)
	WHERE
		[Class].[Class] = @Class
		
	SELECT
		[State].[Class] as [ClassID],
		[State].[State],
		ISNULL([StateGlobal].[Name], [State].[Name]) as [Name]
	FROM
		[State] LEFT OUTER JOIN [StateGlobal]
			ON ([State].[Class] = [StateGlobal].[Class] AND [State].[State] = [StateGlobal].[State] AND
				[StateGlobal].[Language] = @Lang)
	WHERE
		[State].[Class] = @Class
	ORDER BY
		[State].[State]

	RETURN 0
GO

GRANT EXEC ON adfClassGet TO PUBLIC
GO
