IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfRoleMemberDelete')
	BEGIN
		PRINT 'Dropping Procedure adfRoleMemberDelete'
		DROP  Procedure  adfRoleMemberDelete
	END

GO

PRINT 'Creating Procedure adfRoleMemberDelete'
GO
/******************************************************************************
**		File: 
**		Name: adfRoleMemberDelete
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfRoleMemberDelete
	@RoleName TSysname,
	@UserName TSysname,
	@UserID TIdentifier = NULL
AS
	DECLARE @result INT,
			@RoleID TIdentifier
	
	SET NOCOUNT ON

	EXEC @result = adfAccessRightCheck 'ManageUsers'
	IF @result != 0
		RETURN @result
	
	SET @RoleID = dbo.adfGetRoleID(@RoleName)
	
	IF @RoleID = 0
	BEGIN
		RETURN 1
	END
	
	IF @UserID IS NULL
		SET @UserID = dbo.adfGetUserID(@UserName)
	
	DELETE  
		[UserRole]
	WHERE 
		[RoleID] = @RoleID AND 
		[UserID] = @UserID

	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END
	
	RETURN 0
GO

GRANT EXEC ON adfRoleMemberDelete TO PUBLIC
GO
