IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfUserMappingBrowse')
	BEGIN
		PRINT 'Dropping Procedure adfUserMappingBrowse'
		DROP  Procedure  adfUserMappingBrowse
	END

GO

PRINT 'Creating Procedure adfUserMappingBrowse'
GO
/******************************************************************************
**		File: 
**		Name: adfUserMappingBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfUserMappingBrowse
	@UserID TIdentifier
AS
	DECLARE @result INT
			
	SET NOCOUNT ON

	EXEC @result = adfAccessRightCheck 'ManageUsers'
	IF @result != 0
		RETURN @result

	SELECT
		[ID],
		[UserID],
		[NTLogin]
	FROM
		[UserNTLoginMapping]
	WHERE
		@UserID IS NULL OR [UserID] = @UserID
	RETURN 0
GO

IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfUserMappingCreate')
	BEGIN
		PRINT 'Dropping Procedure adfUserMappingCreate'
		DROP  Procedure  adfUserMappingCreate
	END

GO

PRINT 'Creating Procedure adfUserMappingCreate'
GO
/******************************************************************************
**		File: 
**		Name: adfUserMappingCreate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfUserMappingCreate
	@UserID TIdentifier,
	@NTLogin TSysname,
	@ID TIdentifier OUTPUT
AS
	DECLARE @result INT
			
	SET NOCOUNT ON

	EXEC @result = adfAccessRightCheck 'ManageUsers'
	IF @result != 0
		RETURN @result

	IF EXISTS(SELECT * FROM [UserNTLoginMapping] WHERE [NTLogin]=@NTLogin)
	BEGIN
		RAISERROR('#UserLoginMustBeUnique', 16, -1)
		RETURN 1
	END
	
	INSERT INTO [UserNTLoginMapping] ([UserID], [NTLogin]) VALUES(@UserID, @NTLogin)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END
	SET @ID = SCOPE_IDENTITY()
	
	RETURN 0
GO

IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfUserMappingDelete')
	BEGIN
		PRINT 'Dropping Procedure adfUserMappingDelete'
		DROP  Procedure  adfUserMappingDelete
	END

GO

PRINT 'Creating Procedure adfUserMappingDelete'
GO
/******************************************************************************
**		File: 
**		Name: adfUserMappingDelete
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfUserMappingDelete
	@ID TIdentifier
AS
	DECLARE @result INT
			
	SET NOCOUNT ON

	EXEC @result = adfAccessRightCheck 'ManageUsers'
	IF @result != 0
		RETURN @result

	DELETE [UserNTLoginMapping] WHERE [ID] = @ID
	RETURN 0
GO


