IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfUserUpdate')
	BEGIN
		PRINT 'Dropping Procedure adfUserUpdate'
		DROP  Procedure  adfUserUpdate
	END

GO

PRINT 'Creating Procedure adfUserUpdate'
GO
/******************************************************************************
**		File: 
**		Name: adfUserUpdate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfUserUpdate
	@ID TIdentifier,
	@Name TSysname,
	@DisplayName TName,
	@SQLLogin TSysname,
	@NTLogin TSysname,
	@Locked TBool
AS
	DECLARE @result INT
	
	SET NOCOUNT ON

	EXEC @result = adfAccessRightCheck 'ManageUsers'
	IF @result != 0
		RETURN @result

	IF @Locked = 0 AND NOT EXISTS(SELECT * FROM [Employee] WHERE [UserID] = @ID AND [State] = 1)
	BEGIN
		RAISERROR('#UserIsNotAssociateWithWorkingEmployee', 18, -1)
		RETURN 1
	END

	UPDATE [Trustee]
	SET
		[Name] = @Name,
		[DisplayName] = @DisplayName
	WHERE
		[Trustee].[ID] = @ID
		
	IF @@ERROR != 0 
	BEGIN
		RETURN 1
	END
	
	UPDATE [User]
	SET
		[SQLLogin] = @SQLLogin,
		[NTLogin] = @NTLogin,
		[Locked] = (CASE WHEN @Locked IS NULL THEN [Locked] ELSE @Locked END)
	WHERE
		[User].[ID] = @ID
		
	IF @@ERROR != 0 
	BEGIN
		RETURN 1
	END
	
	IF @Locked IS NOT NULL
		EXEC adfUserGet @Name
	
	RETURN 0
GO

