IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfuiCommandGet')
	BEGIN
		PRINT 'Dropping Procedure adfuiCommandGet'
		DROP  Procedure  adfuiCommandGet
	END

GO

PRINT 'Creating Procedure adfuiCommandGet'
GO
/******************************************************************************
**		File: 
**		Name: adfuiCommandGet
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfuiCommandGet
	@ID TIdentifier
AS
	DECLARE @Class TClass
	SET NOCOUNT ON

	SET @Class = dbo.adfGetClassByName('Adf.Command')

	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SELECT 
		[UICommand].[ID],
		@Class as [Class],
		[UICommand].[Class] as [ClassID],
		[UICommand].[ActionID],
		[UICommand].[Name],
		ISNULL([UICommandGlobal].[Text], [UICommand].[Text]) as [Text],
		ISNULL([UICommandGlobal].[AlternateText], [UICommand].[AlternateText]) as [AlternateText],
		[UICommand].[Picture],
		[UICommand].[Shortcut],
		ISNULL([UICommandGlobal].[Comments], [UICommand].[Comments]) as [Comments],
		[UICommand].[Position],
		[UICommand].[BeginGroup],
		1 as [State]
	FROM 
		[UICommand]  LEFT OUTER JOIN [UICommandGlobal]
			ON ([UICommand].[ID] = [UICommandGlobal].[ID] AND [UICommandGlobal].[Language] = @Lang)
	WHERE
		[UICommand].[ID] = @ID
		
	RETURN 0
GO

GRANT EXEC ON adfuiCommandGet TO PUBLIC
GO
