
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'RemovedDocument') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: RemovedDocument                                       */
/*==============================================================*/
create table RemovedDocument (
   ID                   TIdentifier          identity,
   DocumentClass        TClass               not null,
   DocumentID           TIdentifier          not null,
   DocumentNumber	    TName                null,
   DocumentDate         TDate                null,
   [Date]               TDate                not null,
   constraint RemovedDocumentPK primary key  (ID)
)
go

IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'IncomingNumber' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Payment')
	ALTER TABLE [Payment] ADD [IncomingNumber] TCode NULL
GO

IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'IncomingDate' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Payment')
	ALTER TABLE [Payment] ADD [IncomingDate] TDate NULL
GO

IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'ExchangeBanned' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Invoice')
	ALTER TABLE [Invoice] ADD [ExchangeBanned] TBool NOT NULL DEFAULT 0
GO

IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'ExchangeBanned' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Statement')
	ALTER TABLE [Statement] ADD [ExchangeBanned] TBool NOT NULL DEFAULT 0
GO

IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'ExchangeBanned' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Facture')
	ALTER TABLE [Facture] ADD [ExchangeBanned] TBool NOT NULL DEFAULT 0
GO


------------------------------  
IF EXISTS (SELECT * FROM syscolumns WHERE [name] = 'Exported' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Invoice')
	ALTER TABLE [Invoice] DROP COLUMN [Exported]
GO

IF EXISTS (SELECT * FROM syscolumns WHERE [name] = 'Exported' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Statement')
	ALTER TABLE [Statement] DROP COLUMN [Exported]
GO

IF EXISTS (SELECT * FROM syscolumns WHERE [name] = 'Exported' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Facture')
	ALTER TABLE [Facture] DROP COLUMN [Exported]
GO

IF EXISTS (SELECT * FROM syscolumns WHERE [name] = 'ExportedBy' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Invoice')
	ALTER TABLE [Invoice] DROP COLUMN [ExportedBy]
GO

IF EXISTS (SELECT * FROM syscolumns WHERE [name] = 'ExportedBy' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Statement')
	ALTER TABLE [Statement] DROP COLUMN [ExportedBy]
GO

IF EXISTS (SELECT * FROM syscolumns WHERE [name] = 'ExportedBy' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Facture')
	ALTER TABLE [Facture] DROP COLUMN [ExportedBy]
GO

IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'ExportItemID' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Invoice')
	ALTER TABLE [Invoice] ADD [ExportItemID] TIdentifier NULL
GO

IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'ExportItemID' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Statement')
	ALTER TABLE [Statement] ADD [ExportItemID] TIdentifier NULL
GO

IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'ExportItemID' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Facture')
	ALTER TABLE [Facture] ADD [ExportItemID] TIdentifier NULL
GO
------------------------------   ()


IF NOT EXISTS (SELECT * FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Name] = 'ExportFinanceOnce')
BEGIN
	DECLARE @true bit
	SET @true = 1
	EXEC adfParameterSet 'ExportFinanceOnce', 'Pjm6', @true
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'ExportItem') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: ExportItem                                            */
/*==============================================================*/
create table ExportItem (
   ID                   TIdentifier       identity,
   Date                 TDate             not null default GETDATE(),
   EmployeeID           TIdentifier       not null,
   ExportTypeID         TIdentifier       not null,
   CompanyID            TIdentifier       not null,
   PeriodStart          TDate             not null,
   PeriodEnd            TDate             not null,
   constraint ExportItemPK primary key (ID)
)
go

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'ExportType') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: ExportType                                            */
/*==============================================================*/
create table ExportType (
   ID                   TIdentifier       identity,
   Name                 TName			  not null,
   Name2				TName			  not null,
   constraint ExportTypePK primary key (ID)
)
go

IF NOT EXISTS(SELECT * FROM [ExportType])
BEGIN
	SET IDENTITY_INSERT [ExportType] ON
	INSERT INTO [ExportType] ([ID], [Name], [Name2]) VALUES(1, ' ', 'for period')
	INSERT INTO [ExportType] ([ID], [Name], [Name2]) VALUES(2, '   ', 'from last export date')
	INSERT INTO [ExportType] ([ID], [Name], [Name2]) VALUES(3, ' ', 'single document')
	SET IDENTITY_INSERT [ExportType] OFF
END
GO