ALTER TABLE [Issue] DISABLE TRIGGER ALL
GO

IF EXISTS(
	SELECT * 
	FROM [Issue] 
	WHERE 
		([State] = 5 AND [EndTime] = [Modified]) OR
		([State] = 4 AND [EndTime] != [Modified])
	)
BEGIN
	UPDATE [Issue] SET [EndTime] = NULL;

	WITH [Executed] ([ID], [EndTime]) AS
	(
		SELECT
			[Issue].[ID],
			MAX([Transition].[Created])
		FROM
			[Issue]
			INNER JOIN [Transition]
				ON [Transition].[Class] = [Issue].[Class] AND
					[Transition].[DocumentID] = [Issue].[ID]
			INNER JOIN [TransitionTemplate]
				ON [Transition].[TransitionTemplateID] = [TransitionTemplate].[ID] AND
					[TransitionTemplate].[ToState] = 4
		WHERE
			[Issue].[State] IN (4, 5)
		GROUP BY
			[Issue].[ID]
	)
	UPDATE
		[Issue]
	SET
		[Issue].[EndTime] = [Executed].[EndTime]
	FROM
		[Issue]
		INNER JOIN [Executed]
			ON [Executed].[ID] = [Issue].[ID]
END
GO

ALTER TABLE [Issue] ENABLE TRIGGER ALL
GO
