IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'DocumentCardID' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='TaskRequest')
	ALTER TABLE [TaskRequest] ADD [DocumentCardID] TIdentifier NULL
GO

IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'EmployeeID' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='TaskRequest')
	ALTER TABLE [TaskRequest] ADD [EmployeeID] TIdentifier NULL
GO

IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'SupervisorEmployeeID' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='TaskRequest')
	ALTER TABLE [TaskRequest] ADD [SupervisorEmployeeID] TIdentifier NULL
GO

IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'EndTime' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='TaskRequest')
	ALTER TABLE [TaskRequest] ADD [EndTime] TDateTime NULL
GO

IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'Resolution' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='TaskRequest')
	ALTER TABLE [TaskRequest] ADD [Resolution] TNotes NULL
GO

IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'DocumentEditAccess' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='TaskRequest')
	ALTER TABLE [TaskRequest] ADD [DocumentEditAccess] TBool not null default 0
GO

IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'Accepted' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='TaskRequestAssignment')
	ALTER TABLE [TaskRequestAssignment] ADD [Accepted] TBool not null default 0
GO

IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'PercentComplete' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='TaskRequestAssignment')
	ALTER TABLE [TaskRequestAssignment] ADD [PercentComplete] TPercent not null default 0
GO

IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'Resolution' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='TaskRequestAssignment')
	ALTER TABLE [TaskRequestAssignment] ADD [Resolution] TNotes null
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'TaskRequestAssignmentResponse') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	/*==============================================================*/
	/* Table: TaskRequestAssignmentResponse                         */
	/*==============================================================*/
	create table TaskRequestAssignmentResponse (
	   TaskRequestID        TIdentifier          not null,
	   EmployeeID           TIdentifier          not null,
	   Response             TIdentifier          not null default 0
	   constraint TaskRequestAssignmentResponsePK primary key  (TaskRequestID, EmployeeID)
	)
	INSERT INTO [TaskRequestAssignmentResponse] ([TaskRequestID], [EmployeeID], [Response])
	SELECT 
		[TaskRequestID], [EmployeeID], [Accepted]
	FROM
		[TaskRequestAssignment] 
END
ELSE
BEGIN
	DELETE 
		[TaskRequestAssignmentResponse]
	WHERE [TaskRequestID] NOT IN (SELECT [ID] FROM [TaskRequest])

END
go

