SET QUOTED_IDENTIFIER ON
GO

IF NOT EXISTS(SELECT * FROM master.sys.databases WHERE name = DB_NAME() 
			  AND is_broker_enabled = 1)
BEGIN
	DECLARE @sql nvarchar(4000);
	SET @sql = N'USE [master]; ALTER DATABASE [' + DB_NAME() +  N'] SET NEW_BROKER; USE [' + DB_NAME() + '];';
	EXECUTE(@sql)
	
	SET @sql = N'USE [master]; ALTER DATABASE [' + DB_NAME() +  N'] SET ENABLE_BROKER; USE [' + DB_NAME() + '];';
	EXECUTE(@sql)
END;
GO

IF NOT EXISTS (SELECT * FROM sys.service_message_types WHERE name = N'http://schemas.projectmate.ru/Notifications/DocumentChangeEvent')
BEGIN
	CREATE MESSAGE TYPE [http://schemas.projectmate.ru/Notifications/DocumentChangeEvent]
		VALIDATION = WELL_FORMED_XML;
END
GO

IF  NOT EXISTS (SELECT * FROM sys.service_contracts WHERE name = N'http://schemas.projectmate.ru/Notifications/PostEventNotification')
BEGIN
	CREATE CONTRACT [http://schemas.projectmate.ru/Notifications/PostEventNotification] 
	(
		[http://schemas.projectmate.ru/Notifications/DocumentChangeEvent] SENT BY ANY
	);
END
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[pjm5ProcessNotificationEvents]') AND type in (N'P', N'PC'))
BEGIN
	DROP PROCEDURE [dbo].[pjm5ProcessNotificationEvents]
END
GO

CREATE PROCEDURE [pjm5ProcessNotificationEvents]
AS
BEGIN
	RETURN 0;
END
GO

IF  NOT EXISTS (SELECT * FROM sys.service_queues WHERE name = N'ProjectMateEventNotificationQueue')
BEGIN
	CREATE QUEUE [ProjectMateEventNotificationQueue] WITH 
		STATUS = ON,
		ACTIVATION (
			STATUS = ON, 
			PROCEDURE_NAME = pjm5ProcessNotificationEvents, 
			MAX_QUEUE_READERS = 1,
			EXECUTE AS OWNER
		);
END
GO

IF NOT EXISTS (SELECT * FROM sys.services WHERE name = N'http://schemas.projectmate.ru/Notifications/EventNotificationService')
BEGIN
	CREATE SERVICE [http://schemas.projectmate.ru/Notifications/EventNotificationService] 
		ON QUEUE [ProjectMateEventNotificationQueue] 
		(
		[http://schemas.projectmate.ru/Notifications/PostEventNotification] 
		);
END
GO