﻿if exists (select * from dbo.sysobjects where id = object_id(N'[exch].[TimeEntryFind]') and objectproperty(id, N'IsProcedure') = 1)
begin
	print 'Dropping procedure TimeEntryFind'
	drop procedure [exch].[TimeEntryFind]
end
go

print 'Creating procedure TimeEntryFind'
go

create procedure [exch].[TimeEntryFind] @UserID TIdentifier, @XData xml, @ID TIdentifier output
with execute as 'pjmexchangesync'
as
begin	
	declare @Class TClass, @FileAs TName, @Start TDateTime, @End TDateTime, @EmployeeID TIdentifier, @Duration TCount, @Count int;

	set nocount on;

	set @Class = dbo.adfGetClassByName('Pjm5.TimeEntry');

	select
		@FileAs = T.C.value('@FileAs', 'TName'),
		@Start = T.C.value('@Start', 'TDateTime'),
		@End = T.C.value('@End', 'TDateTime')
	from
		@XData.nodes('TimeEntry') T(C);

	select
		@EmployeeID = [Employee].[ID]
	from 
		[Employee] 
	where 
		[Employee].[UserID] = @UserID 
	and
		[Employee].[State] = 1;
	
	set @Duration = datediff(minute, @Start, @End);

	select 
		@ID = min([ID]),
		@Count = count(*)
	from
		[dbo].[TimeEntry]
	where
		[EmployeeID] = @EmployeeID and [StartTime] = @Start and [Duration] = @Duration and [FileAs] = @FileAs;

	if @Count = 1
	begin
		exec [exch].[TimeEntryGet] @UserID, @ID;
		return 0;
	end
	else 
	begin
		declare @xml xml;
		set @ID = null;
		set @xml = N'<TimeEntry />';
		select @xml;
		return 1;
	end
end
go


grant execute on [exch].[TimeEntryFind] to [projectmateservice];
go
