IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].fnPjm6GetBudgetTotalWithVATWD') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6GetBudgetTotalWithVATWD'
		DROP FUNCTION [dbo].fnPjm6GetBudgetTotalWithVATWD
	END

GO

PRINT 'Creating function fnPjm6GetBudgetTotalWithVATWD'
GO
/******************************************************************************
**		File:	fnPjm6GetBudgetVATForTotal.sql
**		Name: 	fnPjm6GetBudgetVATForTotal
**		Desc:	returns formatted time interval
*******************************************************************************
**		Date:		Author:		Description:
**		-----		-------		-------------
**    	18.02.11		PAM		first version
*******************************************************************************/

CREATE FUNCTION fnPjm6GetBudgetTotalWithVATWD(
	@VATRate			TPercent,
	@VATIsIncluded		TBool,
	@DiscountView		TBool,
	@DiscountPercent	TMoney,
	@DiscountTotal		TMoney,
	@Total				TMoney,
	@TotalWithVAT		TMoney)
RETURNS TMoney
BEGIN
	DECLARE
		@totalSum			TMoney
		
		SET @totalSum = 
			(CASE 
				WHEN @VATRate IS NOT NULL AND @VATIsIncluded = 1 THEN 
					dbo.fnPjm6GetBudgetTotalWithDiscount(@VATRate, @VATIsIncluded, @DiscountView, @DiscountPercent, @DiscountTotal, @Total, @TotalWithVAT)
				ELSE
					dbo.fnPjm6GetBudgetTotalWithDiscount(@VATRate, @VATIsIncluded, @DiscountView, @DiscountPercent, @DiscountTotal, @Total, @TotalWithVAT) +
					dbo.fnPjm6GetBudgetVATForTotal(@VATRate, @VATIsIncluded, @DiscountView, @DiscountPercent, @DiscountTotal, @Total, @TotalWithVAT)
		END)
		
	RETURN @totalSum
END
GO

GRANT EXEC ON fnPjm6GetBudgetTotalWithVATWD TO PUBLIC
GO