﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm7GetLocalDate]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm7GetLocalDate'
		DROP FUNCTION [dbo].[fnPjm7GetLocalDate]
	END

GO

PRINT 'Creating function fnPjm7GetLocalDate'
GO
/******************************************************************************
**		File: fnPjm7GetLocalDate.sql
**		Name: fnPjm7GetLocalDate
**		Desc: Функция возвращает текущую дату с учетом часового пояса, указанного
**			в карточке сотрудника
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: anton.paramonov
**		Date: 16.07.2012 11:20
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm7GetLocalDate
(  
)

RETURNS TDate

AS
BEGIN

	DECLARE 
		@TimeZoneOffset int,
		@CurrentEmployeeID TIdentifier

	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()

	SELECT @TimeZoneOffset = ISNULL([TimeZoneOffset], 0) FROM [EmployeeTimeZone] WHERE [EmployeeID] = @CurrentEmployeeID

	RETURN DATEADD(minute, @TimeZoneOffset, GETUTCDATE())

END