IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5IsProjectMember]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5IsProjectMember'
		DROP FUNCTION [dbo].[fnPjm5IsProjectMember]
	END

GO

PRINT 'Creating function fnPjm5IsProjectMember'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5IsProjectMember
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5IsProjectMember
	(@ProjectID TIdentifier, @EmployeeID TIdentifier)
RETURNS BIT
AS
BEGIN
	DECLARE @result BIT
	IF @EmployeeID IS NULL
		SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
		
	IF EXISTS(
		SELECT * 
		FROM [vwAssignment] 
		WHERE 
			[ProjectID] = @ProjectID AND 
			[EmployeeID] = @EmployeeID AND 
			[State] = 1
		)
		SET @result = 1
	ELSE
		SET @result = 0
	
	RETURN @result
END
GO

GRANT EXEC ON fnPjm5IsProjectMember TO PUBLIC
GO
