IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6GetAvailableProjectsForBrowse]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function pjm6GetAvailableProjectsForBrowse'
		DROP FUNCTION [dbo].[pjm6GetAvailableProjectsForBrowse]
	END

GO

PRINT 'Creating function pjm6GetAvailableProjectsForBrowse'
GO
/******************************************************************************
**		File:	fnPjm6GetAvailableProjectsForBrowse.sql
**		Name: 	pjm6GetAvailableProjectsForBrowse
**		Desc:	      
**				      
**			       
**
*******************************************************************************
**		Date:		Author:		Description:
**		-----		-------		-------------
**    	31.03.09	ENB			 
**		13.07.11	SYV			   UseSubProjects
**		03.04.13	SOV			    . - 
**								     " "
**		07.05.13	SOV			 ,      
								" -"    , -   - 
*******************************************************************************/
CREATE FUNCTION pjm6GetAvailableProjectsForBrowse (
	@ManagerID  TIdentifier = NULL,
	@StateSelector INT = 0,
	@WithAddingOfAllSubprojects TBool --     ,
								-- -   -  ?
)

RETURNS @Projects TABLE (
		[ID] INT PRIMARY KEY,	
		[ViewFinance] INT NOT NULL DEFAULT 0,
		[ParentProjectID] INT
)

AS 

BEGIN

	DECLARE 
		@today	datetime, 
		@ViewFinance TBool,
		@ViewAllFinance TBool,
		@HasManageProject TBool, 
     	@CurrentEmployeeID  TIdentifier
		--@UseSubProjects		TBool,
		--@value				TVariant

--   
	--EXEC adfParameterGet @Name='UseSubProjects', @Group='Pjm6', @Value = @value OUTPUT
	--SET @UseSubProjects = ISNULL(CAST(@value as bit), 0)
		
	SET @today = GETDATE()
	SET @HasManageProject = dbo.adfHasAccessRight(dbo.adfGetRightID('ManageProject'))
	SET @ViewFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewFinance')) 
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance')) 
	
	INSERT INTO @Projects ( 
		[ID], 
		[ViewFinance],
		[ParentProjectID]
	) 
	SELECT
		[Project].[ID],
--	 ,     
		CASE 
			WHEN (@ViewAllFinance = 1) 
					OR
			--    
				 (@ManagerID IS NOT NULL)
			THEN  
				1
			ELSE
				0
		END,
		CASE 
			WHEN @WithAddingOfAllSubprojects = 1 OR
				dbo.fnPjm5IsProjectManager([SubProjects].[ProjectID], [ProjectManagerEmployeeID]) = 1
				THEN [SubProjects].[ProjectID]
			ELSE NULL
		END 
	FROM			
		[Project]
		LEFT OUTER JOIN fnpjm6GetSubprojectsForBrowse() AS [SubProjects]
			ON [SubProjects].[SubprojectID] = [Project].[ID]
	WHERE
	--   NULL,    ,  ,   
	--  	
		(@ManagerID IS NULL OR
		 [Project].[ProjectManagerEmployeeID] = @ManagerID
		) 
        AND (
		 (@StateSelector  = 0 AND [Project].[State] NOT IN (5, 6)) OR 
		 (@StateSelector != 0 AND [Project].[State] = @StateSelector)
		)	
--  ParentID  NULL   ,    
	--IF @UseSubProjects = 1
	UPDATE @Projects
	SET [ParentProjectID] = NULL
	WHERE
		[ParentProjectID] IS NOT NULL AND
		[ParentProjectID] NOT IN (SELECT [ID] FROM @Projects)

--    ViewFinance
--    ,    
	IF @ViewFinance = 1 AND @ManagerID IS NULL BEGIN
		SELECT 
     		@CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()		
		UPDATE @Projects 
		SET	[ViewFinance] = 1
		WHERE ID IN (
			SELECT
				[Assignment].[ProjectID]
			FROM
				[Assignment] 
			WHERE 	
				[Assignment].[ID] IN (
					SELECT [AssignmentEntry].[AssignmentID]
					FROM   [AssignmentEntry]
					WHERE  
						[AssignmentEntry].[EmployeeID] = @CurrentEmployeeID
				) AND
			   ([Assignment].[State] = 1 AND [Assignment].[FinanceManagement] = 1)
		)
	END
	--     ,     
	IF @ManagerID IS NULL BEGIN
	--   
		SELECT 
     		@CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()		
		UPDATE @Projects 
		SET	[ViewFinance] = 1
		WHERE ID IN (
			SELECT 
				[Project].[ID]
			FROM 
				[Project]
			WHERE
				([ProjectManagerEmployeeID] = @CurrentEmployeeID AND @HasManageProject = 1) OR 
				([FinanceManagerEmployeeID] = @CurrentEmployeeID AND @ViewFinance = 1)
		)
	END

	RETURN

END
	
GO
