IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6GetAvailableProjectsForProjectManager]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6GetAvailableProjectsForProjectManager'
		DROP FUNCTION [dbo].[fnPjm6GetAvailableProjectsForProjectManager]
	END

GO

PRINT 'Creating function fnPjm6GetAvailableProjectsForProjectManager'
GO
/******************************************************************************
**		File:	fnPjm6GetAvailableProjectsForProjectManager.sql
**		Name: 	fnPjm6GetAvailableProjectsForProjectManager
**		Desc:	      
**				   
*******************************************************************************
**		Date:		Author:		Description:
**		-----		-------		-------------
**    	16.03.09	ENB			 
**		13.07.11	SYV			   UseSubProjects
*******************************************************************************/
CREATE FUNCTION fnPjm6GetAvailableProjectsForProjectManager ()

RETURNS @Projects TABLE ([ID] INT PRIMARY KEY, [ViewFinance] INT NOT NULL DEFAULT 0, [ParentProjectID] INT)

AS 

BEGIN

	DECLARE 
		@CurrentEmployeeID TIdentifier
		--@UseSubProjects		TBool,
		--@value				TVariant

	--EXEC adfParameterGet @Name='UseSubProjects', @Group='Pjm6', @Value = @value OUTPUT
	--SET @UseSubProjects = ISNULL(CAST(@value as bit), 0)

	SELECT 
		@CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()

--   ,   
--    
	INSERT INTO @Projects ([ID], [ViewFinance], [ParentProjectID])
	SELECT
		[Project].[ID], 1, [SubProjects].[ProjectID]
	FROM
		[Project]
		LEFT OUTER JOIN fnpjm6GetSubprojectsForBrowse() AS [SubProjects]
			ON [SubProjects].[SubprojectID] = [Project].[ID]
	WHERE
		[Project].[ProjectManagerEmployeeID] = @CurrentEmployeeID

	--IF @UseSubProjects = 1
	UPDATE @Projects
	SET [ParentProjectID] = NULL
	WHERE
		[ParentProjectID] IS NOT NULL AND
		[ParentProjectID] NOT IN (SELECT [ID] FROM @Projects)

	RETURN

END
	
GO
