IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6GetDetailedLegalCompanyName]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6GetDetailedLegalCompanyName'
		DROP FUNCTION [dbo].[fnPjm6GetDetailedLegalCompanyName]
	END

GO

PRINT 'Creating function fnPjm6GetDetailedLegalCompanyName'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm6GetDetailedLegalCompanyName
**		Desc:     (   )
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		26.06.2009	SPV				 
**    
*******************************************************************************/
CREATE FUNCTION fnPjm6GetDetailedLegalCompanyName
	(@Legal TName, @WithShortName TBool)
RETURNS nvarchar(512)
AS
BEGIN
	DECLARE
	@LegalLong TName,
	@LegalName TName

	SET @LegalLong = ' ' + @Legal + ' '

	SET @LegalLong = REPLACE(@LegalLong, '  ', '     ')
	SET @LegalLong = REPLACE(@LegalLong, '  ', '    ')
	SET @LegalLong = REPLACE(@LegalLong, '  ', '    ')
	SET @LegalLong = REPLACE(@LegalLong, '  ', '   ')
	SET @LegalLong = REPLACE(@LegalLong, '  ', '     ')

	SET @LegalLong = REPLACE(@LegalLong, '  ', '   ')
	SET @LegalLong = REPLACE(@LegalLong, '  ', '   ')
	SET @LegalLong = REPLACE(@LegalLong, '  ', '    ')

	SET @LegalLong = REPLACE(@LegalLong, '  ', '    ')
	SET @LegalLong = REPLACE(@LegalLong, '  ', '   ')
	SET @LegalLong = REPLACE(@LegalLong, '  ', '   ')

	SET @LegalLong = RTRIM(@LegalLong)
	SET @LegalLong = LTRIM(@LegalLong)
	IF @WithShortName = 1
		SET @LegalName = @LegalLong + ' (' + @Legal + ')'
	ELSE
		SET @LegalName = @LegalLong

	RETURN @LegalName
END
GO

GRANT EXEC ON fnPjm6GetDetailedLegalCompanyName TO PUBLIC
GO
