IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6GetProjectBudget]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6GetProjectBudget'
		DROP FUNCTION [dbo].[fnPjm6GetProjectBudget]
	END

GO

PRINT 'Creating function fnPjm6GetProjectBudget'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm6GetProjectBudget
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm6GetProjectBudget (@ProjectID TIdentifier)
RETURNS TMoney
AS
BEGIN
	DECLARE @timeentry TMoney, @expense TMoney
	SELECT 
		@timeentry = SUM([TimeEntry].[Billable] * [EntryAmount].[Amount] * [TimeEntry].[Rate])
	FROM 
		[TimeEntry]
		INNER JOIN [EntryAmount]
			ON [TimeEntry].[ID] = [EntryAmount].[ID]
	WHERE
		[TimeEntry].[ProjectID] = @ProjectID AND
		[TimeEntry].[State] IN (2,3,6)
		
	SELECT 
		@expense = SUM([Expense].[Billable] * ISNULL(
			CASE 
				WHEN [Project].[RatesWithVAT] = 0 
					THEN [Expense].[TotalPC]
				ELSE [Expense].[TotalWithVATPC]
			END, 0))
	FROM 
		[Expense]
		INNER JOIN [Project]
			ON [Project].[ID] = [Expense].[ProjectID]
	WHERE
		[Expense].[ProjectID] = @ProjectID AND
		[Expense].[State] IN (2,3,6)	
	
	RETURN ISNULL(@timeentry, 0) + ISNULL(@expense, 0)
END
GO

GRANT EXECUTE ON dbo.fnPjm6GetProjectBudget TO PUBLIC
GO


  