IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6HasBillingPersonAccessToCompany]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6HasBillingPersonAccessToCompany'
		DROP FUNCTION [dbo].[fnPjm6HasBillingPersonAccessToCompany]
	END

GO

PRINT 'Creating function fnPjm6HasBillingPersonAccessToCompany'
GO
/******************************************************************************
**		File: fnPjm6HasBillingPersonAccessToCompany.sql
**		Name: fnPjm6HasBillingPersonAccessToCompany
**		Desc:        
**		  ViewFinance (   BillingPerson)  
**		 /  ,   
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: yuriy.soldatkin
**		Date: 17.11.09
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		03.04.13	SOV				    . - 
**									     " "
**		18.04.13	SOV				 
*******************************************************************************/
CREATE FUNCTION fnPjm6HasBillingPersonAccessToCompany
	(@CompanyID TIdentifier)
RETURNS TIdentifier
AS
BEGIN
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	DECLARE @HasAccess INT
	SET @HasAccess = dbo.adfHasAccessRightByName('ViewFinance')
	
	IF @CompanyID IN 
	(
		SELECT
			[SupplierCompanyID] 
		FROM 
			[Project]
		UNION
		SELECT DISTINCT 
			[CustomerCompanyID] 
		FROM 
			[vwAssignment], [Project]
		WHERE 
			([Project].[ID] = [vwAssignment].[ProjectID]
		AND
			[vwAssignment].[EmployeeID] = @EmployeeID 
		AND 
			[vwAssignment].[State] = 1
		AND
			[FinanceManagement] = 1)
		UNION
		SELECT DISTINCT 
			[CustomerCompanyID] 
		FROM 
			[Project]
		WHERE 
			dbo.fnPjm7IsFinanceManager([Project].[ID], @EmployeeID) = 1
	)
	AND
	@HasAccess = 1
	AND
	@CompanyID IS NOT NULL 
		RETURN 1 
	RETURN 0
END
GO

GRANT EXEC ON [fnPjm6HasBillingPersonAccessToCompany] TO PUBLIC
GO