﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm7GetDatesListBetweenTwoDates]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm7GetDatesListBetweenTwoDates'
		DROP FUNCTION [dbo].[fnPjm7GetDatesListBetweenTwoDates]
	END

GO

PRINT 'Creating function fnPjm7GetDatesListBetweenTwoDates'
GO
/******************************************************************************
**		File: fnPjm7GetDatesListBetweenTwoDates.sql
**		Name: fnPjm7GetDatesListBetweenTwoDates
**		Desc: Функция возвращает список дат (по дням) между двумя датами
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: anton.paramonov
**		Date: 03.10.2011 14:55
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm7GetDatesListBetweenTwoDates
(
      @DtFrom DATETIME,
      @DtTo DATETIME
)

RETURNS @DateList TABLE ([Day] datetime, [PeriodName] nvarchar(30))

AS
BEGIN

      DECLARE @TotDays INT
      DECLARE @CNT INT

      SET @TotDays =  DATEDIFF(DD,@DtFrom,@DtTo)

      SET @CNT = 0
      WHILE @TotDays >= @CNT
      BEGIN
		DECLARE @DayDate datetime
		SET @DayDate = (@DtTo - @CNT)

		INSERT INTO @DateList
		SELECT 
			@DayDate AS [Day],
			(CASE MONTH(@DayDate)
						WHEN 1 THEN 'Январь'
						WHEN 2 THEN 'Февраль'
						WHEN 3 THEN 'Март'
						WHEN 4 THEN 'Апрель'
						WHEN 5 THEN 'Май'
						WHEN 6 THEN 'Июнь'
						WHEN 7 THEN 'Июль'
						WHEN 8 THEN 'Август'
						WHEN 9 THEN 'Сентябрь'
						WHEN 10 THEN 'Октябрь'
						WHEN 11 THEN 'Ноябрь'
						WHEN 12 THEN 'Декабрь'
					END)+ ', ' + CAST(YEAR(@DayDate) as nvarchar)
		
		SET @CNT = @CNT + 1
      END
      RETURN
END

GO 
  