IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].fnPjm7GetFormattedDaysBeforeEvent') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm7GetFormattedDaysBeforeEvent'
		DROP FUNCTION [dbo].fnPjm7GetFormattedDaysBeforeEvent
	END

GO

PRINT 'Creating Function fnPjm7GetFormattedDaysBeforeEvent'
GO
/******************************************************************************
**		File:	fnPjm7GetFormattedDaysBeforeEvent.sql
**		Name: 	fnPjm7GetFormattedDaysBeforeEvent
**		Desc:	returns 
*******************************************************************************
**		Date:		Author:		Description:
**		-----		-------		-------------
**    	29.11.11		ASA		first version
*******************************************************************************/

CREATE FUNCTION fnPjm7GetFormattedDaysBeforeEvent(@Days int, @EventDate datetime)
RETURNS varchar(20)
BEGIN
	DECLARE
		@XDays varchar(10),
		@XMonths varchar(10),
		@LaterLimit int,
		@Result varchar(20),
		@ThisYearDate datetime,
		@eventDay datetime,
		@Language TCode,
		@today datetime,
		@nextYear datetime,
		@daysUntil int,
		@monthsUntil int
	-----------------------------------------------------
	SET @today = GetDate()
	SET @nextYear = DATEADD(YEAR,1,@today)

	--    (    )
		--     
	IF((DATEPART(MONTH,@EventDate) < DATEPART(MONTH,@today)) OR ((DATEPART(MONTH,@EventDate) = DATEPART(MONTH,@today)) AND (DATEPART(DAY,@EventDate) < DATEPART(DAY,@EventDate))))
		IF(Datepart(month, @EventDate) > 2)					--    
		BEGIN
			IF(isdate(datename(year,@EventDate)+'0229') = 1)	--  
			BEGIN
				IF(isdate(datename(year,@today)+'0229') = 1)		--  
				BEGIN
					SET @eventDay = dateadd(year,1,Dateadd(day,datepart(dayofyear,@EventDate) - 1, datename(year,@today)))
				END
				ELSE												--   	
				BEGIN
					SET @eventDay = Dateadd(day,datepart(dayofyear,@EventDate) - 1 - 1, datename(year,@today))
				END
			END													--   
			ELSE IF(isdate(datename(year,@EventDate)+'0229') = 0)
			BEGIN
				IF(isdate(datename(year,@today)+'0229') = 1)		--  
				BEGIN
					SET @eventDay = Dateadd(day,datepart(dayofyear,@EventDate) - 1 + 1, datename(year,@today))
				END
				ELSE												--   	
				BEGIN
					SET @eventDay = Dateadd(day,datepart(dayofyear,@EventDate) - 1 - 1 , datename(year,@today))
				END
			END
		END
		ELSE													--   
		BEGIN
			SET @eventDay = Dateadd(day,datepart(dayofyear,@EventDate) - 1, datename(year,@today))
		END
	ELSE	--     
	BEGIN
		IF(Datepart(month, @EventDate) > 2)					--    
		BEGIN
			IF(isdate(datename(year,@EventDate)+'0229') = 1)	--  
			BEGIN
				IF(isdate(datename(year,@today)+'0229') = 1)		--  
				BEGIN
					SET @eventDay = Dateadd(day,datepart(dayofyear,@EventDate) - 1, datename(year,@today))
				END
				ELSE												--   	
				BEGIN
					SET @eventDay = Dateadd(day,datepart(dayofyear,@EventDate) - 1 - 1, datename(year,@today))
				END
			END													--   
			ELSE IF(isdate(datename(year,@EventDate)+'0229') = 0)
			BEGIN
				IF(isdate(datename(year,@today)+'0229') = 1)		--  
				BEGIN
					SET @eventDay = Dateadd(day,datepart(dayofyear,@EventDate) - 1 + 1, datename(year,@today))
				END
				ELSE												--   	
				BEGIN
					SET @eventDay = Dateadd(day,datepart(dayofyear,@EventDate) - 1 - 1 , datename(year,@today))
				END
			END
		END
		ELSE													--   
		BEGIN
			SET @eventDay = Dateadd(day,datepart(dayofyear,@EventDate) - 1, datename(year,@today))
		END
	END

	SET @daysUntil = DATEDIFF(DAY,@today,@eventDay)
	SET @monthsUntil = DATEDIFF(month,@today,@eventDay)

	-----------------------------------------------------

	SET @Language = dbo.adfGetLanguage()
	SET @LaterLimit = 2

	IF(@Language = 'en')
	BEGIN
		IF(@Days = 0)
			RETURN 'today'
		IF(@Days / 30 < @LaterLimit)
		BEGIN
			SET @XMonths = CAST(@Days / 30 AS varchar(2)) + ' months '
			SET @XDays = CAST(@Days % 30 AS varchar(2))

			IF(@Days / 30 = 0)
				SET @XMonths = ''
			ELSE IF(@Days / 30 = 1)
				SET @XMonths = '1 month '

			IF(@Days = 1)
			BEGIN
				SET @Result = @XMonths + @XDays + ' day' 
			END
			ELSE
			BEGIN
				IF (@Days % 30 = 1)
				BEGIN
					SET @Result = @XMonths + @XDays + ' day'
				END
				ELSE IF(@Days % 30 = 0)
				BEGIN
					SET @Result = @XMonths
				END
				ELSE
				BEGIN
					SET @Result = @XMonths + @XDays + ' days'
				END
			END
		END
		ELSE
		BEGIN
			SET @XMonths = CAST(@Days / 31 AS varchar(2)) + ' months'
			SET @Result = @XMonths
		END
		IF (datepart(month,@Eventdate) = datepart(month,dateadd(month,2,GetDate())))
		BEGIN
			SET @XMonths = '2 months'
			SET @Result = @XMonths
		END
	END
	ELSE IF(@Language = 'ru')
	--BEGIN
	--	IF(@Days = 0)
	--		RETURN ''
		
	--	IF(@Days / 30 < @LaterLimit)
	--	BEGIN
	--		SET @XMonths = CAST(@Days / 30 AS varchar(2)) + ' . '
	--		SET @XDays = CAST(@Days % 30 AS varchar(2))

	--		IF(@Days / 30 = 0)
	--			SET @XMonths = '';
		
	--		IF(@XDays IN (2,3,4,22,23,24))
	--		BEGIN
	--			SET @Result = @XMonths + @XDays + ' ' 
	--		END
	--		ELSE IF(@XDays IN (1,21))
	--		BEGIN
	--			SET @Result = @XMonths + @XDays + ' ' 
	--		END
	--		ELSE
	--		BEGIN
	--			SET @Result = @XMonths + @XDays + ' '
	--			IF(@Days % 30 = 0)
	--			BEGIN
	--				SET @Result = @XMonths
	--			END
	--		END
	--	END
	--	ELSE
	--	BEGIN
	--		IF ((@Days / 31) IN (2,3,4))
	--			SET @XMonths = CAST(@Days / 31 AS varchar(2)) + ' '
	--		ELSE
	--			SET @XMonths = CAST(@Days / 31 AS varchar(2)) + ' '
	--		SET @Result = @XMonths
	--	END
	--	IF (datepart(month,@Eventdate) = datepart(month,dateadd(month,2,GetDate())))
	--	BEGIN
	--		SET @XMonths = '2 '
	--		SET @Result = @XMonths
	--	END
	--END 
	BEGIN

		
		IF(@Days = 0)
			RETURN ''
	END
	RETURN @Result
END
GO

GRANT EXEC ON fnPjm7GetFormattedDaysBeforeEvent TO PUBLIC
GO
