IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm7GetProjectsBudgets]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm7GetProjectsBudgets'
		DROP FUNCTION [dbo].[fnPjm7GetProjectsBudgets]
	END

GO

PRINT 'Creating function fnPjm7GetProjectsBudgets'
GO
/******************************************************************************
**		File:	fnPjm7GetProjectsBudgets.sql
**		Name: 	fnPjm7GetProjectsBudgets
**		Desc:	      
*******************************************************************************
**		Date:		Author:		Description:
**		-----		-------		-------------
**
*******************************************************************************/
CREATE FUNCTION fnPjm7GetProjectsBudgets()

RETURNS @Budgets TABLE
(
	[ProjectID] INT,
	[PlannedManHour] TAmount,
	[PlannedBudget] TMoney,
	[ProjectTypeID] INT,
	[MsProjectID] INT
)
BEGIN

DECLARE 
	@EnabledTasks TVariant,
	@UseBudgetPlanning TVariant
	
	--     ?
	SELECT @EnabledTasks = [Value] 
	FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] 
	WHERE [Name]  = 'EnabledTasks' AND [Group] = 'Pjm6'
	
	--   ?
	SELECT @UseBudgetPlanning = [Value] 
	FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] 
	WHERE [Name]  = 'UseBudgetPlanning' AND [Group] = 'Pjm6'
	
	--      
	INSERT INTO @Budgets
	SELECT
		[Project].[ID],
		CASE
			WHEN [MsProjectID] IS NOT NULL OR [ProjectTypeID] != 1 THEN NULL
			--   60, ..     
			ELSE [PlannedManHour] * 60 
		END,
		CASE
			WHEN [MsProjectID] IS NOT NULL OR [ProjectTypeID] != 1 THEN NULL
			ELSE dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork],
				[DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour])
		END,
		[ProjectTypeID],
		[MsProjectID]
	FROM
		[Budget]
		INNER JOIN (SELECT
						[DocumentID],
						MAX([StartDate]) AS StartDate
					FROM
						[Budget]
					GROUP BY
						[DocumentID]
					HAVING
						[DocumentID] IS NOT NULL) AS [LastBudgets]
			ON [LastBudgets].[DocumentID] = [Budget].[DocumentID] AND 
				[LastBudgets].[StartDate] = [Budget].[StartDate]
		RIGHT JOIN [Project]
			ON [Budget].[DocumentID] = [Project].[ID] AND @UseBudgetPlanning = 1
	ORDER BY [Project].[ID]
	
	--   ,     ,    
	--    MSProject
	UPDATE @Budgets	
	SET 
		[PlannedManHour] = 
			CASE
				WHEN [Tasks].[ProjectID] IS NOT NULL OR [ProjectTypeID] != 1
					OR [MsProjectID] IS NOT NULL
					THEN [ProjectDetail].[PlannedManHour]
				ELSE NULL
			END,
		[PlannedBudget] = 
			CASE
				WHEN [Tasks].[ProjectID] IS NOT NULL OR [ProjectTypeID] != 1
					OR [MsProjectID] IS NOT NULL
					THEN [ProjectDetail].[PlannedBudget]
				ELSE NULL
			END
	FROM
		@Budgets AS [Budgets]
		LEFT JOIN (SELECT DISTINCT [ProjectID] FROM [Task] 
					WHERE [SubprojectID] IS NULL AND [State] = 2) AS [Tasks]
			ON	[Tasks].[ProjectID] = [Budgets].[ProjectID]
		INNER JOIN [ProjectDetail]
			ON [ProjectDetail].[ID] = [Budgets].[ProjectID]
	WHERE
		@EnabledTasks = 1 AND [Budgets].[PlannedManHour] IS NULL AND [Budgets].[PlannedBudget] IS NULL
	
	RETURN
END
GO