﻿ IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm7HasRightCreateUserOnServer]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm7HasRightCreateUserOnServer'
		DROP FUNCTION [dbo].[fnPjm7HasRightCreateUserOnServer]
	END

GO

PRINT 'Creating function fnPjm7HasRightCreateUserOnServer'
GO

/******************************************************************************
**		File: fnPjm7HasRightCreateUserOnServer.sql
**		Name: fnPjm7HasRightCreateUserOnServer
**		Desc: Функция проверяет, входит ли пользователь в роли, позволяющие создавать
**				учетные записи на сервере
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Oleg.Safarov
**		Date: 12.12.2012 16.00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm7HasRightCreateUserOnServer()
RETURNS BIT
AS
BEGIN
	DECLARE @IsSysAdmin int = IS_SRVROLEMEMBER('sysadmin')
	DECLARE @IsSecurityAdmin int = IS_SRVROLEMEMBER('securityadmin')
	
	IF @IsSecurityAdmin = 1 OR @IsSysAdmin = 1
		RETURN 1
	
	RETURN 0
END
GO

GRANT EXEC ON fnPjm7HasRightCreateUserOnServer TO PUBLIC
GO