 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5AssignmentBrowseForBooking]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5AssignmentBrowseForBooking'
		DROP PROCEDURE [dbo].[pjm5AssignmentBrowseForBooking]
	END
GO

PRINT 'Creating procedure pjm5AssignmentBrowseForBooking'
GO

/******************************************************************************
**		File: pjm5AssignmentBrowseForBooking.sql
**		Name: pjm5AssignmentBrowseForBooking
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:18:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5AssignmentBrowseForBooking]
	@QualificationID TIdentifier
AS
	SET NOCOUNT ON

	SELECT
		[Employee].[ID],
		[Employee].[FileAs] as [Name],
		[Qualification].[FileAs] AS [Qualification],
		[Company].[FileAs] as [Organization],
		(SELECT TOP 1 [Phone] FROM [Phone] WHERE [BusinessCardClass] = [Employee].[Class] AND [BusinessCardID] = [Employee].[ID] ORDER BY [PhoneTypeID]) as [Phone],
		(SELECT TOP 1 [Email] FROM [Email] WHERE [BusinessCardClass] = [Employee].[Class] AND [BusinessCardID] = [Employee].[ID] AND [EmailTypeID] < 4 ORDER BY [EmailTypeID]) as [Email]
	FROM 
		[Employee] INNER JOIN [Company]
			ON ([Company].[ID] = [Employee].[CompanyID])
		LEFT OUTER JOIN [Qualification]
			ON ([Employee].[QualificationID] = [Qualification].[ID])
	WHERE
		[Employee].[State] = 1 
		AND
		[Company].[State] = 1 
		AND
		[Company].[Own] = 1 
		AND
		(
			@QualificationID IS NULL OR [Employee].[QualificationID] = @QualificationID
		) 		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5AssignmentBrowseForBooking] TO PUBLIC
GO
