IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm5trAssignmentInsert')
	BEGIN
		PRINT 'Dropping Trigger pjm5trAssignmentInsert'
		DROP  Trigger pjm5trAssignmentInsert
	END
GO

/******************************************************************************
**		File: 
**		Name: pjm5trAssignmentInsert
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger pjm5trAssignmentInsert'
GO
CREATE TRIGGER pjm5trAssignmentInsert ON [Assignment] FOR INSERT, DELETE, UPDATE
AS
	IF @@rowcount = 0 
		RETURN

	SET NOCOUNT ON
	IF (EXISTS (
			SELECT * FROM [inserted]
			INNER JOIN [Project] ON [Project].[ID] = [inserted].[ProjectID]
			WHERE [Project].[State] = 4
		)
	)
	BEGIN
		RAISERROR('#AssignmentFailedInCompleteProject', 16, -1)
		ROLLBACK TRANSACTION
	END
	
	IF (EXISTS (
			SELECT * FROM [deleted]
			INNER JOIN [Project] ON [Project].[ID] = [deleted].[ProjectID]
			WHERE [Project].[State] = 4
		)
	)
	BEGIN
		RAISERROR('#AssignmentFailedInCompleteProject', 16, -1)
		ROLLBACK TRANSACTION
	END
	
	RETURN
GO

   