﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetDeleteActualTotals]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetDeleteActualTotals'
		DROP PROCEDURE [dbo].[pjm6BudgetDeleteActualTotals]
	END
GO

PRINT 'Creating procedure pjm6BudgetDeleteActualTotals'
GO

/******************************************************************************
**		File: BudgetDeleteActualTotals.sql
**		Name: pjm6BudgetDeleteActualTotals
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 25/01/2011 11:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
** 
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetDeleteActualTotals
	@BudgetID				TIdentifier,
	@CalculationProcess		TBool = 0				--1 - если процедура вызвана из расчета бюджета
AS
	IF @CalculationProcess = 0
	BEGIN
		UPDATE [Budget]
		SET
			[Budget].[Modified] = DEFAULT,
			[Budget].[ModifiedBy] = DEFAULT,
			[Budget].[ActualManHour] = 0,
			[Budget].[ActualManHourWithSub] = 0,
			[Budget].[PlannedManHourWithSub] = 0,
			[Budget].[TotalPCPlannedManHourWithSub] = 0,
			[Budget].[TotalWithVATPCPlannedManHourWithSub] = 0,
			[Budget].[TotalPCActualManHour] = 0,
			[Budget].[TotalWithVATPCActualManHour] = 0,
			[Budget].[TotalPCActualManHourWithSub] = 0,
			[Budget].[TotalWithVATPCActualManHourWithSub] = 0,
			[Budget].[TotalPCPlannedExpenseWithSub] = 0,
			[Budget].[TotalWithVATPCPlannedExpenseWithSub] = 0,
			[Budget].[TotalPCActualExpense] = 0,
			[Budget].[TotalWithVATPCActualExpense] = 0,
			[Budget].[TotalPCActualExpenseWithSub] = 0,
			[Budget].[TotalWithVATPCActualExpenseWithSub] = 0,
			[Budget].[TotalPCWDPlannedManHourWithSub] = 0,
			[Budget].[TotalWithVATPCWDPlannedManHourWithSub] = 0,
			[Budget].[TotalPCWDActualManHourWithSub] = 0,
			[Budget].[TotalWithVATPCWDActualManHourWithSub] = 0,
			[Budget].[TotalPCWDPlannedExpenseWithSub] = 0,
			[Budget].[TotalWithVATPCWDPlannedExpenseWithSub] = 0,
			[Budget].[TotalPCWDActualExpenseWithSub] = 0,
			[Budget].[TotalWithVATPCWDActualExpenseWithSub] = 0
		WHERE
			[Budget].[ID] = @BudgetID
		IF @@ERROR!= 0
			RETURN 2
	END

	UPDATE [BudgetLineExpense]
	SET
		[BudgetLineExpense].[ActualAmount] = 0,
		[BudgetLineExpense].[TotalActualExpense] = 0,
		[BudgetLineExpense].[TotalWithVATActualExpense] = 0,
		[BudgetLineExpense].[TotalPCActualExpense] = 0,
		[BudgetLineExpense].[TotalWithVATPCActualExpense] = 0
	WHERE
		[BudgetLineExpense].[BudgetID] = @BudgetID AND [BudgetLineExpense].[State] = 1
	IF @@ERROR!= 0
		RETURN 2

	UPDATE [BudgetLineWork]
	SET
		[BudgetLineWork].[ActualManHour] = 0,
		[BudgetLineWork].[TotalPCActualManHour] = 0,
		[BudgetLineWork].[TotalWithVATPCActualManHour] = 0
	WHERE
		[BudgetLineWork].[BudgetID] = @BudgetID AND [BudgetLineWork].[State] = 1
	IF @@ERROR!= 0
		RETURN 2

	--Удалить все внеплановые линии
	DELETE FROM [BudgetLineExpense] WHERE [BudgetLineExpense].[BudgetID] = @BudgetID AND [BudgetLineExpense].[State] = 2
	IF @@ERROR!= 0
		RETURN 2
	
	DELETE FROM [BudgetLineWork] WHERE [BudgetLineWork].[BudgetID] = @BudgetID AND [BudgetLineWork].[State] = 2
	IF @@ERROR!= 0
		RETURN 2
	DELETE FROM [BudgetLineWorkEntries] WHERE [BudgetID] = @BudgetID
	IF @@ERROR!= 0
		RETURN 2
	DELETE FROM [BudgetLineExpenseEntries] WHERE [BudgetID] = @BudgetID
	IF @@ERROR!= 0
		RETURN 2
	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetDeleteActualTotals TO PUBLIC
GO
