﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetTemplateUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetTemplateUpdate'
		DROP PROCEDURE [dbo].[pjm6BudgetTemplateUpdate]
	END
GO

PRINT 'Creating procedure pjm6BudgetTemplateUpdate'
GO

/******************************************************************************
**		File: pjm6BudgetTemplateUpdate.sql
**		Name: pjm6BudgetTemplateUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 09/12/2010 16:01:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		28.02.13	MAB				Отказ от OPENXML
*******************************************************************************/
CREATE PROCEDURE [pjm6BudgetTemplateUpdate]
	@Xml	XML
AS
	DECLARE
		@ID									TIdentifier,
		@State								TState,
		@FileAs								TName,
		@BudgetTypeID						TIdentifier,
		@UseWorkPlanning					TBool,
		@UseExpensePlanning					TBool,
		@CurrencyCode						TCode3,
		@VATIsIncluded						TBool,
		@VATRate							TPercent,
		@Comments							TNotes,
		@value								TVariant,
		@WorkBudgetBottom					TMoney,
		@WorkBudgetHigh						TMoney,
		@WorkBudgetBottomEqualsPlan			TBool,
		@WorkBudgetHighEqualsPlan			TBool,
		@ExpenseBudgetBottom				TMoney,
		@ExpenseBudgetHigh					TMoney,
		@ExpenseBudgetBottomEqualsPlan		TBool,
		@ExpenseBudgetHighEqualsPlan		TBool,
		@SupervisorEmployeeID				TIdentifier,
		@DiscountViewWork					TBool,
		@DiscountPercentWork				TPercent,
		@DiscountTotalWork					TMoney,
		@DiscountPercentWorkFinal			TPercent,
		@DiscountTotalWorkFinal				TMoney,
		@DiscountTypeWork					TCount,
		@DiscountViewExpense				TBool,
		@DiscountPercentExpense				TPercent,
		@DiscountTotalExpense				TMoney,
		@DiscountPercentExpenseFinal		TPercent,
		@DiscountTotalExpenseFinal			TMoney,
		@DiscountTypeExpense				TCount,
		@PlanningActivityForWork			TBool,
		@PlanningEmployeeForWork			TBool,
		@PlanningQualificationForWork		TBool,
		@PlanningRateForWork				TBool,
		@PlanningDateForWork				TBool,
		@PlanningExpenseTypeForExpense		TBool,
		@PlanningEmployeeForExpense			TBool,
		@PlanningPriceForExpense			TBool,
		@PlanningDateForExpense				TBool,
		@TimeEntryAccount					TIdentifier,
		@TimeEntrySendingForApprovalAccount	TBool,
		@TimeEntryActualTotalsAccount		TIdentifier,
		@PlanProfitability					TPercent,
		@ExpenseAccount						TIdentifier,
		@ExpenseSendingForApprovalAccount	TBool,
		@PlanPurchases						TBool

	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageBudgetTemplates')) != 1 
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	SET NOCOUNT ON

	SELECT
		@ID									= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/ID)[1]','int'),
		@FileAs								= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/FileAs)[1]','nvarchar(256)'),
		@BudgetTypeID						= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/BudgetTypeID)[1]','int'),
		@UseWorkPlanning					= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/UseWorkPlanning)[1]','bit'),
		@UseExpensePlanning					= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/UseExpensePlanning)[1]','bit'),
		@CurrencyCode						= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/CurrencyCode)[1]','char(3)'),
		@VATIsIncluded						= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/VATIsIncluded)[1]','bit'),
		@WorkBudgetBottom					= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/WorkBudgetBottom)[1]','money'),
		@WorkBudgetHigh						= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/WorkBudgetHigh)[1]','money'),
		@WorkBudgetBottomEqualsPlan			= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/WorkBudgetBottomEqualsPlan)[1]','bit'),
		@WorkBudgetHighEqualsPlan			= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/WorkBudgetHighEqualsPlan)[1]','bit'),
		@ExpenseBudgetBottom				= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/ExpenseBudgetBottom)[1]','money'),
		@ExpenseBudgetHigh					= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/ExpenseBudgetHigh)[1]','money'),
		@ExpenseBudgetBottomEqualsPlan		= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/ExpenseBudgetBottomEqualsPlan)[1]','bit'),
		@ExpenseBudgetHighEqualsPlan		= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/ExpenseBudgetHighEqualsPlan)[1]','bit'),
		@SupervisorEmployeeID				= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/SupervisorEmployeeID)[1]','int'),
		@DiscountViewWork					= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/DiscountViewWork)[1]','bit'),
		@DiscountPercentWork				= ABS(@Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/DiscountPercentWork)[1]','decimal(18,4)')),
		@DiscountTotalWork					= ABS(@Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/DiscountTotalWork)[1]','decimal')),
		@DiscountTypeWork					= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/DiscountTypeWork)[1]','int'),
		@DiscountViewExpense				= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/DiscountViewExpense)[1]','bit'),
		@DiscountPercentExpense				= ABS(@Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/DiscountPercentExpense)[1]','decimal(18,4)')),
		@DiscountTotalExpense				= ABS(@Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/DiscountTotalExpense)[1]','decimal')),
		@DiscountTypeExpense				= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/DiscountTypeExpense)[1]','int'),
		@PlanningActivityForWork			= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/PlanningActivityForWork)[1]','bit'),
		@PlanningEmployeeForWork			= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/PlanningEmployeeForWork)[1]','bit'),
		@PlanningQualificationForWork		= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/PlanningQualificationForWork)[1]','bit'),
		@PlanningRateForWork				= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/PlanningRateForWork)[1]','bit'),
		@PlanningDateForWork				= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/PlanningDateForWork)[1]','bit'),
		@PlanningExpenseTypeForExpense		= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/PlanningExpenseTypeForExpense)[1]','bit'),
		@PlanningEmployeeForExpense			= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/PlanningEmployeeForExpense)[1]','bit'),
		@PlanningPriceForExpense			= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/PlanningPriceForExpense)[1]','bit'),
		@PlanningDateForExpense				= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/PlanningDateForExpense)[1]','bit'),
		@TimeEntryAccount					= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/TimeEntryAccount)[1]','int'),
		@TimeEntrySendingForApprovalAccount	= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/TimeEntrySendingForApprovalAccount)[1]','bit'),
		@TimeEntryActualTotalsAccount		= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/TimeEntryActualTotalsAccount)[1]','int'),
		@PlanProfitability					= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/PlanProfitability)[1]','decimal(18,4)'),
		@ExpenseAccount						= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/ExpenseAccount)[1]','int'),
		@ExpenseSendingForApprovalAccount	= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/ExpenseSendingForApprovalAccount)[1]','bit'),
		@PlanPurchases						= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/PlanPurchases)[1]','bit'),
		@Comments							= @Xml.value('(/pjm6BudgetTemplateGet/BudgetTemplate/Comments)[1]','nvarchar(max)')
	
	IF(@DiscountTypeWork != 0 AND ((@DiscountViewWork = 0 AND @DiscountPercentWork IS NULL) OR (@DiscountViewWork = 1 AND @DiscountTotalWork IS NULL))) OR
		(@DiscountTypeExpense != 0 AND ((@DiscountViewExpense = 0 AND @DiscountPercentExpense IS NULL) OR (@DiscountViewExpense = 1 AND @DiscountTotalExpense IS NULL)))
	BEGIN
		RAISERROR('#DiscountIsNotDefined', 18, -1)
		RETURN 1
	END
			
	IF ((@DiscountTypeWork = 1 OR @DiscountTypeWork = 2) AND ((@DiscountViewWork = 0 AND @DiscountPercentWork = 0) OR
		(@DiscountViewWork = 1 AND @DiscountTotalWork = 0))) OR
		((@DiscountTypeExpense = 1 OR @DiscountTypeExpense = 2) AND ((@DiscountViewExpense = 0 AND @DiscountPercentExpense = 0) OR
		(@DiscountViewExpense = 1 AND @DiscountTotalExpense = 0)))
	BEGIN
		RAISERROR('#DiscountCantBeZero', 18, -1)
		RETURN 1
	END

	IF @PlanningActivityForWork = 0 AND @PlanningEmployeeForWork = 0 AND 
		@PlanningQualificationForWork = 0 AND @PlanningRateForWork = 0
	BEGIN
		RAISERROR('#WorkPlanningParametersIsNull', 18, -1)
		RETURN 1
	END

	IF @PlanningExpenseTypeForExpense = 0 AND @PlanningEmployeeForExpense = 0 AND @PlanningPriceForExpense = 0
	BEGIN
		RAISERROR('#ExpensePlanningParametersIsNull', 18, -1)
		RETURN 1
	END

	IF @UseWorkPlanning = 0 AND @UseExpensePlanning = 0 
	BEGIN
		RAISERROR('#BudgetMustHaveItemForPlanning', 18, -1)
		RETURN 1
	END

	IF @UseWorkPlanning = 0 AND (EXISTS(SELECT *FROM [BudgetLineWork] WHERE [BudgetID] = @ID) OR
		EXISTS(SELECT *FROM [BudgetLineGroup] WHERE [BudgetID] = @ID AND [State] = 1 AND [GroupTypeID] = 1 ))
	BEGIN
		RAISERROR('#BudgetHasLinesOrGroupsForPlanningItem', 18, -1)
		RETURN 1
	END

	IF @UseExpensePlanning = 0 AND (EXISTS(SELECT *FROM [BudgetLineExpense] WHERE [BudgetID] = @ID) OR
		EXISTS(SELECT *FROM [BudgetLineGroup] WHERE [BudgetID] = @ID AND [State] = 1 AND [GroupTypeID] = 2 ))
	BEGIN
		RAISERROR('#BudgetHasLinesOrGroupsForPlanningItem', 18, -1)
		RETURN 1
	END

	SET @DiscountPercentWorkFinal = CASE @DiscountTypeWork 
									WHEN 0 THEN NULL 
									WHEN 1 THEN 
										CASE WHEN @DiscountViewWork = 0 THEN -@DiscountPercentWork ELSE NULL END
									WHEN 2 THEN
										CASE WHEN @DiscountViewWork = 0 THEN @DiscountPercentWork ELSE NULL END
									END
	SET @DiscountTotalWorkFinal = CASE @DiscountTypeWork 
									WHEN 0 THEN NULL 
									WHEN 1 THEN 
										CASE WHEN @DiscountViewWork = 1 THEN -@DiscountTotalWork ELSE NULL END
									WHEN 2 THEN
										CASE WHEN @DiscountViewWork = 1 THEN @DiscountTotalWork ELSE NULL END
									END
	SET @DiscountPercentExpenseFinal = CASE @DiscountTypeExpense 
										WHEN 0 THEN NULL 
										WHEN 1 THEN 
											CASE WHEN @DiscountViewExpense = 0 THEN -@DiscountPercentExpense ELSE NULL END
										WHEN 2 THEN
											CASE WHEN @DiscountViewExpense = 0 THEN @DiscountPercentExpense ELSE NULL END
										END
	SET @DiscountTotalExpenseFinal = CASE @DiscountTypeExpense 
										WHEN 0 THEN NULL 
										WHEN 1 THEN 
											CASE WHEN @DiscountViewExpense = 1 THEN -@DiscountTotalExpense ELSE NULL END
										WHEN 2 THEN
											CASE WHEN @DiscountViewExpense = 1 THEN @DiscountTotalExpense ELSE NULL END
										END

	DECLARE
		@val TVariant,
		@GlobalPlanPurchases TBool
	EXEC adfParameterGet @Name='PlanPurchases', @Group='Pjm7', @Value = @val OUTPUT
	SET @GlobalPlanPurchases = CAST(@val as bit)

	BEGIN TRANSACTION

	UPDATE [Budget]
	SET
		[Budget].[FileAs] = @FileAs,
		[Budget].[CurrencyCode] = @CurrencyCode,
		[Budget].[VATIsIncluded] = @VATIsIncluded,
		[Budget].[BudgetTypeID] = @BudgetTypeID,
		[Budget].[UseWorkPlanning] = @UseWorkPlanning,
		[Budget].[UseExpensePlanning] = @UseExpensePlanning,
		[Budget].[WarningFlagID] = NULL,
		[Budget].[WorkBudgetBottom] = (CASE @WorkBudgetBottomEqualsPlan WHEN 1 THEN dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], @DiscountViewWork, @DiscountPercentWorkFinal, @DiscountTotalWorkFinal, [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour]) ELSE @WorkBudgetBottom END),
		[Budget].[WorkBudgetHigh] = (CASE @WorkBudgetHighEqualsPlan WHEN 1 THEN dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], @DiscountViewWork, @DiscountPercentWorkFinal, @DiscountTotalWorkFinal, [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour]) ELSE @WorkBudgetHigh END) ,
		[Budget].[WorkBudgetBottomEqualsPlan] = @WorkBudgetBottomEqualsPlan,
		[Budget].[WorkBudgetHighEqualsPlan] = @WorkBudgetHighEqualsPlan,
		[Budget].[ExpenseBudgetBottom] =	(CASE
												WHEN @ExpenseBudgetBottomEqualsPlan = 1 THEN 
												(CASE
													WHEN @PlanPurchases = 1 THEN
													(CASE
														WHEN @GlobalPlanPurchases = 1 THEN
														(CASE
															WHEN [Budget].[VATRate] IS NOT NULL AND [Budget].[VATIsIncluded] = 1 THEN
																([Budget].[VATPCPlanPurchase] + [Budget].[TotalPCPlanPurchase])
															ELSE [Budget].[TotalPCPlanPurchase]
														END)
														ELSE
														(CASE
															WHEN [Budget].[VATRate] IS NOT NULL AND [Budget].[VATIsIncluded] = 1 THEN
																ROUND(ISNULL([Budget].[TotalWithVATPCPlannedExpense] + dbo.fnPjm6GetBudgetTotalDiscount	(	@DiscountViewExpense,
																																							@DiscountPercentExpenseFinal,
																																							@DiscountTotalExpenseFInal,
																																							[Budget].[TotalWithVATPCPlannedExpense]
																																						), 0), 2)
															ELSE
																ROUND(ISNULL([Budget].[TotalPCPlannedExpense] + dbo.fnPjm6GetBudgetTotalDiscount	(	@DiscountViewExpense,
																																						@DiscountPercentExpenseFinal,
																																						@DiscountTotalExpenseFInal,
																																						[Budget].[TotalPCPlannedExpense]
																																					), 0), 2)
														END)	
													END)
													ELSE
													(CASE
														WHEN [Budget].[VATRate] IS NOT NULL AND [Budget].[VATIsIncluded] = 1 THEN
															ROUND(ISNULL([Budget].[TotalWithVATPCPlannedExpense] + dbo.fnPjm6GetBudgetTotalDiscount	(	@DiscountViewExpense,
																																						@DiscountPercentExpenseFinal,
																																						@DiscountTotalExpenseFInal,
																																						[Budget].[TotalWithVATPCPlannedExpense]
																																					), 0), 2)
														ELSE
															ROUND(ISNULL([Budget].[TotalPCPlannedExpense] + dbo.fnPjm6GetBudgetTotalDiscount	(	@DiscountViewExpense,
																																					@DiscountPercentExpenseFinal,
																																					@DiscountTotalExpenseFInal,
																																					[Budget].[TotalPCPlannedExpense]
																																				), 0), 2)
													END)	
												END)
												ELSE @ExpenseBudgetBottom
											END),
		[Budget].[ExpenseBudgetHigh] =	(CASE  
											WHEN @ExpenseBudgetHighEqualsPlan = 1 THEN 
											(CASE
												WHEN [Budget].[VATRate] IS NOT NULL AND [Budget].[VATIsIncluded] = 1 THEN
													ROUND(ISNULL([Budget].[TotalWithVATPCPlannedExpense] + dbo.fnPjm6GetBudgetTotalDiscount	(	@DiscountViewExpense,
																																				@DiscountPercentExpenseFinal,
																																				@DiscountTotalExpenseFInal,
																																				[Budget].[TotalWithVATPCPlannedExpense]
																																			), 0), 2)
												ELSE
													ROUND(ISNULL([Budget].[TotalPCPlannedExpense] + dbo.fnPjm6GetBudgetTotalDiscount	(	@DiscountViewExpense,
																																			@DiscountPercentExpenseFinal,
																																			@DiscountTotalExpenseFInal,
																																			[Budget].[TotalPCPlannedExpense]
																																		), 0), 2)
											END)
											ELSE 
												@ExpenseBudgetHigh 
										END),
		[Budget].[ExpenseBudgetBottomEqualsPlan] = @ExpenseBudgetBottomEqualsPlan,
		[Budget].[ExpenseBudgetHighEqualsPlan] = @ExpenseBudgetHighEqualsPlan,
		[Budget].[SupervisorEmployeeID] = @SupervisorEmployeeID,
		[Budget].[DiscountViewWork] = @DiscountViewWork,
		[Budget].[DiscountPercentWork] = @DiscountPercentWorkFinal,
		[Budget].[DiscountTotalWork] = @DiscountTotalWorkFinal,
		[Budget].[DiscountViewExpense] = @DiscountViewExpense,
		[Budget].[DiscountPercentExpense] = @DiscountPercentExpenseFinal,
		[Budget].[DiscountTotalExpense] = @DiscountTotalExpenseFinal,
		[Budget].[PlanningActivityForWork] = @PlanningActivityForWork,
		[Budget].[PlanningEmployeeForWork] = @PlanningEmployeeForWork,
		[Budget].[PlanningQualificationForWork] = @PlanningQualificationForWork,
		[Budget].[PlanningRateForWork] = @PlanningRateForWork,
		[Budget].[PlanningDateForWork] = @PlanningDateForWork,
		[Budget].[PlanningExpenseTypeForExpense] = @PlanningExpenseTypeForExpense,
		[Budget].[PlanningEmployeeForExpense] = @PlanningEmployeeForExpense,
		[Budget].[PlanningPriceForExpense] = @PlanningPriceForExpense,
		[Budget].[PlanningDateForExpense] = @PlanningDateForExpense,
		[Budget].[TimeEntryAccount] = @TimeEntryAccount,
		[Budget].[TimeEntrySendingForApprovalAccount] = @TimeEntrySendingForApprovalAccount,
		[Budget].[TimeEntryActualTotalsAccount] = @TimeEntryActualTotalsAccount,
		[Budget].[PlanProfitability] = @PlanProfitability/100,
		[Budget].[ExpenseAccount] = @ExpenseAccount,
		[Budget].[ExpenseSendingForApprovalAccount] = @ExpenseSendingForApprovalAccount,
		[Budget].[PlanPurchases] = @PlanPurchases,
		[Budget].[Comments] = @Comments,
		[Budget].[Modified] = DEFAULT,
		[Budget].[ModifiedBy] = DEFAULT
	WHERE
		[Budget].[ID] = @ID

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DECLARE @TemplateClass TClass
	SET @TemplateClass = dbo.adfGetClassByName('Pjm6.BudgetTemplate')
	UPDATE 
		[Document]
	SET 
		[Flag] = [Budget].[Flag], 
		[FileAs] = [Budget].[FileAs], 
		[Modified] = [Budget].[Modified], 
		[ModifiedBy] = [Budget].[ModifiedBy]
	FROM
		[Document]
		INNER JOIN [Budget]
			ON [Document].[ID] = [Budget].[ID] AND
				[Document].[Class] = @TemplateClass
	WHERE
		[Budget].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION

	EXEC pjm6BudgetTemplateGet @ID

	RETURN 0
GO

GRANT EXECUTE ON [pjm6BudgetTemplateUpdate] TO PUBLIC
GO  