IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetUpdate'
		DROP PROCEDURE [dbo].[pjm6BudgetUpdate]
	END
GO

PRINT 'Creating procedure pjm6BudgetUpdate'
GO

/******************************************************************************
**		File: pjm6BudgetUpdate.sql
**		Name: pjm6BudgetUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 20/08/2010 17:05:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		13.07.11	SYV				   #crossingbudgetperiod
**		21.02.13	MAB				      
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetUpdate
	@Xml	XML
AS
	DECLARE
		@ID									TIdentifier,
		@State								TState,
		@BudgetType							TIdentifier,
		@StartDate							TDate,
		@EndDate							TDate,
		@ProjectID							TIdentifier,
		@UseWorkPlanning					TBool,
		@UseExpensePlanning					TBool,
		@WorkBudgetBottom					TMoney,
		@WorkBudgetHigh						TMoney,
		@WorkBudgetBottomEqualsPlan			TBool,
		@WorkBudgetHighEqualsPlan			TBool,
		@ExpenseBudgetBottom				TMoney,
		@ExpenseBudgetHigh					TMoney,
		@ExpenseBudgetBottomEqualsPlan		TBool,
		@ExpenseBudgetHighEqualsPlan		TBool,
		@NextCalculationDate				TDate,
		@ReminderState						TState,
		@ReminderInterval					TTimeSpan,
		@ReminderTime						TDateTime,
		@WorkTimeStart						TCount,
		@RecurrenceID						TIdentifier,
		@SupervisorEmployeeID				TIdentifier,
		@DiscountViewWork					TBool,
		@DiscountPercentWork				TPercent,
		@DiscountTotalWork					TMoney,
		@DiscountPercentWorkFinal			TPercent,
		@DiscountTotalWorkFinal				TMoney,
		@DiscountTypeWork					TCount,
		@DiscountViewExpense				TBool,
		@DiscountPercentExpense				TPercent,
		@DiscountTotalExpense				TMoney,
		@DiscountPercentExpenseFinal		TPercent,
		@DiscountTotalExpenseFinal			TMoney,
		@DiscountTypeExpense				TCount,
		@PlanningActivityForWork			TBool,
		@PlanningEmployeeForWork			TBool,
		@PlanningQualificationForWork		TBool,
		@PlanningRateForWork				TBool,
		@PlanningDateForWork				TBool,
		@PlanningExpenseTypeForExpense		TBool,
		@PlanningEmployeeForExpense			TBool,
		@PlanningPriceForExpense			TBool,
		@PlanningDateForExpense				TBool,
		@TimeEntryAccount					TIdentifier,
		@TimeEntrySendingForApprovalAccount	TBool,
		@TimeEntryActualTotalsAccount		TIdentifier,
		@PlanProfitability					TPercent,	
		@ExpenseAccount						TIdentifier,
		@ExpenseSendingForApprovalAccount	TBool,
		@PlanPurchases						TBool,	
		@Comments							TNotes,
		@value								TVariant,
		@rv									int
	
	DECLARE -- RECURRENCE
		@Occurrences TCount

	SELECT
		@ID										= @Xml.value('(/pjm6BudgetGet/Budget/ID)[1]','int'),
		@State									= @Xml.value('(/pjm6BudgetGet/Budget/State)[1]','int'),
		@StartDate								= CAST(@Xml.value('(/pjm6BudgetGet/Budget/StartDate)[1]','varchar(19)') AS datetime),
		@EndDate								= CAST(@Xml.value('(/pjm6BudgetGet/Budget/EndDate)[1]','varchar(19)') AS datetime),
		@BudgetType								= @Xml.value('(/pjm6BudgetGet/Budget/BudgetTypeID)[1]','int'),
		@ProjectID								= @Xml.value('(/pjm6BudgetGet/Budget/DocumentID)[1]','int'),
		@UseWorkPlanning						= @Xml.value('(/pjm6BudgetGet/Budget/UseWorkPlanning)[1]','bit'),
		@UseExpensePlanning						= @Xml.value('(/pjm6BudgetGet/Budget/UseExpensePlanning)[1]','bit'),
		@WorkBudgetBottom						= @Xml.value('(/pjm6BudgetGet/Budget/WorkBudgetBottom)[1]','money'),
		@WorkBudgetHigh							= @Xml.value('(/pjm6BudgetGet/Budget/WorkBudgetHigh)[1]','money'),
		@WorkBudgetBottomEqualsPlan				= @Xml.value('(/pjm6BudgetGet/Budget/WorkBudgetBottomEqualsPlan)[1]','bit'),
		@WorkBudgetHighEqualsPlan				= @Xml.value('(/pjm6BudgetGet/Budget/WorkBudgetHighEqualsPlan)[1]','bit'),
		@ExpenseBudgetBottom					= @Xml.value('(/pjm6BudgetGet/Budget/ExpenseBudgetBottom)[1]','money'),
		@ExpenseBudgetHigh						= @Xml.value('(/pjm6BudgetGet/Budget/ExpenseBudgetHigh)[1]','money'),
		@ExpenseBudgetBottomEqualsPlan			= @Xml.value('(/pjm6BudgetGet/Budget/ExpenseBudgetBottomEqualsPlan)[1]','bit'),
		@ExpenseBudgetHighEqualsPlan			= @Xml.value('(/pjm6BudgetGet/Budget/ExpenseBudgetHighEqualsPlan)[1]','bit'),
		@NextCalculationDate					= CAST(@Xml.value('(/pjm6BudgetGet/Budget/NextCalculationDate)[1]','varchar(19)') AS datetime),
		@ReminderState							= CASE @Xml.value('(/pjm6BudgetGet/Budget/ReminderState)[1]',' varchar(5)') WHEN 'false' THEN 0 ELSE 1 END,
		@RecurrenceID							= @Xml.value('(/pjm6BudgetGet/Budget/RecurrencePatternID)[1]','int'),
		@SupervisorEmployeeID					= @Xml.value('(/pjm6BudgetGet/Budget/SupervisorEmployeeID)[1]','int'),
		@DiscountViewWork						= @Xml.value('(/pjm6BudgetGet/Budget/DiscountViewWork)[1]','bit'),
		@DiscountPercentWork					= ABS(@Xml.value('(/pjm6BudgetGet/Budget/DiscountPercentWork)[1]','decimal(18,4)')),
		@DiscountTotalWork						= ABS(@Xml.value('(/pjm6BudgetGet/Budget/DiscountTotalWork)[1]','money')),
		@DiscountTypeWork						= @Xml.value('(/pjm6BudgetGet/Budget/DiscountTypeWork)[1]','int'),
		@DiscountViewExpense					= @Xml.value('(/pjm6BudgetGet/Budget/DiscountViewExpense)[1]','bit'),
		@DiscountPercentExpense					= ABS(@Xml.value('(/pjm6BudgetGet/Budget/DiscountPercentExpense)[1]','decimal(18,4)')),
		@DiscountTotalExpense					= ABS(@Xml.value('(/pjm6BudgetGet/Budget/DiscountTotalExpense)[1]','money')),
		@DiscountTypeExpense					= @Xml.value('(/pjm6BudgetGet/Budget/DiscountTypeExpense)[1]','int'),
		@PlanningActivityForWork				= @Xml.value('(/pjm6BudgetGet/Budget/PlanningActivityForWork)[1]','bit'),
		@PlanningEmployeeForWork				= @Xml.value('(/pjm6BudgetGet/Budget/PlanningEmployeeForWork)[1]','bit'),
		@PlanningQualificationForWork			= @Xml.value('(/pjm6BudgetGet/Budget/PlanningQualificationForWork)[1]','bit'),
		@PlanningRateForWork					= @Xml.value('(/pjm6BudgetGet/Budget/PlanningRateForWork)[1]','bit'),
		@PlanningDateForWork					= @Xml.value('(/pjm6BudgetGet/Budget/PlanningDateForWork)[1]','bit'),
		@PlanningExpenseTypeForExpense			= @Xml.value('(/pjm6BudgetGet/Budget/PlanningExpenseTypeForExpense)[1]','bit'),
		@PlanningEmployeeForExpense				= @Xml.value('(/pjm6BudgetGet/Budget/PlanningEmployeeForExpense)[1]','bit'),
		@PlanningPriceForExpense				= @Xml.value('(/pjm6BudgetGet/Budget/PlanningPriceForExpense)[1]','bit'),
		@PlanningDateForExpense					= @Xml.value('(/pjm6BudgetGet/Budget/PlanningDateForExpense)[1]','bit'),
		@TimeEntryAccount						= @Xml.value('(/pjm6BudgetGet/Budget/TimeEntryAccount)[1]','int'),
		@TimeEntrySendingForApprovalAccount		= @Xml.value('(/pjm6BudgetGet/Budget/TimeEntrySendingForApprovalAccount)[1]','bit'),
		@TimeEntryActualTotalsAccount			= @Xml.value('(/pjm6BudgetGet/Budget/TimeEntryActualTotalsAccount)[1]','int'),
		@PlanProfitability						= @Xml.value('(/pjm6BudgetGet/Budget/PlanProfitability)[1]','decimal(18,4)'),
		@ExpenseAccount							= @Xml.value('(/pjm6BudgetGet/Budget/ExpenseAccount)[1]','int'),
		@ExpenseSendingForApprovalAccount		= @Xml.value('(/pjm6BudgetGet/Budget/ExpenseSendingForApprovalAccount)[1]','bit'),
		@PlanPurchases							= @Xml.value('(/pjm6BudgetGet/Budget/PlanPurchases)[1]','bit'),
		@Comments								= @Xml.value('(/pjm6BudgetGet/Budget/Comments)[1]','nvarchar(max)')
	
	IF dbo.fnPjm6CanEditBudget(@ID) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF EXISTS(SELECT @Xml.value('(/pjm6BudgetGet/RecurrencePattern/ID)[1]','int'))
	BEGIN
		SELECT
			@Occurrences = @Xml.value('(pjm6BudgetGet/RecurrencePattern/Occurrences)[1]','int')
	END

	IF(@DiscountTypeWork != 0 AND ((@DiscountViewWork = 0 AND @DiscountPercentWork IS NULL) OR (@DiscountViewWork = 1 AND @DiscountTotalWork IS NULL))) OR
		(@DiscountTypeExpense != 0 AND ((@DiscountViewExpense = 0 AND @DiscountPercentExpense IS NULL) OR (@DiscountViewExpense = 1 AND @DiscountTotalExpense IS NULL)))
	BEGIN
		RAISERROR('#DiscountIsNotDefined', 18, -1)
		RETURN 1
	END
			
	IF ((@DiscountTypeWork = 1 OR @DiscountTypeWork = 2) AND ((@DiscountViewWork = 0 AND @DiscountPercentWork = 0) OR
		(@DiscountViewWork = 1 AND @DiscountTotalWork = 0))) OR
		((@DiscountTypeExpense = 1 OR @DiscountTypeExpense = 2) AND ((@DiscountViewExpense = 0 AND @DiscountPercentExpense = 0) OR
		(@DiscountViewExpense = 1 AND @DiscountTotalExpense = 0)))
	BEGIN
		RAISERROR('#DiscountCantBeZero', 18, -1)
		RETURN 1
	END

	IF @PlanningActivityForWork = 0 AND @PlanningEmployeeForWork = 0 AND 
		@PlanningQualificationForWork = 0 AND @PlanningRateForWork = 0 
	BEGIN
		RAISERROR('#WorkPlanningParametersIsNull', 18, -1)
		RETURN 1
	END

	IF @PlanningExpenseTypeForExpense = 0 AND @PlanningEmployeeForExpense = 0 AND @PlanningPriceForExpense = 0
	BEGIN
		RAISERROR('#ExpensePlanningParametersIsNull', 18, -1)
		RETURN 1
	END

	IF @UseWorkPlanning = 0 AND @UseExpensePlanning = 0
	BEGIN
		RAISERROR('#BudgetMustHaveItemForPlanning', 18, -1)
		RETURN 1
	END

	IF @UseWorkPlanning = 0 AND (EXISTS(SELECT *FROM [BudgetLineWork] WHERE [BudgetID] = @ID) OR
		EXISTS(SELECT *FROM [BudgetLineGroup] WHERE [BudgetID] = @ID AND [State] = 1 AND [GroupTypeID] = 1 ))
	BEGIN
		RAISERROR('#BudgetHasLinesOrGroupsForPlanningItem', 18, -1)
		RETURN 1
	END

	IF @UseExpensePlanning = 0 AND (EXISTS(SELECT *FROM [BudgetLineExpense] WHERE [BudgetID] = @ID) OR
		EXISTS(SELECT *FROM [BudgetLineGroup] WHERE [BudgetID] = @ID AND [State] = 1 AND [GroupTypeID] = 2 ))
	BEGIN
		RAISERROR('#BudgetHasLinesOrGroupsForPlanningItem', 18, -1)
		RETURN 1
	END

	IF (@BudgetType > 1 AND EXISTS(SELECT * FROM [Budget] WHERE [DocumentID] = @ProjectID AND
		@ID != [ID] AND
		((@StartDate Between [Budget].[StartDate] AND [Budget].[EndDate])
		OR (@EndDate Between [Budget].[StartDate] AND [Budget].[EndDate]) OR 
		([Budget].[StartDate] Between @StartDate AND @EndDate)
		OR ([Budget].[EndDate] Between @StartDate AND @EndDate))))
	BEGIN
		RAISERROR('#crossingbudgetperiod', 18, -1)
		RETURN 1
	END

	SET @DiscountPercentWorkFinal = CASE @DiscountTypeWork 
									WHEN 0 THEN NULL 
									WHEN 1 THEN 
										CASE WHEN @DiscountViewWork = 0 THEN -@DiscountPercentWork ELSE NULL END
									WHEN 2 THEN
										CASE WHEN @DiscountViewWork = 0 THEN @DiscountPercentWork ELSE NULL END
									END
	SET @DiscountTotalWorkFinal = CASE @DiscountTypeWork 
									WHEN 0 THEN NULL 
									WHEN 1 THEN 
										CASE WHEN @DiscountViewWork = 1 THEN -@DiscountTotalWork ELSE NULL END
									WHEN 2 THEN
										CASE WHEN @DiscountViewWork = 1 THEN @DiscountTotalWork ELSE NULL END
									END
	SET @DiscountPercentExpenseFinal =	(CASE @DiscountTypeExpense 
											WHEN 0 THEN 
												NULL 
											WHEN 1 THEN 
											(CASE 
												WHEN @DiscountViewExpense = 0 THEN 
													-@DiscountPercentExpense 
												ELSE 
													NULL 
											END)
											WHEN 2 THEN
											(CASE 
												WHEN @DiscountViewExpense = 0 THEN
													@DiscountPercentExpense 
												ELSE 
													NULL 
											END)
										END)
	SET @DiscountTotalExpenseFinal = (CASE @DiscountTypeExpense 
										WHEN 0 THEN 
											NULL 
										WHEN 1 THEN 
										(CASE
											WHEN @DiscountViewExpense = 1 THEN 
												-@DiscountTotalExpense 
											ELSE 
												NULL 
										END)
										WHEN 2 THEN
										(CASE 
											WHEN @DiscountViewExpense = 1 THEN 
												@DiscountTotalExpense 
											ELSE 
												NULL 
										END)
									END)

	DECLARE
		@val TVariant,
		@GlobalPlanPurchases TBool
	EXEC adfParameterGet @Name='PlanPurchases', @Group='Pjm7', @Value = @val OUTPUT
	SET @GlobalPlanPurchases = CAST(@val as bit)

	BEGIN TRANSACTION
	/*
	IF @State = 1
	BEGIN*/
		UPDATE [Budget]
		SET
			[Budget].[StartDate] = @StartDate,
			[Budget].[EndDate] = @EndDate,
			[Budget].[WarningFlagID] = NULL,
			[Budget].[UseWorkPlanning] = @UseWorkPlanning,
			[Budget].[UseExpensePlanning] = @UseExpensePlanning,
			[Budget].[WorkBudgetBottom] = (CASE @WorkBudgetBottomEqualsPlan WHEN 1 THEN dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], @DiscountViewWork, @DiscountPercentWorkFinal, @DiscountTotalWorkFinal, [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour]) ELSE @WorkBudgetBottom END),
			[Budget].[WorkBudgetHigh] = (CASE @WorkBudgetHighEqualsPlan WHEN 1 THEN dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], @DiscountViewWork, @DiscountPercentWorkFinal, @DiscountTotalWorkFinal, [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour]) ELSE @WorkBudgetHigh END) ,
			[Budget].[WorkBudgetBottomEqualsPlan] = @WorkBudgetBottomEqualsPlan,
			[Budget].[WorkBudgetHighEqualsPlan] = @WorkBudgetHighEqualsPlan,
			[Budget].[ExpenseBudgetBottom] =	(CASE
													WHEN @ExpenseBudgetBottomEqualsPlan = 1 THEN 
													(CASE
														WHEN @PlanPurchases = 1 THEN
														(CASE
															WHEN @GlobalPlanPurchases = 1 THEN
															(CASE
																WHEN [Budget].[VATRate] IS NOT NULL AND [Budget].[VATIsIncluded] = 1 THEN
																	([Budget].[VATPCPlanPurchase] + [Budget].[TotalPCPlanPurchase])
																ELSE
																	[Budget].[TotalPCPlanPurchase]
															END)
															ELSE
															(CASE
																WHEN [Budget].[VATRate] IS NOT NULL AND [Budget].[VATIsIncluded] = 1 THEN
																	ROUND(ISNULL([Budget].[TotalWithVATPCPlannedExpense] + dbo.fnPjm6GetBudgetTotalDiscount	(	@DiscountViewExpense,
																																								@DiscountPercentExpenseFinal,
																																								@DiscountTotalExpenseFInal,
																																								[Budget].[TotalWithVATPCPlannedExpense]
																																							), 0), 2)
																ELSE
																	ROUND(ISNULL([Budget].[TotalPCPlannedExpense] + dbo.fnPjm6GetBudgetTotalDiscount	(	@DiscountViewExpense,
																																							@DiscountPercentExpenseFinal,
																																							@DiscountTotalExpenseFInal,
																																							[Budget].[TotalPCPlannedExpense]
																																						), 0), 2)
															END)	
														END)
														ELSE
														(CASE
															WHEN [Budget].[VATRate] IS NOT NULL AND [Budget].[VATIsIncluded] = 1 THEN
																ROUND(ISNULL([Budget].[TotalWithVATPCPlannedExpense] + dbo.fnPjm6GetBudgetTotalDiscount	(	@DiscountViewExpense,
																																							@DiscountPercentExpenseFinal,
																																							@DiscountTotalExpenseFInal,
																																							[Budget].[TotalWithVATPCPlannedExpense]
																																						), 0), 2)
															ELSE
																ROUND(ISNULL([Budget].[TotalPCPlannedExpense] + dbo.fnPjm6GetBudgetTotalDiscount	(	@DiscountViewExpense,
																																						@DiscountPercentExpenseFinal,
																																						@DiscountTotalExpenseFInal,
																																						[Budget].[TotalPCPlannedExpense]
																																					), 0), 2)
														END)	
													END)
													ELSE
														@ExpenseBudgetBottom
												END),
			[Budget].[ExpenseBudgetHigh] =	(CASE  
												WHEN @ExpenseBudgetHighEqualsPlan = 1 THEN 
												(CASE
													WHEN [Budget].[VATRate] IS NOT NULL AND [Budget].[VATIsIncluded] = 1 THEN
														ROUND(ISNULL([Budget].[TotalWithVATPCPlannedExpense] + dbo.fnPjm6GetBudgetTotalDiscount	(	@DiscountViewExpense,
																																					@DiscountPercentExpenseFinal,
																																					@DiscountTotalExpenseFInal,
																																					[Budget].[TotalWithVATPCPlannedExpense]
																																				), 0), 2)
													ELSE
														ROUND(ISNULL([Budget].[TotalPCPlannedExpense] + dbo.fnPjm6GetBudgetTotalDiscount	(	@DiscountViewExpense,
																																				@DiscountPercentExpenseFinal,
																																				@DiscountTotalExpenseFInal,
																																				[Budget].[TotalPCPlannedExpense]
																																			), 0), 2)
												END)
												ELSE 
													@ExpenseBudgetHigh 
											END),
			[Budget].[ExpenseBudgetBottomEqualsPlan] = @ExpenseBudgetBottomEqualsPlan,
			[Budget].[ExpenseBudgetHighEqualsPlan] = @ExpenseBudgetHighEqualsPlan,
			[Budget].[NextCalculationDate] = @NextCalculationDate,
			[Budget].[SupervisorEmployeeID] = @SupervisorEmployeeID,
			[Budget].[DiscountViewWork] = @DiscountViewWork,
			[Budget].[DiscountPercentWork] = @DiscountPercentWorkFinal,
			[Budget].[DiscountTotalWork] = @DiscountTotalWorkFinal,
			[Budget].[DiscountViewExpense] = @DiscountViewExpense,
			[Budget].[DiscountPercentExpense] = @DiscountPercentExpenseFinal,
			[Budget].[DiscountTotalExpense] = @DiscountTotalExpenseFinal,
			[Budget].[PlanningActivityForWork] = @PlanningActivityForWork,
			[Budget].[PlanningEmployeeForWork] = @PlanningEmployeeForWork,
			[Budget].[PlanningQualificationForWork] = @PlanningQualificationForWork,
			[Budget].[PlanningRateForWork] = @PlanningRateForWork,
			[Budget].[PlanningDateForWork] = @PlanningDateForWork,
			[Budget].[PlanningExpenseTypeForExpense] = @PlanningExpenseTypeForExpense,
			[Budget].[PlanningEmployeeForExpense] = @PlanningEmployeeForExpense,
			[Budget].[PlanningPriceForExpense] = @PlanningPriceForExpense,
			[Budget].[PlanningDateForExpense] = @PlanningDateForExpense,
			[Budget].[TimeEntryAccount] = @TimeEntryAccount,
			[Budget].[TimeEntrySendingForApprovalAccount] = @TimeEntrySendingForApprovalAccount,
			[Budget].[TimeEntryActualTotalsAccount] = @TimeEntryActualTotalsAccount,
			[Budget].[PlanProfitability] = (@PlanProfitability/100),
			[Budget].[ExpenseAccount] = @ExpenseAccount,
			[Budget].[ExpenseSendingForApprovalAccount] = @ExpenseSendingForApprovalAccount,
			[Budget].[PlanPurchases] = @PlanPurchases,
			[Budget].[Comments] = @Comments,
			[Budget].[Modified] = DEFAULT,
			[Budget].[ModifiedBy] = DEFAULT
		WHERE
			[Budget].[ID] = @ID

		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	/*END
	ELSE IF @State = 2
	BEGIN
		UPDATE [Budget]
		SET
			[Budget].[WarningFlagID] = NULL,
			[Budget].[NextCalculationDate] = @NextCalculationDate,
			[Budget].[SupervisorEmployeeID] = @SupervisorEmployeeID,
			[Budget].[Comments] = @Comments,
			[Budget].[Modified] = DEFAULT,
			[Budget].[ModifiedBy] = DEFAULT
		WHERE
			[Budget].[ID] = @ID

		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
	END*/

	IF @State = 1
	BEGIN
		
		UPDATE
			[RecurrencePattern]
		SET
			[Occurrences] = @Occurrences
		WHERE
			[ID] = @RecurrenceID
		IF @@error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END


	EXEC adfParameterGet 'WorkTimeStart1', 'Pjm5', @value OUTPUT	
	SET  @WorkTimeStart = CAST(@value AS int)

	SET @ReminderInterval = -@WorkTimeStart
	EXEC @rv = pjm7BudgetReminderCreate @ID,
		@NextCalculationDate, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END

	COMMIT TRANSACTION	
	
	EXEC pjm6BudgetGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetUpdate TO PUBLIC
GO
