 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CaseCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CaseCreate'
		DROP PROCEDURE [dbo].[pjm5CaseCreate]
	END
GO

PRINT 'Creating procedure pjm5CaseCreate'
GO

SET QUOTED_IDENTIFIER ON
GO

/******************************************************************************
**		File: pjm5CaseCreate.sql
**		Name: pjm5CaseCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		27.03.13	SAP				  OPENXML	
*******************************************************************************/
CREATE PROCEDURE [pjm5CaseCreate]
	@Xml XML
AS
	SET NOCOUNT ON
	DECLARE
		@ID TIdentifier,
		@State TState
	
	SET @State = dbo.adfwfGetInitialState('6043fc81-6f77-4e97-8a83-c4a60cd990f0')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	DECLARE 
		@FileAs TName,
		@Code TCode,
		@CompanyID TIdentifier,
		@EmployeeID TIdentifier,
		@StartDate TDate,
		@EndDate TDate,
		@NumberTemplate TName,
		@CurrentNumber TCount,
		@Increment TCount,
		@AllowInternal TBool,
		@AllowIncoming TBool,
		@AllowOutgoing TBool,
		@AllowFolder TBool,
		@HasToBeSentBack TBool,
		@Comments TNotes,
		@WordTemplatesFolderID TIdentifier,
		@WordTemplatesPath TNotes
		
	SELECT
		@FileAs = T.c.value('FileAs[1]', 'nvarchar(512)'),
		@Code = T.c.value('Code[1]','nvarchar(32)'),
		@CompanyID = T.c.value('CompanyID[1]','int'),
		@EmployeeID = T.c.value('EmployeeID[1]','int'),
		@StartDate = CAST(T.c.value('StartDate[1]','varchar(19)') as datetime),
		@EndDate = CAST(T.c.value('EndDate[1]','varchar(19)') as datetime),
		@NumberTemplate  = T.c.value('NumberTemplate[1]','nvarchar(512)'),
		@CurrentNumber = T.c.value('CurrentNumber[1]','int'),
		@Increment = T.c.value('Increment[1]','int'),
		@AllowInternal = CASE WHEN T.c.value('AllowInternal[1]','varchar(5)') = 'false' THEN 0 ELSE 1 END,
		@AllowIncoming = CASE WHEN T.c.value('AllowIncoming[1]','varchar(5)') = 'false' THEN 0 ELSE 1 END,
		@AllowOutgoing = CASE WHEN T.c.value('AllowOutgoing[1]','varchar(5)') = 'false' THEN 0 ELSE 1 END,
		@AllowFolder = CASE WHEN T.c.value('AllowFolder[1]','varchar(5)') = 'false' THEN 0 ELSE 1 END,
		@HasToBeSentBack  = CASE WHEN T.c.value('HasToBeSentBack[1]','varchar(5)') = 'false' THEN 0 ELSE 1 END,
		@Comments = T.c.value('Comments[1]','nvarchar(max)'),
		@WordTemplatesFolderID = T.c.value('WordTemplatesFolderID[1]','int'),
		@WordTemplatesPath = T.c.value('WordTemplatesPath[1]','nvarchar(max)')
	FROM
		 @Xml.nodes('/pjm5CaseGet/Case') AS T(c)

	BEGIN TRANSACTION
	INSERT INTO [Case]
		([State], 
		[Flag], 
		[Code],
		[FileAs],
		[CompanyID],
		[EmployeeID],
		[StartDate],
		[EndDate],
		[NumberTemplate],
		[CurrentNumber],
		[Increment],
		[AllowInternal],
		[AllowIncoming],
		[AllowOutgoing],
		[AllowFolder],
		[HasToBeSentBack],
		[Comments],
		[WordTemplatesFolderID],
		[WordTemplatesPath])
	VALUES
		(@State, 
		0, 
		@Code,
		@FileAs,
		@CompanyID,
		@EmployeeID,
		@StartDate,
		@EndDate,
		@NumberTemplate,
		@CurrentNumber,
		@Increment,
		@AllowInternal,
		@AllowIncoming,
		@AllowOutgoing,
		@AllowFolder,
		@HasToBeSentBack,
		@Comments,
		@WordTemplatesFolderID,
		@WordTemplatesPath)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	SET @ID = SCOPE_IDENTITY()
	
	INSERT INTO [CaseOfFolder] ([FolderID], [CaseID], [Allowed])
	SELECT
		[Folder].[ID], @ID, 
		CASE WHEN ISNULL(T.C.value('.', 'int'), 0) = 0 THEN 1 ELSE 0 END
	FROM
		[Folder]
		OUTER APPLY [Folder].[Parameters].nodes('/Parameters/AllowClassFlag') T(C)
	WHERE
		[Folder].[CompanyID] = @CompanyID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	EXEC pjm5CaseGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5CaseCreate TO PUBLIC
GO