 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentCardMoveTo]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentCardMoveTo'
		DROP PROCEDURE [dbo].[pjm5DocumentCardMoveTo]
	END
GO

PRINT 'Creating procedure pjm5DocumentCardMoveTo'
GO

/******************************************************************************
**		File: pjm5DocumentCardMoveTo.sql
**		Name: pjm5DocumentCardMoveTo
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentCardMoveTo]
	@ID TIdentifier,
	@FolderID TIdentifier
AS
	SET NOCOUNT ON
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('AccessToPublicFolders')) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF NOT EXISTS(SELECT * FROM [Folder] WHERE [ID] = @FolderID)
	BEGIN
		RAISERROR('#folderisdeleted', 18, -1)
		RETURN 1
	END
	
	DECLARE 
		@UserID TIdentifier,
		@PrevFolderID TIdentifier,
		@CreatedBy TIdentifier,
		@ModifiedBy TIdentifier,
		@State TState,
		@DocumentItemID TIdentifier,
		@rv int

	SELECT 
		@PrevFolderID = [DocumentCard].[FolderID],
		@CreatedBy = [DocumentCard].[CreatedBy],
		@ModifiedBy = [DocumentCard].[ModifiedBy],
		@State = [DocumentItem].[State],
		@DocumentItemID = [DocumentItem].[ID]
	FROM 
		[DocumentCard]
		LEFT OUTER JOIN [DocumentItem]
			ON [DocumentItem].[DocumentCardID] = [DocumentCard].[ID]
	WHERE
		[DocumentCard].[ID] = @ID
	IF @PrevFolderID != @FolderID
	BEGIN
		SET @UserID = dbo.adfGetCurrentUserID()
		IF NOT (@PrevFolderID = -1 AND @UserID = @ModifiedBy)
		BEGIN
			IF dbo.fnFolderHasRightAccess(@PrevFolderID, @UserID, 'DeleteAll') = 0
			BEGIN
				IF dbo.fnFolderHasRightAccess(@PrevFolderID, @UserID, 'DeleteOwn') = 0
				BEGIN
					RAISERROR('#accessdenied', 18, -1)
					RETURN 1
				END
				IF @UserID != @CreatedBy
				BEGIN
					RAISERROR('#accessdenied', 18, -1)
					RETURN 1
				END
			END
		END
		
		IF dbo.fnFolderHasRightAccess(@FolderID, @UserID, 'CreateItems') = 0
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END
		
		IF @State = 3 -- Checked Out
		BEGIN
			RAISERROR('#cannotmovecheckedoutdocument', 18, -1)
			RETURN 1
		END
		
		BEGIN TRANSACTION
		EXEC pjm5DocumentItemDeleteNotification @DocumentItemID
		
		IF @PrevFolderID = -1
		BEGIN
			EXEC @rv = pjm5DocumentCardChangeState @ID, 1
			IF @rv != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
			IF @DocumentItemID IS NOT NULL
			BEGIN
				EXEC @rv = pjm5DocumentItemChangeState @DocumentItemID, 1
				IF @rv != 0
				BEGIN
					ROLLBACK TRANSACTION
					RETURN 1
				END
			END
		END

		UPDATE
			[DocumentCard]
		SET
			[FolderID] = @FolderID,
			[Modified] = DEFAULT,
			[ModifiedBy] = DEFAULT
		WHERE
			[ID] = @ID
		IF @@error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		UPDATE
			[DocumentItem]
		SET
			[FolderID] = @FolderID,
			[Modified] = DEFAULT,
			[ModifiedBy] = DEFAULT
		WHERE
			[ID] = @DocumentItemID
		IF @@error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		EXEC pjm5DocumentItemCreateNotification @DocumentItemID
		
		COMMIT TRANSACTION
	END	
	EXEC pjm5DocumentCardGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentCardMoveTo TO PUBLIC
GO
