 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentItemGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentItemGet'
		DROP PROCEDURE [dbo].[pjm5DocumentItemGet]
	END
GO

PRINT 'Creating procedure pjm5DocumentItemGet'
GO

/******************************************************************************
**		File: pjm5DocumentItemGet.sql
**		Name: pjm5DocumentItemGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentItemGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE @FolderID TIdentifier
	SELECT @FolderID = [FolderID] FROM [DocumentItem] WHERE [ID] = @ID
	
	IF @FolderID > 0
	BEGIN
		IF dbo.adfHasAccessRight(dbo.adfGetRightID('AccessToPublicFolders')) = 0
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END
	END

	DECLARE 
		@UserID TIdentifier,
		@rv int
	SET @UserID = dbo.adfGetCurrentUserID()
	EXEC @rv = pjm5DocumentItemCheckReadAccess @ID
	IF @rv != 0
		RETURN 1

	SELECT
		[DocumentItem].[Class],
		[DocumentItem].[ID],
		[DocumentItem].[State],
		[DocumentItem].[Flag],
		[DocumentItem].[FolderID],

		[DocumentCard].[Class] AS [DocumentCardClass],
		[DocumentCard].[ID] AS [DocumentCardID],
		[DocumentCard].[CardOwnerID],
		[DocumentCard].[FileAs],

		[DocumentItem].[FileName],
		[DocumentItem].[Extension],
		[DocumentItem].[LatestVersion],
		[DocumentVersion].[DataLength],
		[DocumentItem].[CheckedOutBy],
		[DocumentCard].[Comments],
		[DocumentCard].[Created],
		[DocumentCard].[CreatedBy],
		[DocumentCard].[Modified],
		[DocumentCard].[ModifiedBy],
		CAST([DocumentCard].[Timestamp] as bigint) AS [Timestamp],
		CAST('acb865ab-ae3c-429e-af10-d14d6a46363b' as uniqueidentifier) AS [Guid]
	FROM
		[DocumentItem]
		INNER JOIN [DocumentCard]
			ON [DocumentItem].[DocumentCardID] = [DocumentCard].[ID]
		LEFT OUTER JOIN [DocumentVersion]
			ON [DocumentVersion].[DocumentItemID] = [DocumentItem].[ID] AND
				[DocumentVersion].[Version] = [DocumentItem].[LatestVersion]
	WHERE
		[DocumentItem].[ID] = @ID

	SELECT
		[DocumentVersion].[ID],
		[DocumentVersion].[DocumentItemID],
		[DocumentVersion].[Version],
		[DocumentVersion].[DataLength],
		[DocumentVersion].[Created],
		[DocumentVersion].[CreatedBy],
		[DocumentVersion].[Comments],
		[Trustee].[DisplayName] AS [UserName]
	FROM
		[DocumentVersion]
		INNER JOIN [Trustee]
			ON [Trustee].[ID] = [DocumentVersion].[CreatedBy]
	WHERE
		[DocumentItemID] = @ID
	RETURN 0
GO

GRANT EXECUTE ON [pjm5DocumentItemGet] TO PUBLIC
GO

