IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentItemCreateNotification]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5DocumentItemCreateNotification'
	DROP PROCEDURE [dbo].[pjm5DocumentItemCreateNotification]
END
GO

PRINT 'Creating procedure pjm5DocumentItemCreateNotification'
GO

/******************************************************************************
**		File: pjm5DocumentItemCreateNotification.sql
**		Name: pjm5DocumentItemCreateNotification
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentItemCreateNotification]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE 
		@FromID TIdentifier,
		@Language TCode
		
	SET @FromID = dbo.adfGetCurrentUserID()
	SET @Language = dbo.adfGetLanguage()

	
	INSERT INTO [MailItem]
		([State], [Flag], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	SELECT
		1,
		0,
		CASE @Language 
			WHEN 'en' THEN 'File ''' + [DocumentItem].[FileAs] + ''' has been created in folder''' + [Folder].[FileAs] + '''.'
			ELSE ' ''' + [DocumentItem].[FileAs] + '''     '''+ [Folder].[FileAs] + '''.'
		END,
		N'KickMail',
		@FromID,
		[FolderNotificationSettings].[TrusteeID],
		[DocumentItem].[Class],
		[DocumentItem].[ID],
		0,
		CASE @Language 
			WHEN 'en' THEN 'File ''' + REPLACE([DocumentItem].[FileAs], '&', '&amp;') + ''' has been created in folder''' + [Folder].[FileAs] + '''.'
			ELSE ' ''' + REPLACE([DocumentItem].[FileAs], '&', '&amp;') + '''     '''+ [Folder].[FileAs] + '''.'
		END,
		CASE
			WHEN [DocumentItem].[State] = 2 AND @Language = 'en' THEN 'File has been created and publicated.'
			WHEN [DocumentItem].[State] = 2 AND @Language != 'en' THEN '    .'
			ELSE NULL
		END
	FROM
		[DocumentItem]
		INNER JOIN [DocumentCard]
			ON [DocumentCard].[ID] = [DocumentItem].[DocumentCardID]
		INNER JOIN [Folder]
			ON [Folder].[ID] = [DocumentCard].[FolderID]
		INNER JOIN [FolderNotificationSettings]
			ON [FolderNotificationSettings].[FolderID] = [Folder].[ID] AND
				[FolderNotificationSettings].[TrusteeID] != @FromID AND
				([FolderNotificationSettings].[FileSettings] & 0x0001) = 0x0001
	WHERE
		[DocumentItem].[ID] = @ID AND
		dbo.fnFolderHasRightAccess([Folder].[ID], [FolderNotificationSettings].[TrusteeID], 'READITEMS') = 1
		
	RETURN 0
GO
  
GRANT EXECUTE ON [pjm5DocumentItemCreateNotification] TO [public]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentItemPublicatedNotification]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5DocumentItemPublicatedNotification'
	DROP PROCEDURE [dbo].[pjm5DocumentItemPublicatedNotification]
END
GO

PRINT 'Creating procedure pjm5DocumentItemPublicatedNotification'
GO

/******************************************************************************
**		File: pjm5DocumentItemPublicatedNotification.sql
**		Name: pjm5DocumentItemPublicatedNotification
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentItemPublicatedNotification]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE 
		@FromID TIdentifier,
		@Language TCode
		
	SET @FromID = dbo.adfGetCurrentUserID()
	SET @Language = dbo.adfGetLanguage()

	
	INSERT INTO [MailItem]
		([State], [Flag], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	SELECT
		1,
		0,
		CASE @Language 
			WHEN 'en' THEN 'File ''' + [DocumentItem].[FileAs] + ''' has been publicated.'
			ELSE ' ''' + [DocumentItem].[FileAs] + '''  .'
		END,
		N'KickMail',
		@FromID,
		[FolderNotificationSettings].[TrusteeID],
		[DocumentItem].[Class],
		[DocumentItem].[ID],
		0,
		CASE @Language 
			WHEN 'en' THEN 'File ''' + REPLACE([DocumentItem].[FileAs], '&', '&amp;') + ''' has been publicated.'
			ELSE ' ''' + REPLACE([DocumentItem].[FileAs], '&', '&amp;') + '''  .'
		END,
		NULL
	FROM
		[DocumentItem]
		INNER JOIN [DocumentCard]
			ON [DocumentCard].[ID] = [DocumentItem].[DocumentCardID]
		INNER JOIN [Folder]
			ON [Folder].[ID] = [DocumentCard].[FolderID]
		INNER JOIN [FolderNotificationSettings]
			ON [FolderNotificationSettings].[FolderID] = [Folder].[ID] AND
				[FolderNotificationSettings].[TrusteeID] != @FromID AND
				([FolderNotificationSettings].[FileSettings] & 0x0002) = 0x0002
	WHERE
		[DocumentItem].[ID] = @ID AND
		dbo.fnFolderHasRightAccess([Folder].[ID], [FolderNotificationSettings].[TrusteeID], 'READITEMS') = 1
		
	RETURN 0
GO
  
GRANT EXECUTE ON [pjm5DocumentItemPublicatedNotification] TO [public]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentItemCheckOutNotification]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5DocumentItemCheckOutNotification'
	DROP PROCEDURE [dbo].[pjm5DocumentItemCheckOutNotification]
END
GO

PRINT 'Creating procedure pjm5DocumentItemCheckOutNotification'
GO

/******************************************************************************
**		File: pjm5DocumentItemCheckOutNotification.sql
**		Name: pjm5DocumentItemCheckOutNotification
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentItemCheckOutNotification]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE 
		@FromID TIdentifier,
		@Language TCode
		
	SET @FromID = dbo.adfGetCurrentUserID()
	SET @Language = dbo.adfGetLanguage()

	
	INSERT INTO [MailItem]
		([State], [Flag], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	SELECT
		1,
		0,
		CASE @Language 
			WHEN 'en' THEN 'File ''' + [DocumentItem].[FileAs] + ''' has been checked out.'
			ELSE ' ''' + [DocumentItem].[FileAs] + '''  .'
		END,
		N'KickMail',
		@FromID,
		[FolderNotificationSettings].[TrusteeID],
		[DocumentItem].[Class],
		[DocumentItem].[ID],
		0,
		CASE @Language 
			WHEN 'en' THEN 'File ''' + REPLACE([DocumentItem].[FileAs], '&', '&amp;') + ''' has been checked out.'
			ELSE ' ''' + REPLACE([DocumentItem].[FileAs], '&', '&amp;') + '''  .'
		END,
		NULL
	FROM
		[DocumentItem]
		INNER JOIN [DocumentCard]
			ON [DocumentCard].[ID] = [DocumentItem].[DocumentCardID]
		INNER JOIN [Folder]
			ON [Folder].[ID] = [DocumentCard].[FolderID]
		INNER JOIN [FolderNotificationSettings]
			ON [FolderNotificationSettings].[FolderID] = [Folder].[ID] AND
				[FolderNotificationSettings].[TrusteeID] != @FromID AND
				([FolderNotificationSettings].[FileSettings] & 0x0010) = 0x0010
	WHERE
		[DocumentItem].[ID] = @ID AND
		dbo.fnFolderHasRightAccess([Folder].[ID], [FolderNotificationSettings].[TrusteeID], 'READITEMS') = 1
		
	RETURN 0
GO
  
GRANT EXECUTE ON [pjm5DocumentItemCheckOutNotification] TO [public]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentItemCheckInNotification]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5DocumentItemCheckInNotification'
	DROP PROCEDURE [dbo].[pjm5DocumentItemCheckInNotification]
END
GO

PRINT 'Creating procedure pjm5DocumentItemCheckInNotification'
GO

/******************************************************************************
**		File: pjm5DocumentItemCheckInNotification.sql
**		Name: pjm5DocumentItemCheckInNotification
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentItemCheckInNotification]
	@ID TIdentifier,
	@Mode TName = NULL
AS
	SET NOCOUNT ON
	
	DECLARE 
		@FromID TIdentifier,
		@Language TCode
		
	SET @FromID = dbo.adfGetCurrentUserID()
	SET @Language = dbo.adfGetLanguage()

	
	INSERT INTO [MailItem]
		([State], [Flag], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	SELECT
		1,
		0,
		CASE @Language 
			WHEN 'en' THEN 'File ''' + [DocumentItem].[FileAs] + ''' has been checked in.'
			ELSE ' ''' + [DocumentItem].[FileAs] + '''  .'
		END,
		N'KickMail',
		@FromID,
		[FolderNotificationSettings].[TrusteeID],
		[DocumentItem].[Class],
		[DocumentItem].[ID],
		0,
		CASE @Language 
			WHEN 'en' THEN 'File ''' + REPLACE([DocumentItem].[FileAs], '&', '&amp;') + ''' has been checked in.'
			ELSE ' ''' + REPLACE([DocumentItem].[FileAs], '&', '&amp;') + '''  .'
		END,
		CASE
			WHEN UPPER(@Mode) = 'UNDO' AND @Language = 'en' THEN 'Undo chekout.'
			WHEN UPPER(@Mode) = 'UNDO' AND @Language != 'en' THEN '   .'
			ELSE NULL
		END
	FROM
		[DocumentItem]
		INNER JOIN [DocumentCard]
			ON [DocumentCard].[ID] = [DocumentItem].[DocumentCardID]
		INNER JOIN [Folder]
			ON [Folder].[ID] = [DocumentCard].[FolderID]
		INNER JOIN [FolderNotificationSettings]
			ON [FolderNotificationSettings].[FolderID] = [Folder].[ID] AND
				[FolderNotificationSettings].[TrusteeID] != @FromID AND
				([FolderNotificationSettings].[FileSettings] & 0x0020) = 0x0020
	WHERE
		[DocumentItem].[ID] = @ID AND
		dbo.fnFolderHasRightAccess([Folder].[ID], [FolderNotificationSettings].[TrusteeID], 'READITEMS') = 1
		
	RETURN 0
GO
  
GRANT EXECUTE ON [pjm5DocumentItemCheckInNotification] TO [public]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentItemDeleteNotification]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5DocumentItemDeleteNotification'
	DROP PROCEDURE [dbo].[pjm5DocumentItemDeleteNotification]
END
GO

PRINT 'Creating procedure pjm5DocumentItemDeleteNotification'
GO

/******************************************************************************
**		File: pjm5DocumentItemDeleteNotification.sql
**		Name: pjm5DocumentItemDeleteNotification
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentItemDeleteNotification]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE 
		@FromID TIdentifier,
		@Language TCode
		
	SET @FromID = dbo.adfGetCurrentUserID()
	SET @Language = dbo.adfGetLanguage()

	
	INSERT INTO [MailItem]
		([State], [Flag], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	SELECT
		1,
		0,
		CASE @Language 
			WHEN 'en' THEN 'File ''' + [DocumentItem].[FileAs] + ''' has been deleted from folder''' + [Folder].[FileAs] + '''.'
			ELSE ' ''' + [DocumentItem].[FileAs] + '''     '''+ [Folder].[FileAs] + '''.'
		END,
		N'KickMail',
		@FromID,
		[FolderNotificationSettings].[TrusteeID],
		[Folder].[Class],
		[Folder].[ID],
		0,
		CASE @Language 
			WHEN 'en' THEN 'File ''' + REPLACE([DocumentItem].[FileAs], '&', '&amp;') + ''' has been deleted from folder''' + [Folder].[FileAs] + '''.'
			ELSE ' ''' + REPLACE([DocumentItem].[FileAs], '&', '&amp;') + '''     '''+ [Folder].[FileAs] + '''.'
		END,
		CASE @Language 
			WHEN 'en' THEN 'Element contains folder.'
			ELSE '  '
		END
	FROM
		[DocumentItem]
		INNER JOIN [DocumentCard]
			ON [DocumentCard].[ID] = [DocumentItem].[DocumentCardID]
		INNER JOIN [Folder]
			ON [Folder].[ID] = [DocumentCard].[FolderID]
		INNER JOIN [FolderNotificationSettings]
			ON [FolderNotificationSettings].[FolderID] = [Folder].[ID] AND
				[FolderNotificationSettings].[TrusteeID] != @FromID AND
				([FolderNotificationSettings].[FileSettings] & 0x0100) = 0x0100
	WHERE
		[DocumentItem].[ID] = @ID AND
		dbo.fnFolderHasRightAccess([Folder].[ID], [FolderNotificationSettings].[TrusteeID], 'READITEMS') = 1
		
	RETURN 0
GO
  
GRANT EXECUTE ON [pjm5DocumentItemDeleteNotification] TO [public]
GO

