IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentSendTypeBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentSendTypeBrowse'
		DROP PROCEDURE [dbo].[pjm5DocumentSendTypeBrowse]
	END
GO

PRINT 'Creating procedure pjm5DocumentSendTypeBrowse'
GO

/******************************************************************************
**		File: pjm5DocumentSendTypeBrowse.sql
**		Name: pjm5DocumentSendTypeBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentSendTypeBrowse]
	@StateSelector INT
AS
	SET NOCOUNT ON
	SELECT
		[DocumentSendType].[Class],
		[DocumentSendType].[ID],
		[DocumentSendType].[State],
		[DocumentSendType].[Flag],
		[DocumentSendType].[Code],
		[DocumentSendType].[FileAs],
		[DocumentSendType].[Comments],
		[DocumentSendType].[Created],
		[DocumentSendType].[CreatedBy],
		[DocumentSendType].[Modified],
		[DocumentSendType].[ModifiedBy],
		[DocumentSendType].[Timestamp]
	FROM
		[DocumentSendType]
	WHERE
		(
			(@StateSelector = 0) OR 
			(@StateSelector = 1 AND [DocumentSendType].[State] IN (1, 100)) OR
			(@StateSelector = 2 AND [DocumentSendType].[State] = 2)
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5DocumentSendTypeBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentSendTypeGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentSendTypeGet'
		DROP PROCEDURE [dbo].[pjm5DocumentSendTypeGet]
	END
GO

PRINT 'Creating procedure pjm5DocumentSendTypeGet'
GO

/******************************************************************************
**		File: pjm5DocumentSendTypeGet.sql
**		Name: pjm5DocumentSendTypeGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentSendTypeGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[DocumentSendType].[Class],
		[DocumentSendType].[ID],
		[DocumentSendType].[State],
		[DocumentSendType].[Flag],
		[DocumentSendType].[Code],
		[DocumentSendType].[FileAs],
		[DocumentSendType].[Comments],
		[DocumentSendType].[Created],
		[DocumentSendType].[CreatedBy],
		[DocumentSendType].[Modified],
		[DocumentSendType].[ModifiedBy],
		[DocumentSendType].[Timestamp]
	FROM
		[DocumentSendType]
	WHERE
		[DocumentSendType].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [pjm5DocumentSendTypeGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentSendTypeCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentSendTypeCreate'
		DROP PROCEDURE [dbo].[pjm5DocumentSendTypeCreate]
	END
GO

PRINT 'Creating procedure pjm5DocumentSendTypeCreate'
GO

/******************************************************************************
**		File: pjm5DocumentSendTypeCreate.sql
**		Name: pjm5DocumentSendTypeCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		01.12.09	SPV				 GUID  CustodyPlace  DocumentSendType
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentSendTypeCreate]
	@Code TCode,
	@FileAs TName,
	@Comments TNotes
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('682CC1D9-FD79-4652-B87F-8963FE676486')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	INSERT INTO [DocumentSendType]
		([Flag], [State], [Code], [FileAs], [Comments])
	VALUES
		(0, @State, @Code, @FileAs, @Comments)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	EXEC pjm5DocumentSendTypeGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentSendTypeCreate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentSendTypeUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentSendTypeUpdate'
		DROP PROCEDURE [dbo].[pjm5DocumentSendTypeUpdate]
	END
GO

PRINT 'Creating procedure pjm5DocumentSendTypeUpdate'
GO

/******************************************************************************
**		File: pjm5DocumentSendTypeUpdate.sql
**		Name: pjm5DocumentSendTypeUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5DocumentSendTypeUpdate
	@ID TIdentifier,
	@Code TCode,
	@FileAs TName,
	@Comments TNotes
AS
	
	SET NOCOUNT ON
	
	UPDATE 
		[DocumentSendType]
	SET
		[DocumentSendType].[Code] = @Code,
		[DocumentSendType].[FileAs] = @FileAs,
		[DocumentSendType].[Comments] = @Comments,
		[DocumentSendType].[Modified] = DEFAULT,
		[DocumentSendType].[ModifiedBy] = DEFAULT
	WHERE
		[DocumentSendType].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	EXEC pjm5DocumentSendTypeGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentSendTypeUpdate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentSendTypeDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentSendTypeDelete'
		DROP PROCEDURE [dbo].[pjm5DocumentSendTypeDelete]
	END
GO

PRINT 'Creating procedure pjm5DocumentSendTypeDelete'
GO

/******************************************************************************
**		File: pjm5DocumentSendTypeDelete.sql
**		Name: pjm5DocumentSendTypeDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5DocumentSendTypeDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DELETE FROM [DocumentSendType] WHERE [DocumentSendType].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentSendTypeDelete TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentSendTypeChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentSendTypeChangeState'
		DROP PROCEDURE [dbo].[pjm5DocumentSendTypeChangeState]
	END
GO

PRINT 'Creating procedure pjm5DocumentSendTypeChangeState'
GO

/******************************************************************************
**		File: pjm5DocumentSendTypeChangeState.sql
**		Name: pjm5DocumentSendTypeChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5DocumentSendTypeChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [DocumentSendType].[Class],
		@FromState = [DocumentSendType].[State]
	FROM
		[DocumentSendType]
	WHERE
		[DocumentSendType].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE
		[DocumentSendType]
	SET
		[DocumentSendType].[State] = @ToState,
		[DocumentSendType].[Modified] = DEFAULT,
		[DocumentSendType].[ModifiedBy] = DEFAULT
	WHERE
		[DocumentSendType].[ID] = @ID
	AND
		[DocumentSendType].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentSendTypeChangeState TO PUBLIC
GO
