IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6AutoTransitionParametersSet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6AutoTransitionParametersSet'
		DROP PROCEDURE [dbo].[pjm6AutoTransitionParametersSet]
	END
GO

PRINT 'Creating Procedure pjm6AutoTransitionParametersSet'
GO
/******************************************************************************
**		File: 
**		Name: pjm6AutoTransitionParametersSet
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: yuriy.soldatkin
**		Date: 11.02.10
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure pjm6AutoTransitionParametersSet
	@UserID TIdentifier

AS
	SET NOCOUNT ON
	DECLARE 
		@TimeEntryApproveForDocumentInFinalState TVariant

	SELECT 
		@TimeEntryApproveForDocumentInFinalState = [Value]
	FROM
		[F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53]
	WHERE
		[Name]='TimeEntryApproveForDocumentInFinalState'
	
	IF @TimeEntryApproveForDocumentInFinalState IS NOT NULL
	BEGIN
		BEGIN TRANSACTION
		IF (NOT EXISTS (SELECT *FROM [UserParameter] WHERE [UserID] = @UserID and [Name] = 'TimeEntryApproveForDocumentInFinalState'))
		BEGIN
			INSERT INTO [UserParameter] ([UserID], [Name], [Value]) VALUES(@UserID, 'TimeEntryApproveForDocumentInFinalState', @TimeEntryApproveForDocumentInFinalState)
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		COMMIT TRANSACTION
	END
	RETURN 0
GO

GRANT EXEC ON pjm6AutoTransitionParametersSet TO PUBLIC
GO