IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'EmployeeCalendarBrowse')
	BEGIN
		PRINT 'Dropping Procedure EmployeeCalendarBrowse'
		DROP  Procedure  EmployeeCalendarBrowse
	END

GO

PRINT 'Creating Procedure EmployeeCalendarBrowse'
GO
/******************************************************************************
**		File: 
**		Name: EmployeeCalendarBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE EmployeeCalendarBrowse
	@EmployeeID TIdentifier
AS
	DECLARE @WorkTime INT, @Param TVariant, @result INT, @WorkingDays INT
	
	SET NOCOUNT ON

	EXEC @result = adfParameterGet 'WorkTime', 'Pjm5', @Param OUTPUT
	SET @WorkTime = CAST(@Param as INT)

	EXEC @result = adfParameterGet 'WorkDaysOfWeek', 'Pjm5', @Param OUTPUT
	SET @WorkingDays = CAST(@Param as INT)	
	
	SELECT
		@WorkTime as [WorkTime],
		@WorkingDays as [WorkingDays]

	SELECT
		[Date],
		[NonWorkingTime],
		[Recurrent]
	FROM
		[Calendar]
		
	SELECT
		[Date],
		[Working],
		([Planned] - [Approved]) as [Planned],
		[Approved],
		[Actual]
	FROM
		[EmployeeCalendar]
	WHERE
		[EmployeeID] = @EmployeeID
		
	RETURN 0
GO

GRANT EXEC ON EmployeeCalendarBrowse TO PUBLIC
GO
