IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6DocumentExpenseBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6DocumentExpenseBrowse'
		DROP PROCEDURE [dbo].[pjm6DocumentExpenseBrowse]
	END
GO

PRINT 'Creating procedure pjm6DocumentExpenseBrowse'
GO

/******************************************************************************
**		File: pjm6DocumentExpenseBrowse.sql
**		Name: pjm6DocumentExpenseBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 05/28/2005 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		28.05.09	SPV				 
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6DocumentExpenseBrowse]
	@DocumentID TIdentifier,
	@DocumentClass TClass,
	@EmployeeID TIdentifier,
	@StateSelector INT,
	@DateSelector	INT,
	@PeriodStart	datetime,
	@PeriodEnd		datetime
AS
	SET NOCOUNT ON
	DECLARE 
		@date datetime,
		@ViewAllFinance TBool,
		@CurrentEmployeeID TIdentifier,
		@ProjectID TIdentifier,
		@RestrictedView TBool,
		@TaskRequestClass TClass

	SET @TaskRequestClass = dbo.adfGetClassByName('Pjm5.TaskRequest')
	SET @RestrictedView = dbo.adfHasAccessRightByName('RestrictedView')	
	SET @ViewAllFinance = dbo.adfHasAccessRightByName('ViewAllFinance')
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @date = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime)
		
	SELECT TOP 1
		@ProjectID = [ProjectID]
	FROM
		[Expense]
	WHERE
		[DocumentID] = @DocumentID AND [DocumentClass] = @DocumentClass


	IF @ViewAllFinance = 0 AND
		@EmployeeID != @CurrentEmployeeID AND
		dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID) = 0 AND
		dbo.fnPjm5IsProjectEnhancementMember(@ProjectID, @CurrentEmployeeID) != 1 AND
		@DocumentClass != @TaskRequestClass		
	BEGIN
		RAISERROR('#NotEnoughPermissions', 18, -1)
		RETURN 1
	END
	
	SELECT
		[Expense].[Class],
		[Expense].[ID],
		[Expense].[State],
		[Expense].[Flag],
		[Expense].[FileAs],
		[Expense].[ProjectID],
		[Expense].[EmployeeID],
		[Expense].[ExpenseCodeID],
		[Expense].[Date],
		[Expense].[Amount],
		[Expense].[Billable],
		[Expense].[Price],
		[Expense].[FromCurrencyCode],
		[Expense].[ToCurrencyCode],
		[Expense].[CurrencyRate],
		[Expense].[VATRate],
		[Expense].[VAT],
		[Expense].[Comments],
		[Expense].[Created],
		[Expense].[CreatedBy],
		[Expense].[Modified],
		[Expense].[ModifiedBy],
		[Expense].[Timestamp],
		[Expense].[SumExpense],
		[Expense].[SumProjectCurrency],
		[Expense].[TotalSumExpense],
		[Expense].[TotalSumProjectCurrency]
	FROM
		[pjm5vwExpense] AS [Expense]
		INNER JOIN [Project]
			ON [Project].[ID] = [Expense].[ProjectID]
	WHERE
		( 
			dbo.fnPjm5HasFinansDataAccess([Project].[ID], @CurrentEmployeeID, NULL, NULL) = 1 OR 
			dbo.fnPjm5AllowCreateProjectEntry([Project].[ID], [Expense].[EmployeeID]) = 1 OR
			(dbo.fnPjm5IsProjectMember([Project].[ID], @CurrentEmployeeID) = 1 AND @RestrictedView = 0)
		) AND
		(
			[Expense].[DocumentClass] = @DocumentClass AND [Expense].[DocumentID] = @DocumentID
		) AND
		(
			@EmployeeID IS NULL OR
			[Expense].[EmployeeID] = @EmployeeID
		) AND 
		(
			(@StateSelector = 0) OR										--  
			(@StateSelector = 1 AND [Expense].[State] IN (1, 5)) OR	-- / 
			(@StateSelector = 2 AND [Expense].[State] = 2) OR			-- .  
			(@StateSelector = 3 AND [Expense].[State] = 3) OR			-- 
			(@StateSelector = 4 AND [Expense].[State] = 6) OR			--   
			(@StateSelector = 5 AND [Expense].[State] = 4)			-- 
		) 
	RETURN 0
GO

GRANT EXECUTE ON [pjm6DocumentExpenseBrowse] TO PUBLIC
GO
   
/*
** Made by Nikita
*/

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6DocumentExpenseBrowseExtended]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6DocumentExpenseBrowseExtended'
		DROP PROCEDURE [dbo].[pjm6DocumentExpenseBrowseExtended]
	END
GO

PRINT 'Creating procedure pjm6DocumentExpenseBrowse'
GO

/******************************************************************************
**		File: pjm6DocumentExpenseBrowseExtended.sql
**		Name: pjm6DocumentExpenseBrowseExtended
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: nikita.alexandrov
**		Date: 09/07/2009 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		28.05.09	ANA				 
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6DocumentExpenseBrowseExtended]
	@DocumentID TIdentifier,
	@DocumentClass TClass,
	@EmployeeID TIdentifier,
	@StateSelector INT,
	@DateSelector	INT,
	@PeriodStart	datetime,
	@PeriodEnd		datetime
AS
	SET NOCOUNT ON
	DECLARE 
		@date datetime,
		@ViewAllFinance TBool,
		@CurrentEmployeeID TIdentifier,
		@ProjectID TIdentifier,
		@RestrictedView TBool,
		@TaskRequestClass TClass

	SET @TaskRequestClass = dbo.adfGetClassByName('Pjm5.TaskRequest')
	SET @RestrictedView = dbo.adfHasAccessRightByName('RestrictedView')
	SET @ViewAllFinance = dbo.adfHasAccessRightByName('ViewAllFinance')
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @date = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime)
		
	SELECT TOP 1
		@ProjectID = [ProjectID]
	FROM
		[Expense]
	WHERE
		[DocumentID] = @DocumentID AND [DocumentClass] = @DocumentClass


	IF @ViewAllFinance = 0 AND
		@EmployeeID != @CurrentEmployeeID AND
		dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID) = 0 AND
		dbo.fnPjm5IsProjectEnhancementMember(@ProjectID, @CurrentEmployeeID) != 1 AND
		@DocumentClass != @TaskRequestClass		
	BEGIN
		RAISERROR('#NotEnoughPermissions', 18, -1)
		RETURN 1
	END
	
	EXEC 
		pjm6ExpenseBrowseParameters 
			@DateSelector, 
			@PeriodStart	OUTPUT,
			@PeriodEnd		OUTPUT
	
	SELECT
		[Expense].[Class],
		[Expense].[ID],
		[Expense].[State],
		[Expense].[Flag],
		[Expense].[FileAs],
		[Expense].[ProjectID],
		[Expense].[EmployeeID],
		[Expense].[ExpenseCodeID],
		[Expense].[Date],
		[Expense].[Amount],
		[Expense].[Billable],
		[Expense].[Price],
		[Expense].[FromCurrencyCode],
		[Expense].[ToCurrencyCode],
		[Expense].[CurrencyRate],
		[Expense].[VATRate],
		[Expense].[VAT],
		[Expense].[Comments],
		[Expense].[Created],
		[Expense].[CreatedBy],
		[Expense].[Modified],
		[Expense].[ModifiedBy],
		[Expense].[Timestamp],
		[Expense].[SumExpense],
		[Expense].[SumProjectCurrency],
		[Expense].[TotalSumExpense],
		[Expense].[TotalSumProjectCurrency]
	FROM
		[pjm5vwExpense] AS [Expense]
		INNER JOIN [Project]
			ON [Project].[ID] = [Expense].[ProjectID]
	WHERE
		( 
			dbo.fnPjm5HasFinansDataAccess([Project].[ID], @CurrentEmployeeID, NULL, NULL) = 1 OR 
			dbo.fnPjm5AllowCreateProjectEntry([Project].[ID], [Expense].[EmployeeID]) = 1 OR
			(dbo.fnPjm5IsProjectMember([Project].[ID], @CurrentEmployeeID) = 1 AND @RestrictedView = 0)
		) AND
		(
			[Expense].[DocumentClass] = @DocumentClass AND [Expense].[DocumentID] = @DocumentID
		) AND
		(
			@EmployeeID IS NULL OR
			[Expense].[EmployeeID] = @EmployeeID
		) AND 
		(
			(@StateSelector = 0) OR										--  
			(@StateSelector = 1 AND [Expense].[State] IN (1, 5)) OR	-- / 
			(@StateSelector = 2 AND [Expense].[State] = 2) OR			-- .  
			(@StateSelector = 3 AND [Expense].[State] = 3) OR			-- 
			(@StateSelector = 4 AND [Expense].[State] = 6) OR			--   
			(@StateSelector = 5 AND [Expense].[State] = 4)			-- 
		) AND
		(
			@DateSelector = 0 OR
			[Expense].[Date] BETWEEN @PeriodStart AND @PeriodEnd
		)
	RETURN 0
GO

GRANT EXECUTE ON [pjm6DocumentExpenseBrowseExtended] TO PUBLIC
GO
   