IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ExpenseBrowseByTask]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ExpenseBrowseByTask'
		DROP PROCEDURE [dbo].[pjm5ExpenseBrowseByTask]
	END
GO

PRINT 'Creating procedure pjm5ExpenseBrowseByTask'
GO

/******************************************************************************
**		File: ExpenseBrowseByTask.sql
**		Name: pjm5ExpenseBrowseByTask
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ExpenseBrowseByTask]
	@TaskID TIdentifier,
	@EmployeeID TIdentifier,
	@StateSelector INT,
	@DateSelector	INT,
	@PeriodStart	datetime,
	@PeriodEnd		datetime
AS
	SET NOCOUNT ON
	DECLARE 
		@date datetime,
		@ViewAllFinance TBool,
		@CurrentEmployeeID TIdentifier,
		@ProjectID TIdentifier,
		@RestrictedView TBool,
		@ExpenseSecretary TBool
		
	SET @ExpenseSecretary = dbo.adfHasAccessRightByName('ManageExpenseWithoutAssignment')		
	SET @RestrictedView = dbo.adfHasAccessRight(dbo.adfGetRightID('RestrictedView'))	
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @date = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime)
		
	SELECT
		@ProjectID = [ProjectID]
	FROM
		[Task]
	WHERE
		[ID] = @TaskID
	IF @ViewAllFinance = 0 AND
		@EmployeeID != @CurrentEmployeeID AND
		dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID) = 0 AND
		dbo.fnPjm5IsProjectEnhancementMember(@ProjectID, @CurrentEmployeeID) != 1
	BEGIN
		RAISERROR('#NotEnoughPermissions', 18, -1)
		RETURN 1
	END
	
	SELECT
		[Expense].[Class],
		[Expense].[ID],
		[Expense].[State],
		[Expense].[Flag],
		[Expense].[FileAs],
		[Expense].[ProjectID],
		[Expense].[TaskID],
		[Expense].[EmployeeID],
		[Expense].[ExpenseCodeID],
		[Expense].[Date],
		[Expense].[Amount],
		[Expense].[Billable],
		[Expense].[Price],
		[Expense].[FromCurrencyCode],
		[Expense].[ToCurrencyCode],
		[Expense].[CurrencyRate],
		[Expense].[VATRate],
		[Expense].[VAT],
		[Expense].[Comments],
		[Expense].[Created],
		[Expense].[CreatedBy],
		[Expense].[Modified],
		[Expense].[ModifiedBy],
		[Expense].[Timestamp],
		[Expense].[SumExpense],
		[Expense].[SumProjectCurrency],
		[Expense].[TotalSumExpense],
		[Expense].[TotalSumProjectCurrency]
	FROM
		[pjm5vwExpense] AS [Expense]
		INNER JOIN [Project]
			ON [Project].[ID] = [Expense].[ProjectID]
	WHERE
		( 
			dbo.fnPjm5HasFinansDataAccess([Project].[ID], @CurrentEmployeeID, NULL, NULL) = 1 OR 
			dbo.fnPjm5AllowCreateProjectEntry([Project].[ID], [Expense].[EmployeeID]) = 1 OR
			(dbo.fnPjm5IsProjectMember([Project].[ID], @CurrentEmployeeID) = 1 AND @RestrictedView = 0) OR
			@ExpenseSecretary = 1
		) AND
		[Expense].[TaskID] = @TaskID AND
		(
			@EmployeeID IS NULL OR
			[Expense].[EmployeeID] = @EmployeeID
		) AND 
		(
			(@StateSelector = 0) OR										--  
			(@StateSelector = 1 AND [Expense].[State] IN (1, 5)) OR	-- / 
			(@StateSelector = 2 AND [Expense].[State] = 2) OR			-- .  
			(@StateSelector = 3 AND [Expense].[State] = 3) OR			-- 
			(@StateSelector = 4 AND [Expense].[State] = 6) OR			--   
			(@StateSelector = 5 AND [Expense].[State] = 4)			-- 
		) 
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ExpenseBrowseByTask] TO PUBLIC
GO
   