 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6ExchangeWith1CStart]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6ExchangeWith1CStart'
		DROP PROCEDURE [dbo].[pjm6ExchangeWith1CStart]
	END
GO

PRINT 'Creating procedure pjm6ExchangeWith1CStart'
GO

/******************************************************************************
**		File: pjm6ExchangeWith1CStart.sql
**		Name: pjm6ExchangeWith1CStart
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.svintsov
**		Date: 01/20/2005 15:20:31
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		17/03/10	SPV				First Version
**		23/03/10	SPV				 ,   
**									 
**		22/06/10	SPV				   ExchangeBanned
**									  
**		11.03.13	MAB				  OPENXML
*******************************************************************************/
CREATE PROCEDURE [pjm6ExchangeWith1CStart]
	@StartDate TDate,
	@Companies XML
AS
	
	DECLARE
		@value TVariant
		
	EXEC dbo.adfParameterGet 'ExchangeStartDate1C', 'Pjm6', @value OUTPUT
	
	IF @value IS NOT NULL
	BEGIN
		RAISERROR('#ExchangeDataStartCompleted', 18, -1)
		RETURN
	END
	
	EXEC dbo.adfParameterSet 'ExchangeStartDate1C', 'Pjm6', @StartDate
	
	--   ExchangeBanned  
	
	UPDATE [Company]
	SET
		[Company].[ExchangeBanned] = CASE WHEN T.c.value('Banned[1]','varchar(1)') = 'F' THEN 0 ELSE 1 END
	FROM
		@Companies.nodes('/ExchangeBannedCompanies/Company') AS T(c)	
	WHERE
		T.c IS NOT NULL AND 
		[Company].[ID] = T.c.value('CompanyID[1]','int')
	
	--   ExchangeBanned  
	UPDATE
		[Facture]
	SET
		[Facture].[ExchangeBanned] = 1
	WHERE
		[Facture].[Date] < @StartDate
		
	UPDATE
		[Invoice]
	SET
		[Invoice].[ExchangeBanned] = 1
	WHERE
		[Invoice].[Date] < @StartDate AND
		[Invoice].[ID] NOT IN
		(
			SELECT
				[Invoice].[ID]
			FROM
				[Invoice]
				INNER JOIN [PaymentDetail]
					ON [Invoice].[ID] = [PaymentDetail].[InvoiceID]
				INNER JOIN [Payment]
					ON [PaymentDetail].[PaymentID] = [Payment].[ID]
			WHERE
				[Payment].[Date] >= @StartDate
		)
		
	UPDATE
		[Statement]
	SET
		[Statement].[ExchangeBanned] = 1
	WHERE
		[Statement].[Date] < @StartDate
		
	SELECT
		(SELECT COUNT(*) FROM [Facture] WHERE [ExchangeBanned] = 1 AND [State] = 2) as [FactureBanned],
		(SELECT COUNT(*) FROM [Facture] WHERE [ExchangeBanned] = 0 AND [State] = 2) as [FactureAllowed],
		(SELECT COUNT(*) FROM [Invoice] WHERE [ExchangeBanned] = 1 AND [State] IN (2, 5)) as [InvoiceBanned],
		(SELECT COUNT(*) FROM [Invoice] WHERE [ExchangeBanned] = 0 AND [State] IN (2, 5)) as [InvoiceAllowed],
		(SELECT COUNT(*) FROM [Statement] WHERE [ExchangeBanned] = 1 AND [State] IN (2, 3)) as [StatementBanned],
		(SELECT COUNT(*) FROM [Statement] WHERE [ExchangeBanned] = 0 AND [State] IN (2, 3)) as [StatementAllowed]
	RETURN 0
GO

GRANT EXECUTE ON pjm6ExchangeWith1CStart TO PUBLIC
GO
