IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FactureCreateFromDocument]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FactureCreateFromDocument'
		DROP PROCEDURE [dbo].[pjm5FactureCreateFromDocument]
	END
GO

PRINT 'Creating procedure pjm5FactureCreateFromDocument'
GO

/******************************************************************************
**		File: pjm5FactureCreateFromDocument.sql
**		Name: pjm5FactureCreateFromDocument
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/20/2005 15:20:31
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5FactureCreateFromDocument]
	@Class TClass,
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE @rv int

	BEGIN TRANSACTION
	IF @Class = dbo.adfGetClassByName('Pjm5.Invoice')
	BEGIN
		EXEC @rv = pjm5FactureCreateFromInvoice @ID OUTPUT
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	IF @Class = dbo.adfGetClassByName('Pjm5.Statement')
	BEGIN
		EXEC @rv = pjm5FactureCreateFromStatement @ID OUTPUT
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	COMMIT TRANSACTION
	
	
	SELECT [Class], [ID], [State], [FileAs]
	FROM [Document]
	WHERE [Class] = dbo.adfGetClassByName('Pjm5.Facture') AND [ID] = @ID
	RETURN 0
GO

GRANT EXECUTE ON pjm5FactureCreateFromDocument TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FactureCreateFromInvoice]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FactureCreateFromInvoice'
		DROP PROCEDURE [dbo].[pjm5FactureCreateFromInvoice]
	END
GO

PRINT 'Creating procedure pjm5FactureCreateFromInvoice'
GO

/******************************************************************************
**		File: pjm5FactureCreateFromInvoice.sql
**		Name: pjm5FactureCreateFromInvoice
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/20/2005 15:20:31
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		10.12.13	SAP				  "."    
**		25.02.14	SAP				       
**		29.04.14	SAP				       
**									   [IsEditedInPaymentCurrency]
*******************************************************************************/
CREATE PROCEDURE [pjm5FactureCreateFromInvoice]
	@ID TIdentifier OUTPUT
AS
	SET NOCOUNT ON
	DECLARE
		@Class TClass,
		@CompanyClass TClass,
		@FactureClass TClass,
		@PaymentClass TClass,
		@NewID TIdentifier,
		@NationalCurrencyCode TCode3,
		@State TState,
		@FileAs TName,
		@Date TDate,
		@Number TCode,

		@ProjectID TIdentifier,
		@ProjectCurrencyCode TCode,
		@CurrencyCode TCode,
		@CurrencyRate TAmount,
		@Scale TCount,

		@SupplierCompanyID TIdentifier,
		@SupplierAddress TNotes,
		@SupplierINN TName,
		@SupplierKPP TCode,
		@CustomerCompanyID TIdentifier,
		@CustomerAddress TNotes,
		@ConsigneeAddress TNotes,
		@ConsignorAddress TNotes,
		@CustomerINN TName,
		@CustomerKPP TCode,
		@Sender TNotes,
		@Recipient TNotes,
		@DocumentNumber TName,
		@DocumentDate TDate,
		@Chief TName,
		@Accountant TName,
		@Comments TNotes,
		@Advance TBool,
		@value TVariant,
		@ExchangeBanned TBool

	SET @State = dbo.adfwfGetInitialState('55bf9030-b268-4094-8610-0408eef8a713')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	EXEC adfParameterGet 'NationalCurrency', 'CommonBusiness', @value OUTPUT	
	SET @NationalCurrencyCode = CAST(@value AS varchar(3))
	
	SET @FileAs = '-'
	SET @Scale = 2
	SET @Number = ''
	SET @FactureClass = dbo.adfGetClassByName('Pjm5.Facture')
	SET @PaymentClass = dbo.adfGetClassByName('Adf.Payment')
	SET @CompanyClass = dbo.adfGetClassByName('Adf.Company')
	
	SELECT
		@Date = [Invoice].[Date],
		@Class = [Invoice].[Class],
		@ProjectID = [Invoice].[ProjectID],
		@ProjectCurrencyCode = [Project].[CurrencyCode],
		@CurrencyCode = [Invoice].[CurrencyCode],
		@CurrencyRate = CASE 
			WHEN [Project].[CurrencyCode] = @NationalCurrencyCode 
				THEN  1
			WHEN [Invoice].[CurrencyCode] = @NationalCurrencyCode 
				THEN [Invoice].[CurrencyRate]
			ELSE NULL 
		END,
		@Advance = [Invoice].[Advance],
		@ExchangeBanned = [Invoice].[ExchangeBanned],
		@SupplierCompanyID = [Invoice].[SupplierCompanyID],
		@SupplierINN  = [Supplier].[LegalCode],
		@SupplierKPP = [Supplier].[KPP],
		@Sender = [Supplier].[LegalName],
		@CustomerCompanyID = [Invoice].[CustomerCompanyID],
		@CustomerINN = [Customer].[LegalCode],
		@CustomerKPP = [Customer].[KPP],
		@Recipient = [Customer].[LegalName],
		@Chief = COALESCE(
			dbo.adfPropertyValueGetText([Chief].[Class], [Chief].[ID], '00000002-0000-0000-0000-000000000000'),
			[Chief].[LastName] + ISNULL(' ' + [Chief].[FirstName], '') + ISNULL(' ' + [Chief].[MiddleName], ''), 
			[Chief].[FileAs]), 
		@Accountant = COALESCE(
			dbo.adfPropertyValueGetText([Accountant].[Class], [Accountant].[ID], '00000002-0000-0000-0000-000000000000'), 
			[Accountant].[LastName] + ISNULL(' ' + [Accountant].[FirstName], '') + ISNULL(' ' + [Accountant].[MiddleName], ''), 
			[Accountant].[FileAs])
	FROM
		[Invoice]
		INNER JOIN [Project]
			ON [Project].[ID] = [Invoice].[ProjectID]
		INNER JOIN [Company] AS [Supplier]
			ON [Supplier].[ID] = [Invoice].[SupplierCompanyID]
		INNER JOIN [Company] AS [Customer]
			ON [Customer].[ID] = [Invoice].[CustomerCompanyID]
		LEFT OUTER JOIN [Employee] AS [Chief]
			ON [Chief].[ID] = [Supplier].[ExecutiveEmployeeID]
		LEFT OUTER JOIN [Employee] AS [Accountant]
			ON [Accountant].[ID] = [Supplier].[AccountantEmployeeID]
	WHERE 
		[Invoice].[ID] = @ID

/*
	IF (@CurrencyRate IS NULL)
	BEGIN
		SET @CurrencyRate = dbo.pjm6fnCurrencyGetRate(@ProjectCurrencyCode, @Date, @NationalCurrencyCode)
 	END
*/	
	SELECT
		@SupplierAddress = ISNULL([PostalCode] + ', ', '') + 
			ISNULL([Region] + ', ', '') +
			ISNULL('. ' + [City] + ', ', '')+
			ISNULL([Street], '')
	FROM
		[Address]
	WHERE
		[BusinessCardClass] = @CompanyClass AND
		[BusinessCardID] = @SupplierCompanyID AND
		[AddressTypeID] = 1
	
	SELECT
		@ConsignorAddress = ISNULL([PostalCode] + ', ', '') + 
			ISNULL([Region] + ', ', '') +
			ISNULL('. ' + [City] + ', ', '')+
			ISNULL([Street], '')
	FROM
		[Address]
	WHERE
		[BusinessCardClass] = @CompanyClass AND
		[BusinessCardID] = @SupplierCompanyID AND
		[AddressTypeID] = 7
	
	IF (LEN(@ConsignorAddress) = 0 OR @ConsignorAddress IS NULL)
		SET @ConsignorAddress = @SupplierAddress
	
	SET @SupplierAddress = ISNULL(REPLACE(@SupplierAddress, CHAR(10)+CHAR(13), ' '), '')
	SET @SupplierAddress = REPLACE(@SupplierAddress, CHAR(10), ' ')
	SET @SupplierAddress = REPLACE(@SupplierAddress, CHAR(13), ' ')
	
	SET @ConsignorAddress = ISNULL(REPLACE(@ConsignorAddress, CHAR(10)+CHAR(13), ' '), '')
	SET @ConsignorAddress = REPLACE(@ConsignorAddress, CHAR(10), ' ')
	SET @ConsignorAddress = REPLACE(@ConsignorAddress, CHAR(13), ' ')	
	
	SET @Sender = LTRIM(RTRIM(@Sender)) + ISNULL(', ' + @ConsignorAddress, '')
	
	SELECT
		@CustomerAddress = ISNULL([PostalCode] + ', ', '') + 
			ISNULL([Region] + ', ', '') +
			ISNULL('. ' + [City] + ', ', '')+
			ISNULL([Street], '')
	FROM
		[Address]
	WHERE
		[BusinessCardClass] = @CompanyClass AND
		[BusinessCardID] = @CustomerCompanyID AND
		[AddressTypeID] = 1
	
	SELECT
		@ConsigneeAddress = ISNULL([PostalCode] + ', ', '') + 
			ISNULL([Region] + ', ', '') +
			ISNULL('. ' + [City] + ', ', '')+
			ISNULL([Street], '')
	FROM
		[Address]
	WHERE
		[BusinessCardClass] = @CompanyClass AND
		[BusinessCardID] = @CustomerCompanyID AND
		[AddressTypeID] = 7
	
	IF (LEN(@ConsigneeAddress) = 0 OR @ConsigneeAddress IS NULL)
		SET @ConsigneeAddress = @CustomerAddress
		
	SET @CustomerAddress = ISNULL(REPLACE(@CustomerAddress, CHAR(10)+CHAR(13), ' '), '')
	SET @CustomerAddress = REPLACE(@CustomerAddress, CHAR(10), ' ')
	SET @CustomerAddress = REPLACE(@CustomerAddress, CHAR(13), ' ')
	
	SET @ConsigneeAddress = ISNULL(REPLACE(@ConsigneeAddress, CHAR(10)+CHAR(13), ' '), '')
	SET @ConsigneeAddress = REPLACE(@ConsigneeAddress, CHAR(10), ' ')
	SET @ConsigneeAddress = REPLACE(@ConsigneeAddress, CHAR(13), ' ')
	
	SET @Recipient = LTRIM(RTRIM(@Recipient)) + ISNULL(', ' + @ConsigneeAddress, '')

	BEGIN TRANSACTION
	INSERT INTO [Facture]
		([Flag], [State], [FileAs], [Date], [Number], [SupplierCompanyID], [SupplierAddress], [SupplierINN], [SupplierKPP], 
		[CustomerCompanyID], [CustomerAddress], [CustomerINN], [CustomerKPP], [Sender], [Recipient], [DocumentNumber], 
		[DocumentDate], [Chief], [Accountant], [Comments], [ProjectID], [CurrencyCode], [CurrencyRate], [Scale],
		[Total], [TotalWithVAT], [TotalPC], [TotalWithVATPC], [Advance], [ExchangeBanned])
	VALUES
		(0, @State, @FileAs, 
		@Date, 
		@Number,
		@SupplierCompanyID, 
		@SupplierAddress, 
		@SupplierINN, 
		@SupplierKPP, 
		@CustomerCompanyID, 
		@CustomerAddress, 
		@CustomerINN, 
		@CustomerKPP, 
		@Sender, 
		@Recipient, 
		@DocumentNumber, 
		@DocumentDate,
		@Chief,
		@Accountant,
		@Comments,
		@ProjectID,
		@NationalCurrencyCode,
		@CurrencyRate, 
		@Scale,
		0,0,0,0,
		@Advance, @ExchangeBanned)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	SET @NewID = SCOPE_IDENTITY()
	

	DECLARE @lines TABLE 
	(
		[TMPID] int,
		[FactureID] TIdentifier,
		[DocumentClass] TClass NULL,
		[DocumentID] TIdentifier NULL,
		[UOMID] TIdentifier,
		[Amount] TAmount,
		[VATIsIncluded] bit,
		[VATRate] TAmount,
		[OriginalPrice] money,
		[Price] money,
		[Total] money,
		[Excise] money,
		[VAT] money,
		[TotalWithVAT] money,
		[OriginalPricePC] money,
		[PricePC] money,
		[TotalPC] money,
		[ExcisePC] money,
		[VATPC] money,
		[TotalWithVATPC] money,
		[Country] TName,
		[CustomDeclaration] TName,
		[Description] TNotes,
		[BasePrice] TCount,
		[SortKey] TCode,
		[EditedInPaymentCurrency] TBool
	)
	INSERT INTO @lines
	SELECT
		[ID],
		@NewID,
		DocumentClass,
		DocumentID,
		UOMID,
		Amount,
		VATIsIncluded,
		VATRate,
		[Price] AS [OriginalPrice],
		[Price] AS [Price],		
		CASE
			WHEN VATIsIncluded = 1 THEN ROUND([Price] * [Amount] - [VAT], 2)
			ELSE ROUND([Price] * [Amount], 2)
		END  AS [Total],
		CASE			
			WHEN @ProjectCurrencyCode = @NationalCurrencyCode THEN ROUND(VATPC, 2)
			ELSE NULL
		END AS [Excise],
		[VAT] AS [VAT],
		CASE
			WHEN VATIsIncluded = 1 THEN ROUND(Price * Amount, 2)
			ELSE ROUND(Price * Amount + VAT, 2)
		END AS [TotalWithVAT],
		[PricePC] AS [OriginalPricePC],
		CASE
			WHEN VATIsIncluded = 0 THEN PricePC
			ELSE ROUND((ROUND(PricePC * Amount, 2) - VATPC) / Amount, 2)
		END AS [PricePC],
		CASE
			WHEN VATIsIncluded = 0 THEN ROUND(PricePC * Amount, 2)
			ELSE ROUND(PricePC * Amount - VATPC, 2)
		END AS [TotalPC],
		NULL AS [ExcisePC],
		[VATPC],
		CASE
			WHEN VATIsIncluded = 1 THEN ROUND(PricePC * Amount, 2)
			ELSE ROUND(PricePC * Amount + VATPC, 2)
		END AS [TotalWithVATPC],
		NULL,
		NULL,
		Description,
		BasePrice,
		SortKey,
		[EditedInPaymentCurrency]
	FROM [InvoiceLine]
	WHERE [InvoiceID] = @ID




	DECLARE	@tmpID int,
			@tmpSum money,
			@tmpAmount TAmount,
			@tmpVATRate TPercent,
			@tmpEditedInPaymentCurrency TBool


	DECLARE cur CURSOR FAST_FORWARD FOR
	SELECT
		[L].[TMPID],
		CASE [InvoiceLine].[EditedInPaymentCurrency]
			WHEN 0 THEN [L].[TotalWithVATPC]
			ELSE [L].[TotalWithVAT]
		END AS [Sum],
		[L].[Amount],
		[L].[VATRate],
		[InvoiceLine].[EditedInPaymentCurrency] AS [EditedInPaymentCurrency]
	FROM 
		@Lines as [L]
		INNER JOIN [InvoiceLine]
			ON [InvoiceLine].[ID] = [L].[TMPID]

	OPEN [cur]
	FETCH NEXT FROM [cur] INTO @tmpID, @tmpSum, @tmpAmount, @tmpVATRate,@tmpEditedInPaymentCurrency
	WHILE @@fetch_status = 0
	BEGIN
		DECLARE	
			@TVWPC money,
			@TVW money,
			@Ttl money,
			@TtlPC money,
			@V money,
			@VPC money,
			@PVW money,
			@PVWPC money,
			@P money,
			@PPC money

		--IF @CurrencyCode != @NationalCurrencyCode
		--	SET @CurrencyRate = 1 / @CurrencyRate
		IF @tmpEditedInPaymentCurrency = 0
		BEGIN
			SET @TVWPC = @tmpSum
			SET @TVW = ROUND(@TVWPC * @CurrencyRate, 2)
			SET @V = ROUND(@TVW * @tmpVATRate / (1 + @tmpVATRate), 2)
			SET @Ttl = @TVW - @V
			SET @PVW = ROUND(@TVW / @tmpAmount, 2)
			SET @P = ROUND(@Ttl / @tmpAmount, 2)

			UPDATE @lines
			SET	[Price] = @P,
				[Total] = @Ttl,
				[VAT] = @V,
				[TotalWithVAT] = @TVW,
				[Excise] = 
				CASE
					WHEN @CurrencyCode = @NationalCurrencyCode THEN ROUND(@V, 2)				
					ELSE [Excise]
				END
			WHERE [TMPID] = @tmpID
		END
		ELSE
		BEGIN
			SET @TVW = @tmpSum
			SET @TVWPC = ROUND(@TVW / @CurrencyRate, 2)
			SET @VPC = ROUND(@TVWPC * @tmpVATRate / (1 + @tmpVATRate), 2)
			SET @TtlPC = @TVWPC - @VPC
			SET @PVWPC = ROUND(@TVWPC / @tmpAmount, 2)
			SET @PPC = ROUND(@TtlPC / @tmpAmount, 2)

			UPDATE @lines
			SET	[PricePC] = @PPC,
				[TotalPC] = @TtlPC,
				[VATPC] = @VPC,
				[TotalWithVATPC] = @TVWPC,
				[ExcisePC] = 
				CASE
					WHEN @CurrencyCode = @NationalCurrencyCode THEN ROUND(@VPC, 2)				
					ELSE [ExcisePC]
				END
			WHERE [TMPID] = @tmpID
		END

		FETCH NEXT FROM [cur] INTO @tmpID, @tmpSum, @tmpAmount, @tmpVATRate,@tmpEditedInPaymentCurrency
	END
	CLOSE [cur]
	DEALLOCATE [cur]

	

	INSERT INTO [FactureLine]
		(FactureID,
		DocumentClass,
		DocumentID,
		UOMID,
		Amount,
		VATIsIncluded, 
		VATRate,
		OriginalPrice,
		Price,
		Total,
		Excise,
		VAT,
		TotalWithVAT,
		OriginalPricePC,
		PricePC,
		TotalPC,
		ExcisePC,
		VATPC,
		TotalWithVATPC,
		Country,
		CustomDeclaration,
		Description,
		BasePrice,
		SortKey)	
	SELECT
		[FactureID],
		[DocumentClass],
		[DocumentID],
		[UOMID],
		[Amount],
		[VATIsIncluded],
		[VATRate],
		[OriginalPrice],
		[Price],
		[Total],
		[Excise],
		[VAT],
		[TotalWithVAT],
		[OriginalPricePC],
		[PricePC],
		[TotalPC],
		[ExcisePC],
		[VATPC],
		[TotalWithVATPC],
		[Country],
		[CustomDeclaration],
		[Description],
		[BasePrice],
		[SortKey]
	FROM @lines

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	INSERT INTO [FacturePayment] ([FactureID], [PaymentID])
	SELECT DISTINCT @NewID, [Payment].[ID]
	FROM
		[Invoice]
		INNER JOIN [PaymentDetail]
			ON [PaymentDetail].[InvoiceID] = [Invoice].[ID]
		INNER JOIN [Payment]
			ON [Payment].[ID] = [PaymentDetail].[PaymentID]
	WHERE 
		[Invoice].[ID] = @ID AND
		[Payment].[State] IN (2, 3)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	INSERT INTO [FacturePayment] ([FactureID], [PaymentID])
	SELECT DISTINCT @NewID, [Payment].[ID]
	FROM
		[AdvanceInvoice]	
		INNER JOIN [PaymentDetail]
			ON [PaymentDetail].[InvoiceID] = [AdvanceInvoice].[AdvanceInvoiceID]
		INNER JOIN [Payment]
			ON [Payment].[ID] = [PaymentDetail].[PaymentID]
	WHERE 
		[AdvanceInvoice].[InvoiceID] = @ID AND
		[Payment].[State] IN (2, 3)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	INSERT INTO [Attachment]
		(
		[DocumentClass], [DocumentID], [Name],
		[LinkDocumentClass], [LinkDocumentID], [AttachmentTypeID]
		)
	SELECT
		@PaymentClass, [PaymentID], '-',
		@FactureClass, [FactureID], 3	
	FROM
		[FacturePayment]
	WHERE
		[FactureID] = @NewID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END


	INSERT INTO [Attachment]
		(
		[DocumentClass], [DocumentID], [Name],
		[LinkDocumentClass], [LinkDocumentID], [AttachmentTypeID]
		)
	VALUES
		(@FactureClass, @NewID, '',
		@Class, @ID, 2)	
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	INSERT INTO [Attachment]
		(
		[DocumentClass], [DocumentID], [Name],
		[LinkDocumentClass], [LinkDocumentID], [AttachmentTypeID]
		)
	VALUES
		(@Class, @ID, '-',
		@FactureClass, @NewID, 2)	
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	COMMIT TRANSACTION
	
	SET @ID = @NewID
	RETURN 0
GO

GRANT EXECUTE ON pjm5FactureCreateFromInvoice TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FactureCreateFromStatement]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FactureCreateFromStatement'
		DROP PROCEDURE [dbo].[pjm5FactureCreateFromStatement]
	END
GO

PRINT 'Creating procedure pjm5FactureCreateFromStatement'
GO

/******************************************************************************
**		File: pjm5FactureCreateFromStatement.sql
**		Name: pjm5FactureCreateFromStatement
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/20/2005 15:20:31
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		10.12.13	SAP				  "."    
**		25.02.14	SAP				       
**		29.04.14	SAP				       
**									   [IsEditedInPaymentCurrency]
*******************************************************************************/
CREATE PROCEDURE [pjm5FactureCreateFromStatement]
	@ID TIdentifier OUTPUT
AS
	SET NOCOUNT ON
	DECLARE
		@Class TClass,
		@CompanyClass TClass,
		@FactureClass TClass,
		@PaymentClass TClass,
		@NewID TIdentifier,
		@NationalCurrencyCode TCode3,
		@State TState,
		@FileAs TName,
		@Date TDate,
		@Number TCode,

		@ProjectID TIdentifier,
		@ProjectCurrencyCode TCode,
		@CurrencyCode TCode,
		@CurrencyRate TAmount,
		@Scale TCount,

		@SupplierCompanyID TIdentifier,
		@SupplierAddress TNotes,
		@SupplierINN TName,
		@SupplierKPP TCode,
		@CustomerCompanyID TIdentifier,
		@CustomerAddress TNotes,
		@CustomerINN TName,
		@CustomerKPP TCode,
		@Sender TNotes,
		@Recipient TNotes,
		@ConsigneeAddress TNotes,
		@ConsignorAddress TNotes,
		@DocumentNumber TName,
		@DocumentDate TDate,
		@Chief TName,
		@Accountant TName,
		@Comments TNotes,
		@value TVariant,
		@ExchangeBanned TBool

	SET @State = dbo.adfwfGetInitialState('55bf9030-b268-4094-8610-0408eef8a713')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	EXEC adfParameterGet 'NationalCurrency', 'CommonBusiness', @value OUTPUT	
	SET @NationalCurrencyCode = CAST(@value AS varchar(3))
	
	SET @FileAs = '-'
	SET @Scale = 2
	SET @Number = ''
	SET @FactureClass = dbo.adfGetClassByName('Pjm5.Facture')
	SET @PaymentClass = dbo.adfGetClassByName('Adf.Payment')
	SET @CompanyClass = dbo.adfGetClassByName('Adf.Company')
	
	SELECT
		@Date = [Statement].[Date],
		@Class = [Statement].[Class],
		@ProjectID = [Statement].[ProjectID],
		@ProjectCurrencyCode = [Project].[CurrencyCode],
		@CurrencyCode = [Statement].[CurrencyCode],
		@ExchangeBanned = [Statement].[ExchangeBanned],
		@CurrencyRate = CASE 
			WHEN [Project].[CurrencyCode] = @NationalCurrencyCode 
				THEN 1
			WHEN [Statement].[CurrencyCode] = @NationalCurrencyCode 
				THEN [Statement].[CurrencyRate]
			ELSE NULL 
		END,
		@SupplierCompanyID = [Statement].[SupplierCompanyID],
		@SupplierINN  = [Supplier].[LegalCode],
		@SupplierKPP = [Supplier].[KPP],
		@Sender = [Supplier].[LegalName],
		@CustomerCompanyID = [Statement].[CustomerCompanyID],
		@CustomerINN = [Customer].[LegalCode],
		@CustomerKPP = [Customer].[KPP],
		@Recipient = [Customer].[LegalName],
		@Chief = COALESCE(
			dbo.adfPropertyValueGetText([Chief].[Class], [Chief].[ID], '00000002-0000-0000-0000-000000000000'),
			[Chief].[LastName] + ISNULL(' ' + [Chief].[FirstName], '') + ISNULL(' ' + [Chief].[MiddleName], ''), 
			[Chief].[FileAs]), 
		@Accountant = COALESCE(
			dbo.adfPropertyValueGetText([Accountant].[Class], [Accountant].[ID], '00000002-0000-0000-0000-000000000000'), 
			[Accountant].[LastName] + ISNULL(' ' + [Accountant].[FirstName], '') + ISNULL(' ' + [Accountant].[MiddleName], ''), 
			[Accountant].[FileAs])
	FROM
		[Statement]
		INNER JOIN [Project]
			ON [Project].[ID] = [Statement].[ProjectID]
		INNER JOIN [Company] AS [Supplier]
			ON [Supplier].[ID] = [Statement].[SupplierCompanyID]
		INNER JOIN [Company] AS [Customer]
			ON [Customer].[ID] = [Statement].[CustomerCompanyID]
		LEFT OUTER JOIN [Employee] AS [Chief]
			ON [Chief].[ID] = [Supplier].[ExecutiveEmployeeID]
		LEFT OUTER JOIN [Employee] AS [Accountant]
			ON [Accountant].[ID] = [Supplier].[AccountantEmployeeID]
	WHERE 
		[Statement].[ID] = @ID
/*		
	IF (@CurrencyRate IS NULL)
	BEGIN
		SET @CurrencyRate = dbo.pjm6fnCurrencyGetRate(@ProjectCurrencyCode, @Date, @NationalCurrencyCode)
 	END
*/
	SELECT
		@SupplierAddress = ISNULL([PostalCode] + ', ', '') + 
			ISNULL([Region] + ', ', '') +
			ISNULL('. ' + [City] + ', ', '')+
			ISNULL([Street], '')
	FROM
		[Address]
	WHERE
		[BusinessCardClass] = @CompanyClass AND
		[BusinessCardID] = @SupplierCompanyID AND
		[AddressTypeID] = 1
	
	SELECT
		@ConsignorAddress = ISNULL([PostalCode] + ', ', '') + 
			ISNULL([Region] + ', ', '') +
			ISNULL('. ' + [City] + ', ', '')+
			ISNULL([Street], '')
	FROM
		[Address]
	WHERE
		[BusinessCardClass] = @CompanyClass AND
		[BusinessCardID] = @SupplierCompanyID AND
		[AddressTypeID] = 7
	
	IF (LEN(@ConsignorAddress) = 0 OR @ConsignorAddress IS NULL)
		SET @ConsignorAddress = @SupplierAddress
	
	SET @SupplierAddress = ISNULL(REPLACE(@SupplierAddress, CHAR(10)+CHAR(13), ' '), '')
	SET @SupplierAddress = REPLACE(@SupplierAddress, CHAR(10), ' ')
	SET @SupplierAddress = REPLACE(@SupplierAddress, CHAR(13), ' ')
	
	SET @ConsignorAddress = ISNULL(REPLACE(@ConsignorAddress, CHAR(10)+CHAR(13), ' '), '')
	SET @ConsignorAddress = REPLACE(@ConsignorAddress, CHAR(10), ' ')
	SET @ConsignorAddress = REPLACE(@ConsignorAddress, CHAR(13), ' ')	
	
	SET @Sender = LTRIM(RTRIM(@Sender)) + ISNULL(', ' + @ConsignorAddress, '')
	
	SELECT
		@CustomerAddress = ISNULL([PostalCode] + ', ', '') + 
			ISNULL([Region] + ', ', '') +
			ISNULL('. ' + [City] + ', ', '')+
			ISNULL([Street], '')
	FROM
		[Address]
	WHERE
		[BusinessCardClass] = @CompanyClass AND
		[BusinessCardID] = @CustomerCompanyID AND
		[AddressTypeID] = 1
	
	SET @CustomerAddress = ISNULL(REPLACE(@CustomerAddress, CHAR(10)+CHAR(13), ' '), '')
	SET @CustomerAddress = REPLACE(@CustomerAddress, CHAR(10), ' ')
	SET @CustomerAddress = REPLACE(@CustomerAddress, CHAR(13), ' ')
	
	SELECT
		@ConsigneeAddress = ISNULL([PostalCode] + ', ', '') + 
			ISNULL([Region] + ', ', '') +
			ISNULL('. ' + [City] + ', ', '')+
			ISNULL([Street], '')
	FROM
		[Address]
	WHERE
		[BusinessCardClass] = @CompanyClass AND
		[BusinessCardID] = @CustomerCompanyID AND
		[AddressTypeID] = 7
	
	IF (LEN(@ConsigneeAddress) = 0 OR @ConsigneeAddress IS NULL)
		SET @ConsigneeAddress = @CustomerAddress
	
	SET @ConsigneeAddress = ISNULL(REPLACE(@ConsigneeAddress, CHAR(10)+CHAR(13), ' '), '')
	SET @ConsigneeAddress = REPLACE(@ConsigneeAddress, CHAR(10), ' ')
	SET @ConsigneeAddress = REPLACE(@ConsigneeAddress, CHAR(13), ' ')
	SET @Recipient = LTRIM(RTRIM(@Recipient)) + ISNULL(', ' + @ConsigneeAddress, '')

	BEGIN TRANSACTION
	INSERT INTO [Facture]
		([Flag], [State], [FileAs], [Date], [Number], [SupplierCompanyID], [SupplierAddress], [SupplierINN], [SupplierKPP], 
		[CustomerCompanyID], [CustomerAddress], [CustomerINN], [CustomerKPP], [Sender], [Recipient], [DocumentNumber], [DocumentDate], 
		[Chief], [Accountant], [Comments],[ProjectID], [CurrencyCode], [CurrencyRate], [Scale],[Total], [TotalWithVAT], [TotalPC], 
		[TotalWithVATPC], [ExchangeBanned])
	VALUES
		(0, @State, @FileAs, 
		@Date, 
		@Number,
		@SupplierCompanyID, 
		@SupplierAddress, 
		@SupplierINN, 
		@SupplierKPP, 
		@CustomerCompanyID, 
		@CustomerAddress, 
		@CustomerINN, 
		@CustomerKPP, 
		@Sender, 
		@Recipient, 
		@DocumentNumber, 
		@DocumentDate,
		@Chief,
		@Accountant,
		@Comments,
		@ProjectID,
		@NationalCurrencyCode,
		@CurrencyRate, 
		@Scale,
		0,0,0,0, @ExchangeBanned)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	SET @NewID = SCOPE_IDENTITY()
	
	DECLARE @lines TABLE
	(
		[TMPID] int,
		[FactureID] TIdentifier,
		[DocumentClass] TClass NULL,
		[DocumentID] TIdentifier NULL,
		[UOMID] TIdentifier,
		[Amount] TAmount,
		[VATIsIncluded] bit, 
		[VATRate] TAmount,
		[OriginalPrice] money,
		[Price] money,
		[Total] money,
		[Excise] money,
		[VAT] money,
		[TotalWithVAT] money,
		[OriginalPricePC] money,
		[PricePC] money,
		[TotalPC] money,
		[ExcisePC] money,
		[VATPC] money,
		[TotalWithVATPC] money,
		[Country] TName,
		[CustomDeclaration] TName,
		[Description] TNotes,
		[BasePrice] TCount,
		[SortKey] TCode,
		[EditedInPaymentCurrency] TBool
	)
	INSERT INTO @lines
	SELECT
		[ID],
		@NewID,
		DocumentClass,
		DocumentID,
		UOMID,
		Amount,
		VATIsIncluded,
		VATRate,
		CASE
			WHEN @CurrencyCode = @NationalCurrencyCode THEN Price
			WHEN @ProjectCurrencyCode = @NationalCurrencyCode THEN PricePC
			ELSE NULL
		END AS [OriginalPrice],
		CASE
			WHEN @CurrencyCode = @NationalCurrencyCode AND
				VATIsIncluded = 0 THEN Price
			WHEN @CurrencyCode = @NationalCurrencyCode AND
				VATIsIncluded = 1 THEN ROUND((ROUND(Price * Amount, 2) - VAT) / Amount, 2)
			WHEN @ProjectCurrencyCode = @NationalCurrencyCode AND
				VATIsIncluded = 0 THEN PricePC
			WHEN @ProjectCurrencyCode = @NationalCurrencyCode AND
				VATIsIncluded = 1 THEN ROUND((ROUND(PricePC * Amount, 2) - VATPC) / Amount, 2)
			ELSE NULL
		END AS [Price],
		CASE
			WHEN @CurrencyCode = @NationalCurrencyCode AND
				VATIsIncluded = 0 THEN ROUND(Price * Amount, 2)
			WHEN @CurrencyCode = @NationalCurrencyCode AND
				VATIsIncluded = 1 THEN ROUND(Price * Amount - VAT, 2)
			WHEN @ProjectCurrencyCode = @NationalCurrencyCode AND
				VATIsIncluded = 0 THEN ROUND(PricePC * Amount, 2)
			WHEN @ProjectCurrencyCode = @NationalCurrencyCode AND
				VATIsIncluded = 1 THEN ROUND(PricePC * Amount - VATPC, 2)
			ELSE NULL
		END AS [Total],
		NULL AS [Excise],
		CASE
			WHEN @CurrencyCode = @NationalCurrencyCode THEN ROUND(VAT, 2)
			WHEN @ProjectCurrencyCode = @NationalCurrencyCode THEN ROUND(VATPC, 2)
			ELSE NULL
		END AS [VAT],
		CASE
			WHEN @CurrencyCode = @NationalCurrencyCode AND
				VATIsIncluded = 1 THEN ROUND(Price * Amount, 2)
			WHEN @CurrencyCode = @NationalCurrencyCode AND
				VATIsIncluded = 0 THEN ROUND(Price * Amount + VAT, 2)
			WHEN @ProjectCurrencyCode = @NationalCurrencyCode AND
				VATIsIncluded = 1 THEN ROUND(PricePC * Amount, 2)
			WHEN @ProjectCurrencyCode = @NationalCurrencyCode AND
				VATIsIncluded = 0 THEN ROUND(PricePC * Amount + VATPC, 2)
			ELSE NULL
		END AS [TotalWithVAT],
		[PricePC] AS [OriginalPricePC],
		CASE
			WHEN VATIsIncluded = 0 THEN PricePC
			ELSE ROUND((ROUND(PricePC * Amount, 2) - VATPC) / Amount, 2)
		END AS [PricePC],
		CASE
			WHEN VATIsIncluded = 0 THEN ROUND(PricePC * Amount, 2)
			ELSE ROUND(PricePC * Amount - VATPC, 2)
		END AS [TotalPC],
		NULL AS [ExcisePC],
		[VATPC],
		CASE
			WHEN VATIsIncluded = 1 THEN ROUND(PricePC * Amount, 2)
			ELSE ROUND(PricePC * Amount + VATPC, 2)
		END AS [TotalWithVATPC],
		NULL,
		NULL,
		Description,
		BasePrice,
		SortKey,
		[EditedInPaymentCurrency]
	FROM [StatementLine]
	WHERE [StatementID] = @ID

	DECLARE
		@tmpID int,	
		@tmpSum money,
		@tmpAmount TAmount,
		@tmpVATRate TPercent,
		@tmpEditedInPaymentCurrency TBool


	DECLARE cur CURSOR FAST_FORWARD FOR
	SELECT
		[L].[TMPID],
		CASE [InvoiceLine].[EditedInPaymentCurrency]
			WHEN 0 THEN [L].[TotalWithVATPC]
			ELSE [L].[TotalWithVAT]
		END AS [Sum],
		[L].[Amount],
		[L].[VATRate],
		[InvoiceLine].[EditedInPaymentCurrency] AS [EditedInPaymentCurrency]
	FROM 
		@Lines as [L]
		INNER JOIN [InvoiceLine]
			ON [InvoiceLine].[ID] = [L].[TMPID]

	OPEN [cur]
	FETCH NEXT FROM [cur] INTO @tmpID, @tmpSum, @tmpAmount, @tmpVATRate,@tmpEditedInPaymentCurrency
	WHILE @@fetch_status = 0
	BEGIN
		DECLARE	
			@TVWPC money,
			@TVW money,
			@Ttl money,
			@TtlPC money,
			@V money,
			@VPC money,
			@PVW money,
			@PVWPC money,
			@P money,
			@PPC money

		--IF @CurrencyCode != @NationalCurrencyCode
		--	SET @CurrencyRate = 1 / @CurrencyRate
		IF @tmpEditedInPaymentCurrency = 0
		BEGIN
			SET @TVWPC = @tmpSum
			SET @TVW = ROUND(@TVWPC * @CurrencyRate, 2)
			SET @V = ROUND(@TVW * @tmpVATRate / (1 + @tmpVATRate), 2)
			SET @Ttl = @TVW - @V
			SET @PVW = ROUND(@TVW / @tmpAmount, 2)
			SET @P = ROUND(@Ttl / @tmpAmount, 2)

			UPDATE @lines
			SET	[Price] = @P,
				[Total] = @Ttl,
				[VAT] = @V,
				[TotalWithVAT] = @TVW,
				[Excise] = 
				CASE
					WHEN @CurrencyCode = @NationalCurrencyCode THEN ROUND(@V, 2)				
					ELSE [Excise]
				END
			WHERE [TMPID] = @tmpID
		END
		ELSE
		BEGIN
			SET @TVW = @tmpSum
			SET @TVWPC = ROUND(@TVW / @CurrencyRate, 2)
			SET @VPC = ROUND(@TVWPC * @tmpVATRate / (1 + @tmpVATRate), 2)
			SET @TtlPC = @TVWPC - @VPC
			SET @PVWPC = ROUND(@TVWPC / @tmpAmount, 2)
			SET @PPC = ROUND(@TtlPC / @tmpAmount, 2)

			UPDATE @lines
			SET	[PricePC] = @PPC,
				[TotalPC] = @TtlPC,
				[VATPC] = @VPC,
				[TotalWithVATPC] = @TVWPC,
				[ExcisePC] = 
				CASE
					WHEN @CurrencyCode = @NationalCurrencyCode THEN ROUND(@VPC, 2)				
					ELSE [ExcisePC]
				END
			WHERE [TMPID] = @tmpID
		END

		FETCH NEXT FROM [cur] INTO @tmpID, @tmpSum, @tmpAmount, @tmpVATRate,@tmpEditedInPaymentCurrency
	END
	CLOSE [cur]
	DEALLOCATE [cur]



	INSERT INTO [FactureLine]
		(FactureID,
		DocumentClass,
		DocumentID,
		UOMID,
		Amount,
		VATIsIncluded, 
		VATRate,
		OriginalPrice,
		Price,
		Total,
		Excise,
		VAT,
		TotalWithVAT,
		OriginalPricePC,
		PricePC,
		TotalPC,
		ExcisePC,
		VATPC,
		TotalWithVATPC,
		Country,
		CustomDeclaration,
		Description,
		BasePrice,
		SortKey)
	SELECT
		[FactureID],
		[DocumentClass],
		[DocumentID],
		[UOMID],
		[Amount],
		[VATIsIncluded], 
		[VATRate],
		[OriginalPrice],
		[Price],
		[Total],
		[Excise],
		[VAT],
		[TotalWithVAT],
		[OriginalPricePC],
		[PricePC],
		[TotalPC],
		[ExcisePC],
		[VATPC],
		[TotalWithVATPC],
		[Country],
		[CustomDeclaration],
		[Description],
		[BasePrice],
		[SortKey]
	FROM
		@lines


	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	INSERT INTO [FacturePayment] ([FactureID], [PaymentID])
	SELECT DISTINCT @NewID, [Payment].[ID]
	FROM
		[StatementAdvanceInvoice]	
		INNER JOIN [PaymentDetail]
			ON [PaymentDetail].[InvoiceID] = [StatementAdvanceInvoice].[AdvanceInvoiceID]
		INNER JOIN [Payment]
			ON [Payment].[ID] = [PaymentDetail].[PaymentID]
	WHERE 
		[StatementAdvanceInvoice].[StatementID] = @ID AND
		[Payment].[State] IN (2, 3)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	INSERT INTO [Attachment]
		(
		[DocumentClass], [DocumentID], [Name],
		[LinkDocumentClass], [LinkDocumentID], [AttachmentTypeID]
		)
	SELECT
		@PaymentClass, [PaymentID], '-',
		@FactureClass, [FactureID], 3	
	FROM
		[FacturePayment]
	WHERE
		[FactureID] = @NewID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	INSERT INTO [Attachment]
		(
		[DocumentClass], [DocumentID], [Name],
		[LinkDocumentClass], [LinkDocumentID], [AttachmentTypeID]
		)
	VALUES
		(@FactureClass, @NewID, '',
		@Class, @ID, 2)	
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	INSERT INTO [Attachment]
		(
		[DocumentClass], [DocumentID], [Name],
		[LinkDocumentClass], [LinkDocumentID], [AttachmentTypeID]
		)
	VALUES
		(@Class, @ID, '-',
		@FactureClass, @NewID, 2)	
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	
	SET @ID = @NewID
	RETURN 0
GO

GRANT EXECUTE ON pjm5FactureCreateFromStatement TO PUBLIC
GO
