 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskFind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TaskFind'
		DROP PROCEDURE [dbo].[pjm5TaskFind]
	END
GO

PRINT 'Creating procedure pjm5TaskFind'
GO

/******************************************************************************
**		File: pjm5TaskFind.sql
**		Name: pjm5TaskFind
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 10:53:44
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		08.08.12	SOV				     [Task].[FileAs]
*******************************************************************************/
CREATE PROCEDURE [pjm5TaskFind]
	@Text nvarchar(256), -- NULL -  , 
	@TextField int, -- 0 - FileAs, -- 1 - FileAs, Comments
	@State int, -- NULL - 
	@Flag tinyint, -- NULL -  , 0-7 
	@UserOption int,
	@TimeField int, -- 0 - , 1 - Created, 2 - Modified
	@StartTime datetime,
	@EndTime datetime,
	@ProjectID TIdentifier
AS
	SET NOCOUNT ON

	DECLARE @UserID TIdentifier, @EmployeeID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	
	SELECT
		[Task].[Class],
		[Task].[ID],
		[Task].[State],
		[Task].[DueDate],
		[Task].[FileAs],
		[Task].[Comments],
		[Task].[ProjectID],
		[Task].[Flag],
		[Task].[Created],
		[Task].[CreatedBy],
		[Task].[Modified],
		[Task].[ModifiedBy]
	FROM
		[Task] INNER JOIN dbo.fnPjm5GetAvailableProjects() as [P]
			ON ([Task].[ProjectID] = [P].[ID])
	WHERE
		(
			@ProjectID IS NULL OR (@ProjectID IS NOT NULL AND [Task].[ProjectID] = @ProjectID)
		)
		AND
		(
			@Text IS NULL
			OR
			(@TextField = 0 AND [Task].[FileAs] LIKE '%' + @Text + '%')
			OR
			(@TextField IN (1, 2) AND ([Task].[FileAs] LIKE '%' + @Text + '%' OR [Task].[Comments] LIKE '%' + @Text + '%'))
		)
		AND
		(
			@State IS NULL
			OR
			(@State IS NOT NULL AND [Task].[State] = @State)
		)		
		AND
		(
			@Flag IS NULL
			OR
			(@Flag IS NOT NULL AND [Task].[Flag] = @Flag)
		)
		AND
		(
			@UserOption IS NULL
			OR
			(@UserOption = 0 AND EXISTS(SELECT * FROM [TaskAssignment] as [TA] INNER JOIN [vwAssignment] as [A] ON ([TA].[AssignmentID]=[A].[ID]) WHERE [TA].[TaskID] = [Task].[ID] AND [A].[EmployeeID] = @EmployeeID))
			OR
			(@UserOption = 1 AND ([CreatedBy] = @UserID OR [ModifiedBy] = @UserID))
			OR
			(@UserOption = 2 AND [CreatedBy] = @UserID)
			OR
			(@UserOption = 3 AND [ModifiedBy] = @UserID)
		)
		AND
		(
			@TimeField = 0
			OR
			(@TimeField = 1 AND [Task].[Created] BETWEEN @StartTime AND @EndTime)
			OR
			(@TimeField = 2 AND [Task].[Modified] BETWEEN @StartTime AND @EndTime)
		)
	ORDER BY 
		[Task].[FileAs]
	RETURN 0
GO

GRANT EXECUTE ON [pjm5TaskFind] TO PUBLIC
GO 