IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FolderDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FolderDelete'
		DROP PROCEDURE [dbo].[pjm5FolderDelete]
	END
GO

PRINT 'Creating procedure pjm5FolderDelete'
GO

/******************************************************************************
**		File: pjm5FolderDelete.sql
**		Name: pjm5FolderDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5FolderDelete
	@ID TIdentifier,
	@Forced int
AS
	SET NOCOUNT ON
	DECLARE @UserID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()

	-- TODO: check folder children
	IF dbo.fnFolderHasRightAccess(@ID, @UserID, 'CreateSubfolder') = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF EXISTS(SELECT * FROM [DocumentItem] WHERE [FolderID] = @ID)
	BEGIN
		IF EXISTS(
			SELECT * 
			FROM 
				[DocumentCard]
			WHERE 
				[DocumentCard].[FolderID] = @ID AND
				[DocumentCard].[State] IN (3, 4)
		)
		BEGIN
			RAISERROR('#cannotdeletedocumentcard', 18, -1)
			RETURN 1
		END
	END
	
	DECLARE
		@CardID TIdentifier,
		@rv int
		
	DECLARE cards CURSOR LOCAL FAST_FORWARD FOR
		SELECT [ID] FROM [DocumentCard] WHERE [FolderID] = @ID
	OPEN cards
	FETCH NEXT FROM cards INTO @CardID
	WHILE @@FETCH_STATUS = 0
	BEGIN
		EXEC @rv = pjm5DocumentCardDelete @CardID
		IF @rv != 0
		BEGIN
			CLOSE cards
			DEALLOCATE cards
			RETURN 1
		END
		FETCH NEXT FROM cards INTO @CardID
	END
	CLOSE cards
	DEALLOCATE cards
	
	BEGIN TRANSACTION
	DELETE FROM [FolderAccessControl] WHERE [FolderID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DELETE FROM [CaseOfFolder] WHERE [FolderID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [Folder] WHERE [Folder].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	EXEC pjm5FolderDeleteNotification @ID
	
	COMMIT TRANSACTION

	RETURN 0
GO

GRANT EXECUTE ON pjm5FolderDelete TO PUBLIC
GO
