 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnFolderIsSubfolder]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnFolderIsSubfolder'
		DROP FUNCTION [dbo].[fnFolderIsSubfolder]
	END

GO

PRINT 'Creating function fnFolderIsSubfolder'
GO
/******************************************************************************
**		File: 
**		Name: fnFolderIsSubfolder
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnFolderIsSubfolder(
	@ID TIdentifier,
	@FolderID TIdentifier
)
RETURNS BIT
AS
BEGIN
	DECLARE @result TBool
	;WITH FolderTable([FolderID], [ID], [Level]) AS (
		SELECT 
			[FolderID], [ID], 0 AS [Level] 
		FROM
			[Folder] 
		WHERE [ID] = @FolderID
		UNION ALL
		SELECT 
			f.[FolderID], f.[ID], [Level] + 1
		FROM
			[Folder] f
			INNER JOIN [FolderTable]
				ON f.[FolderID] = [FolderTable].[ID]
	)
	SELECT @result = COUNT(*)
	FROM 
		[FolderTable]
	WHERE
		[ID] = @ID AND [Level] > 0
		
	RETURN @result
END
GO

GRANT EXEC ON fnFolderIsSubfolder TO PUBLIC
GO
