IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5InvoiceUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5InvoiceUpdate'
		DROP PROCEDURE [dbo].[pjm5InvoiceUpdate]
	END
GO

PRINT 'Creating procedure pjm5InvoiceUpdate'
GO

/******************************************************************************
**		File: pjm5InvoiceUpdate.sql
**		Name: pjm5InvoiceUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/20/2005 15:20:31
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**      26.10.10    BVY             Added the state '6' for functionality of reccurence in planned invoices
**		30.06.11	SYV				      
**		01.07.11	SYV				 WarningFlagID,   
**		26.03.13	SOV				 OpenXml  Xml
*******************************************************************************/
CREATE PROCEDURE pjm5InvoiceUpdate
	@Xml XML
AS
	SET NOCOUNT ON
	DECLARE @ID TIdentifier,
			@InvoiceCurrencyRate TAmount,
			@InvoiceBaseCurrencyRate TAmount,
			@BaseCurrencyRate TAmount,
			@CurrencyRate TAmount,
			@PrevCurrencyCode TCode3,
			@CurrencyCode TCode3,
			@ProjectCurrencyCode TCode3,
			@NationalCurrencyCode TCode3,
			@Class TClass,
			@State TState,
			@timeClass TClass,
			@value TVariant,
			@RecurrenceID TIdentifier,
			@ReminderState TState,
			@ReminderTime TDateTime,
			@ReminderInterval TTimeSpan,
			@DueDate TDateTime,
			@ReminderPublishState TState,
			@ReminderPublishTime TDateTime,
			@ReminderPublishInterval TTimeSpan,
			@Date TDateTime,
			@rv int,
			@UserID TIdentifier,
			@InvoiceClass TClass,
			@InvoiceDateChanged bit,
			@Scale TCount,
			@ProjectID TIdentifier,
			@Number TCode,
			@FileAs TName,
			@SupplierBankAccountID TIdentifier,
			@Comments TNotes,
			@PaymentCurrencyPoint TIdentifier,
			@Advance TBool,
			@SupplierCompanyID TIdentifier,
			@CustomerCompanyID TIdentifier,
			@ExchangeBanned TBool,
			@InvoiceExpirationPeriodType TIdentifier
			
	DECLARE -- RECURRENCE
		@RStartDate TDate, 
		@REndDate TDate, 
		@RRecurrenceType TIdentifier, 
		@ROccurrences TCount,
		@RInterval TCount, 
		@RDayOfWeekMask TIdentifier, 
		@RInstance TIdentifier, 
		@RMonthOfYear TCount, 
		@RDayOfMonth TCount,
		@Recurrence TBool,
		@WarningFlagID TIdentifier

	SET @timeClass = dbo.adfGetClassByName('Pjm5.TimeEntry')

	EXEC adfParameterGet 'NationalCurrency', 'CommonBusiness', @value OUTPUT	
	SET @NationalCurrencyCode = CAST(@value AS varchar(3))

	SET @InvoiceDateChanged = 0
	SELECT
		@ID = [XmlTable].value('ID[1]', 'int'),
		@ProjectID = [XmlTable].value('ProjectID[1]', 'int'),
		@CurrencyRate = [XmlTable].value('CurrencyRate[1]', 'money'),
		@BaseCurrencyRate = [XmlTable].value('BaseCurrencyRate[1]', 'money'),
		@InvoiceCurrencyRate = [Invoice].[CurrencyRate],
		@InvoiceBaseCurrencyRate = [Invoice].[BaseCurrencyRate],
		@PrevCurrencyCode = [Invoice].[CurrencyCode],
		@CurrencyCode = [XmlTable].value('CurrencyCode[1]', 'char(3)'),
		@ProjectCurrencyCode = [Project].[CurrencyCode],
		@RecurrenceID =  [XmlTable].value('RecurrencePatternID[1]', 'int'),
		@Class = [Invoice].[Class],
		@State = [Invoice].[State],
		@ReminderState = CASE [XmlTable].value('ReminderState[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END,
		@ReminderTime = CONVERT(datetime, [XmlTable].value('ReminderTime[1]', 'varchar(19)')),
		@ReminderPublishState = CASE [XmlTable].value('ReminderPublishState[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END,
		@ReminderPublishTime = CONVERT(datetime, [XmlTable].value('ReminderPublishTime[1]', 'varchar(19)')),
		@Date = CONVERT(datetime, [XmlTable].value('Date[1]', 'nvarchar(19)')),
		@Scale = [XmlTable].value('Scale[1]', 'int'),
		@Number = [XmlTable].value('Number[1]', 'varchar(32)'),
		@FileAs = [XmlTable].value('FileAs[1]', 'nvarchar(512)'),
		@SupplierBankAccountID = [XmlTable].value('SupplierBankAccountID[1]', 'int'),
		@Comments = [XmlTable].value('Comments[1]', 'nvarchar(max)'),
		@PaymentCurrencyPoint = [XmlTable].value('PaymentCurrencyPoint[1]', 'int'),
		@Advance = (CASE [XmlTable].value('Advance[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		@SupplierCompanyID = [XmlTable].value('SupplierCompanyID[1]', 'int'),
		@CustomerCompanyID = [XmlTable].value('CustomerCompanyID[1]', 'int'),
		@DueDate = CASE 
			WHEN [Invoice].[Date] = [XmlTable].value('Date[1]', 'nvarchar(19)') THEN [XmlTable].value('DueDate[1]', 'nvarchar(19)')
			ELSE dbo.fnPjm5AddWorkingDays([XmlTable].value('Date[1]', 'nvarchar(19)'), dbo.fnPjm5GetWorkingDays([Invoice].[Date], [Invoice].[DueDate]))
		END,
		@InvoiceDateChanged = CASE
			WHEN [Invoice].[Date] = [XmlTable].value('Date[1]', 'nvarchar(19)') THEN 0
			ELSE 1
		END,
		@ExchangeBanned = CASE [XmlTable].value('ExchangeBanned[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END,
		@WarningFlagID = [Invoice].[WarningFlagID],
		@InvoiceExpirationPeriodType = [XmlTable].value('InvoiceExpirationPeriodType[1]','int')
	FROM 
		@Xml.nodes('/pjm5InvoiceGet/Invoice') List(XmlTable) 		 
		INNER JOIN [Invoice]
			ON [Invoice].[ID] = [XmlTable].value('ID[1]', 'int')
		INNER JOIN [Project]
			ON [Project].[ID] = [XmlTable].value('ProjectID[1]', 'int')
				
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageAllInvoices')) = 0 AND
		dbo.fnPjm5HasFinansDataAccess(@ProjectID, @EmployeeID, NULL, NULL) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	--     
	DECLARE @ApprovedRatesUpdated TBool
	SELECT
		@ApprovedRatesUpdated = CASE WHEN
			[State] = 2 AND
			(
				ISNULL([CurrencyRate], -100) = ISNULL(@CurrencyRate, -100) OR
				ISNULL([CurrencyCode], -100) = ISNULL(@CurrencyCode, -100) OR
				ISNULL([BaseCurrencyRate], -100) = ISNULL(@BaseCurrencyRate, -100)
			)
		THEN 1 ELSE 0 END
	FROM
		[Invoice]
	WHERE
		[ID] = @ID

	IF @ApprovedRatesUpdated = 1
	BEGIN
		RAISERROR('#TransitionTemplateCouldNotBeFound', 16, -1)
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DECLARE @OnlyCustomFields TBool
	SELECT
		@OnlyCustomFields = CASE WHEN
			[Invoice].[ExchangeBanned] != @ExchangeBanned AND
			ISNULL([Invoice].[Date], -100) = ISNULL(@Date, -100) AND
			ISNULL([Invoice].[Number], -100) = ISNULL(@Number, -100) AND
			ISNULL([Invoice].[FileAs], -100) = ISNULL(@FileAs, -100) AND
			ISNULL([Invoice].[SupplierBankAccountID], -100) = ISNULL(@SupplierBankAccountID, -100) AND
			ISNULL([Invoice].[ProjectID], -100) = ISNULL(@ProjectID, -100) AND
			ISNULL([Invoice].[CurrencyRate], -100) = ISNULL(@CurrencyRate, -100) AND
			ISNULL([Invoice].[CurrencyCode], -100) = ISNULL(@CurrencyCode, -100) AND
			ISNULL([Invoice].[BaseCurrencyRate], -100) = ISNULL(@BaseCurrencyRate, -100) AND
			ISNULL([Invoice].[Comments], -100) = ISNULL(@Comments, -100) AND
			ISNULL([Invoice].[PaymentCurrencyPoint], -100) = ISNULL(@PaymentCurrencyPoint, -100) AND
			ISNULL([Invoice].[Advance], -100) = ISNULL(@Advance, -100) AND
			ISNULL([Invoice].[DueDate], -100) = ISNULL(@DueDate, -100) AND
			ISNULL([Invoice].[SupplierCompanyID], -100) = ISNULL(@SupplierCompanyID,  -100) AND
			ISNULL([Invoice].[CustomerCompanyID], -100) = ISNULL(@CustomerCompanyID, -100) AND
			ISNULL([Invoice].[Scale], -100) = ISNULL(@Scale, -100)
		THEN 1 ELSE 0 END
	FROM
		[Invoice]
	WHERE
		[Invoice].[ID] = @ID
	
	
	IF @OnlyCustomFields = 1
	BEGIN
		UPDATE
			[Invoice]
		SET
			[Invoice].[ExchangeBanned] = @ExchangeBanned
		WHERE
			[Invoice].[ID] = @ID
		
		EXEC pjm5InvoiceGet @ID
		RETURN 0
	END

	IF ISNULL(@InvoiceCurrencyRate, -1) != ISNULL(@CurrencyRate, -1) OR 
		ISNULL(@InvoiceBaseCurrencyRate, -1) != ISNULL(@BaseCurrencyRate, -1) OR
		@PrevCurrencyCode != @CurrencyCode
	BEGIN
		SET @WarningFlagID = NULL
	END

	BEGIN TRANSACTION
	UPDATE 
		[Invoice]
	SET
 		[Invoice].[Date] = @Date,
		[Invoice].[Number] = ISNULL(@Number, ''),
		[Invoice].[FileAs] = @FileAs,
		[Invoice].[SupplierBankAccountID] = @SupplierBankAccountID,
		[Invoice].[ProjectID] = @ProjectID,
		[Invoice].[CurrencyRate] = @CurrencyRate,
		[Invoice].[CurrencyCode] = @CurrencyCode,
		[Invoice].[BaseCurrencyRate] = @BaseCurrencyRate,
		[Invoice].[Comments] = @Comments,
		[Invoice].[Modified] = GETDATE(),
		[Invoice].[ModifiedBy] = dbo.adfGetCurrentUserID(),
		[Invoice].[PaymentCurrencyPoint] = @PaymentCurrencyPoint,
		[Invoice].[Advance] = @Advance,
		[Invoice].[DueDate] = @DueDate,
		[Invoice].[SupplierCompanyID] = @SupplierCompanyID, 
		[Invoice].[CustomerCompanyID] = @CustomerCompanyID,
		[Invoice].[Scale] = @Scale,
		[Invoice].[WarningFlagID] = @WarningFlagID,
		[Invoice].[InvoiceExpirationPeriodType] = @InvoiceExpirationPeriodType
	WHERE
		[Invoice].[ID] = @ID
	
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	IF @OnlyCustomFields = 0
	BEGIN
		UPDATE
			[Invoice]
		SET
			[Invoice].[ExchangeBanned] = @ExchangeBanned
		WHERE
			[Invoice].[ID] = @ID
	END
	
	SET @Recurrence = 0
	IF EXISTS(SELECT [XmlTable].value('ID[1]', 'int') FROM @Xml.nodes('/pjm5InvoiceGet/RecurrencePattern') AS List(XmlTable))
	BEGIN
		SET @Recurrence = 1
		SELECT
			@RStartDate = [XmlTable].value('StartDate[1]', 'varchar(19)'), 
			@REndDate = [XmlTable].value('EndDate[1]', 'varchar(19)'), 
			@RRecurrenceType = [XmlTable].value('RecurrenceType[1]', 'int'), 
			@ROccurrences = [XmlTable].value('Occurrences[1]', 'int'),
			@RInterval = [XmlTable].value('Interval[1]', 'int'),
			@RDayOfWeekMask = [XmlTable].value('DayOfWeekMask[1]', 'int'),
			@RInstance = [XmlTable].value('Instance[1]', 'int'),
			@RMonthOfYear = [XmlTable].value('MonthOfYear[1]', 'int'),
			@RDayOfMonth = [XmlTable].value('DayOfMonth[1]', 'int')
		FROM
			@Xml.nodes('/pjm5InvoiceGet/RecurrencePattern') List(XmlTable) 
	END

	IF @State IN (1,6) --   
	BEGIN
		IF @Recurrence = 0 AND @RecurrenceID IS NOT NULL
		BEGIN
			UPDATE [Document] SET [RecurrencePatternID] = NULL WHERE [Class] = @Class AND [ID] = @ID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		ELSE IF @Recurrence = 1 AND @RecurrenceID IS NULL
		BEGIN
			INSERT INTO [RecurrencePattern]
				([StartDate], [EndDate], [RecurrenceType], [Occurrences],
				[Interval], [DayOfWeekMask], [Instance], [MonthOfYear], [DayOfMonth])
			VALUES
				(@RStartDate, @REndDate, @RRecurrenceType, @ROccurrences,
				@RInterval, @RDayOfWeekMask, @RInstance, @RMonthOfYear, @RDayOfMonth)
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
			SET @RecurrenceID = SCOPE_IDENTITY()
			
			UPDATE [Document] SET [RecurrencePatternID] = @RecurrenceID WHERE [Class] = @Class AND [ID] = @ID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		ELSE IF @Recurrence = 1 AND @RecurrenceID IS NOT NULL
		BEGIN
			UPDATE
				[RecurrencePattern]
			SET
				[StartDate] = @RStartDate, 
				[EndDate] = @REndDate, 
				[RecurrenceType] = @RRecurrenceType, 
				[Occurrences] = @ROccurrences,
				[Interval] = @RInterval, 
				[DayOfWeekMask] = @RDayOfWeekMask, 
				[Instance] = @RInstance, 
				[MonthOfYear] = @RMonthOfYear, 
				[DayOfMonth] = @RDayOfMonth
			WHERE
				[ID] = @RecurrenceID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
	END

	IF ISNULL(@InvoiceCurrencyRate, -1) != ISNULL(@CurrencyRate, -1) OR 
		ISNULL(@InvoiceBaseCurrencyRate, -1) != ISNULL(@BaseCurrencyRate, -1) OR
		@PrevCurrencyCode != @CurrencyCode
	BEGIN
		DECLARE @lines TABLE (
		   ID int,
		   DocumentID int null,
		   VATIsIncluded bit null,
		   VATRate decimal(18,4) null,
		   Amount decimal(18,4) null,
		   PricePC money null,
		   VATPC money null,
		   Price money null,
		   VAT money null,
		   TotalBC money null,
		   TotalWithVATBC money null,
		   BasePrice int,
		   modified bit)
		INSERT INTO @lines (ID,DocumentID,VATIsIncluded,VATRate,Amount,PricePC,VATPC,Price,VAT,TotalBC,TotalWithVATBC,BasePrice,modified)
		SELECT ID,DocumentID,VATIsIncluded,VATRate,Amount,PricePC,VATPC,Price,VAT,TotalBC,TotalWithVATBC,BasePrice,0 
		FROM [InvoiceLine] WHERE InvoiceID = @ID
		
		IF @CurrencyRate = 1
		BEGIN
			UPDATE @lines
			SET 
				PricePC = Price,
				VATPC = VAT,
				modified = 1
			WHERE
				BasePrice = 2

			UPDATE @lines
			SET 
				Price = PricePC,
				VAT = VATPC,
				modified = 1
			WHERE
				BasePrice = 1
		END
		ELSE
		BEGIN
			UPDATE @lines
			SET 
				PricePC = ROUND(CASE 
							WHEN @CurrencyCode = @NationalCurrencyCode THEN Price / @CurrencyRate
							ELSE Price * @CurrencyRate
						END, @Scale),
				modified = 1
			WHERE
				BasePrice = 2
				
			UPDATE @lines
			SET 
				Price = ROUND(CASE 
							WHEN @CurrencyCode = @NationalCurrencyCode THEN PricePC * @CurrencyRate
							ELSE PricePC / @CurrencyRate
						END, @Scale),
				modified = 1
			WHERE
				BasePrice = 1
		END
		UPDATE @lines
		SET
			[VATPC] = CASE [VATIsIncluded]
					WHEN 0 THEN ROUND([Amount] * [PricePC] * [VatRate], @Scale)
					ELSE ROUND([Amount] * [PricePC] * [VatRate] / (1 + [VatRate]), @Scale)
				END
		WHERE
			BasePrice = 2

		UPDATE @lines
		SET
			[VAT] = CASE [VATIsIncluded]
					WHEN 0 THEN ROUND([Amount] * [Price] * [VatRate], @Scale)
					ELSE ROUND([Amount] * [Price] * [VatRate] / (1 + [VatRate]), @Scale)
				END
		WHERE
			BasePrice = 1
		
		DECLARE @BaseCurrency TName
		EXEC adfParameterGet 'BaseCurrency', 'CommonBusiness', @value OUTPUT	
		SET @BaseCurrency = CAST(@value AS varchar(3))
		
		UPDATE @lines
		SET 
			TotalBC = ROUND(CASE 
							WHEN @ProjectCurrencyCode = @BaseCurrency
								THEN PricePC * Amount - VATIsIncluded * VATPC
							WHEN @CurrencyCode = @BaseCurrency
								THEN Price * Amount - VATIsIncluded * VAT
							WHEN @ProjectCurrencyCode = @NationalCurrencyCode
								THEN (PricePC * Amount - VATIsIncluded * VATPC) / @BaseCurrencyRate
							ELSE (PricePC * Amount - VATIsIncluded * VATPC) * @BaseCurrencyRate
						END, 2),
			TotalWithVATBC = ROUND(CASE 
							WHEN @ProjectCurrencyCode = @BaseCurrency
								THEN PricePC * Amount + (1 - VATIsIncluded) * VATPC
							WHEN @CurrencyCode = @BaseCurrency
								THEN Price * Amount + (1 - VATIsIncluded) * VAT
							WHEN @ProjectCurrencyCode = @NationalCurrencyCode
								THEN (PricePC * Amount + (1 - VATIsIncluded) * VATPC) / @BaseCurrencyRate
							ELSE (PricePC * Amount + (1 - VATIsIncluded) * VATPC) * @BaseCurrencyRate
						END, 2)

		UPDATE
			[InvoiceLine]
		SET
			PricePC = l.PricePC,
			VATPC = l.VATPC,
			Price = l.Price,
			VAT = l.VAT,
			TotalBC = l.TotalBC,
			TotalWithVATBC = l.TotalWithVATBC
		FROM
			[InvoiceLine]
			INNER JOIN @lines l
				ON l.[ID] = [InvoiceLine].[ID]
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	SELECT @UserID = dbo.adfGetCurrentUserID(),
	       @InvoiceClass = dbo.adfGetClassByName('Pjm5.Invoice')
	
	DECLARE @FixDueDate TDate, @FixDate TDate
	SET @FixDueDate = CAST(CONVERT(varchar(10), @DueDate, 112) as datetime)
	IF @InvoiceDateChanged = 1
		SET @ReminderInterval = dbo.fnPjm5GetReminderInterval(@InvoiceClass, 'VP', @UserID)
	ELSE
		SET @ReminderInterval = DATEDIFF(minute, @ReminderTime, @FixDueDate)
	EXEC @rv = pjm7InvoiceReminderCreate @ID, 'VP',
		@FixDueDate, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	SET @FixDate = CAST(CONVERT(varchar(10), @Date, 112) as datetime)
	IF @InvoiceDateChanged = 1
		SET @ReminderPublishInterval = dbo.fnPjm5GetReminderInterval(@InvoiceClass, 'VA', @UserID)
	ELSE
		SET @ReminderPublishInterval = DATEDIFF(minute, @ReminderPublishTime, @FixDate)
	EXEC @rv = pjm7InvoiceReminderCreate @ID, 'VA',
		@FixDate, @ReminderPublishState, @ReminderPublishInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	COMMIT TRANSACTION
	
	EXEC pjm5InvoiceGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5InvoiceUpdate TO PUBLIC
GO
 