IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5IssueUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5IssueUpdate'
		DROP PROCEDURE [dbo].[pjm5IssueUpdate]
	END
GO

PRINT 'Creating procedure pjm5IssueUpdate'
GO

/******************************************************************************
**		File: pjm5IssueUpdate.sql
**		Name: pjm5IssueUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 03/18/2005 14:40:18
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    02.08.10		SYV				 ,     
*******************************************************************************/
CREATE PROCEDURE pjm5IssueUpdate
	@ID TIdentifier,
	@Number TCode,
	@FileAs TName,
	@DuplicateOfIssueID TIdentifier,
	@ProjectID TIdentifier,
	@EmployeeID TIdentifier,
	@SeverityID TIdentifier,
	@PriorityID TIdentifier,
	@DueDate TDate,
	@EndTime TDate,
	@ResolutionID TIdentifier,
	@Resolution TNotes,
	@SendStatusReport TBool,
	@WSSDocumentURL THref,
	@UDF1 TCode,
	@UDF2 TCode,
	@UDF3 TCode,
	@UDF4 TCode,
	@Comments TNotes,
	@ReminderState TState,
	@ReminderInterval TTimeSpan,
	@ManHour TCount,
	@Budget TMoney
AS
	
	SET NOCOUNT ON
	
	IF @ProjectID IS NULL
	BEGIN
		RAISERROR('#projectnotspecified', 18, -1)
		RETURN 1
	END
	
	IF NOT EXISTS(SELECT * FROM [Project] WHERE [ID] = @ProjectID AND [SupportsRequestManagement] = 1)
	BEGIN
		RAISERROR('#doesnotsupportsrequestmanagement', 18, -1)
		RETURN 1
	END
	
	IF @EmployeeID IS NOT NULL
	BEGIN
		IF NOT EXISTS(SELECT * FROM [vwAssignment] WHERE [ProjectID] = @ProjectID AND [EmployeeID] = @EmployeeID AND [State]=1)
		BEGIN
			RAISERROR('#notassignedtospecifiedproject', 18, -1)
			RETURN 1
		END
	END
	DECLARE @State TState

	BEGIN TRANSACTION
	UPDATE [Issue]
	SET
		@State = [Issue].[State],
		[Issue].[Number] = @Number,
		[Issue].[FileAs] = @FileAs,
		[Issue].[DuplicateOfIssueID] = @DuplicateOfIssueID,
		[Issue].[ProjectID] = @ProjectID,
		[Issue].[EmployeeID] = @EmployeeID,
		[Issue].[SeverityID] = @SeverityID,
		[Issue].[PriorityID] = @PriorityID,
		[Issue].[DueDate] = @DueDate,
		[Issue].[EndTime] = @EndTime,
		[Issue].[ResolutionID] = @ResolutionID,
		[Issue].[Resolution] = @Resolution,
		[Issue].[SendStatusReport] = @SendStatusReport,
		[Issue].[WSSDocumentURL] = @WSSDocumentURL,
		[Issue].[UDF1] = @UDF1,
		[Issue].[UDF2] = @UDF2,
		[Issue].[UDF3] = @UDF3,
		[Issue].[UDF4] = @UDF4,
		[Issue].[Comments] = @Comments,
		[Issue].[Modified] = DEFAULT,
		[Issue].[ModifiedBy] = DEFAULT,
		[Issue].[Budget] = ISNULL(@Budget, 0),
		[Issue].[ManHour] = ISNULL(@ManHour, 0)
	WHERE
		[Issue].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	IF @State = 4 AND @ResolutionID IS NULL 
	BEGIN
		ROLLBACK TRANSACTION
		RAISERROR('#issueresolutionnotspecified', 18, -1)
		RETURN 1
	END

	DECLARE @rv int		
	EXEC @rv = pjm7IssueReminderCreate @ID,
		@DueDate, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	COMMIT TRANSACTION
	
	EXEC pjm5IssueGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5IssueUpdate TO PUBLIC
GO
 