IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6MailParserForIssue]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6MailParserForIssue'
		DROP PROCEDURE [dbo].[pjm6MailParserForIssue]
	END
GO

PRINT 'Creating procedure pjm6MailParserForIssue'
GO

/******************************************************************************
**		File: pjm6MailParserForIssue.sql
**		Name: pjm6MailParserForIssue
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: PAM
**		Date: 24.11.09
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6MailParserForIssue]
	@EmailFrom					THref,
	@PriorityID					TIdentifier,
	@DueDate					TDate,
	@Subject					TName,
	@Comments					TNotes,
	@Number						TCode OUTPUT,
	@ID							TIdentifier OUTPUT,
	@Class						TClass OUTPUT
AS
DECLARE
		@ContactID		TIdentifier,
		@CompanyID		TIdentifier,
		@ProjectID		TIdentifier,
		@CursorExit		bit

DECLARE ContactCursor CURSOR FOR
	SELECT
		[BusinessCardID] 
	FROM
		[Email] e
		INNER JOIN [Employee] emp
			ON e.[BusinessCardID] = emp.[ID] and e.[BusinessCardClass] = emp.[Class]
		INNER JOIN [Company] c
			ON emp.[CompanyID] = c.[ID]
	WHERE e.[EmailTypeID] <= 3 and c.[Own] = 0 and [Email] = @EmailFrom
	ORDER BY [emp].[FireDate] desc, [emp].[Created] asc

OPEN ContactCursor
SET @CursorExit = 0
FETCH NEXT FROM ContactCursor INTO @ContactID
WHILE @@FETCH_STATUS = 0 AND @CursorExit = 0
BEGIN
	IF(@ContactID IS NOT NULL)
	BEGIN
		SET @CompanyID = (SELECT [CompanyID] FROM [Employee] WHERE ID = @ContactID)
	END
	
	IF(@CompanyID IS NOT NULL)
	BEGIN
		SET @ProjectID = (SELECT TOP 1 [ID] FROM [Project] 
							WHERE [CustomerCompanyID] = @CompanyID AND [SupportsRequestManagement] = 1 AND [State] = 2
							ORDER BY [Created] asc)
		IF(@ProjectID IS NOT NULL)
			SET @CursorExit = 1
	END

	FETCH NEXT FROM ContactCursor INTO @ContactID
END
CLOSE ContactCursor
DEALLOCATE ContactCursor

IF(@ProjectID IS NULL)
BEGIN
	DECLARE CompanyCursor CURSOR FOR
		SELECT	[BusinessCardID]
		FROM [Email] e
		INNER JOIN [Company] c
			ON e.[BusinessCardID] = c.[ID] and e.[BusinessCardClass] = c.[Class]
		WHERE (e.[EmailTypeID] = 4 and c.[Own] = 0 and [dbo].[fnsiteprocNormalizeSiteValue]([Email]) LIKE [dbo].[fnPjm6GetDomainFromEmail](@EmailFrom)+'%')
			OR (e.[EmailTypeID] < 4 and c.[Own] = 0 and [Email] LIKE '%' + @EmailFrom + '%')
		ORDER BY [c].[Created] asc
	OPEN CompanyCursor
	SET @CursorExit = 0
	FETCH NEXT FROM CompanyCursor INTO @CompanyID
	WHILE @@FETCH_STATUS = 0 AND @CursorExit = 0
	BEGIN
		IF(@CompanyID IS NOT NULL)
		BEGIN
			SET @ProjectID = (SELECT TOP 1 [ID] FROM [Project] 
							WHERE [CustomerCompanyID] = @CompanyID AND [SupportsRequestManagement] = 1 AND [State] = 2
							ORDER BY [Created] asc)
			IF(@ProjectID IS NOT NULL)
				SET @CursorExit = 1
		END
		FETCH NEXT FROM CompanyCursor INTO @CompanyID
	END
	CLOSE CompanyCursor
	DEALLOCATE CompanyCursor
END

	IF(@ProjectID IS NOT NULL)
	BEGIN
		DECLARE @Index TCount, 
				@Prefix TCode, 
				@N varchar(10),
				@State TState
		
		SET @State = dbo.adfwfGetInitialState('1acd1e8f-3c88-43b1-81ac-0dcabc871562')
		IF @State IS NULL
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END
		
		IF NOT EXISTS(SELECT * FROM [DocumentIndex] WHERE [ProjectID] = @ProjectID)
			BEGIN
				INSERT INTO [DocumentIndex] ([ProjectID]) VALUES(@ProjectID)
			END

		BEGIN TRANSACTION

		UPDATE
			[DocumentIndex]
		SET
			@Index = [IssueIndex] + 1,
			[IssueIndex] = [IssueIndex] + 1
		WHERE
			[ProjectID] = @ProjectID
		
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
			
		SELECT
			@Prefix = LEFT(UPPER([Number]), 8)
		FROM
			[Project] 
		WHERE
			[ID] = @ProjectID
			
		SET @N = CAST(@Index as varchar(10))
		
		SET @Number = @Prefix + REPLICATE('0', 8 - LEN(@N)) + @N

		INSERT INTO [Issue]
			([Flag], [State], [Number], [FileAs], [ProjectID], [SeverityID], [PriorityID], [DueDate], [Comments],
			[SendStatusReport])
		VALUES
			(1, @State, @Number, @Subject, @ProjectID, 2, @PriorityID, @DueDate, @Comments, 0)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		SET @ID = SCOPE_IDENTITY()
		SET @Class = dbo.adfGetClassByName('Pjm5.Issue')
		
		DECLARE @PropertyID TIdentifier
		
		SELECT @PropertyID = [ID] FROM [Property] WHERE [Class]=@Class AND [Guid] = CAST('{00000001-0000-0000-0000-000000000000}' as uniqueidentifier)
		
		EXEC adfPropertyValueUpdate @Class, @ID, @PropertyID ,@EmailFrom
		
		DECLARE @BusinessCardClass TClass,
				@BusinessCardID TIdentifier
		
		SELECT
			@BusinessCardClass = [BusinessCardClass],
			@BusinessCardID = [BusinessCardID]
		FROM
			[Email]
		WHERE
			[BusinessCardID] = @ContactID
			
		IF @BusinessCardID IS NOT NULL
		BEGIN
			
			INSERT INTO [DocumentContact]
				([DocumentClass], [DocumentID], [BusinessCardClass], [BusinessCardID])
			VALUES
				(@Class, @ID, @BusinessCardClass, @BusinessCardID)
		
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END			
		END
		
		COMMIT TRANSACTION

		EXEC pjm5IssueChangeState @ID = @ID, @ToState = 2

	END
	ELSE
	BEGIN
		RETURN 1
	END

	RETURN 0
GO

GRANT EXECUTE ON [pjm6MailParserForIssue] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6GetDomainFromEmail]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6GetDomainFromEmail'
		DROP FUNCTION [dbo].[fnPjm6GetDomainFromEmail]
	END

GO

PRINT 'Creating function fnPjm6GetDomainFromEmail'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm6GetDomainFromEmail
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm6GetDomainFromEmail(@Email TName)
RETURNS TName
AS
BEGIN
	Declare @domain TName

	SET @domain = RIGHT(@Email, LEN(@Email) - PATINDEX('%@%', @Email))
	RETURN(@domain)
END
GO

GRANT EXEC ON fnPjm6GetDomainFromEmail TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnsiteprocNormalizeSiteValue]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnsiteprocNormalizeSiteValue'
		DROP FUNCTION [dbo].[fnsiteprocNormalizeSiteValue]
	END

GO

PRINT 'Creating function fnsiteprocNormalizeSiteValue'
GO
/******************************************************************************
**		File: 
**		Name: fnsiteprocNormalizeSiteValue
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnsiteprocNormalizeSiteValue(@string TName)
RETURNS TName
AS
BEGIN
	Declare @stringWitoutWildcards TName

	SET @stringWitoutWildcards = @string	
	SET @stringWitoutWildcards = REPLACE(@stringWitoutWildcards, 'http://', '')
	SET @stringWitoutWildcards = REPLACE(@stringWitoutWildcards, 'https://', '')
	SET @stringWitoutWildcards = REPLACE(@stringWitoutWildcards, 'www.', '')
	SET @stringWitoutWildcards = REPLACE(@stringWitoutWildcards, 'www3.', '')	
	RETURN(@stringWitoutWildcards)
END
GO

GRANT EXEC ON fnsiteprocNormalizeSiteValue TO PUBLIC
GO