IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6LastDocumentAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6LastDocumentAdd'
		DROP PROCEDURE [dbo].[pjm6LastDocumentAdd]
	END
GO

PRINT 'Creating procedure pjm6LastDocumentAdd'
GO

/******************************************************************************
**		File: pjm6LastDocumentAdd.sql
**		Name: pjm6LastDocumentAdd
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.svintsov
**		Date: 07/08/2009 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    12.03.10		SYV				    
**    03.09.13		SOV				    
*******************************************************************************/
CREATE PROCEDURE [pjm6LastDocumentAdd]
	@DocumentClass TClass,
	@DocumentID TIdentifier,
	@ProjectID TIdentifier
AS
	DECLARE
		@EmployeeID TIdentifier,
		@TimeStamp timestamp,
		@RecordsCount int,
		@ID TIdentifier,
		@DeletedDocumentID TIdentifier

	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()

	IF @EmployeeID IS NOT NULL
	BEGIN
		--   	
		DELETE [LastDocument]
		WHERE [DocumentClass] = @DocumentClass AND [DocumentID] = @DocumentID AND [EmployeeID] = @EmployeeID
	
		IF NOT EXISTS(
			SELECT
				*
			FROM
				[Document]
			WHERE
				[ID] = @DocumentID
				AND
				[Class] = @DocumentClass
		)
		BEGIN
			RETURN 0
		END

		--  
		INSERT INTO [LastDocument]
			 ([DocumentClass], [DocumentID], [ProjectID], [EmployeeID])
		VALUES (@DocumentClass, @DocumentID, @ProjectID, @EmployeeID)
	
		SELECT @RecordsCount = COUNT(*)
		FROM [LastDocument]
		WHERE [EmployeeID] = @EmployeeID AND [DocumentClass] = @DocumentClass
		--     
		IF @RecordsCount > 9
		BEGIN
			--   
			SELECT
				@ID = [RecordForOut].[ID]
			FROM
				(
					SELECT TOP (1) [ID] FROM [LastDocument]
					WHERE
						[DocumentClass] = @DocumentClass AND
						[EmployeeID] = @EmployeeID
					ORDER BY [Timestamp] ASC
				) AS [RecordForOut]
			-- 
			DELETE [LastDocument] WHERE [ID] = @ID

		END
	END

	RETURN 0
GO

GRANT EXECUTE ON pjm6LastDocumentAdd TO PUBLIC
GO
 

