SET QUOTED_IDENTIFIER ON
GO

 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5MeetingRequestBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5MeetingRequestBrowse'
		DROP PROCEDURE [dbo].[pjm5MeetingRequestBrowse]
	END
GO

PRINT 'Creating procedure pjm5MeetingRequestBrowse'
GO

/******************************************************************************
**		File: pjm5MeetingRequestBrowse.sql
**		Name: pjm5MeetingRequestBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/19/2006 12:50:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:		Description:
**		--------	--------	-------------------------------------------
**		30.11.12	SAP			     
**								 ""   
**		07.12.12	SAP			    "  "
**								        
**		09.09.13	SAP			    ,    
**		26.03.14	SAP			     	
*******************************************************************************/
CREATE PROCEDURE [pjm5MeetingRequestBrowse]
	-- 	
	@OriginatorEmployeeID INT,
	-- 	
	@AttendeeEmployeeID INT,
	--
	@ProjectSelector INT,
	@ActiveProjectID INT,
	@InactiveProjectID INT,
	--  
	@DateSelector INT, 
	@PeriodStart DATETIME,
	@PeriodEnd DATETIME,
	--
	@StateSelector INT,	
	--  - 0 - , 1 -   
	@OwnMeetings INT = 0
AS
	SET NOCOUNT ON
	
	DECLARE @employeeID INT	
	
	-- @DateSelector:
	--0 -  
	--1 -  7 
	--2 -  
	--3 -  
	--4 -  
	
	--         
	EXEC pjm6TimeEntryBrowseParameters 
			@DateSelector, 
			@PeriodStart	OUTPUT,
			@PeriodEnd		OUTPUT
	
	DECLARE @AvailableProjects TABLE
	(
		[ID] int,
		[State] int
	)
	INSERT INTO @AvailableProjects
	SELECT * FROM [dbo].[fnPjm5GetAvailableProjects] ()

	IF @OwnMeetings = 0
	BEGIN
		SELECT
			[MeetingRequest].[Class],
			[MeetingRequest].[ID],
			[MeetingRequest].[State],		
			[MeetingRequest].[FileAs],
			[MeetingRequest].[ProjectID],
			[MeetingRequest].[OriginatorEmployeeID],
			[MeetingRequest].[PriorityID] AS [Priority],
			[MeetingRequest].[ActivityTypeID],		
			[MeetingRequest].[StartTime],
			[MeetingRequest].[Duration],	
			[MeetingRequest].[Comments],
			[MeetingRequest].[Created],
			[MeetingRequest].[CreatedBy],
			[MeetingRequest].[Modified],
			[MeetingRequest].[ModifiedBy],
			[MeetingRequest].[Timestamp],
			[MeetingRequest].[Flag],
			[ProjectType].[FileAs] AS [ProjectType],
			[ActivityType].[FileAs] AS [ActivityType],				
			[Company].[FileAs] AS [Customer],
			[CostCenter].[FileAs] AS [CostCenter]
		FROM
			[MeetingRequest]
			LEFT JOIN [Attendee]
				ON [Attendee].[MeetingRequestID] = [MeetingRequest].[ID]
			LEFT JOIN [Project]
				ON [Project].[ID] = [MeetingRequest].[ProjectID]			
			LEFT JOIN [ProjectType]
				ON [ProjectType].[ID] = [Project].[ProjectTypeID]
			LEFT JOIN [ActivityType]
				ON [ActivityType].[ID] = [MeetingRequest].[ActivityTypeID]		
			LEFT JOIN [Company]
				ON [Company].[ID] = [Project].[CustomerCompanyID]
			LEFT JOIN [CostCenter]
				ON [CostCenter].[ID] = [Project].[CostCenterID]
		WHERE
		--
			((@OriginatorEmployeeID IS NULL) OR (@OriginatorEmployeeID IS NOT NULL AND [MeetingRequest].[OriginatorEmployeeID] = @OriginatorEmployeeID))
			AND
		-- 
			((@AttendeeEmployeeID IS NULL) OR (@AttendeeEmployeeID IS NOT NULL  AND [Attendee].[EmployeeID] = @AttendeeEmployeeID))
			AND
		--
			(			
				(
					@ProjectSelector = 0 AND
					(
						([Project].[ID] IN (SELECT [ID] FROM @AvailableProjects))OR
						[MeetingRequest].[ProjectID] IS NULL
					)
				)
				OR
				(
					@ProjectSelector = 1 AND 
					(
						(@ActiveProjectID IS NULL AND [Project].[State] = 2 AND [Project].[ID] IN (SELECT [ID] FROM @AvailableProjects)) 
						OR
						(@ActiveProjectID IS NOT NULL AND [Project].[ID] = @ActiveProjectID AND [Project].[ID] IN (SELECT [ID] FROM @AvailableProjects))
					)
				) 
				OR
				(
					@ProjectSelector = 2 AND 
					(
						(@InactiveProjectID IS NULL AND [Project].[State] IN (3,4) AND [Project].[ID] IN (SELECT [ID] FROM @AvailableProjects)) OR
						(@InactiveProjectID IS NOT NULL AND [Project].[ID] = @InactiveProjectID AND [Project].[ID] IN (SELECT [ID] FROM @AvailableProjects))
					)
				)
			
			)
			AND
		--  
			(@DateSelector = 0 OR ([MeetingRequest].[StartTime] BETWEEN @PeriodStart AND @PeriodEnd))
			AND
		--
			((@StateSelector = 0) OR (@StateSelector != 0 AND [MeetingRequest].[State] = @StateSelector))
		GROUP BY
			[MeetingRequest].[Class],
			[MeetingRequest].[ID],
			[MeetingRequest].[State],		
			[MeetingRequest].[FileAs],
			[MeetingRequest].[ProjectID],
			[MeetingRequest].[OriginatorEmployeeID],
			[MeetingRequest].[ActivityTypeID],
			[MeetingRequest].[PriorityID],
			[MeetingRequest].[StartTime],
			[MeetingRequest].[Duration],		
			[MeetingRequest].[Comments],
			[MeetingRequest].[Created],
			[MeetingRequest].[CreatedBy],
			[MeetingRequest].[Modified],
			[MeetingRequest].[ModifiedBy],
			[MeetingRequest].[Timestamp],
			[MeetingRequest].[Flag],
			[ProjectType].[FileAs],
			[ActivityType].[FileAs],			
			[Company].[FileAs],
			[CostCenter].[FileAs]
	END
	ELSE
	BEGIN	
		SET @employeeID = dbo.adfGetCurrentEmployeeID()
		
		SELECT
			[MeetingRequest].[Class],
			[MeetingRequest].[ID],
			[MeetingRequest].[State],		
			[MeetingRequest].[FileAs],
			[MeetingRequest].[ProjectID],
			[MeetingRequest].[OriginatorEmployeeID],
			[MeetingRequest].[PriorityID] AS [Priority],
			[MeetingRequest].[ActivityTypeID],		
			[MeetingRequest].[StartTime],
			[MeetingRequest].[Duration],	
			[MeetingRequest].[Comments],
			[MeetingRequest].[Created],
			[MeetingRequest].[CreatedBy],
			[MeetingRequest].[Modified],
			[MeetingRequest].[ModifiedBy],
			[MeetingRequest].[Timestamp],
			[MeetingRequest].[Flag],
			[ProjectType].[FileAs] AS [ProjectType],
			[ActivityType].[FileAs] AS [ActivityType],				
			[Company].[FileAs] AS [Customer],
			[CostCenter].[FileAs] AS [CostCenter]
		FROM
			[MeetingRequest]
			LEFT JOIN [Attendee]
				ON [Attendee].[MeetingRequestID] = [MeetingRequest].[ID]
			LEFT JOIN [Project]
				ON [Project].[ID] = [MeetingRequest].[ProjectID]			
			LEFT JOIN [ProjectType]
				ON [ProjectType].[ID] = [Project].[ProjectTypeID]
			LEFT JOIN [ActivityType]
				ON [ActivityType].[ID] = [MeetingRequest].[ActivityTypeID]		
			LEFT JOIN [Company]
				ON [Company].[ID] = [Project].[CustomerCompanyID]
			LEFT JOIN [CostCenter]
				ON [CostCenter].[ID] = [Project].[CostCenterID]
		WHERE
		-- -  
			(
				[MeetingRequest].[OriginatorEmployeeID] = @employeeID
				OR
		--   -  
				(EXISTS(
				SELECT 
					* 
				FROM 
					[Attendee] 
				WHERE 
					[MeetingRequestID] = [MeetingRequest].[ID] 
					AND 
					[EmployeeID] = @employeeID 
					AND 
					(	[ResponseType] IS NULL 
						OR 
						[ResponseType] IN ('Accept', 'Tentative'))) 
					AND 
					[MeetingRequest].[State] IN (2, 3))
			)
			AND
		--
			(			
				(
					@ProjectSelector = 0 AND
					(
						([Project].[ID] IN (SELECT [ID] FROM @AvailableProjects))OR
						[MeetingRequest].[ProjectID] IS NULL
					)
				)
				OR
				(
					@ProjectSelector = 1 AND 
					(
						(@ActiveProjectID IS NULL AND [Project].[State] = 2 AND [Project].[ID] IN (SELECT [ID] FROM @AvailableProjects)) 
						OR
						(@ActiveProjectID IS NOT NULL AND [Project].[ID] = @ActiveProjectID AND [Project].[ID] IN (SELECT [ID] FROM @AvailableProjects))
					)
				) 
				OR
				(
					@ProjectSelector = 2 AND 
					(
						(@InactiveProjectID IS NULL AND [Project].[State] IN (3,4) AND [Project].[ID] IN (SELECT [ID] FROM @AvailableProjects)) OR
						(@InactiveProjectID IS NOT NULL AND [Project].[ID] = @InactiveProjectID AND [Project].[ID] IN (SELECT [ID] FROM @AvailableProjects))
					)
				)
			
			)
			AND
		--  
			(@DateSelector = 0 OR ([MeetingRequest].[StartTime] BETWEEN @PeriodStart AND @PeriodEnd))
			AND
		--
			((@StateSelector = 0) OR (@StateSelector != 0 AND [MeetingRequest].[State] = @StateSelector))
		GROUP BY
			[MeetingRequest].[Class],
			[MeetingRequest].[ID],
			[MeetingRequest].[State],		
			[MeetingRequest].[FileAs],
			[MeetingRequest].[ProjectID],
			[MeetingRequest].[OriginatorEmployeeID],
			[MeetingRequest].[ActivityTypeID],
			[MeetingRequest].[PriorityID],
			[MeetingRequest].[StartTime],
			[MeetingRequest].[Duration],		
			[MeetingRequest].[Comments],
			[MeetingRequest].[Created],
			[MeetingRequest].[CreatedBy],
			[MeetingRequest].[Modified],
			[MeetingRequest].[ModifiedBy],
			[MeetingRequest].[Timestamp],
			[MeetingRequest].[Flag],
			[ProjectType].[FileAs],
			[ActivityType].[FileAs],			
			[Company].[FileAs],
			[CostCenter].[FileAs]
	END
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm5MeetingRequestBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5MeetingRequestGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5MeetingRequestGet'
		DROP PROCEDURE [dbo].[pjm5MeetingRequestGet]
	END
GO

PRINT 'Creating procedure pjm5MeetingRequestGet'
GO

/******************************************************************************
**		File: pjm5MeetingRequestGet.sql
**		Name: pjm5MeetingRequestGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/19/2006 12:50:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		29.07.13	SAP				    ExchangeLastSyncDate  
**		07.10.13	BAO				    OriginatorPresent
**		16.10.13	BAO				    OriginatorTimeEntryIsBillable
**									  MeetingRequest
**									  Billable  Attendee
**		17.10.13	SOV				     " "
*******************************************************************************/
CREATE PROCEDURE [pjm5MeetingRequestGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE @EmployeeID				TIdentifier, 
			@UserID					TIdentifier,
			@RecurrencePatternID	TIdentifier,
			@MeetingRequestClass	TClass,
			@ExchangeSync			TBool,
			@UserSyncMeetingRequest	TBool = 0,
			@AppSyncMeetingRequest	TBool = 0,
			@value					TVariant
	
	SET @MeetingRequestClass = dbo.adfGetClassByName('Pjm5.MeetingRequest')

	SET @EmployeeID = dbo.adfGetCurrentEmployeeID();
	SET @UserID = dbo.adfGetCurrentUserID();
	
	SELECT 
		@RecurrencePatternID = [RecurrencePatternID] 
	FROM 
		[Document] 
	WHERE 
		[Document].[Class] = @MeetingRequestClass AND [Document].[ID] = @ID

	IF EXISTS	(	SELECT * 
					FROM 
						[dbo].[ExchangeDocumentSync] 
					WHERE 
						[DocumentID] = @ID AND 
						[DocumentClass] = @MeetingRequestClass AND 
						[UserID] = @UserID
				)
		SET @ExchangeSync = 1;
	ELSE
		SET @ExchangeSync = 0;

	EXEC adfParameterGet @Name='ExchangeSyncMeetingRequests', @Group='Pjm6', @Value = @value OUTPUT
	SET @AppSyncMeetingRequest = CAST(@value as bit)
	IF @AppSyncMeetingRequest = 1
	BEGIN
		SELECT
			@value = [Value] 
		FROM 
			[UserParameter] 
		WHERE 
			[Name] = 'SyncExchangeMeetings' AND 
			[UserID] = @UserID

		SET @UserSyncMeetingRequest = ISNULL(CAST(@value AS BIT), 0)
	END
	
	DECLARE @IsManagerAssistant TBool,
			@IsProjectManager TBool,
			@IsApprover TBool,
			@IsAdministrator TBool,
			@ProjectTypeID INT
		
	SELECT
		@IsManagerAssistant = dbo.fnPjm7IsManagerAssistant([ProjectID], @EmployeeID),
		@IsProjectManager = dbo.fnPjm5IsProjectManager([ProjectID], @EmployeeID),
		@IsApprover = dbo.fnPjm5IsProjectApprover([ProjectID], @EmployeeID),
		@IsAdministrator = dbo.fnPjm5IsProjectAdministrator([ProjectID], @EmployeeID),
		@ProjectTypeID = [ProjectTypeID]
	FROM [MeetingRequest]
		INNER JOIN [Project]
			ON [Project].[ID] = [MeetingRequest].[ProjectID]
	WHERE [MeetingRequest].[ID] = @ID
	
	SELECT
		[MeetingRequest].[Class],
		[MeetingRequest].[ID],
		[MeetingRequest].[State],
		[MeetingRequest].[Flag],
		[MeetingRequest].[FileAs],
		[MeetingRequest].[ProjectID],
		[MeetingRequest].[OriginatorEmployeeID],
		[MeetingRequest].[ActivityTypeID],
		[MeetingRequest].[PriorityID],
		[MeetingRequest].[StartTime],
		[MeetingRequest].[Duration],
		[MeetingRequest].[Location],
		[MeetingRequest].[Color],
		[MeetingRequest].[Comments],
		(SELECT [ResponseType] FROM [Attendee] WHERE [MeetingRequestID] = @ID AND [EmployeeID] = @EmployeeID) as [ResponseType],
		@RecurrencePatternID as [RecurrencePatternID],
		ISNULL([UserReminder].[State], CAST(0 as int)) AS [ReminderState],
		ISNULL([UserReminder].[OriginalInterval], dbo.fnPjm5GetReminderInterval([MeetingRequest].[Class], 'MS', @UserID)) AS [ReminderInterval],
		[MeetingRequest].[Created],
		[MeetingRequest].[CreatedBy],
		[MeetingRequest].[Modified],
		[MeetingRequest].[ModifiedBy],
		[MeetingRequest].[Timestamp],
		[MeetingRequest].[SendUpdate],
		@ExchangeSync as [ExchangeSync],
		@UserSyncMeetingRequest AS [ExchangeSyncMeetingRequests],
		[exch].[ExchangeLink].[SyncTime] AS [ExchangeLastSyncDate],
		[MeetingRequest].[OriginatorPresent],
		ISNULL([MeetingRequest].[OriginatorTimeEntryIsBillable],
		CASE
			WHEN @ProjectTypeID != 1 OR 
				dbo.fnPjm5IsProjectMember([MeetingRequest].[ProjectID], [OriginatorEmployeeID]) = 0 THEN 0
			WHEN [MeetingRequest].[ActivityTypeID] IS NULL THEN 1
			ELSE [ProjectActivityType].[Billable]	
		END) AS [OriginatorTimeEntryIsBillable],
		CASE
			WHEN @ProjectTypeID != 1 OR
				[MeetingRequest].[ProjectID] IS NULL OR
				dbo.fnpjm7BillableHourGet([MeetingRequest].[ProjectID], 1, 0, 0) != 1 THEN 0
			WHEN @IsManagerAssistant = 0 AND @IsProjectManager = 0 AND	@IsApprover = 0 AND	@IsAdministrator = 0 THEN 1
			ELSE 2
		END AS [BillableFlag] --     (1)     (2)
	FROM
		[MeetingRequest]
		LEFT OUTER JOIN [Reminder]
			ON ([Reminder].[DocumentClass] = [MeetingRequest].[Class] AND
				[Reminder].[DocumentID] = [MeetingRequest].[ID] AND
				[Reminder].[Subtype] = 'MS')
		LEFT OUTER JOIN [UserReminder]
			ON ([Reminder].[ID] = [UserReminder].[ReminderID] AND
				[UserReminder].[UserID] = @UserID)
		LEFT JOIN [exch].[ExchangeLink]
			ON([exch].[ExchangeLink].[DocumentID] = [MeetingRequest].[ID] AND 
				[exch].[ExchangeLink].[DocumentClass] = @MeetingRequestClass AND 
				[exch].[ExchangeLink].[UserID] = @UserID)
		LEFT JOIN [ProjectActivityType]
			ON [MeetingRequest].[ProjectID] = [ProjectActivityType].[ProjectID] AND
				[MeetingRequest].[ActivityTypeID] = [ProjectActivityType].[ActivityTypeID]
	WHERE
		[MeetingRequest].[ID] = @ID
		
	SELECT
		[EmployeeID],
		[Required],
		[Present],
		[ResponseType],
		ISNULL([Attendee].[Billable],
			CASE
				WHEN @ProjectTypeID != 1 OR
					dbo.fnPjm5IsProjectMember([MeetingRequest].[ProjectID], [EmployeeID]) = 0 THEN 0
				WHEN [MeetingRequest].[ActivityTypeID] IS NULL THEN 1
				ELSE [ProjectActivityType].[Billable]	
			END) AS [Billable]
	FROM
		[Attendee]
		INNER JOIN [MeetingRequest]
			ON [MeetingRequest].[ID] = [MeetingRequestID]
		LEFT JOIN [ProjectActivityType]
			ON [MeetingRequest].[ProjectID] = [ProjectActivityType].[ProjectID] AND
				[MeetingRequest].[ActivityTypeID] = [ProjectActivityType].[ActivityTypeID]
	WHERE
		[MeetingRequestID] = @ID

	SELECT
		[MeetingResource].[ResourceID],
		[Resource].[ResourceTypeID],
		[MeetingResource].[Required]
	FROM
		[MeetingResource] INNER JOIN [Resource]
			On ([MeetingResource].[ResourceID] = [Resource].[ID])
	WHERE
		[MeetingRequestID] = @ID
		
	SELECT
		[ID],
		[EmployeeID],
		[FileAs],
		[Comments],
		[Created]
	FROM
		[AttendeeResponse]
	WHERE
		[MeetingRequestID] = @ID
		
	SELECT
		[RecurrencePattern].[ID],
		[RecurrencePattern].[StartDate],
		[RecurrencePattern].[EndDate],
		[RecurrencePattern].[Occurrences],
		[RecurrencePattern].[RecurrenceType],
		[RecurrencePattern].[Interval],
		[RecurrencePattern].[DayOfWeekMask],
		[RecurrencePattern].[Instance],
		[RecurrencePattern].[MonthOfYear],
		[RecurrencePattern].[DayOfMonth]
	FROM
		[RecurrencePattern]
	WHERE
		[RecurrencePattern].[ID] = @RecurrencePatternID
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5MeetingRequestGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5MeetingRequestCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5MeetingRequestCreate'
		DROP PROCEDURE [dbo].[pjm5MeetingRequestCreate]
	END
GO

PRINT 'Creating procedure pjm5MeetingRequestCreate'
GO

/******************************************************************************
**		File: pjm5MeetingRequestCreate.sql
**		Name: pjm5MeetingRequestCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/19/2006 12:50:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		07.12.2012	SOV				 ,     0
*******************************************************************************/
CREATE PROCEDURE [pjm5MeetingRequestCreate]
	@Xml XML
AS
	SET NOCOUNT ON

	DECLARE @State TState,
			@ID TIdentifier,
			@RecurrenceID TIdentifier
	
	SET @State = dbo.adfwfGetInitialState('8dd9c3da-a9a1-4bbb-90a2-a8f6fcff6ad6')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	DECLARE @_xml xml
	
	SET @_xml = @Xml
	DECLARE @Duration INT
	
	SELECT @Duration = T.c.value('Duration[1]', 'int')
	FROM
		@_xml.nodes('/pjm5MeetingRequestGet/MeetingRequest') T(c)
	
	IF @Duration IS NULL OR @Duration < 0
	BEGIN
		RAISERROR('#DurationIsInvalid', 18, -1)
		RETURN 1
	END
	
	DECLARE @CurrentEmployeeID TIdentifier, @result INT
	
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	
	BEGIN TRANSACTION

	INSERT INTO [RecurrencePattern]
		([StartDate], [EndDate], [RecurrenceType], [Occurrences],
		[Interval], [DayOfWeekMask], [Instance], [MonthOfYear], [DayOfMonth])
	SELECT
		CAST(T.c.value('StartDate[1]', 'varchar(19)') as datetime),
		CAST(T.c.value('EndDate[1]', 'varchar(19)') as datetime),
		T.c.value('RecurrenceType[1]', 'int'),
		T.c.value('Occurrences[1]', 'int'),
		T.c.value('Interval[1]', 'int'),
		T.c.value('DayOfWeekMask[1]', 'int'),
		T.c.value('Instance[1]', 'int'),
		T.c.value('MonthOfYear[1]', 'int'),
		T.c.value('DayOfMonth[1]', 'int')
	FROM
		@_xml.nodes('/pjm5MeetingRequestGet/RecurrencePattern') T(c)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	SET @RecurrenceID = SCOPE_IDENTITY()
	
	INSERT INTO [MeetingRequest]
		([Flag], [State], [FileAs], [ProjectID], [OriginatorEmployeeID], 
		[ActivityTypeID], [PriorityID], [StartTime], [Duration], [Location], [Color], [Comments])
	SELECT
		0, 
		@State, 
		T.c.value('FileAs[1]', 'nvarchar(256)'),
		T.c.value('ProjectID[1]', 'int'),
		@CurrentEmployeeId,
		T.c.value('ActivityTypeID[1]', 'int'),
		T.c.value('PriorityID[1]', 'int'),
		CAST(T.c.value('StartTime[1]', 'varchar(19)') as datetime),
		T.c.value('Duration[1]', 'int'),
		T.c.value('Location[1]', 'nvarchar(256)'),
		T.c.value('Color[1]', 'int'),
		T.c.value('Comments[1]', 'nvarchar(max)')
	FROM
		@_xml.nodes('/pjm5MeetingRequestGet/MeetingRequest') T(c)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()
	
	IF @RecurrenceID IS NOT NULL
	BEGIN
		UPDATE [Document]
		SET 
			[RecurrencePatternID] = @RecurrenceID
		WHERE 
			[Class] = dbo.adfGetClassByName('Pjm5.MeetingRequest') AND [ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END	
	
	INSERT INTO [Attendee] ([MeetingRequestID], [EmployeeID], [Required])
	SELECT
		@ID,
		T.c.value('EmployeeID[1]', 'int'),
		T.c.value('Required[1]', 'bit')
	FROM
		@_xml.nodes('/pjm5MeetingRequestGet/Attendee') T(c)
	WHERE
		T.c.value('EmployeeID[1]', 'int') != @CurrentEmployeeID
		
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DECLARE @ReminderState TBool, @ReminderInterval TTimeSpan, @StartTime TDateTime
	
	SELECT
		@ReminderState = T.c.value('ReminderState[1]', 'bit'),
		@ReminderInterval = T.c.value('ReminderInterval[1]', 'int'),
		@StartTime = CAST(T.c.value('StartTime[1]', 'varchar(19)') as datetime)
	FROM
		@_xml.nodes('/pjm5MeetingRequestGet/MeetingRequest') T(c)

	EXEC @result = pjm7MeetingRequestReminderCreate @ID, @StartTime, @ReminderState, @ReminderInterval
	IF @result != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	INSERT INTO [MeetingResource] ([MeetingRequestID], [ResourceID], [Required])
	SELECT
		@ID,
		T.c.value('ResourceID[1]', 'int'),
		T.c.value('Required[1]', 'bit')
	FROM
		@_xml.nodes('/pjm5MeetingRequestGet/MeetingResource') T(c)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	EXEC @result = pjm6MeetingRequestAutoAssign @ID
	IF @result != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @result
	END

	COMMIT TRANSACTION

	EXEC pjm5MeetingRequestGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5MeetingRequestCreate TO PUBLIC
GO


IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5MeetingRequestUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5MeetingRequestUpdate'
		DROP PROCEDURE [dbo].[pjm5MeetingRequestUpdate]
	END
GO

PRINT 'Creating procedure pjm5MeetingRequestUpdate'
GO

/******************************************************************************
**		File: pjm5MeetingRequestUpdate.sql
**		Name: pjm5MeetingRequestUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/19/2006 12:50:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		07.12.12	SOV				 ,     0
**		14.03.13	SOV				 ,    " "
**		27.03.13	SOV				 " "     
**		04.04.13	SOV				. -   
**		07.10.13	BAO				  OriginatorPresent
**		16.10.13	BAO				  OriginatorTimeEntryIsBillable
**									  Billable
*******************************************************************************/
CREATE PROCEDURE pjm5MeetingRequestUpdate
	@Xml XML
AS
		
	SET NOCOUNT ON
	DECLARE @ID TIdentifier, @_xml xml, @OriginatorEmployeeID TIdentifier, @StartTime TDateTime, @ReminderState TState,
			@ReminderInterval TTimeSpan, @CurrentEmployeeID TIdentifier, @OldStartTime TDateTime, @RecurrenceID TIdentifier,
			@ProjectID TIdentifier

	SET @_xml = @Xml
	DECLARE @Duration INT
	
	SELECT @Duration = T.c.value('Duration[1]', 'int')
	FROM
		@_xml.nodes('/pjm5MeetingRequestGet/MeetingRequest') T(c)
	
	IF @Duration IS NULL OR @Duration < 0
	BEGIN
		RAISERROR('#DurationIsInvalid', 18, -1)
		RETURN 1
	END
	
	DECLARE -- RECURRENCE
		@StartDate TDate, 
		@EndDate TDate, 
		@RecurrenceType TIdentifier, 
		@Occurrences TCount,
		@Interval TCount, 
		@DayOfWeekMask TIdentifier, 
		@Instance TIdentifier, 
		@MonthOfYear TCount, 
		@DayOfMonth TCount,
		@Recurrence TBool,
		@var sql_variant, 
		@ActivityTypeID TIdentifier, 
		@State TState,
		@NewProjectID INT
		
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
			
	SELECT 
		@ID = T.c.value('ID[1]', 'int'), 
		@ReminderState = T.c.value('ReminderState[1]', 'bit'),
		@ReminderInterval =	T.c.value('ReminderInterval[1]', 'int'),
		@RecurrenceID = T.c.value('RecurrencePatternID[1]', 'int'),
		@ActivityTypeID = T.c.value('ActivityTypeID[1]', 'int'),
		@State = T.c.value('State[1]', 'int')
	FROM 
		@_xml.nodes('/pjm5MeetingRequestGet/MeetingRequest') T(c)
	
	SELECT
		@NewProjectID = T.c.value('ProjectID[1]', 'int')
	FROM
		@_xml.nodes('/pjm5MeetingRequestGet/MeetingRequest') T(c)
				
	IF @ActivityTypeID IS NULL AND @NewProjectID IS NOT NULL
	BEGIN
		EXEC adfParameterGet 'ActivityTypeIsMandatory', 'Pjm5', @var OUTPUT
		IF (@var IS NULL OR CAST(@var as BIT) = 1) AND @State NOT IN (1, 4)
		BEGIN
			RAISERROR('#activitytypecannotbenull', 18, -1)
			RETURN 1
		END
	END

	SET @Recurrence = 0
	IF EXISTS(SELECT * FROM @_xml.nodes('/pjm5MeetingRequestGet/RecurrencePattern') T(c))
	BEGIN 
		SET @Recurrence = 1
		SELECT
			@StartDate = CAST(T.c.value('StartDate[1]', 'varchar(19)') as datetime),
			@EndDate = CAST(T.c.value('EndDate[1]', 'varchar(19)') as datetime),
			@RecurrenceType = T.c.value('RecurrenceType[1]', 'int'),
			@Occurrences = T.c.value('Occurrences[1]', 'int'),
			@Interval = T.c.value('Interval[1]', 'int'),
			@DayOfWeekMask = T.c.value('DayOfWeekMask[1]', 'int'),
			@Instance = T.c.value('Instance[1]', 'int'),
			@MonthOfYear = T.c.value('MonthOfYear[1]', 'int'),
			@DayOfMonth = T.c.value('DayOfMonth[1]', 'int')
		FROM
			@_xml.nodes('/pjm5MeetingRequestGet/RecurrencePattern') T(c)
	END	


	BEGIN TRANSACTION
		
	SELECT 
		@OriginatorEmployeeID = [OriginatorEmployeeID],
		@OldStartTime = [StartTime],
		@ProjectID = [ProjectID]
	FROM 
		[MeetingRequest] 
	WHERE 
		[ID] = @ID
	DECLARE @IsProjectManager INT,
			@IsManagerAssistant TBool
	
	SET @IsProjectManager = 0
	SET @ISManagerAssistant = 0
	IF @ProjectID IS NOT NULL
	BEGIN
		SET @IsProjectManager = dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID)
		SET @IsManagerAssistant = dbo.fnPjm7IsManagerAssistant(@ProjectID, @CurrentEmployeeID)
	END
	
	IF @OriginatorEmployeeID = @CurrentEmployeeID OR @IsProjectManager = 1 OR @IsManagerAssistant = 1
	BEGIN
		UPDATE [MeetingRequest]
		SET
			@StartTime = [S].[StartTime],
			[MeetingRequest].[ProjectID] = [S].[ProjectID],
			[MeetingRequest].[FileAs] = [S].[FileAs],
			[MeetingRequest].[ActivityTypeID] = @ActivityTypeID,
			[MeetingRequest].[PriorityID] = [S].[PriorityID],
			[MeetingRequest].[StartTime] = [S].[StartTime],
			[MeetingRequest].[Duration] = [S].[Duration],
			[MeetingRequest].[Location] = [S].[Location],
			[MeetingRequest].[Color] = [S].[Color],
			[MeetingRequest].[Comments] = [S].[Comments],
			[MeetingRequest].[Modified] = DEFAULT,
			[MeetingRequest].[ModifiedBy] = DEFAULT,
			[MeetingRequest].[SendUpdate] = CASE WHEN @State = 2 THEN [S].[SendUpdate]
			ELSE 0 END,
			[MeetingRequest].[OriginatorPresent] = [S].[OriginatorPresent],
			[MeetingRequest].[OriginatorTimeEntryIsBillable] = [S].[OriginatorTimeEntryIsBillable]
		FROM
			(
				SELECT 
					T.c.value('ID[1]', 'int') as [ID],
					T.c.value('FileAs[1]', 'nvarchar(256)') as [FileAs],
					@NewProjectID as [ProjectID],
					T.c.value('ActivityTypeID[1]', 'int') as [ActivityTypeID],
					T.c.value('PriorityID[1]', 'int') as [PriorityID],
					CAST(T.c.value('StartTime[1]', 'varchar(19)') as datetime) as [StartTime], 
					T.c.value('Duration[1]', 'int') as [Duration],
					T.c.value('Location[1]', 'nvarchar(256)') as [Location],
					T.c.value('Color[1]', 'int') as [Color],
					T.c.value('Comments[1]', 'nvarchar(max)') as [Comments],
					T.c.value('SendUpdate[1]', 'bit') as [SendUpdate],
					T.c.value('ReminderState[1]', 'bit') as [ReminderState],
					T.c.value('ReminderInterval[1]', 'int') as [ReminderInterval],
					T.c.value('OriginatorPresent[1]', 'bit') as [OriginatorPresent],
					T.c.value('OriginatorTimeEntryIsBillable[1]', 'bit') as [OriginatorTimeEntryIsBillable]
				FROM
					@_xml.nodes('/pjm5MeetingRequestGet/MeetingRequest') T(c)
			) S INNER JOIN [MeetingRequest] D
				On ([S].[ID] = [D].[ID])
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		IF @Recurrence = 0 AND @RecurrenceID IS NOT NULL
		BEGIN
			UPDATE [Document] SET [RecurrencePatternID] = NULL WHERE [Class] = dbo.adfGetClassByName('Pjm5.MeetingRequest') AND [ID] = @ID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		ELSE IF @Recurrence = 1 AND @RecurrenceID IS NULL
		BEGIN
			INSERT INTO [RecurrencePattern]
				([StartDate], [EndDate], [RecurrenceType], [Occurrences],
				[Interval], [DayOfWeekMask], [Instance], [MonthOfYear], [DayOfMonth])
			VALUES
				(@StartDate, @EndDate, @RecurrenceType, @Occurrences,
				@Interval, @DayOfWeekMask, @Instance, @MonthOfYear, @DayOfMonth)
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
			SET @RecurrenceID = SCOPE_IDENTITY()
			
			UPDATE [Document] SET [RecurrencePatternID] = @RecurrenceID WHERE [Class] = dbo.adfGetClassByName('Pjm5.MeetingRequest') AND [ID] = @ID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		ELSE IF @Recurrence = 1 AND @RecurrenceID IS NOT NULL
		BEGIN
			UPDATE	[RecurrencePattern]
			SET
				[StartDate] = @StartDate, 
				[EndDate] = @EndDate, 
				[RecurrenceType] = @RecurrenceType, 
				[Occurrences] = @Occurrences,
				[Interval] = @Interval, 
				[DayOfWeekMask] = @DayOfWeekMask, 
				[Instance] = @Instance, 
				[MonthOfYear] = @MonthOfYear, 
				[DayOfMonth] = @DayOfMonth
			WHERE
				[ID] = @RecurrenceID
			IF @@error != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
	END
	ELSE
	BEGIN
		SET @StartTime = @OldStartTime
	END
	
	DECLARE @result INT	

	IF @OriginatorEmployeeID = @CurrentEmployeeID OR @IsProjectManager = 1 OR @ISManagerAssistant = 1
	BEGIN
		DELETE [AttendeeResponse] WHERE [MeetingRequestID] = @ID
			AND [EmployeeID] NOT IN (
				SELECT T.c.value('EmployeeID[1]', 'int') 
				FROM @_xml.nodes('/pjm5MeetingRequestGet/Attendee') T(c)
				)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		DELETE [Attendee] WHERE [MeetingRequestID] = @ID 
			AND [EmployeeID] NOT IN (
				SELECT T.c.value('EmployeeID[1]', 'int') 
				FROM @_xml.nodes('/pjm5MeetingRequestGet/Attendee') T(c)
				)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		INSERT INTO [Attendee] ([MeetingRequestID], [EmployeeID], [Required])
		SELECT
			@ID,
			T.c.value('EmployeeID[1]', 'int'),
			T.c.value('Required[1]', 'bit')
		FROM
			@_xml.nodes('/pjm5MeetingRequestGet/Attendee') T(c)
		WHERE
			T.c.value('EmployeeID[1]', 'int') NOT IN (SELECT [EmployeeID] FROM [Attendee] WHERE [MeetingRequestID] = @ID)
			AND 
			T.c.value('EmployeeID[1]', 'int') != @OriginatorEmployeeID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		UPDATE [Attendee]
		SET
			[Required] = [E].[Required],
			[Present] = [E].[Present],
			[Billable] = [E].[Billable]
		FROM
			[Attendee] INNER JOIN (SELECT 
				T.c.value('EmployeeID[1]', 'int') as [EmployeeID],
				T.c.value('Required[1]', 'bit') as [Required],
				T.c.value('Present[1]', 'bit') as [Present],
				T.c.value('Billable[1]', 'bit') as [Billable] 
				FROM @_xml.nodes('/pjm5MeetingRequestGet/Attendee') T(c)) [E]
				ON ([Attendee].[EmployeeID] = [E].[EmployeeID] AND [Attendee].[MeetingRequestID] = @ID)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		EXEC @result = pjm7MeetingRequestReminderCreate @ID, @StartTime, @ReminderState, @ReminderInterval
		IF @result != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	
		DELETE [MeetingResource] WHERE [MeetingRequestID] = @ID AND 
			[ResourceID] NOT IN (
				SELECT 
					T.c.value('ResourceID[1]', 'int') 
				FROM
					@_xml.nodes('/pjm5MeetingRequestGet/MeetingResource') T(c))

		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		INSERT INTO [MeetingResource] ([MeetingRequestID], [ResourceID], [Required])
		SELECT
			@ID,
			T.c.value('ResourceID[1]', 'int'),
			T.c.value('Required[1]', 'bit')
		FROM
			@_xml.nodes('/pjm5MeetingRequestGet/MeetingResource') T(c)
		WHERE
			T.c.value('ResourceID[1]', 'int') NOT IN (SELECT [ResourceID] FROM [MeetingResource] WHERE [MeetingRequestID] = @ID)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	ELSE
	BEGIN
		EXEC @result = pjm7MeetingRequestReminderCreate @ID, @StartTime, @ReminderState, @ReminderInterval
		IF @result != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	COMMIT TRANSACTION

	EXEC pjm5MeetingRequestGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5MeetingRequestUpdate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5MeetingRequestDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5MeetingRequestDelete'
		DROP PROCEDURE [dbo].[pjm5MeetingRequestDelete]
	END
GO

PRINT 'Creating procedure pjm5MeetingRequestDelete'
GO

/******************************************************************************
**		File: pjm5MeetingRequestDelete.sql
**		Name: pjm5MeetingRequestDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/19/2006 12:50:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5MeetingRequestDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	BEGIN TRANSACTION
	
	DECLARE curDeleted CURSOR LOCAL FORWARD_ONLY READ_ONLY FOR SELECT [MeetingRequestID], [ResourceID] FROM [MeetingResource] WHERE [MeetingRequestID] = @ID
	OPEN curDeleted
	
	DECLARE @MeetingRequestID TIdentifier, @ResourceID TIdentifier, @MeetingRequestState TState,
			@result int
	
	FETCH NEXT FROM curDeleted INTO @MeetingRequestID, @ResourceID
	WHILE @@FETCH_STATUS = 0
	BEGIN
		SELECT @MeetingRequestState = [State] FROM [MeetingRequest] WHERE [ID] = @MeetingRequestID
		EXEC @result = pjm5ResourceFree @ResourceID, @MeetingRequestID
		IF @@ERROR != 0 OR @result != 0
		BEGIN
			ROLLBACK TRANSACTION
			CLOSE curDeleted
			DEALLOCATE curDeleted
			RETURN 1
		END
		FETCH NEXT FROM curDeleted INTO @MeetingRequestID, @ResourceID
	END
	
	CLOSE curDeleted
	DEALLOCATE curDeleted
	
	DELETE [MeetingResource] WHERE [MeetingRequestID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DELETE [AttendeeResponse] WHERE [MeetingRequestID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DELETE [Attendee] WHERE [MeetingRequestID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DELETE FROM [MeetingRequest] WHERE [MeetingRequest].[ID] = @ID

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	COMMIT TRANSACTION

	RETURN 0
GO

GRANT EXECUTE ON pjm5MeetingRequestDelete TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5MeetingRequestChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5MeetingRequestChangeState'
		DROP PROCEDURE [dbo].[pjm5MeetingRequestChangeState]
	END
GO

PRINT 'Creating procedure pjm5MeetingRequestChangeState'
GO

/******************************************************************************
**		File: pjm5MeetingRequestChangeState.sql
**		Name: pjm5MeetingRequestChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/19/2006 12:50:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		14.03.13	SOV				   ,     " "
**		27.03.13	SOV				 " "     
**		04.04.13	SOV				. -    
**		23.07.13	MAB				   
**		03.09.13	BAO				         
**									   OR,   AND
**		05.09.13	BAO				  OR  AND
*******************************************************************************/
CREATE PROCEDURE pjm5MeetingRequestChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState					TState,
			@TransitionTemplateID		TIdentifier,
			@RightID					TIdentifier,
			@Class						TClass,
			@var						sql_variant,
			@ActivityTypeIsMandatory	TBool,
			@ActivityTypeID				TIdentifier,
			@ProjectID					TIdentifier,
			@EmployeeID					TIdentifier,
			@rv							INT,
			@OriginatorEmployeeID		TIdentifier,
			@OriginatorUserID			TIdentifier
		
	SET NOCOUNT ON
	
	SELECT
		@Class					= [MeetingRequest].[Class],
		@FromState				= [MeetingRequest].[State],
		@OriginatorEmployeeID	= [MeetingRequest].[OriginatorEmployeeID]
	FROM
		[MeetingRequest]
	WHERE
		[MeetingRequest].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END

	SELECT
		@OriginatorUserID = [UserID]
	FROM
		[Employee]
	WHERE
		[Employee].[ID] = @OriginatorEmployeeID
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	SELECT
		@ActivityTypeID = [ActivityTypeID],
		@ProjectID = [ProjectID]
	FROM 
		[MeetingRequest] 
	WHERE 
		[ID] = @ID

	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()

	IF @ToState != 4 AND @ProjectID IS NOT NULL
	BEGIN
		--     
		EXEC adfParameterGet 'ActivityTypeIsMandatory', 'Pjm5', @var OUTPUT
		IF @var IS NULL
			SET @ActivityTypeIsMandatory = 1
		ELSE
			SET @ActivityTypeIsMandatory = CAST(@var as BIT)

		IF @ActivityTypeID IS NULL AND @ActivityTypeIsMandatory = 1
		BEGIN
			SET @ActivityTypeID = dbo.fnPjm5GetDefaultActivity(@ProjectID, @EmployeeID)
		END
	
		IF @ActivityTypeID IS NULL AND @ActivityTypeIsMandatory = 1
		BEGIN
			RAISERROR('#activitytypecannotbenull', 18, -1)
			RETURN 1
		END
	END

	IF @ToState IN (2, 3, 4)
	BEGIN
		DECLARE @UserID TIdentifier, @IsProjectManager TBool, @IsManagerAssistant TBool
		
		SET @IsProjectManager = 0
		SET @IsManagerAssistant = 0
		IF @ProjectID IS NOT NULL
		BEGIN
			SET @IsProjectManager = dbo.fnPjm5IsProjectManager(@ProjectID, @EmployeeID)
			SET @IsManagerAssistant = dbo.fnPjm7IsManagerAssistant(@ProjectID, @EmployeeID)
		END
		
		IF (NOT EXISTS(SELECT * FROM [MeetingRequest] WHERE [ID] = @ID AND [OriginatorEmployeeID] = @EmployeeID)) 
			AND @IsProjectManager = 0 AND @IsManagerAssistant = 0
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END
	END
	
	DECLARE @RecurrenceID TIdentifier,
			@StartTime TDatetime,
			@CurrentDate TDatetime
	
	SELECT
		@RecurrenceID = [RecurrencePatternID],
		@StartTime = [MeetingRequest].[StartTime],
		@CurrentDate = GETDATE()
	FROM
		[MeetingRequest] INNER JOIN [Document]
			ON [MeetingRequest].[Class] = [Document].[Class] AND [MeetingRequest].[ID] = [Document].[ID]
	
	BEGIN TRANSACTION

	UPDATE [MeetingRequest]
	SET
		[MeetingRequest].[State] = @ToState,
		[MeetingRequest].[Modified] = DEFAULT,
		[MeetingRequest].[ModifiedBy] = DEFAULT
	WHERE
		[MeetingRequest].[ID] = @ID
	AND
		[MeetingRequest].[State] = @FromState
		
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	IF @FromState = 2 AND @ToState = 3 AND @RecurrenceID IS NOT NULL
	BEGIN	
		DECLARE @NewDate TDateTime
		
		SET @NewDate = dbo.fnPjm5RecurrenceGetNextDateTime(@RecurrenceID, @StartTime, @CurrentDate)
		
		IF ISNULL(@NewDate, @StartTime) > @StartTime
		BEGIN
			EXEC @rv = pjm5MeetingRequestCopy @ID, @NewDate, @RecurrenceID
			IF @rv != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
			
			DECLARE @Occurrences TCount
			SELECT 
				@Occurrences = [Occurrences] 
			FROM 
				[RecurrencePattern] 
			WHERE 
				[ID] = @RecurrenceID
			IF ISNULL(@Occurrences, 0) > 0
			BEGIN
				UPDATE [RecurrencePattern]
				SET
					[Occurrences] = @Occurrences - 1
				WHERE
					[ID] = @RecurrenceID
				IF @@ERROR != 0
				BEGIN
					ROLLBACK TRANSACTION
					RETURN 1
				END
			END			
		END
	END
	
	COMMIT TRANSACTION
	
	IF @ToState != 2
	BEGIN
		EXEC @rv = pjm7AllDocumentReminderDismiss @Class, @ID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN @rv
		END
	END
	
	IF @ToState = 2
		EXEC pjm5PostDocumentChangeNotificationEvent 'MeetingRequestAppointed', 'Pjm5.MeetingRequest', @ID, NULL
	ELSE IF @ToState = 3
		EXEC pjm5PostDocumentChangeNotificationEvent 'MeetingRequestCompleted', 'Pjm5.MeetingRequest', @ID, NULL
	ELSE IF @ToState = 4
		EXEC pjm5PostDocumentChangeNotificationEvent 'MeetingRequestCanceled', 'Pjm5.MeetingRequest', @ID, NULL

	--   
	IF @Tostate = 2
	BEGIN
		DECLARE 
			@value							TVariant,
			@ExchangeSyncMeetingRequests	TBool,
			@LocalNowDateTime				TDate,
			@UserSyncMeetings				bit,
			@UserSyncMeetingsInFuture		int
		--     
		EXEC adfParameterGet @Name='ExchangeSyncMeetingRequests', @Group='Pjm6', @Value = @value OUTPUT
		SET @ExchangeSyncMeetingRequests = CAST(@value as bit)
		SET @LocalNowDateTime = dbo.fnPjm7GetLocalDate()
		--         
		IF @ExchangeSyncMeetingRequests = 1 AND @StartTime > @LocalNowDateTime
		BEGIN
			--   
			EXEC @rv = pjm7MeetingRequestAutoSyncExchange @ID, @Class, @OriginatorUserID, @OriginatorEmployeeID
			IF @rv = 2
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END 
			--     
			ELSE 
			IF @rv = 0
			BEGIN
				DECLARE
					@MeetingRequestEmployeeID	INT,
					@MeetingRequestUserID		INT
				--   
				DECLARE 
					Employee CURSOR LOCAL FAST_FORWARD READ_ONLY FOR
				SELECT
					[EmployeeID],
					[UserID]
				FROM
					[Attendee]
					INNER JOIN [Employee]
						ON [Attendee].[EmployeeID] = [Employee].[ID]
				WHERE
					[MeetingRequestID] = @ID AND
					[UserID] IS NOT NULL

				OPEN Employee

				FETCH NEXT FROM Employee INTO @MeetingRequestEmployeeID, @MeetingRequestUserID

				WHILE @@FETCH_STATUS = 0
				BEGIN
					--   
					EXEC @rv = pjm7MeetingRequestAutoSyncExchange @ID, @Class, @MeetingRequestUserID, @MeetingRequestEmployeeID
					IF @rv = 2
					BEGIN
						ROLLBACK TRANSACTION
						RETURN 1
					END
				FETCH NEXT FROM Employee INTO @MeetingRequestEmployeeID, @MeetingRequestUserID
				END
				CLOSE Employee
				DEALLOCATE Employee		
			END
		END
	END
	RETURN 0
GO

GRANT EXECUTE ON pjm5MeetingRequestChangeState TO PUBLIC
GO
