IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6MeetingRequestAttendeeDeleteNotification]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm6MeetingRequestAttendeeDeleteNotification'
	DROP PROCEDURE [dbo].[pjm6MeetingRequestAttendeeDeleteNotification]
END
GO

PRINT 'Creating procedure pjm6MeetingRequestAttendeeDeleteNotification'
GO

/******************************************************************************
**		File: pjm6MeetingRequestAttendeeDeleteNotification.sql
**		Name: pjm6MeetingRequestAttendeeDeleteNotification
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: PAM
**		Date: 22.12.09
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6MeetingRequestAttendeeDeleteNotification]
	@MeetingRequestID TIdentifier,
	@UserID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE 
		@FromID TIdentifier,
		@Language TCode,
		@Class TClass,
		@FileAs TName
		
	SET @FromID = dbo.adfGetCurrentUserID()
	IF @FromID = @UserID
		RETURN 0

	SET @Language = dbo.adfGetLanguage()
	SET @Class = dbo.adfGetClassByName('Pjm5.MeetingRequest')
	SELECT @FileAs = [FileAs] FROM [MeetingRequest] WHERE [ID] = @MeetingRequestID
	
	INSERT INTO [MailItem]
		([State], [Flag], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	VALUES(
		1,
		0,
		@FileAs,
		N'MeetingRequestExcluded',
		@FromID,
		@UserID,
		@Class,
		@MeetingRequestID,
		0,
		NULL,
		CASE @Language 
			WHEN 'en' THEN 'You have been excluded from Meeting Request "' + @FileAs + '".' 
			ELSE '      "' + @FileAs + '".'
		END)
	
	RETURN 0
GO
  
GRANT EXECUTE ON [pjm6MeetingRequestAttendeeDeleteNotification] TO [public]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6MeetingRequestAttendeeAppointNotification]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm6MeetingRequestAttendeeAppointNotification'
	DROP PROCEDURE [dbo].[pjm6MeetingRequestAttendeeAppointNotification]
END
GO

PRINT 'Creating procedure pjm6MeetingRequestAttendeAppointNotification'
GO

/******************************************************************************
**		File: pjm6MeetingRequestAttendeeAppointNotification.sql
**		Name: pjm6MeetingRequestAttendeeAppointNotification
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: PAM
**		Date: 22.12.09
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6MeetingRequestAttendeeAppointNotification]
	@MeetingRequestID TIdentifier,
	@UserID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE 
		@FromID TIdentifier,
		@Language TCode,
		@Class TClass,
		@FileAs TName

	SET @FromID = dbo.adfGetCurrentUserID()
	IF @FromID = @UserID
		RETURN 0
	
	SET @Language = dbo.adfGetLanguage()
	SET @Class = dbo.adfGetClassByName('Pjm5.MeetingRequest')
	SELECT @FileAs = [FileAs] FROM [MeetingRequest] WHERE [ID] = @MeetingRequestID
	
	INSERT INTO [MailItem]
		([State], [Flag], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	VALUES(
		1,
		0,
		@FileAs,
		N'MeetingRequestAppointed',
		@FromID,
		@UserID,
		@Class,
		@MeetingRequestID,
		0,
		NULL,
		NULL)
	
	RETURN 0
GO
  
GRANT EXECUTE ON [pjm6MeetingRequestAttendeeAppointNotification] TO [public]
GO