IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7AllDocumentReminderDismiss]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7AllDocumentReminderDismiss'
		DROP PROCEDURE [dbo].[pjm7AllDocumentReminderDismiss]
	END
GO

PRINT 'Creating procedure pjm7AllDocumentReminderDismiss'
GO

/******************************************************************************
**		File: pjm7AllDocumentReminderDismiss.sql
**		Name: pjm7AllDocumentReminderDismiss
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 02.05.2012 16:15:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm7AllDocumentReminderDismiss]
	@DocumentClass			TClass,
	@DocumentID				TIdentifier,
	@ReminderSubtype		TCode2 = NULL

AS
	SET NOCOUNT ON
	
	UPDATE ur
	SET ur.[State] = 0
	FROM [UserReminder] ur
		INNER JOIN [Reminder] r
			ON ur.[ReminderID] = r.[ID]
	WHERE
		r.[DocumentClass] = @DocumentClass AND
		r.[DocumentID] = @DocumentID AND
		r.[Subtype] != 'UR'
		AND
		(
			@ReminderSubtype IS NULL
			OR
			@ReminderSubtype IS NOT NULL AND r.[Subtype] = @ReminderSubtype
		)

	/* ,   ,       
	DELETE FROM [Reminder] 
	WHERE 
		[DocumentClass] = @DocumentClass 
		AND 
		[DocumentID] = @DocumentID
		AND
		[Subtype] != 'UR'
		AND
		(
			@ReminderSubtype IS NULL
			OR
			@ReminderSubtype IS NOT NULL AND [Subtype] = @ReminderSubtype
		)
	*/
	RETURN 0
GO

GRANT EXECUTE ON [pjm7AllDocumentReminderDismiss] TO PUBLIC
GO 