IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7TimeEntryReminderCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7TimeEntryReminderCreate'
		DROP PROCEDURE [dbo].[pjm7TimeEntryReminderCreate]
	END
GO

PRINT 'Creating procedure pjm7TimeEntryReminderCreate'
GO

/******************************************************************************
**		File: pjm7TimeEntryReminderCreate.sql
**		Name: pjm7TimeEntryReminderCreate
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: anton.paramonov
**		Date: 28.04.2012 11:57:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm7TimeEntryReminderCreate]
	@DocumentID TIdentifier,
	@ReminderEventTime TDateTime,
	@ReminderState TState,
	@ReminderInterval TTimeSpan
AS
	SET NOCOUNT ON

	DECLARE
		@CurrentUserID			TIdentifier,
		@DocumentClass			TClass,
		@ReminderDescription	TName,
		@Lang					TLanguage,
		@rv int
	
	SET @Lang = dbo.adfGetLanguage()	
	SELECT   
		@CurrentUserID = dbo.adfGetCurrentUserID(),
		@DocumentClass = dbo.adfGetClassByName('Pjm5.TimeEntry')
	
	SELECT 
		@ReminderDescription = [Description] 
	FROM 
		[ReminderDescription] 
	WHERE 
		[Subtype] = 'ES'
		AND
		[Language] = @Lang

	EXEC @rv = dbo.pjm7ReminderForUserCreate	@DocumentClass,
												@DocumentID,
												@CurrentUserID,
												'ES',
												@ReminderEventTime,
												@ReminderState,
												@ReminderInterval,
												@ReminderDescription,
												1
	IF @rv != 0
	BEGIN
		RETURN @rv
	END
	
	IF @ReminderEventTime > GETDATE()
	BEGIN
		EXEC @rv = dbo.pjm7DocumentUserReminderCreate	@DocumentClass,
														@DocumentID,
														@ReminderEventTime
		IF @rv != 0
		BEGIN
			RETURN @rv
		END
	END
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm7TimeEntryReminderCreate] TO PUBLIC
GO 