IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ExternalSubscriptionRuleCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ExternalSubscriptionRuleCreate'
		DROP PROCEDURE [dbo].[pjm5ExternalSubscriptionRuleCreate]
	END
GO

PRINT 'Creating procedure pjm5ExternalSubscriptionRuleCreate'
GO

/******************************************************************************
**		File: pjm5ExternalSubscriptionRuleCreate.sql
**		Name: pjm5ExternalSubscriptionRuleCreate
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 20/12/2005 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ExternalSubscriptionRuleCreate]
	@ID TIdentifier OUTPUT,
	@ProjectID TIdentifier,
	@UserID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE	@DocumentClass TClass	
	SET @DocumentClass = dbo.adfGetClassByName('Pjm5.Project')
		
	SELECT
		@ID = [SubscriptionRule].[ID]
	FROM
		[DocumentSubscriptionRule]
		INNER JOIN [SubscriptionRule]
			ON [DocumentSubscriptionRule].[SubscriptionRuleID] = [SubscriptionRule].[ID]
	WHERE
		[DocumentSubscriptionRule].[DocumentClass] = @DocumentClass AND
		[DocumentSubscriptionRule].[DocumentID] = @ProjectID AND
		[SubscriptionRule].[ExternalInitiator] = 1
		
	IF @ID IS NULL
	BEGIN
		INSERT INTO [SubscriptionRule] ([State], [FileAs], [UserID], [ExternalInitiator], [Created], [Modified])	
			VALUES (1, '', @UserID, 1, GETDATE(), GETDATE())
		IF @@ERROR != 0
		BEGIN
			RETURN 1
		END
		SET @ID = SCOPE_IDENTITY()
		
		INSERT INTO [DocumentSubscriptionRule] ([DocumentClass], [DocumentID], [SubscriptionRuleID])
		SELECT
			@DocumentClass,
			@ProjectID,
			@ID
		IF @@ERROR != 0
		BEGIN
			RETURN 1
		END
				
		INSERT INTO [SubscriptionRuleNotificationWay] ([NotificationWayID], [SubscriptionRecurrencePatternID], [SubscriptionRuleID])
		SELECT
			2,
			NULL,
			@ID
		IF @@ERROR != 0
		BEGIN
			RETURN 1
		END
	END
	ELSE
	BEGIN
		DELETE FROM [Subscription] WHERE [SubscriptionRuleID] = @ID
		IF @@ERROR != 0
		BEGIN
			RETURN 1
		END
	END
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ExternalSubscriptionRuleCreate] TO PUBLIC
GO
   