/*=========================================================*/
/* Database View:                            */
/*=========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwCreateServiceRequest]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwCreateServiceRequest]
go

create view pjm5vwCreateServiceRequest
as
	SELECT
		[ServiceRequest].[Class] as [DocumentClass],
		[ServiceRequest].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[ServiceRequest].[ProjectID] as [ContainerID],
		NULL as [UserID],
		NULL as [Value],
		[ServiceRequest].[ModifiedBy] as [OwnerUserID]
	FROM
		[ServiceRequest]
	WHERE
		[ServiceRequest].[State] = 1
go

/*=========================================================*/
/* Database View:                          */
/*=========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwExecuteServiceRequest]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwExecuteServiceRequest]
go

create view pjm5vwExecuteServiceRequest
as
	SELECT
		[ServiceRequest].[Class] as [DocumentClass],
		[ServiceRequest].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[ServiceRequest].[ProjectID] as [ContainerID],
		NULL as [UserID],
		NULL as [Value],
		[ServiceRequest].[ModifiedBy] as [OwnerUserID]
	FROM
		[ServiceRequest]
	WHERE
		[ServiceRequest].[State] = 3
go

/*=========================================================*/
/* Database View:                            */
/*=========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwPostponeServiceRequest]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwPostponeServiceRequest]
go

create view pjm5vwPostponeServiceRequest
as
	SELECT
		[ServiceRequest].[Class] as [DocumentClass],
		[ServiceRequest].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[ServiceRequest].[ProjectID] as [ContainerID],
		[Employee].[UserID] as [UserID],
		NULL as [Value],
		[ServiceRequest].[ModifiedBy] as [OwnerUserID]
	FROM
		[ServiceRequest]
		LEFT OUTER JOIN [Employee]
			ON [Employee].[ID] = [ServiceRequest].[EmployeeID]
	WHERE
		[ServiceRequest].[State] = 7
go

/*=========================================================*/
/* Database View:                       */
/*=========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwCancelServiceRequest]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwCancelServiceRequest]
go

create view pjm5vwCancelServiceRequest
as
	SELECT
		[ServiceRequest].[Class] as [DocumentClass],
		[ServiceRequest].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[ServiceRequest].[ProjectID] as [ContainerID],
		[Employee].[UserID] as [UserID],
		NULL as [Value],
		[ServiceRequest].[ModifiedBy] as [OwnerUserID]
	FROM
		[ServiceRequest]
		LEFT OUTER JOIN [Employee]
			ON [Employee].[ID] = [ServiceRequest].[EmployeeID]
	WHERE
		[ServiceRequest].[State] = 6
go

/*=========================================================*/
/* Database View:                         */
/*=========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwApproveServiceRequest]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwApproveServiceRequest]
go

create view pjm5vwApproveServiceRequest
as
	SELECT
		[ServiceRequest].[Class] as [DocumentClass],
		[ServiceRequest].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[ServiceRequest].[ProjectID] as [ContainerID],
		[Employee].[UserID] as [UserID],
		NULL as [Value],
		[ServiceRequest].[ModifiedBy] as [OwnerUserID]
	FROM
		[ServiceRequest]
		LEFT OUTER JOIN [Employee]
			ON [Employee].[ID] = [ServiceRequest].[EmployeeID]
	WHERE
		[ServiceRequest].[State] = 4
go

/*=========================================================*/
/* Database View:              */
/*=========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwAssignOnServiceRequest]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwAssignOnServiceRequest]
go

create view pjm5vwAssignOnServiceRequest
as
	SELECT
		[ServiceRequest].[Class] as [DocumentClass],
		[ServiceRequest].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[ServiceRequest].[ProjectID] as [ContainerID],
		[Employee].[UserID] as [UserID],
		[Employee].[UserID] as [Value],
		[ServiceRequest].[ModifiedBy] as [OwnerUserID]
	FROM
		[ServiceRequest]
		LEFT OUTER JOIN [Employee]
			ON [Employee].[ID] = [ServiceRequest].[EmployeeID]
	WHERE
		[ServiceRequest].[State] = 2
go

/*=========================================================*/
/* Database View:            */
/*=========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwExclusionFromServiceRequest]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwExclusionFromServiceRequest]
go

create view pjm5vwExclusionFromServiceRequest
as
	SELECT
		[ServiceRequest].[Class] as [DocumentClass],
		[ServiceRequest].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[ServiceRequest].[ProjectID] as [ContainerID],
		[Employee].[UserID] as [UserID],
		[Employee].[UserID] as [Value],
		[ServiceRequest].[ModifiedBy] as [OwnerUserID]
	FROM
		[ServiceRequest]
		LEFT OUTER JOIN [Employee]
			ON [Employee].[ID] = [ServiceRequest].[EmployeeID]
	WHERE
		[ServiceRequest].[State] = 2
go

/*=========================================================*/
/* Database View:         */
/*=========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwReminderServiceRequest]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwReminderServiceRequest]
go

create view pjm5vwReminderServiceRequest
as
	SELECT
		[ServiceRequest].[Class] as [DocumentClass],
		[ServiceRequest].[ID] as [DocumentID],
		[Employee].[UserID] as [RecipientUserID],
		[ServiceRequest].[DueDate] as [EventTime]
	FROM
		[ServiceRequest]
		LEFT OUTER JOIN [Employee]
			ON [Employee].[ID] = [ServiceRequest].[EmployeeID]
go

grant select on [dbo].[pjm5vwReminderServiceRequest] to [public]
go