IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfPaymentInfo]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfPaymentInfo'
		DROP PROCEDURE [dbo].[adfPaymentInfo]
	END
GO

PRINT 'Creating procedure adfPaymentInfo'
GO

/******************************************************************************
**		File: adfPaymentInfo.sql
**		Name: adfPaymentInfo
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/21/2005 17:11:09
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfPaymentInfo]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	SELECT
		[Payment].[Class],
		[Payment].[ID],
		[Payment].[State],
		[Payment].[Flag],
		[Payment].[FileAs],
		[Payment].[Date],
		[Payment].[Number],
		[Payment].[PaymentTypeID],
		[Payment].[CurrencyCode],
		[Payment].[PayeeCompanyID],
		[Payment].[PayeeBankAccountID],
		[Payment].[PayerCompanyID],
		[Payment].[Reason],
		[Payment].[Payer],
		[Payment].[Comments],
		[Payment].[Created],
		[Payment].[CreatedBy],
		[Payment].[Modified],
		[Payment].[ModifiedBy]
	FROM
		[Payment]
	WHERE
		[Payment].[ID] = @ID
		
	IF @@ROWCOUNT = 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON [adfPaymentInfo] TO PUBLIC
GO

 