IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ProjectBrowseSelectorDialogForEntry]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ProjectBrowseSelectorDialogForEntry'
		DROP PROCEDURE [dbo].[pjm5ProjectBrowseSelectorDialogForEntry]
	END
GO

PRINT 'Creating procedure pjm5ProjectBrowseSelectorDialogForEntry'
GO

/******************************************************************************
**		File: ProjectBrowseSelectorDialogForEntry.sql
**		Name: pjm5ProjectBrowseSelectorDialogForEntry
**		Desc:
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 11:01:32
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
/*
CREATE PROCEDURE [pjm5ProjectBrowseSelectorDialogForEntry]
	@Number varchar(256),
	@FileAs varchar(256),
	@Manager varchar(256),
	@Customer varchar(256),
	@EmployeeID TIdentifier,
	@StateSelector int,
	@ContractOnly bit
AS
	SET NOCOUNT ON

	IF @EmployeeID IS NULL OR @EmployeeID <= 0
		SELECT @EmployeeID = dbo.adfGetCurrentEmployeeID()
		
	SELECT DISTINCT
		[Project].[ID],
		[Project].[Class],
		[Project].[State],
		[Project].[Flag],
		[Project].[Date],
		[Project].[Number],
		CASE @ContractOnly
			WHEN 1 THEN ISNULL(''+[Project].[ContractNumber]+'  '+CONVERT(varchar(10), [Project].[ContractDate], 104) + ' .', [Project].[FileAs])
			ELSE [Project].[FileAs]
		END AS [FileAs],
		[Project].[SupplierCompanyID],
		[Project].[ProjectManagerEmployeeID],
		[Project].[CustomerCompanyID],
		[Project].[ResponsiblePersonEmployeeID],
		[Project].[Created],
		[Project].[CreatedBy],
		[Project].[Modified],
		[Project].[ModifiedBy],
		[Project].[Timestamp],
		[Employee].[FileAs] AS [Manager],
		[Supplier].[FileAs] AS [Supplier],
		[Customer].[FileAs] AS [Customer]
	FROM
		[Project]
		LEFT OUTER JOIN [Employee]
			ON [Employee].[ID] = [Project].[ProjectManagerEmployeeID]
		LEFT OUTER JOIN [Company] AS [Supplier]
			ON [Supplier].[ID] = [Project].[SupplierCompanyID]
		LEFT OUTER JOIN [Company] AS [Customer]
			ON [Customer].[ID] = [Project].[CustomerCompanyID]
		
	WHERE
		(
			(@StateSelector = 1 AND [Project].[State] = 2) OR
			(@StateSelector = 2 AND [Project].[State] = 3) OR
			(@StateSelector = 3 AND [Project].[State] = 4)
		) AND
		(
			@Number IS NULL OR [Project].[Number] LIKE @Number
		) AND
		(
			@FileAs IS NULL OR [Project].[FileAs] LIKE @FileAs
		) AND
		(
			@Manager IS NULL OR ISNULL([Employee].[FileAs], '') LIKE @Manager
		) AND
		(
			@Customer IS NULL OR ISNULL([Customer].[FileAs], '') LIKE @Customer
		) AND
		(@ContractOnly = 0 OR [Project].[ProjectTypeID] = 1)

	RETURN 0
*/
GO

--GRANT EXECUTE ON [pjm5ProjectBrowseSelectorDialogForEntry] TO PUBLIC
GO

   