IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportEmployeeWorkResultHeader')
	BEGIN
		PRINT 'Dropping Procedure ReportEmployeeWorkResultHeader'
		DROP  Procedure  ReportEmployeeWorkResultHeader
	END

GO

PRINT 'Creating Procedure ReportEmployeeWorkResultHeader'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/
CREATE Procedure ReportEmployeeWorkResultHeader
	@EmployeeID		int,
	@PeriodStart	datetime,
	@PeriodEnd		datetime,
	@DateSelector	int,
	@WorkTime		decimal(18,2),
	@WorkingDays	decimal(18,2)
AS
	SET NOCOUNT ON
	SET DATEFIRST 7
	DECLARE
		@UserID			TIdentifier,
		@UserName		TName,
		@EmployeeName	TName,
		@DimensionID	TIdentifier,
		@CompanyName	TName
		
				
	SET @UserID = dbo.adfGetCurrentUserID()
		
	SELECT
		@UserName = [Trustee].[DisplayName]
	FROM
		[Trustee]
	WHERE
		[Trustee].[ID] = @UserID
		
	SELECT
		@DimensionID = [Employee].[ID],
		@EmployeeName = [Employee].[FileAs],
		@CompanyName = [Company].[FileAs]
	FROM 
		[Employee]
			LEFT OUTER JOIN [Company]
				ON [Employee].[CompanyID] = [Company].[ID]
	WHERE
		[Employee].[ID] = @EmployeeID 
		
	SELECT
		@DimensionID		AS [PersonDimensionID],
		@EmployeeName	AS [PersonName],
		@CompanyName	AS [CompanyName],
		@PeriodStart		AS [PeriodStart],
		DATEADD(day, -1, @PeriodEnd)	AS [PeriodEnd],
		@UserName			AS [UserName],
		@DateSelector		AS [DateSelector],
		@WorkingDays		AS [WorkingDays],
		@WorkTime AS [WorkTime]	


RETURN 0
GO

GRANT EXEC ON ReportEmployeeWorkResultHeader TO PUBLIC

GO
