IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportEmployeesTimeAllocationByPeriodHeader')
	BEGIN
		PRINT 'Dropping Procedure ReportEmployeesTimeAllocationByPeriodHeader'
		DROP  Procedure  ReportEmployeesTimeAllocationByPeriodHeader
	END
GO

PRINT 'Creating Procedure ReportEmployeesTimeAllocationByPeriodHeader'
GO
/******************************************************************************
**		File: ReportEmployeesTimeAllocationByPeriodHeader.sql
**		Name: ReportEmployeesTimeAllocationByPeriodHeader
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: MAN
**		Date: 22/11/2010 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		22.11.2010	MAN				First Version
**		09.09.2013	BAO				  '  '
**									 '  ""' 
**									'   " "' 
**									 '  " "'
*******************************************************************************/
CREATE PROCEDURE [dbo].[ReportEmployeesTimeAllocationByPeriodHeader]
        @CompanyID		TIdentifier,
        @DivisionID		TIdentifier,
        @PeriodName		TName,
        @PeriodStart	TDateTime,
        @PeriodEnd		TDateTime,
        @DeviationType	TIdentifier
AS
SET NOCOUNT ON
DECLARE
	@CompanyName TName,
	@DivisionName TName,
	@WorkingDays	decimal(18,2),
	@UserName TName,
	@UserID TIdentifier,
	@DeviationTypeName TName

SET @CompanyName = '()'

SELECT 
	@CompanyName = [Company].[FileAs]
FROM
    [Company]
WHERE 
    [Company].[ID] = @CompanyID   

SELECT 
	@DivisionName = [Division].[FileAs]
FROM
   [Division]
WHERE 
   [Division].[ID] = @DivisionID
   SET DATEFIRST 7
   SET @WorkingDays = dbo.fnPjm5GetWorkingDays(@PeriodStart,DATEADD(day, -1, @PeriodEnd))
   SET DATEFIRST 1
   SET @UserID = dbo.adfGetCurrentUserID()
   
SELECT
	@UserName = [Trustee].[DisplayName]
FROM 
	[Trustee]
WHERE 
	[Trustee].[ID] = @UserID
	
SET @DeviationTypeName =
	CASE @DeviationType
		WHEN 0 THEN '  ""'
		WHEN 1 THEN '  " "' 
	END
	
SELECT
     @CompanyName  AS [CompanyName],
     @DivisionName AS [DivisionName],
     @WorkingDays AS [WorkingDays],
     @WorkingDays*8 as [WorkingHours],
     @UserName as [UserName],
     @PeriodName AS [PeriodName],
     @DeviationTypeName AS [DeviationTypeName]   
RETURN 0
GO
GRANT EXEC ON ReportEmployeesTimeAllocationByPeriodHeader TO PUBLIC
GO
