	IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[ReportFuturePeriodsRealizationHeader]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure ReportFuturePeriodsRealizationHeader'
		DROP PROCEDURE [dbo].[ReportFuturePeriodsRealizationHeader]
	END
	GO

	PRINT 'Creating procedure ReportFuturePeriodsRealizationHeader'
	GO

	/******************************************************************************
	**		File: ReportFuturePeriodsRealizationHeader.sql
	**		Name: ReportFuturePeriodsRealizationHeader
	**		Desc: 
	**
	**              
	**		Return values:
	** 
	**		Called by:   
	**              
	**		Parameters:
	**		Input							Output
	**      ----------						-----------
	**
	**		Auth: Sergey Pelevin
	**		Date: 04.12.13
	*******************************************************************************
	**		Change History
	*******************************************************************************
	**		Date:		Author:			Description:
	**		--------	--------		-------------------------------------------
	**		 
	*******************************************************************************/
	CREATE PROCEDURE [ReportFuturePeriodsRealizationHeader]		
		@OwnCompanyID TIdentifier,-- ID   (NULL - )
		@ReportCurrency varchar(50), --    
		@CompanyManagerSelector int, --   : 0 - , 1 -  
		@ManagerID TIdentifier, -- ID   (NULL - ,    )
		@CostCenterSelector	int, --  : 0 -  , 1 -  
		@CostCenterID TIdentifier,-- ID   (NULL -  )
		@ReportDate TDate,-- ,    
		@CountSelector int, --    : 0 - , 1 -  5, 2 -  10, 3 - 
		@Count int, --  
		@SortSelector int, -- : 0 -   , 1 -  
		@TypeSelector int

	AS

	SET NOCOUNT ON

	DECLARE
		@OwnCompanyName TName,
		@CompanyManagerName TName,
		@CostCenterName TName,
		@CurrentUserName TName,
		@CurrentUserID TIdentifier,
		@Displayed TName


	--  	
	SELECT 
		@OwnCompanyName = [Company].[FileAs]		
	FROM
		[Company]
	WHERE 
		[Company].[ID] = @OwnCompanyID	

	IF @OwnCompanyName IS NULL
		SET @OwnCompanyName = '()'

	-- 
	IF @CompanyManagerSelector = 0
		SET @CompanyManagerName = '()'
	ELSE
	BEGIN
		IF @ManagerID IS NULL
			SET @CompanyManagerName = '( )'
		ELSE
			SELECT
				@CompanyManagerName = [Employee].[FileAs]				
			FROM
				[Employee]
			WHERE
				[Employee].[ID] = @ManagerID
	END

	-- 
	IF @CostCenterSelector = 0
	BEGIN
		SET @CostCenterName = '()'
	END
	ELSE
	BEGIN
		IF @CostCenterID IS NULL
			SET @CostCenterName = '( )'
		ELSE
			SELECT 
				@CostCenterName = [CostCenter].[FileAs]		
			FROM
				[CostCenter]
			WHERE 
				[ID] = @CostCenterID		
	END


	---  
	SELECT
		@Displayed = 
		CASE @CountSelector
			WHEN 0 THEN ' '
			WHEN 1 THEN ' 5 '
			WHEN 2 THEN ' 10 '
			WHEN 3 THEN ' ' + CAST(@Count as varchar(100)) + ' '				
		END
	
	-- 
	SET @CurrentUserID = dbo.adfGetCurrentUserID()		
	SELECT
		@CurrentUserName = [Trustee].[DisplayName]
	FROM 
		[Trustee]
	WHERE 
		[Trustee].[ID] = @CurrentUserID
		
		
	--    
	SELECT
		@OwnCompanyName AS [OwnCompanyName],
		@ReportCurrency AS [ReportCurrency],
		@CompanyManagerName AS [CompanyManagerName],
		@CostCenterName AS [CostCenterName],
		@ReportDate AS [ReportDate],
		@Displayed AS [Displayed],
		@CurrentUserName AS [CurrentUserName],
		@SortSelector AS [SortSelector],
		@TypeSelector AS [TypeSelector],
		@CountSelector AS [CountSelector],
		@Count AS [Count]


	RETURN 0
GO
GRANT EXEC ON ReportFuturePeriodsRealizationHeader TO PUBLIC
GO
				