IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportStatisticsByIssuesHeader')
	BEGIN
		PRINT 'Dropping Procedure ReportStatisticsByIssuesHeader'
		DROP  Procedure  ReportStatisticsByIssuesHeader
	END

GO

PRINT 'Creating Procedure ReportStatisticsByIssuesHeader'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/
CREATE Procedure ReportStatisticsByIssuesHeader
	@PeriodStart		Tdatetime,
	@PeriodEnd			Tdatetime
AS

	DECLARE
		@UserID			TIdentifier,
		@UserName		TName
		
	SET @UserID = dbo.adfGetCurrentUserID()
			
	SELECT
		@UserName = [Trustee].[DisplayName]
	FROM
		[Trustee]
	WHERE
		[Trustee].[ID] = @UserID	

	SELECT
		@UserName AS [UserName],
		@PeriodStart AS [PeriodStart],
		DATEADD(day, -1, @PeriodEnd) AS [PeriodEnd]
		
RETURN 0
GO

GRANT EXEC ON ReportStatisticsByIssuesHeader TO PUBLIC

GO
