IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportWordEmployee')
	BEGIN
		PRINT 'Dropping Procedure ReportWordEmployee'
		DROP  Procedure  ReportWordEmployee
	END

GO

PRINT 'Creating Procedure ReportWordEmployee'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/
CREATE Procedure ReportWordEmployee
	@ID int,
	@Language TName = NULL
AS
	SET NOCOUNT ON
	DECLARE @Class TClass
	SET @Class = dbo.adfGetClassByName('Adf.Employee')
	
	SELECT
		[Employee].[Class],
		[Employee].[ID],
		[Employee].[State],
		[Employee].[Title],
		[Employee].[FirstName], 
		[Employee].[MiddleName],
		[Employee].[LastName],
		[Employee].[Suffix],
		[Employee].[Initials],
		[Employee].[BirthDate],
		[Employee].[BirthPlace],
		[Employee].[LegalCode],
		[Employee].[FileAs],
		[Employee].[PositionID],
		[Employee].[QualificationID],
		[Employee].[DivisionID],
		[Employee].[HireDate],
		[Employee].[FireDate],
		[Employee].[UserID],
		[Position].[FileAs] AS [PositionFileAs],
		[Qualification].[FileAs] AS [QualificationFileAs],
		[Division].[FileAs] AS [DivisionFileAs],
		dbo.fnPjm5GetContactList([Employee].[ID], [Employee].[Class]) AS [Contacts],
		dbo.fnPjm5GetCategoryList([Employee].[ID], [Employee].[Class]) AS [Categories],
		dbo.fnPjm5GetPhoneList([Employee].[ID], [Employee].[Class])	AS [Phonelist]
	FROM
		[Employee]
		LEFT OUTER JOIN [Position]
			ON [Employee].[PositionID] = [Position].[ID]
		LEFT OUTER JOIN [Division]
			ON [Employee].[DivisionID] = [Division].[ID]
		LEFT OUTER JOIN [Qualification]
			ON [Employee].[QualificationID] = [Qualification].[ID]
	WHERE
		[Employee].[ID] = @ID
		
	
	SELECT
		[Address].[AddressTypeID],
		[Address].[Street],
		[Address].[City],
		[Address].[Region],
		[Address].[PostalCode],
		[Address].[Country],
		[Address].[Mail],
		dbo.fnPjm5AddressAsString([Address].[Street], [Address].[City],[Address].[Region],[Address].[PostalCode],[Address].[Country]) AS [AsString]
	FROM
		[Address]
	WHERE
		[Address].[BusinessCardID] = @ID AND 
		[Address].[BusinessCardClass] = @Class
		
	SELECT
		[Phone].[PhoneTypeID],
		[Phone].[Phone]
	FROM
		[Phone]	
	WHERE
		[Phone].[BusinessCardID] = @ID AND 
		[Phone].[BusinessCardClass] = @Class


	SELECT
		[Email].[EmailTypeID],
		[Email].[Email],
		[Email].[DisplayAs]
	FROM
		[Email]
	WHERE
		[Email].[BusinessCardID] = @ID AND 
		[Email].[BusinessCardClass] = @Class
	
	DECLARE @author TName
	SELECT @author = [FileAs] FROM [Employee] WHERE [ID] = dbo.adfGetCurrentEmployeeID()
	SELECT
		[Employee].[LastName] + ISNULL(' ' + [Employee].[FirstName], '') + ISNULL(' ' + [Employee].[MiddleName], '') AS [Title],
		[Employee].[FileAs] AS [Subject],
		@author AS [Author],
		NULL AS [Manager],
		[Company].[FileAs] AS [Company],
		dbo.fnPjm5GetCategoryList([Employee].[ID], [Employee].[Class]) AS [Category],
		NULL AS [Keywords]
     FROM
		[Employee]
		INNER JOIN [Company]
			ON [Company].[ID] = [Employee].[CompanyID]
     WHERE
		[Employee].[ID] = @ID

	RETURN 0
GO

GRANT EXEC ON ReportWordEmployee TO PUBLIC
GO
