IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportWordFacture')
	BEGIN
		PRINT 'Dropping Procedure ReportWordFacture'
		DROP  Procedure  ReportWordFacture
	END

GO

PRINT 'Creating Procedure ReportWordFacture'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/
CREATE Procedure ReportWordFacture
	@ID int,
	@Version TName
AS
	IF @Version = '5.5'
	BEGIN
		EXEC ReportFacture @ID
		RETURN 0
	END
	
	EXEC ReportWordFactureV2 @ID
	RETURN 0
GO

GRANT EXEC ON ReportWordFacture TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[ReportWordFactureV2]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure ReportWordFactureV2'
		DROP PROCEDURE [dbo].[ReportWordFactureV2]
	END
GO

PRINT 'Creating procedure ReportWordFactureV2'
GO

/******************************************************************************
**		File: ReportWordFactureV2.sql
**		Name: ReportWordFactureV2
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**      14.10.10    BVY               . .  ,     -
**		30.01.12	ASA				-   ( 2012 .)
**		26.10.12	SAP			   Calculation  ProjectLanguage
*******************************************************************************/
CREATE PROCEDURE [ReportWordFactureV2]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE @CurrencyCode TCode, @CustomerID TIdentifier, @SupplierID TIdentifier
	SELECT			
		@SupplierID = [Facture].[SupplierCompanyID],
		@CustomerID = [Facture].[CustomerCompanyID],
		@CurrencyCode = CASE [Project].[FactureCurrency]
			WHEN 0 THEN [Project].[CurrencyCode]
			ELSE [Facture].[CurrencyCode]
		END
	FROM
		[Facture]
		INNER JOIN [Project]
			ON [Facture].[ProjectID] = [Project].[ID]
	WHERE 
		[Facture].[ID] = @ID		

	DECLARE 
		@CurrencyClass TClass, 
		@CurrencyID TIdentifier, 
		@CurrencyMale TBool, 
		@CurrencyName TName,  
		@CompanyClass TClass, 
		@CurrencyNumericCode TCode3,
		@CountryNumericCode TCode3
	SET @CompanyClass = dbo.adfGetClassByName('Adf.Company')
	SET @CurrencyClass = dbo.adfGetClassByName('Adf.Currency')
	SELECT @CurrencyID = [ID] FROM [Currency] WHERE [Code] = @CurrencyCode
	SET @CurrencyMale = CASE 
		WHEN dbo.adfPropertyValueGetText(@CurrencyClass, @CurrencyID, '00000001-0000-0000-0000-000000000000') = 'False'
			THEN 0
		ELSE 1
	END

	DECLARE @Statements TABLE
	(
		[ID] TIdentifier
	)
	
	DECLARE
		@FactureClass TClass,
		@InvoiceClass TClass,
		@StatementClass TClass,
		@StatementNumber TName,
		@StatementDate TDate
	
	-- Linked Invoices
	SET @FactureClass = dbo.adfGetClassbyName('Pjm5.Facture')
	SET @InvoiceClass = dbo.adfGetClassByName('Pjm5.Invoice')
	SET @StatementClass = dbo.adfGetClassByName('Pjm5.Statement')
	
	
	INSERT INTO @Statements ([ID])
	SELECT
		[Attachment].[LinkDocumentID]
	FROM
		[Attachment]
	WHERE
		[Attachment].[DocumentClass] = @FactureClass AND [Attachment].[DocumentID] = @ID AND [Attachment].[LinkDocumentClass] = @StatementClass
	UNION
	SELECT
		[Attachment].[DocumentID]
	FROM
		[Attachment]
	WHERE
		[Attachment].[LinkDocumentClass] = @FactureClass AND [Attachment].[LinkDocumentID] = @ID AND [Attachment].[DocumentClass] = @StatementClass
	
	SELECT
		@StatementNumber = [Statement].[Number],
		@StatementDate = [Statement].[Date]
	FROM
		@Statements
		INNER JOIN [Statement]
			ON [@Statements].[ID] = [Statement].[ID]
	
	SELECT @CurrencyName = [FileAs] FROM [Currency] WHERE [Currency].[ID] = @CurrencyID
	SELECT @CurrencyNumericCode = [NumericCode] FROM [Currency] WHERE [Currency].[ID] = @CurrencyID

	SELECT
		[Facture].[Class],
		[Facture].[ID],
		[Facture].[State],
		[Facture].[Flag],
		[Facture].[FileAs],
		[Facture].[Date],
		[Facture].[Number],
		[Facture].[ProjectID],
		@CurrencyCode AS [CurrencyCode],
		@CurrencyMale AS [CurrencyMale],		
		@CurrencyName AS [CurrencyName],
		@CurrencyNumericCode AS [CurrencyNumericCode],
		[Facture].[CurrencyRate],
		[Facture].[Scale],
		[Facture].[SupplierCompanyID],
		[SupplierCompany].[LegalName] as [SupplierCompanyLegalName],
		dbo.fnPjm6GetDetailedLegalCompanyName([SupplierCompany].[LegalName], 1) AS [SupplierCompanyName],
		[SupplierCompany].[ExecutiveEmployeeID] AS [SupplierExecutiveEmployeeID],
		[SupplierCompany].[AccountantEmployeeID] AS [SupplierAccountantEmployeeID],
		ISNULL([SupplierExecutiveEmployee].[LastName] + ISNULL(' ' + [SupplierExecutiveEmployee].[FirstName], '') + ISNULL(' ' + [SupplierExecutiveEmployee].[MiddleName], ''), 
			[SupplierExecutiveEmployee].[FileAs]) AS [ExecutiveName],
		ISNULL([SupplierAccountantEmployee].[LastName] + ISNULL(' ' + [SupplierAccountantEmployee].[FirstName], '') + ISNULL(' ' + [SupplierAccountantEmployee].[MiddleName], ''), 
			[SupplierAccountantEmployee].[FileAs]) AS [AccountantName], 
		[Facture].[SupplierAddress],
		[Facture].[SupplierINN],
		[Facture].[SupplierKPP],
		[Facture].[CustomerCompanyID],
		[CustomerCompany].[LegalName] AS [CustomerCompanyName],
		[CustomerCompany].[ExecutiveEmployeeID] AS [CustomerExecutiveEmployeeID],
		[CustomerCompany].[AccountantEmployeeID] AS [CustomerAccountantEmployeeID],
		[Facture].[CustomerAddress],
		[Facture].[CustomerINN],
		[Facture].[CustomerKPP],
		[Facture].[Sender],
		[Facture].[Recipient],
		[Facture].[DocumentNumber],
		[Facture].[DocumentDate],
		[Facture].[Created],
		[Facture].[CreatedBy],
		[Facture].[Modified],
		[Facture].[ModifiedBy],
		[Facture].[Comments],
		[Facture].[Timestamp],
		CASE [Project].[FactureCurrency]
			WHEN 0 THEN [Facture].[TotalPC]
			ELSE [Facture].[Total]
		END AS [Total],
		CASE [Project].[FactureCurrency]
			WHEN 0 THEN [Facture].[VATPC]
			ELSE [Facture].[VAT]
		END AS [VAT],
		CASE [Project].[FactureCurrency]
			WHEN 0 THEN [Facture].[TotalWithVATPC]
			ELSE [Facture].[TotalWithVAT]
		END AS [TotalWithVAT],
		[Facture].[Advance],
		CASE [Project].[FactureCurrency]
			WHEN 0 THEN
				CASE [Facture].[VATPC] WHEN 0 THEN '' ELSE dbo.fnPjm6FormatMoney(LTRIM(STR([Facture].[VATPC], 15, 2))) END
			ELSE
				CASE [Facture].[VAT] WHEN 0 THEN '' ELSE dbo.fnPjm6FormatMoney(LTRIM(STR([Facture].[VAT], 15, 2))) END
		END AS [VAT2],
		[Project].[ContractNumber],
		[Project].[ContractDate],
		[Project].[ContractSubject],
		dbo.fnPjm5CurrencyToString(
		CASE [Project].[FactureCurrency]
			WHEN 0 THEN [Facture].[TotalPC]
			ELSE [Facture].[Total]
		END, @CurrencyCode) as [TotalCurrency],
		dbo.fnPjm5CurrencyToString(
		CASE [Project].[FactureCurrency]
			WHEN 0 THEN [Facture].[TotalWithVATPC]
			ELSE [Facture].[TotalWithVAT]
		END, @CurrencyCode) as [TotalWithVATCurrency],
		dbo.fnPjm5CurrencyToString(
		CASE [Project].[FactureCurrency]
			WHEN 0 THEN [Facture].[VATPC]
			ELSE [Facture].[VAT]
		END, @CurrencyCode) AS [VATCurrency],
		[SupplierBankAccount].[Account] as [SupplierAccount],
		[SupplierBankAccount].[ID] as [SupplierAccountID],
		[CustomerBankAccount].[Account] as [CustomerAccount],
		[CustomerBankAccount].[ID] as [CustomerAccountID],
		CASE WHEN [Facture].[Advance] = 0 THEN @StatementNumber ELSE NULL END as [StatementNumber],
		CASE WHEN [Facture].[Advance] = 0 THEN @StatementDate ELSE NULL END as [StatementDate],
		[SupplierCompany].[Number] as [SupplierCode],
		[CustomerCompany].[Number] as [CustomerCode],
		[Project].[NumerationCode] as [ProjectNumerationCode],
		[SupplierBankAccount].[BankName]			AS [SupplierBankName],
		[SupplierBankAccount].[City]				AS [SupplierBankCity],
		[SupplierBankAccount].[Address]				AS [SupplierBankAddress],
		[SupplierBankAccount].[BankCode]			AS [SupplierBankCode],
		[SupplierBankAccount].[Account]				AS [SupplierCAccount],
		[SupplierBankAccount].[IntermediaryBank]	AS [SupplierSBankName],
		[SupplierBankAccount].[IntermediaryAccount] AS [SupplierSAccount],
		[SupplierBankAccount].[IntermediaryAddress] AS [SupplierSBankAddress],
		[SupplierBankAccount].[SWIFT]				AS [SupplierSWIFT],
		[SupplierBankAccount].[IntermediarySWIFT]	AS [SupplierSSWIFT],
		[CustomerBankAccount].[BankName]			AS [CustomerBankName],
		[CustomerBankAccount].[City]				AS [CustomerBankCity],
		[CustomerBankAccount].[Address]				AS [CustomerBankAddress],
		[CustomerBankAccount].[BankCode]			AS [CustomerBankCode],
		[CustomerBankAccount].[Account]				AS [CustomerCAccount],
		[CustomerBankAccount].[IntermediaryBank]	AS [CustomerSBankName],
		[CustomerBankAccount].[IntermediaryAccount] AS [CustomerSAccount],
		[CustomerBankAccount].[IntermediaryAddress] AS [CustomerSBankAddress],
		[CustomerBankAccount].[SWIFT]				AS [CustomerSWIFT],
		[CustomerBankAccount].[IntermediarySWIFT]	AS [CustomerSSWIFT],
		[Project].[ProjectLanguageCode] AS [ProjectLanguage]
	FROM
		[Facture]
		INNER JOIN [Project]
			ON [Facture].[ProjectID] = [Project].[ID]
		INNER JOIN [Company] AS [CustomerCompany]	
			ON [Facture].[CustomerCompanyID] = [CustomerCompany].[ID]
		INNER JOIN [Company] AS [SupplierCompany]	
			ON [Facture].[SupplierCompanyID] = [SupplierCompany].[ID]
		LEFT OUTER JOIN [Employee] AS [SupplierExecutiveEmployee]
			ON [SupplierCompany].[ExecutiveEmployeeID] = [SupplierExecutiveEmployee].[ID]
		LEFT OUTER JOIN [Employee] AS [SupplierAccountantEmployee]
			ON [SupplierCompany].[AccountantEmployeeID] = [SupplierAccountantEmployee].[ID]
		LEFT OUTER JOIN [BankAccount] [SupplierBankAccount]
			ON [SupplierBankAccount].[ID] = ISNULL([Project].[BankAccountID], [SupplierCompany].[BankAccountID])
		LEFT OUTER JOIN [BankAccount] [CustomerBankAccount]
			ON [CustomerBankAccount].[ID] = [CustomerCompany].[BankAccountID]
	WHERE
		[Facture].[ID] = @ID
	
	SELECT
		[FactureLine].[ID],
		[FactureLine].[FactureID],
		[FactureLine].[DocumentClass],
		[FactureLine].[DocumentID],
		[FactureLine].[UOMID],
		[FactureLine].[Amount] AS [Amount],
		[FactureLine].[VATIsIncluded], 
		[FactureLine].[VATRate], 
		CASE [Project].[FactureCurrency]
			WHEN 0 THEN [FactureLine].[OriginalPricePC]
			ELSE [FactureLine].[OriginalPrice]
		END AS [OriginalPrice],
		CASE [Project].[FactureCurrency]
			WHEN 0 THEN [FactureLine].[PricePC]
			ELSE [FactureLine].[Price]
		END AS [Price],
		CASE [Project].[FactureCurrency]
			WHEN 0 THEN [FactureLine].[TotalPC]
			ELSE [FactureLine].[Total]
		END AS [Total],
		ISNULL(CASE [Project].[FactureCurrency]
			WHEN 0 THEN [FactureLine].[ExcisePC]
			ELSE [FactureLine].[Excise]
		END, 0) AS [Excise],
		CASE [Project].[FactureCurrency]
			WHEN 0 THEN [FactureLine].[VATPC]
			ELSE [FactureLine].[VAT]
		END AS [VAT],
		CASE [Project].[FactureCurrency]
			WHEN 0 THEN [FactureLine].[TotalWithVATPC]
			ELSE [FactureLine].[TotalWithVAT]
		END AS [TotalWithVAT],
		CASE ISNULL([FactureLine].[Country], '')
			WHEN '' THEN '-'
			ELSE [FactureLine].[Country]
		END AS [Country],
		ISNULL([Country].[NumericCode], '-') AS [CountryNumericCode],	--  
		CASE ISNULL([FactureLine].[CustomDeclaration], '')
			WHEN '' THEN '-'
			ELSE [FactureLine].[CustomDeclaration]
		END AS [CustomDeclaration],
		[FactureLine].[Description],
		ISNULL([UOM].[Code], '-') AS [UOM],
		ISNULL([UOM].[NumericCode], '-') AS [UOMNumericCode],			--   
		CASE [FactureLine].[VATRate] WHEN 0 THEN ' ' ELSE
			CASE [Facture].[Advance]
				WHEN 0 THEN LTRIM(STR([FactureLine].[VatRate]*100))+'%'
				ELSE LTRIM(STR([FactureLine].[VatRate]*100))+'% / 1'+LTRIM(STR([FactureLine].[VatRate]*100))+'%' END
		END as [VATRate2],
		CASE [Project].[FactureCurrency]
			WHEN 0 THEN
				CASE [FactureLine].[VATPC] WHEN 0 THEN '-' ELSE dbo.fnPjm6FormatMoney(LTRIM(STR([FactureLine].[VATPC], 15, 2))) END
			ELSE
				CASE [FactureLine].[VAT] WHEN 0 THEN '-' ELSE dbo.fnPjm6FormatMoney(LTRIM(STR([FactureLine].[VAT], 15, 2))) END
		END AS [VAT2],
		dbo.fnPjm5CurrencyToString
		(
			CASE [Project].[FactureCurrency]
				WHEN 0 THEN [FactureLine].[TotalPC]
				ELSE [FactureLine].[Total]
			END, @CurrencyCode
		) as [TotalCurrency],
		dbo.fnPjm5CurrencyToString(
			CASE [Project].[FactureCurrency]
				WHEN 0 THEN [FactureLine].[TotalWithVATPC]
				ELSE [FactureLine].[TotalWithVAT]
			END
			, @CurrencyCode) as [TotalWithVATCurrency],
		dbo.fnPjm5CurrencyToString(
		CASE [Project].[FactureCurrency]
			WHEN 0 THEN [FactureLine].[PricePC]
			ELSE [FactureLine].[Price]
		END, @CurrencyCode) as [PriceCurrency],
		dbo.fnPjm5CurrencyToString(
		CASE [Project].[FactureCurrency]
			WHEN 0 THEN [FactureLine].[VATPC]
			ELSE [FactureLine].[VAT]
		END, @CurrencyCode) as [VATCurrency],
		[Class].[Code] as [LineClass]
	FROM
		[FactureLine]
		INNER JOIN [Facture]
			ON [FactureLine].[FactureID] = [Facture].[ID]
		INNER JOIN [Project]
			ON [Facture].[ProjectID] = [Project].[ID]
		LEFT OUTER JOIN [UOM]
			ON [UOM].[ID] = [FactureLine].[UOMID]
		LEFT OUTER JOIN [Class]
			ON [FactureLine].[DocumentClass] = [Class].[Class]
		LEFT OUTER JOIN [Country]
			ON [FactureLine].[Country] = [Country].[FileAs]
	WHERE
		[FactureLine].[FactureID] = @ID
	ORDER BY
		[FactureLine].[Description]
		
	SELECT
		[FacturePayment].[FactureID],
		[FacturePayment].[PaymentID],
		ISNULL([Payment].[IncomingDate], [Payment].[Date]) as [Date],
		[Payment].[Number]
	FROM
		[FacturePayment]
		INNER JOIN [Payment]
			ON [Payment].[ID] = [FacturePayment].[PaymentID]
	WHERE
		[FactureID] = @ID
		
	SELECT
		[Address].[AddressTypeID],
		[Address].[Street],
		[Address].[City],
		[Address].[Region],
		[Address].[PostalCode],
		[Address].[Country],
		[Address].[Mail],
		dbo.fnPjm5AddressAsString([Address].[Street], [Address].[City],[Address].[Region],[Address].[PostalCode],[Address].[Country]) AS [AsString]
	FROM
		[Address]
	WHERE
		[Address].[BusinessCardID] = @SupplierID AND 
		[Address].[BusinessCardClass] = @CompanyClass
		
		SELECT
		[Address].[AddressTypeID],
		[Address].[Street],
		[Address].[City],
		[Address].[Region],
		[Address].[PostalCode],
		[Address].[Country],
		[Address].[Mail],
		dbo.fnPjm5AddressAsString([Address].[Street], [Address].[City],[Address].[Region],[Address].[PostalCode],[Address].[Country]) AS [AsString]
	FROM
		[Address]
	WHERE
		[Address].[BusinessCardID] = @CustomerID AND 
		[Address].[BusinessCardClass] = @CompanyClass
		
		
	
	--  	
	
	SELECT DISTINCT [Invoice].[Number], [Invoice].[Date] FROM
	(
	--  --
	SELECT
		[Attachment].[LinkDocumentID] as [ID]
	FROM
		[Attachment]
	WHERE
		[Attachment].[DocumentClass] = @FactureClass AND [Attachment].[DocumentID] = @ID AND [Attachment].[LinkDocumentClass] = @InvoiceClass
	--  --
	UNION
	SELECT
		[Attachment].[DocumentID]
	FROM
		[Attachment]
	WHERE
		[Attachment].[LinkDocumentClass] = @FactureClass AND [Attachment].[LinkDocumentID] = @ID AND [Attachment].[DocumentClass] = @InvoiceClass
	--
	UNION
	--  -   (   )
	SELECT
		[Attachment].[LinkDocumentID]
	FROM
		[Attachment]
	WHERE
		[Attachment].[DocumentClass] = @StatementClass AND [Attachment].[DocumentID] IN (SELECT [ID] FROM @Statements) AND [Attachment].[LinkDocumentClass] = @InvoiceClass
	UNION
	--  -   (   )
	SELECT
		[Attachment].[DocumentID]
	FROM
		[Attachment]
	WHERE
		[Attachment].[LinkDocumentClass] = @StatementClass AND [Attachment].[LinkDocumentID] IN (SELECT [ID] FROM @Statements) AND [Attachment].[DocumentClass] = @InvoiceClass
	--     
	UNION
	SELECT
		[StatementAdvanceInvoice].[AdvanceInvoiceID]
	FROM
		@Statements as [Statements]
		INNER JOIN [StatementAdvanceInvoice]
			ON [Statements].[ID] = [StatementAdvanceInvoice].[StatementID]
	) as [Invoices]
	INNER JOIN [Invoice]
		ON [invoice].[ID] = [Invoices].[ID]

	RETURN 0
GO

GRANT EXECUTE ON [ReportWordFactureV2] TO PUBLIC
GO

