IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResolutionBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResolutionBrowse'
		DROP PROCEDURE [dbo].[pjm5ResolutionBrowse]
	END
GO

PRINT 'Creating procedure pjm5ResolutionBrowse'
GO

/******************************************************************************
**		File: pjm5ResolutionBrowse.sql
**		Name: pjm5ResolutionBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 03/18/2005 13:42:22
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ResolutionBrowse]
	@StateSelector INT
AS
	SET NOCOUNT ON
	SELECT
		[Resolution].[Class],
		[Resolution].[ID],
		[Resolution].[State],
		[Resolution].[Flag],
		[Resolution].[Code],
		[Resolution].[FileAs],
		[Resolution].[Comments],
		[Resolution].[Created],
		[Resolution].[CreatedBy],
		[Resolution].[Modified],
		[Resolution].[ModifiedBy],
		[Resolution].[Timestamp]
	FROM
		[Resolution]
	WHERE
		((@StateSelector = 0) OR (@StateSelector != 0 AND [Resolution].[State] = @StateSelector))
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ResolutionBrowse] TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResolutionGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResolutionGet'
		DROP PROCEDURE [dbo].[pjm5ResolutionGet]
	END
GO

PRINT 'Creating procedure pjm5ResolutionGet'
GO

/******************************************************************************
**		File: pjm5ResolutionGet.sql
**		Name: pjm5ResolutionGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 03/18/2005 13:42:22
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ResolutionGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[Resolution].[Class],
		[Resolution].[ID],
		[Resolution].[State],
		[Resolution].[Flag],
		[Resolution].[Code],
		[Resolution].[FileAs],
		[Resolution].[Comments],
		[Resolution].[Created],
		[Resolution].[CreatedBy],
		[Resolution].[Modified],
		[Resolution].[ModifiedBy],
		[Resolution].[Timestamp]
	FROM
		[Resolution]
	WHERE
		[Resolution].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ResolutionGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResolutionCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResolutionCreate'
		DROP PROCEDURE [dbo].[pjm5ResolutionCreate]
	END
GO

PRINT 'Creating procedure pjm5ResolutionCreate'
GO

/******************************************************************************
**		File: pjm5ResolutionCreate.sql
**		Name: pjm5ResolutionCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 03/18/2005 13:42:22
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ResolutionCreate]
	@Code TCode,
	@FileAs TName,
	@Comments TNotes
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('2243fa3b-50a4-4bad-8fe2-6a4b0aa55674')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	INSERT INTO [Resolution]
		([Flag], [State], [Code], [FileAs], [Comments])
	VALUES
		(0, @State, @Code, @FileAs, @Comments)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	EXEC pjm5ResolutionGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5ResolutionCreate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResolutionUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResolutionUpdate'
		DROP PROCEDURE [dbo].[pjm5ResolutionUpdate]
	END
GO

PRINT 'Creating procedure pjm5ResolutionUpdate'
GO

/******************************************************************************
**		File: pjm5ResolutionUpdate.sql
**		Name: pjm5ResolutionUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 03/18/2005 13:42:22
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ResolutionUpdate
	@ID TIdentifier,
	@Code TCode,
	@FileAs TName,
	@Comments TNotes
AS
	
	SET NOCOUNT ON
	
	UPDATE 
		[Resolution]
	SET
		[Resolution].[Code] = @Code,
		[Resolution].[FileAs] = @FileAs,
		[Resolution].[Comments] = @Comments,
		[Resolution].[Modified] = GETDATE(),
		[Resolution].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[Resolution].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	EXEC pjm5ResolutionGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5ResolutionUpdate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResolutionDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResolutionDelete'
		DROP PROCEDURE [dbo].[pjm5ResolutionDelete]
	END
GO

PRINT 'Creating procedure pjm5ResolutionDelete'
GO

/******************************************************************************
**		File: pjm5ResolutionDelete.sql
**		Name: pjm5ResolutionDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 03/18/2005 13:42:22
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ResolutionDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DELETE FROM [Resolution] WHERE [Resolution].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5ResolutionDelete TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResolutionChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResolutionChangeState'
		DROP PROCEDURE [dbo].[pjm5ResolutionChangeState]
	END
GO

PRINT 'Creating procedure pjm5ResolutionChangeState'
GO

/******************************************************************************
**		File: pjm5ResolutionChangeState.sql
**		Name: pjm5ResolutionChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 03/18/2005 13:42:22
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ResolutionChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [Resolution].[Class],
		@FromState = [Resolution].[State]
	FROM
		[Resolution]
	WHERE
		[Resolution].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE
		[Resolution]
	SET
		[Resolution].[State] = @ToState,
		[Resolution].[Modified] = GETDATE(),
		[Resolution].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[Resolution].[ID] = @ID
	AND
		[Resolution].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5ResolutionChangeState TO PUBLIC
GO
