IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceSelectorBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceSelectorBrowse'
		DROP PROCEDURE [dbo].[pjm5ResourceSelectorBrowse]
	END
GO

PRINT 'Creating procedure pjm5ResourceSelectorBrowse'
GO

/******************************************************************************
**		File: pjm5ResourceSelectorBrowse.sql
**		Name: pjm5ResourceSelectorBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/12/2006 17:37:34
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ResourceSelectorBrowse]
	@NodeType nvarchar(128),
	@Id TIdentifier
AS
	SET NOCOUNT ON

	SELECT
		[Resource].[ID],
		[Resource].[FileAs] as [Name],
		[Resource].[Code] as [Code],
		[ResourceType].[FileAs] as [ResourceType],
		[Resource].[ResourceTypeId],
		[Employee].[FileAs] as [ResponsibleEmployee]
	FROM
		[Resource] LEFT OUTER JOIN [Employee]
			ON ([Resource].[ResponsibleEmployeeID] = [Employee].[ID])
		INNER JOIN [ResourceType]
			ON ([Resource].[ResourceTypeID] = [ResourceType].[ID])
	WHERE
		[Resource].[State] = 1
	AND
		(
			(@NodeType = N'AllResourcesNode')
		OR
			(@NodeType = N'TypeResourcesNode' AND [Resource].[ResourceTypeID] = @Id)
		)
	
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ResourceSelectorBrowse] TO PUBLIC
GO
 