 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceRequestBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceRequestBrowse'
		DROP PROCEDURE [dbo].[pjm5ResourceRequestBrowse]
	END
GO

PRINT 'Creating procedure pjm5ResourceRequestBrowse'
GO

/******************************************************************************
**		File: pjm5ResourceRequestBrowse.sql
**		Name: pjm5ResourceRequestBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/15/2006 12:35:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		11.06.10	SYV				' '      
**		16.09.10	SYV				    
**		04.10.10	SYV				  fnPjm6AllowCreateResourceRequest
*******************************************************************************/
CREATE PROCEDURE [pjm5ResourceRequestBrowse]
	@StateSelector INT
AS
	SET NOCOUNT ON

	DECLARE @EmployeeID TIdentifier,
			@Lang					TLanguage,
			@ViewAllFinance			TBool,
			@ViewAllProjects		TBool, 
			@Assistant				TBool
			
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	
	SET @Lang = dbo.adfGetLanguage()
	
	SELECT
		[ResourceRequest].[Class],
		[ResourceRequest].[ID],
		[ResourceRequest].[State],
		[ResourceRequest].[Flag],
		CASE
			WHEN dbo.fnPjm6AllowCreateResourceRequest([Project].[ID], @EmployeeID) = 1
				OR [ResourceRequest].[EmployeeID] = @EmployeeID
				THEN [ResourceRequest].[FileAs]
			WHEN @Lang = 'ru'
				THEN ' .'
			WHEN @Lang = 'en'
				THEN 'Resource is Filled'
		END AS [FileAs],
		[ResourceRequest].[StartTime],
		DATEADD(minute, [ResourceRequest].[Duration], [ResourceRequest].[StartTime]) as [EndTime],
		[ResourceRequest].[Duration],
		[ResourceRequest].[ProjectID],
		[ResourceRequest].[EmployeeID],
		[ResourceRequest].[ResourceID],
		[Resource].[ResourceTypeID],
		[Resource].[Code] as [ResourceCode],
		[ResourceRequest].[PriorityID],
		[ResourceRequest].[Color],
		[ResourceRequest].[Comments],
		[ResourceRequest].[Created],
		[ResourceRequest].[CreatedBy],
		[ResourceRequest].[Modified],
		[ResourceRequest].[ModifiedBy],
		[ResourceRequest].[Timestamp]
	FROM
		[ResourceRequest] INNER JOIN [Resource]
			ON ([ResourceRequest].[ResourceID] = [Resource].[ID])
		LEFT OUTER JOIN [Project]
			ON ([Project].[ID] = [ResourceRequest].[ProjectID])
	WHERE
		(	
			([ResourceRequest].[State] IN (2, 3))
		OR
			([ResourceRequest].[State] IN (1, 4, 5) AND [ResourceRequest].[EmployeeID] = @EmployeeID)
		 )
	AND
		(
			(@StateSelector = 0) 
		OR 
			(@StateSelector = 1 AND [ResourceRequest].[State] IN (1, 2, 4))
		OR
			(@StateSelector = 2 AND [ResourceRequest].[State] = 3)
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ResourceRequestBrowse] TO PUBLIC
GO

 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceRequestAllBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceRequestAllBrowse'
		DROP PROCEDURE [dbo].[pjm5ResourceRequestAllBrowse]
	END
GO

PRINT 'Creating procedure pjm5ResourceRequestAllBrowse'
GO

/******************************************************************************
**		File: pjm5ResourceRequestAllBrowse.sql
**		Name: pjm5ResourceRequestAllBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Maria.Bastrakova
**		Date: 30/07/2012
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
*******************************************************************************/
CREATE PROCEDURE [pjm5ResourceRequestAllBrowse]
	@StateSelector	INT,
	@ResourceID		TIdentifier,
	@DateSelector	INT,
	@PeriodStart	DateTime,
	@PeriodEnd		DateTime
AS
	SET NOCOUNT ON

	DECLARE @EmployeeID TIdentifier,
			@Lang					TLanguage,
			@ViewAllFinance			TBool,
			@ViewAllProjects		TBool, 
			@Assistant				TBool
			
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	
	SET @Lang = dbo.adfGetLanguage()

	IF @DateSelector = 1 -- today
		SELECT
			@PeriodStart = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime),
			@PeriodEnd = DATEADD(day, 1, @PeriodStart)
	
	IF @DateSelector = 2 -- next seven days
		SELECT
			@PeriodStart = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime),
			@PeriodEnd = DATEADD(day, 7, @PeriodStart)

	IF @DateSelector = 3 -- current week
		SELECT
			@PeriodStart = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime),
			@PeriodStart = DATEADD(day, 1-DATEPART(weekday, @PeriodStart), @PeriodStart),
			@PeriodEnd = DATEADD(day, 7, @PeriodStart)

	IF @DateSelector = 4 -- previous week
		SELECT
			@PeriodStart = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime),
			@PeriodStart = DATEADD(day, 1-7-DATEPART(weekday, @PeriodStart), @PeriodStart),
			@PeriodEnd = DATEADD(day, 7, @PeriodStart)

	IF @DateSelector = 5 -- current month
		SELECT
			@PeriodStart = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime),
			@PeriodStart = DATEADD(day, 1-DATEPART(day, @PeriodStart), @PeriodStart),
			@PeriodEnd = DATEADD(month, 1, @PeriodStart)
			
	IF @DateSelector = 6 -- arbitrary period
		SELECT
			@PeriodStart = CAST(CONVERT(varchar(8), @PeriodStart, 112) AS datetime),
			@PeriodEnd = CAST(CONVERT(varchar(8), @PeriodEnd, 112) AS datetime),
			@PeriodEnd = DATEADD(day, 1, @PeriodEnd)
	
	SELECT
		[ResourceRequest].[Class],
		[ResourceRequest].[ID],
		[ResourceRequest].[State],
		[ResourceRequest].[Flag],
		CASE
			WHEN dbo.fnPjm6AllowCreateResourceRequest([Project].[ID], @EmployeeID) = 1
				OR [ResourceRequest].[EmployeeID] = @EmployeeID
				THEN [ResourceRequest].[FileAs]
			WHEN @Lang = 'ru'
				THEN ' .'
			WHEN @Lang = 'en'
				THEN 'Resource is Filled'
		END AS [FileAs],
		[Resource].[ResponsibleEmployeeID],
		[ResourceRequest].[StartTime],
		DATEADD(minute, [ResourceRequest].[Duration], [ResourceRequest].[StartTime]) as [EndTime],
		[ResourceRequest].[Duration],
		[ResourceRequest].[ProjectID],
		[ResourceRequest].[EmployeeID],
		[ResourceRequest].[ResourceID],
		[Resource].[ResourceTypeID],
		[Resource].[Code] as [ResourceCode],
		[ResourceRequest].[PriorityID],
		[ResourceRequest].[Color],
		[ResourceRequest].[Comments],
		[ResourceRequest].[Created],
		[ResourceRequest].[CreatedBy],
		[ResourceRequest].[Modified],
		[ResourceRequest].[ModifiedBy],
		[ResourceRequest].[Timestamp]
	FROM
		[ResourceRequest]  INNER JOIN [Resource]
			ON ([ResourceRequest].[ResourceID] = [Resource].[ID])
		LEFT OUTER JOIN [Project]
			ON ([Project].[ID] = [ResourceRequest].[ProjectID])
	WHERE
		(	
			([ResourceRequest].[State] IN (2, 3))
		OR
			([ResourceRequest].[State] IN (1, 4, 5) AND [ResourceRequest].[EmployeeID] = @EmployeeID)
		 )
		 AND
		(
			(@StateSelector = 0) 
		OR 
			(@StateSelector = 1 AND [ResourceRequest].[State] IN (1, 2, 4))
		OR
			(@StateSelector = 2 AND [ResourceRequest].[State] = 3)
		)
		AND
		(
			@ResourceID IS NULL OR ([Resource].[ID] = @ResourceID)
		)
		AND
		(
			(@DateSelector = 0) OR
			(
				([ResourceRequest].[StartTime] >= @PeriodStart) AND
				((DATEADD(minute, [ResourceRequest].[Duration], [ResourceRequest].[StartTime])) < @PeriodEnd)
			)
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ResourceRequestAllBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceRequestGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceRequestGet'
		DROP PROCEDURE [dbo].[pjm5ResourceRequestGet]
	END
GO

PRINT 'Creating procedure pjm5ResourceRequestGet'
GO

/******************************************************************************
**		File: pjm5ResourceRequestGet.sql
**		Name: pjm5ResourceRequestGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/15/2006 12:35:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		11.06.10	SYV				' '     
**		16.09.10	SYV				    
**		04.10.10	SYV				      
**		04.10.10	SYV				  fnPjm6AllowCreateResourceRequest
*******************************************************************************/
CREATE PROCEDURE [pjm5ResourceRequestGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE @EmployeeID TIdentifier,
			@ViewAllFinance			TBool,
			@ViewAllProjects		TBool, 
			@Assistant				TBool,
			@ProjectID				TIdentifier,
			@ProjectManagerEmployeeID TIdentifier
			
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()

	IF (dbo.fnPjm6AllowCreateResourceRequest((SELECT [ProjectID] FROM [ResourceRequest] WHERE [ResourceRequest].[ID] = @ID), @EmployeeID) = 0 AND
		@EmployeeID <> (SELECT [EmployeeID] FROM [ResourceRequest] WHERE [ResourceRequest].[ID] = @ID))
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END		
	
	SELECT
		[ResourceRequest].[Class],
		[ResourceRequest].[ID],
		[ResourceRequest].[State],
		[ResourceRequest].[Flag],
		[ResourceRequest].[FileAs],
		[ResourceRequest].[StartTime],
		[ResourceRequest].[Duration],
		[ResourceRequest].[ProjectID],
		[ResourceRequest].[EmployeeID],
		[ResourceRequest].[ResourceID],
		[ResourceRequest].[PriorityID],
		[ResourceRequest].[Color],
		[ResourceRequest].[Comments],
		[ResourceRequest].[Created],
		[ResourceRequest].[CreatedBy],
		[ResourceRequest].[Modified],
		[ResourceRequest].[ModifiedBy],
		[ResourceRequest].[Timestamp]
	FROM
		[ResourceRequest]
	WHERE
		[ResourceRequest].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ResourceRequestGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceRequestCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceRequestCreate'
		DROP PROCEDURE [dbo].[pjm5ResourceRequestCreate]
	END
GO

PRINT 'Creating procedure pjm5ResourceRequestCreate'
GO

/******************************************************************************
**		File: pjm5ResourceRequestCreate.sql
**		Name: pjm5ResourceRequestCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/15/2006 12:35:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		04.10.10	SYV				  fnPjm6AllowCreateResourceRequest   
**		05.10.10	SYV				    
*******************************************************************************/
CREATE PROCEDURE [pjm5ResourceRequestCreate]
	@FileAs TName,
	@StartTime TDateTime,
	@Duration TCount,
	@ProjectID TIdentifier,
	@EmployeeID TIdentifier,
	@ResourceID TIdentifier,
	@PriorityID TIdentifier,
	@Color TColor,
	@Comments TNotes
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('5b41fe29-efad-4378-9cd2-16c008451fab')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	DECLARE @CurrentEmployeeID TIdentifier
	
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	
	IF @EmployeeID IS NULL
	BEGIN
		SET @EmployeeID = @CurrentEmployeeID
	END
	
	IF @EmployeeID IS NULL OR @CurrentEmployeeID != @EmployeeID
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	IF dbo.fnPjm6AllowCreateResourceRequest(@ProjectID, @EmployeeID) = 0 AND @ProjectID IS NOT NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	INSERT INTO [ResourceRequest]
		([Flag], [State], [FileAs], [StartTime], [Duration], [ProjectID], [EmployeeID], [ResourceID], [PriorityID], [Color], [Comments])
	VALUES
		(0, @State, @FileAs, @StartTime, @Duration, @ProjectID, @EmployeeID, @ResourceID, @PriorityID, @Color, @Comments)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	EXEC pjm5ResourceRequestGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5ResourceRequestCreate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceRequestUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceRequestUpdate'
		DROP PROCEDURE [dbo].[pjm5ResourceRequestUpdate]
	END
GO

PRINT 'Creating procedure pjm5ResourceRequestUpdate'
GO

/******************************************************************************
**		File: pjm5ResourceRequestUpdate.sql
**		Name: pjm5ResourceRequestUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/15/2006 12:35:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		06.10.10	SYV				  fnPjm6AllowCreateResourceRequest     
**		05.10.10	SYV				    
*******************************************************************************/
CREATE PROCEDURE pjm5ResourceRequestUpdate
	@ID TIdentifier,
	@FileAs TName,
	@StartTime TDateTime,
	@Duration TCount,
	@ProjectID TIdentifier,
	@EmployeeID TIdentifier,
	@ResourceID TIdentifier,
	@PriorityID TIdentifier,
	@Color TColor,
	@Comments TNotes
AS
	
	SET NOCOUNT ON
	
	DECLARE
		@CurrentEmployee	TIdentifier,
		@MeetingRequest		TIdentifier
	
	SET @CurrentEmployee =  dbo.adfGetCurrentEmployeeID()
	SET @MeetingRequest = (SELECT [MeetingRequestID] FROM [ResourceRequest] WHERE [ID] = @ID)
	
	IF ((dbo.fnPjm6AllowCreateResourceRequest(@ProjectID, @EmployeeID) = 0 AND @ProjectID IS NOT NULL) OR
		@MeetingRequest IS NOT NULL OR
		@CurrentEmployee <> (SELECT [EmployeeID] FROM [ResourceRequest] WHERE [ResourceRequest].[ID] = @ID))
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE [ResourceRequest]
	SET
		[ResourceRequest].[FileAs] = @FileAs,
		[ResourceRequest].[StartTime] = @StartTime,
		[ResourceRequest].[Duration] = @Duration,
		[ResourceRequest].[ProjectID] = @ProjectID,
		[ResourceRequest].[EmployeeID] = @EmployeeID,
		[ResourceRequest].[ResourceID] = @ResourceID,
		[ResourceRequest].[PriorityID] = @PriorityID,
		[resourceRequest].[Color] = @Color,
		[ResourceRequest].[Comments] = @Comments,
		[ResourceRequest].[Modified] = DEFAULT,
		[ResourceRequest].[ModifiedBy] = DEFAULT
	WHERE
		[ResourceRequest].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	EXEC pjm5ResourceRequestGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5ResourceRequestUpdate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceRequestDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceRequestDelete'
		DROP PROCEDURE [dbo].[pjm5ResourceRequestDelete]
	END
GO

PRINT 'Creating procedure pjm5ResourceRequestDelete'
GO

/******************************************************************************
**		File: pjm5ResourceRequestDelete.sql
**		Name: pjm5ResourceRequestDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/15/2006 12:35:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ResourceRequestDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DELETE FROM [ResourceRequest] WHERE [ResourceRequest].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5ResourceRequestDelete TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceRequestChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceRequestChangeState'
		DROP PROCEDURE [dbo].[pjm5ResourceRequestChangeState]
	END
GO

PRINT 'Creating procedure pjm5ResourceRequestChangeState'
GO

/******************************************************************************
**		File: pjm5ResourceRequestChangeState.sql
**		Name: pjm5ResourceRequestChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/15/2006 12:35:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ResourceRequestChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [ResourceRequest].[Class],
		@FromState = [ResourceRequest].[State]
	FROM
		[ResourceRequest]
	WHERE
		[ResourceRequest].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	DECLARE @rv int
	
	IF @ToState = 3
	BEGIN
		EXEC @rv = pjm5ResourceRequestValidate @ID
		IF @@error != 0 OR @rv != 0
			RETURN 1
	END
	ELSE IF @ToState = 5 AND user_name() <> 'pjmexchangesync'
	BEGIN
		DECLARE @ProjectID TIdentifier, @EmployeeID TIdentifier
		SELECT @ProjectID = [ProjectID] FROM [ResourceRequest] WHERE [ID] = @ID
		SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
		
		IF @ProjectID IS NOT NULL
		BEGIN
			IF  dbo.fnPjm5IsProjectManager(@ProjectID, @EmployeeID) = 0 AND 
				NOT EXISTS(SELECT * FROM [ResourceRequest] WHERE [ID] = @ID AND [EmployeeID]=@EmployeeID)
			BEGIN
				RAISERROR('#YouAreNotOwnerOfResourceRequest', 18, -1)
				RETURN 1
			END
		END	
		ELSE IF NOT EXISTS(SELECT * FROM [ResourceRequest] WHERE [ID] = @ID AND [EmployeeID]=@EmployeeID)
		BEGIN
			RAISERROR('#YouAreNotOwnerOfResourceRequest', 18, -1)
			RETURN 1
		END
	END
	
	DECLARE @internalTransaction BIT
	
	IF @@TRANCOUNT = 0
	BEGIN	
		BEGIN TRANSACTION
		SET @internalTransaction = 1
	END
	ELSE
	BEGIN
		SET @internalTransaction = 0
	END
	
	UPDATE [ResourceRequest]
	SET
		[ResourceRequest].[State] = @ToState,
		[ResourceRequest].[Modified] = DEFAULT,
		[ResourceRequest].[ModifiedBy] = DEFAULT
	WHERE
		[ResourceRequest].[ID] = @ID
	AND
		[ResourceRequest].[State] = @FromState

	IF @@ERROR != 0
	BEGIN
		IF @internalTransaction = 1
			ROLLBACK TRANSACTION
		RETURN 1
	END
		
	IF @ToState = 2 -- Sent for approval
	BEGIN
		DECLARE @ResourceID TIdentifier, @AutoSubmit TBool, @EID TIdentifier, @REID TIdentifier
		
		SELECT @ResourceID = [ResourceID], @EID = [EmployeeID] FROM [ResourceRequest] WHERE [ID] = @ID
		SELECT @AutoSubmit = [AutoSubmit], @REID = [ResponsibleEmployeeID] FROM [Resource] WHERE [ID] = @ResourceID
		
		IF @AutoSubmit = 1 OR @EID = @REID
		BEGIN
			EXEC @rv = pjm5ResourceRequestAutoSubmit @ID
			IF @@error != 0 OR @rv != 0
			BEGIN
				IF @internalTransaction = 1
					ROLLBACK TRANSACTION
				RETURN 1
			END
		END
	END
	
	IF @internalTransaction = 1
		COMMIT TRANSACTION
	
	IF @ToState = 2
		EXEC pjm5PostDocumentChangeNotificationEvent 'ResourceRequestSubmitted', 'Pjm5.ResourceRequest', @ID, NULL
	ELSE IF @ToState = 3
		EXEC pjm5PostDocumentChangeNotificationEvent 'ResourceRequestApproved', 'Pjm5.ResourceRequest', @ID, NULL
	ELSE IF @ToState = 4
		EXEC pjm5PostDocumentChangeNotificationEvent 'ResourceRequestRejected', 'Pjm5.ResourceRequest', @ID, NULL
	ELSE IF @ToState = 5
	BEGIN
		EXEC pjm5PostDocumentChangeNotificationEvent 'ResourceRequestCanceled', 'Pjm5.ResourceRequest', @ID, NULL
	END
	RETURN 0
GO

GRANT EXECUTE ON pjm5ResourceRequestChangeState TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceRequestAutoSubmit]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceRequestAutoSubmit'
		DROP PROCEDURE [dbo].[pjm5ResourceRequestAutoSubmit]
	END
GO

PRINT 'Creating procedure pjm5ResourceRequestAutoSubmit'
GO

/******************************************************************************
**		File: pjm5ResourceRequestAutoSubmit.sql
**		Name: pjm5ResourceRequestAutoSubmit
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/15/2006 12:35:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ResourceRequestAutoSubmit
	@ID TIdentifier
WITH EXECUTE AS OWNER
AS
	DECLARE @rv INT
	
	EXEC @rv = pjm5ResourceRequestValidate @ID
	IF @@error != 0 OR @rv != 0
		RETURN 1
		
	UPDATE [ResourceRequest]
	SET
		[ResourceRequest].[State] = 3,
		[ResourceRequest].[Modified] = DEFAULT,
		[ResourceRequest].[ModifiedBy] = DEFAULT
	WHERE
		[ResourceRequest].[ID] = @ID
	AND
		[ResourceRequest].[State] = 2

	RETURN 0
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceRequestValidate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceRequestValidate'
		DROP PROCEDURE [dbo].[pjm5ResourceRequestValidate]
	END
GO

PRINT 'Creating procedure pjm5ResourceRequestValidate'
GO

/******************************************************************************
**		File: pjm5ResourceRequestValidate.sql
**		Name: pjm5ResourceRequestValidate
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/15/2006 12:35:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		05.06.14	SAP				      
**									 
*******************************************************************************/
CREATE PROCEDURE pjm5ResourceRequestValidate
	@ID TIdentifier
AS
	DECLARE @ResourceID TIdentifier, @AutoSubmit TBool, 
			@StartDate TDate, @EndDate TDate, 
			@StartTime TDateTime, @EndTime TDateTime
	
	SELECT 
		@ResourceID = [ResourceID],
		@StartTime = [StartTime],
		@EndTime = DATEADD(minute, [Duration], [StartTime]),
		@StartDate = CONVERT(datetime, CONVERT(varchar(8), @StartTime, 112), 112),
		@EndDate = CONVERT(datetime, CONVERT(varchar(8), @EndTime, 112), 112)
	FROM 
		[ResourceRequest] 
	WHERE 
		[ID] = @ID
		
	IF EXISTS(SELECT * FROM [Resource] WHERE [ID] = @ResourceID AND [State] = 2)
	BEGIN
		RAISERROR('#ResourceIsUnavailable', 18, -1)
		RETURN 1
	END
		
	IF EXISTS(SELECT * FROM [ResourceAvailability] WHERE [ResourceID] = @ResourceID)
	BEGIN
		DECLARE 
			@MaxDate date = cast('2900-01-01 00:00:00.000' as date)

		IF NOT EXISTS(SELECT * FROM [ResourceAvailability] 
			WHERE [ResourceID] = @ResourceID
				AND (@StartDate BETWEEN [AvailableFrom] AND ISNULL([AvailableTo], @MaxDate))
				AND (@EndDate BETWEEN [AvailableFrom] AND ISNULL([AvailableTo], @MaxDate)))
		BEGIN
			RAISERROR('#ResourceIsUnavailable', 18, -1)
			RETURN 1
		END
	END		
	IF EXISTS(SELECT * FROM [ResourceRequest] WHERE [ResourceID] = @ResourceID AND [State]=3 AND 
		(
			([StartTime] >= @StartTime AND [StartTime] < @EndTime)
		OR 
			(DATEADD(minute, [Duration], [StartTime]) > @StartTime AND  DATEADD(minute, [Duration], [StartTime]) <= @EndTime)
		OR 
			(@StartTime >= [StartTime] AND @StartTime < DATEADD(minute, [Duration], [StartTime]))
		OR 
			(@EndTime > [StartTime] AND @EndTime <= DATEADD(minute, [Duration], [StartTime]))
			)
		)
	BEGIN
		RAISERROR('#ResourceAlreadyReserved', 18, -1)
		RETURN 1
	END		

	RETURN 0
GO

