IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'adftrServiceAssignmentUpdate')
	BEGIN
		PRINT 'Dropping Trigger adftrServiceAssignmentUpdate'
		DROP Trigger adftrServiceAssignmentUpdate
	END
GO

/******************************************************************************
**		File: 
**		Name: adftrIssueUpdate
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		17.12.09	SPV					first version
**    
*******************************************************************************/

PRINT 'Creating Trigger adftrServiceAssignmentUpdate'
GO
CREATE TRIGGER adftrServiceAssignmentUpdate 
ON [ServiceAssignment] FOR UPDATE
AS
BEGIN
    IF @@rowcount = 0
       RETURN

	SET NOCOUNT ON
	
    DECLARE @actuals TBool
	
	IF UPDATE(ActualManHour) OR UPDATE(ActualBudget)
	BEGIN
		SET @actuals = dbo.adfHasAccessRight(dbo.adfGetRightID('RecalculateActualField'))
		IF @actuals = 1
			RETURN
	END
	
	UPDATE [Document] 
	SET
		[State] = [inserted].[State], 
		[Flag] = [inserted].[Flag], 
		[FileAs] = [inserted].[FileAs], 
		[Modified] = [inserted].[Modified], 
		[ModifiedBy] = [inserted].[ModifiedBy], 
		[Timestamp] = [inserted].[Timestamp]
	FROM
		[Document] INNER JOIN [inserted]
			ON ([Document].[ID] = [inserted].[ID] AND [Document].[Class] = [inserted].[Class])
    RETURN
END
GO
