IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm5trServiceAssignmentInsert')
	BEGIN
		PRINT 'Dropping Trigger pjm5trServiceAssignmentInsert'
		DROP  Trigger pjm5trServiceAssignmentInsert
	END
GO

/******************************************************************************
**		File: 
**		Name: pjm5trServiceAssignmentInsert
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger pjm5trServiceAssignmentInsert'
GO
CREATE TRIGGER pjm5trServiceAssignmentInsert ON [ServiceAssignment] FOR INSERT, DELETE, UPDATE
AS
	IF @@rowcount = 0 
		RETURN

	SET NOCOUNT ON
	
	IF (EXISTS (
			SELECT * FROM [inserted]
			INNER JOIN [Project] ON [Project].[ID] = [inserted].[ProjectID]
			WHERE [Project].[ProjectTypeID] != 1
		)
	)
	BEGIN
		RAISERROR('#WrongProjectTypeToServiceAssignment', 16, -1)
		ROLLBACK TRANSACTION
	END

	IF (EXISTS (
			SELECT * FROM [inserted]
			INNER JOIN [Project] ON [Project].[ID] = [inserted].[ProjectID]
			WHERE [Project].[State] = 4
		)
	)
	BEGIN
		RAISERROR('#ServiceAssignmentFailedInCompleteProject', 16, -1)
		ROLLBACK TRANSACTION
	END
	
	IF (EXISTS (
			SELECT * FROM [deleted]
			INNER JOIN [Project] ON [Project].[ID] = [deleted].[ProjectID]
			WHERE [Project].[State] = 4
		)
	)
	BEGIN
		RAISERROR('#ServiceAssignmentFailedInCompleteProject', 16, -1)
		ROLLBACK TRANSACTION
	END
	
	RETURN
GO 