IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[lmServiceAssignment]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure lmServiceAssignment'
		DROP PROCEDURE [dbo].[lmServiceAssignment]
	END
GO

PRINT 'Creating procedure lmServiceAssignment'
GO

/******************************************************************************
**		File: pjm6lmServiceAssignment.sql
**		Name: lmServiceAssignment
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: SPV
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [lmServiceAssignment]
AS
	SET NOCOUNT ON
		
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()	

	SELECT
		[ServiceAssignment].[ID],
		[ServiceAssignment].[State],
		[ServiceAssignment].[FileAs] AS [Name],
		[ServiceAssignment].[ProjectID]
	FROM
		[ServiceAssignment]
		INNER JOIN dbo.fnPjm5GetAvailableProjects() as [Project]
			ON [Project].[ID] = [ServiceAssignment].[ProjectID]
	
	EXEC lmSaveTimestamp 'lmServiceAssignment', 'ServiceAssignment'
	RETURN 0
GO

GRANT EXECUTE ON [lmServiceAssignment] TO PUBLIC
GO
 