IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[ServiceRequestBrowseSelectorDialogCalculation]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure ServiceRequestBrowseSelectorDialogCalculation'
		DROP PROCEDURE [dbo].[ServiceRequestBrowseSelectorDialogCalculation]
	END
GO

PRINT 'Creating procedure ServiceRequestBrowseSelectorDialogCalculation'
GO

/******************************************************************************
**		File: pjm5ServiceRequestBrowseByCategory.sql
**		Name: pjm5ServiceRequestBrowseByCategory
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 03/18/2005 14:40:18
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		09.01.13	MAB				Убрано фильтр по исполнителю заявок
*******************************************************************************/
CREATE PROCEDURE [ServiceRequestBrowseSelectorDialogCalculation]
	@EmployeeID TIdentifier,
	@ProjectID TIdentifier,
	@State TIdentifier,
	@View int
AS
	SET NOCOUNT ON
	
	DECLARE 
		@StateClass TClass,
		@ServiceRequestManager int
		
	SET @ServiceRequestManager = dbo.adfHasAccessRightByName('ManageServiceRequest')
	
	IF (@EmployeeID = 0)
		SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
		
	SELECT
		[ServiceRequest].[ID],
		[ServiceRequest].[State],
		[ServiceRequest].[ProjectID],
		[ServiceRequest].[FileAs],
		[Contract].[ContractSubject] as [Contract],
		[ServiceRequest].[DueDate],
		[Employee].[FileAs] as [Employee]
	FROM
		[ServiceRequest]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [ServiceRequest].[EmployeeID]
		INNER JOIN dbo.fnPjm6GetAvailableProjectsForTimeEntryGet(@EmployeeID, @ProjectID) AS [Project]
			ON [Project].[ID] = [ServiceRequest].[ProjectID]
		INNER JOIN [Project] as [Contract]
			ON [Contract].[ID] = [ServiceRequest].[ProjectID]
	WHERE
		[ServiceRequest].[State] IN (2,3,4,5,7) AND
		--(
			--@ServiceRequestManager = 1 --OR
			--[ServiceRequest].[EmployeeID] = @EmployeeID
		--)AND 
		(
			@ProjectID = 0 OR
			[ServiceRequest].[ProjectID] = @ProjectID
		) AND
		(
			[ServiceRequest].[State] = @State OR	-- только указанного состояния
			@State = 0 -- все доступные состояния
		) --AND
		--(
			--@View = 0 --OR -- все доступные запросы
			--[ServiceRequest].[EmployeeID] = @EmployeeID -- только свои запросы
		--)
		
	RETURN 0
GO

GRANT EXECUTE ON [ServiceRequestBrowseSelectorDialogCalculation] TO PUBLIC
GO
