IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceRequestMyBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceRequestMyBrowse'
		DROP PROCEDURE [dbo].[pjm5ServiceRequestMyBrowse]
	END
GO

PRINT 'Creating procedure pjm5ServiceRequestMyBrowse'
GO

/******************************************************************************
**		File: pjm5ServiceRequestMyBrowse.sql
**		Name: pjm5ServiceRequestMyBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: andrew.maklakov
**		Date: 08/02/2005 14:07:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ServiceRequestMyBrowse]
	@StateSelector  INT,
	@ProjectID		TIdentifier,
	@DateSelector	INT,
	@PeriodStart	datetime,
	@PeriodEnd		datetime
AS
	SET NOCOUNT ON
	
	DECLARE
		@today datetime,
		@CurrentEmployeeID TIdentifier,
		@UserID int
		
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @today = GETDATE()
	SET @UserID = dbo.adfGetCurrentUserID()
	
	DECLARE @ViewAllFinance TBool
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	
	IF @DateSelector = 1 -- today
		SELECT
			@PeriodStart = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime),
			@PeriodEnd = DATEADD(day, 1, @PeriodStart)
	
	IF @DateSelector = 2 -- next seven days
		SELECT
			@PeriodStart = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime),
			@PeriodEnd = DATEADD(day, 7, @PeriodStart)

	IF @DateSelector = 3 -- current week
		SELECT
			@PeriodStart = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime),
			@PeriodStart = DATEADD(day, 1-DATEPART(weekday, @PeriodStart), @PeriodStart),
			@PeriodEnd = DATEADD(day, 7, @PeriodStart)

	IF @DateSelector = 4 -- previous week
		SELECT
			@PeriodStart = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime),
			@PeriodStart = DATEADD(day, 1-7-DATEPART(weekday, @PeriodStart), @PeriodStart),
			@PeriodEnd = DATEADD(day, 7, @PeriodStart)

	IF @DateSelector = 5 -- current month
		SELECT
			@PeriodStart = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime),
			@PeriodStart = DATEADD(day, 1-DATEPART(day, @PeriodStart), @PeriodStart),
			@PeriodEnd = DATEADD(month, 1, @PeriodStart)
			
	IF @DateSelector = 6 -- arbitrary period
		SELECT
			@PeriodStart = CAST(CONVERT(varchar(8), @PeriodStart, 112) AS datetime),
			@PeriodEnd = CAST(CONVERT(varchar(8), @PeriodEnd, 112) AS datetime),
			@PeriodEnd = DATEADD(day, 1, @PeriodEnd)
	
	SELECT
		[ServiceRequest].[Class],
		[ServiceRequest].[ID],
		[ServiceRequest].[ProjectID],
		[ServiceRequest].[EmployeeID],
		[ServiceRequest].[PriorityID],
		[ServiceRequest].[State],
		[ServiceRequest].[Flag],
		[ServiceRequest].[Date],
		[ServiceRequest].[Number],
		[ServiceRequest].[FileAs],
		[ServiceRequest].[Description],
		[ServiceRequest].[StartDate],
		[ServiceRequest].[DueDate],
		[ServiceRequest].[Billable],
		[ServiceRequest].[VATIsIncluded],
		[ServiceRequest].[Comments],
		[ServiceRequest].[Created],
		[ServiceRequest].[CreatedBy],
		[ServiceRequest].[Modified],
		[ServiceRequest].[ModifiedBy],
		[ServiceRequest].[Timestamp],
		[Project].[SupplierCompanyID],
		[Project].[CustomerCompanyID],
		[Project].[CurrencyCode] AS [CurrencyCode],
		[Project].[CurrencyCode] AS [ProjectCurrencyCode],
		[ServiceRequest].[ManHour],
		[ServiceRequest].[ActualManHour],
		CASE 
			WHEN @ViewAllFinance = 1 OR [Project].[ProjectManagerEmployeeID] = @CurrentEmployeeID
				THEN [ServiceRequest].[ActualBudget]
			ELSE -1
		END AS [ActualBudget]
	FROM
		[ServiceRequest]
		INNER JOIN [Project]
			ON [Project].[ID] = [ServiceRequest].[ProjectID]
	WHERE
		(
			(@DateSelector = 0) OR
			(
				([ServiceRequest].[Date] >= @PeriodStart) AND
				([ServiceRequest].[Date] < @PeriodEnd)
			)
		) AND
		(
			[ServiceRequest].[EmployeeID] = @CurrentEmployeeID OR
			([ServiceRequest].[CreatedBy] = @UserID AND [ServiceRequest].[State] = 1)
		) AND
		(
			@StateSelector = 0 OR
			[ServiceRequest].[State] = @StateSelector
		) AND
		(
			@ProjectID IS NULL OR [Project].[ID] = @ProjectID
		)
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ServiceRequestMyBrowse] TO PUBLIC
GO
