IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5StatementBrowseByCompany]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5StatementBrowseByCompany'
		DROP PROCEDURE [dbo].[pjm5StatementBrowseByCompany]
	END
GO

PRINT 'Creating procedure pjm5StatementBrowseByCompany'
GO

/******************************************************************************
**		File: pjm5StatementBrowseByCompany.sql
**		Name: pjm5StatementBrowseByCompany
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/21/2005 15:47:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5StatementBrowseByCompany]
	@CompanyID TIdentifier,
	@StateSelector INT,
	@DateSelector INT,
	@PeriodStart TDate,
	@PeriodEnd TDate
AS
	SET NOCOUNT ON
	DECLARE
		@EmployeeID TIdentifier,
		@ViewAllProjects TBool,
		@BaseCurrencyCode TCode3,
		@value TVariant

	EXEC adfParameterGet @Name='BaseCurrency', @Group='CommonBusiness', @Value = @value OUTPUT
	SET @BaseCurrencyCode = CAST(@value as varchar(3))

	SELECT 
		@ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects')),
		@EmployeeID = dbo.adfGetCurrentEmployeeID()

	IF @DateSelector != 0
		EXEC BillingFilterPeriodGet @DateSelector, @PeriodStart OUTPUT, @PeriodEnd OUTPUT
					
	SELECT
		[Statement].[Class],
		[Statement].[ID],
		[Statement].[State],
		[Statement].[Flag],
		[WarningFlag].[WarningType],
		[Statement].[Date],
		[Statement].[Number],
		[Statement].[FileAs],
		[Statement].[ProjectID],
		[Statement].[PeriodStart],
		[Statement].[PeriodEnd],
		[Statement].[Comments],
		[Statement].[Created],
		[Statement].[CreatedBy],
		[Statement].[Modified],
		[Statement].[ModifiedBy],
		[Statement].[Timestamp],
		[Statement].[CurrencyCode],
		[Statement].[SupplierCompanyID],
		[Statement].[CustomerCompanyID],
		[Statement].[Total],
		[Statement].[VAT],
		[Statement].[TotalWithVAT],
		[Statement].[TotalWithVATPC] AS [ProjectTotal],
		[Project].[CurrencyCode] AS [ProjectCurrencyCode],
		[Statement].[TotalWithVATBC] AS [BaseTotal],
		@BaseCurrencyCode AS [BaseCurrencyCode],
		[Project].[ProjectManagerEmployeeID],
		[Project].[CostCenterID],
		[Company].[ManagerEmployeeID],
		[Statement].[ExchangeBanned]
	FROM
		[Statement]
		INNER JOIN [Project]
			ON [Project].[ID] = [Statement].[ProjectID]
		LEFT OUTER JOIN [Company]
			ON [Project].[CustomerCompanyID] = [Company].[ID]
		LEFT OUTER JOIN [WarningFlag]
			ON ([Statement].[WarningFlagID] = [WarningFlag].[ID])
	WHERE
		(
			[Project].[SupplierCompanyID] = @CompanyID OR
			[Project].[CustomerCompanyID] = @CompanyID
		)AND
		(@DateSelector = 0 OR [Statement].[Date] BETWEEN @PeriodStart AND @PeriodEnd) AND
		(
			@StateSelector = 0 OR 
			@StateSelector = 5 AND [Statement].[State] != 4 OR
			[Statement].[State] = @StateSelector
		) AND
		(@ViewAllProjects = 1 OR dbo.fnPjm5HasFinansDataAccess([Project].[ID], @EmployeeID, NULL, NULL) = 1)

	RETURN 0
GO

GRANT EXECUTE ON [pjm5StatementBrowseByCompany] TO PUBLIC
GO
