IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5StatementLineDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5StatementLineDelete'
		DROP PROCEDURE [dbo].[pjm5StatementLineDelete]
	END
GO

PRINT 'Creating procedure pjm5StatementLineDelete'
GO

/******************************************************************************
**		File: pjm5StatementLineDelete.sql
**		Name: pjm5StatementLineDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/20/2005 15:20:31
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		05.04.13	SOV				   . -
*******************************************************************************/
CREATE PROCEDURE pjm5StatementLineDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE @ProjectID TIdentifier
	SELECT @ProjectID = [Statement].[ProjectID] 
	FROM 
		[StatementLine]
		INNER JOIN [Statement] 
			ON [StatementLine].[StatementID] = [Statement].[ID]
	WHERE 
		[StatementLine].[ID] = @ID
	
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageAllStatements')) = 0 AND
		dbo.fnPjm5IsProjectManager(@ProjectID, @EmployeeID) = 0 AND
		dbo.fnPjm5IsProjectMember(@ProjectID, @EmployeeID) = 0 AND
		dbo.fnPjm7IsFinanceManager(@ProjectID, @EmployeeID) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END		
	DELETE FROM [StatementLine] WHERE [ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5StatementLineDelete TO PUBLIC
GO
