
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TaskUpdateWbs]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6TaskUpdateWbs'
		DROP PROCEDURE [dbo].[pjm6TaskUpdateWbs]
	END
GO

PRINT 'Creating procedure pjm6TaskUpdateWbs'
GO

/******************************************************************************
**		File: pjm6TaskUpdateWbs.sql
**		Name: pjm6TaskUpdateWbs
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 02/21/2008 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm6TaskUpdateWbs
	@TaskID TIdentifier,
	@TaskIndex TCount,
	@Wbs TName
AS
	DECLARE 
		@ProjectID TIdentifier,
		@PrevIndex TCount,
		@MaxIndex TCount
		
	SELECT
		@PrevIndex = [TaskWbs].[TaskIndex],
		@ProjectID = [Task].[ProjectID]
	FROM
		[Task]
		INNER JOIN [TaskWbs]
			ON [TaskWbs].[TaskID] = [Task].[ID]
	WHERE
		[Task].[ID] = @TaskID
		
	SELECT
		@MaxIndex = MAX([TaskWbs].[TaskIndex])
	FROM
		[Task]
		INNER JOIN [TaskWbs]
			ON [TaskWbs].[TaskID] = [Task].[ID]
	WHERE
		[Task].[ProjectID] = @ProjectID AND
		[Task].[ID] != @TaskID
			
	IF @TaskIndex > ISNULL(@MaxIndex, 0) + 1
		SET @TaskIndex = ISNULL(@MaxIndex, 0) + 1
	
	BEGIN TRANSACTION
	UPDATE [Task]
	SET
		[Task].[Modified] = DEFAULT,
		[Task].[ModifiedBy] = DEFAULT
	WHERE
		[Task].[ID] = @TaskID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	UPDATE 
		[TaskWbs]
	SET
		[TaskIndex] = @TaskIndex,
		[Wbs] = @Wbs
	WHERE
		[TaskID] = @TaskID
	IF @@error != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	IF @PrevIndex = 0 OR @PrevIndex > @TaskIndex
	BEGIN
		WITH [Tasks] ([ID], [RowNumber]) AS
		(
			SELECT
				[TaskWbs].[TaskID],
				ROW_NUMBER() OVER (ORDER BY [TaskWbs].[TaskIndex] ASC)
			FROM
				[TaskWbs]
				INNER JOIN [Task]
					ON [Task].[ID] = [TaskWbs].[TaskID]
			WHERE
				[Task].[ProjectID] = @ProjectID AND 
				[Task].[ID] != @TaskID AND 
				[TaskWbs].[TaskIndex] >= @TaskIndex
		)
		UPDATE
			[TaskWbs]
		SET
			[TaskIndex] = @TaskIndex + [Tasks].[RowNumber]
		FROM 
			[TaskWbs]
			INNER JOIN [Tasks]
				ON [Tasks].[ID] = [TaskWbs].[TaskID]
		IF @@error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	ELSE IF @PrevIndex < @TaskIndex
	BEGIN
		WITH [Tasks] ([ID], [RowNumber]) AS
		(
			SELECT
				[TaskWbs].[TaskID],
				ROW_NUMBER() OVER (ORDER BY [TaskWbs].[TaskIndex] DESC)
			FROM
				[TaskWbs]
				INNER JOIN [Task]
					ON [Task].[ID] = [TaskWbs].[TaskID]
			WHERE
				[Task].[ProjectID] = @ProjectID AND 
				[Task].[ID] != @TaskID AND 
				[TaskWbs].[TaskIndex] <= @TaskIndex
		)
		UPDATE
			[TaskWbs]
		SET
			[TaskIndex] = @TaskIndex - [Tasks].[RowNumber]
		FROM 
			[TaskWbs]
			INNER JOIN [Tasks]
				ON [Tasks].[ID] = [TaskWbs].[TaskID]
		IF @@error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	

	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm6TaskUpdateWbs TO PUBLIC
GO
 