IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm5trTaskAssignmentDelete')
	BEGIN
		PRINT 'Dropping Trigger pjm5trTaskAssignmentDelete'
		DROP  Trigger pjm5trTaskAssignmentDelete
	END
GO
/******************************************************************************
**		File: 
**		Name: pjm5trTaskAssignmentDelete
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger pjm5trTaskAssignmentDelete'
GO
CREATE Trigger pjm5trTaskAssignmentDelete 
ON [TaskAssignment] FOR DELETE
AS
BEGIN
	DELETE
		[BusyEntry]
	FROM 
		[BusyEntry]
		INNER JOIN deleted
			ON ([BusyEntry].[TaskID] = deleted.[TaskID] AND
				[BusyEntry].[AssignmentID] = deleted.[AssignmentID])

	IF @@error != 0
	BEGIN
		RAISERROR('#cannotchangeemployeecalendar', 18, -1)
		ROLLBACK TRANSACTION
		RETURN
	END
END

GO

IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm5trTaskAssignmentInsert')
	BEGIN
		PRINT 'Dropping Trigger pjm5trTaskAssignmentInsert'
		DROP  Trigger pjm5trTaskAssignmentInsert
	END

--GO
--/******************************************************************************
--**		File: 
--**		Name: pjm5trTaskAssignmentInsert
--**		Desc: 
--**
--**		This template can be customized:
--**              
--**
--**		Auth: 
--**		Date: 
--*******************************************************************************
--**		Change History
--*******************************************************************************
--**		Date:		Author:				Description:
--**		--------		--------				-------------------------------------------
--**    
--*******************************************************************************/
--
--
--PRINT 'Creating Trigger pjm5trTaskAssignmentInsert'
--GO
--CREATE Trigger pjm5trTaskAssignmentInsert 
--ON [TaskAssignment] FOR INSERT
--AS
--BEGIN
--	IF EXISTS(
--		SELECT  
--		FROM 
--			[inserted] 
--			INNER JOIN [Task] 
--				ON ([inserted].[TaskID] = [Task].[ID]) 
--			INNER JOIN [vwAssignment] 
--				ON ([inserted].[AssignmentID] = [vwAssignment].[ID])
--		WHERE
--			[Task].[State] IN (2, 3) AND [vwAssignment].[EmployeeID] IS NULL)
--	BEGIN
--		RAISERROR('#taskassignmentisnotcomplete', 18, -1)
--		ROLLBACK TRANSACTION
--		RETURN
--	END
--
--END
--
--GO

IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm5trTaskAssignmentUpdate')
	BEGIN
		PRINT 'Dropping Trigger pjm5trTaskAssignmentUpdate'
		DROP  Trigger pjm5trTaskAssignmentUpdate
	END
GO
/******************************************************************************
**		File: 
**		Name: pjm5trTaskAssignmentUpdate
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

--PRINT 'Creating Trigger pjm5trTaskAssignmentUpdate'
GO
/*CREATE Trigger pjm5trTaskAssignmentUpdate 
ON [TaskAssignment] FOR UPDATE
AS
BEGIN
	DECLARE 
		@TaskID TIdentifier, 
		@AssignmentID TIdentifier,
		@Work TAmount, 
		@RemainingOvertimeWork TAmount, 
		@RemainingWork TAmount, 
		@rv int
	DECLARE items CURSOR FOR SELECT [TaskID], [AssignmentID], [Work], [RemainingWork], [RemainingOvertimeWork] FROM [inserted]
	OPEN items
	FETCH NEXT FROM items INTO @TaskID, @AssignmentID, @Work, @RemainingWork, @RemainingOvertimeWork
	WHILE @@FETCH_STATUS = 0
	BEGIN
		SET @RemainingWork = ISNULL(@RemainingWork, 0)
		EXEC @rv = pjm6AssignmentCheckBudgetOverdraft @TaskID, @AssignmentID, @Work, @RemainingWork
		IF @rv != 0
		BEGIN
			CLOSE items
			DEALLOCATE items
			
			ROLLBACK TRANSACTION
			RETURN
		END
		FETCH NEXT FROM items INTO @TaskID, @AssignmentID, @Work, @RemainingWork, @RemainingOvertimeWork
	END
	CLOSE items
	DEALLOCATE items
END*/

GO