IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TaskRequestDeclineAssignment]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6TaskRequestDeclineAssignment'
		DROP PROCEDURE [dbo].[pjm6TaskRequestDeclineAssignment]
	END
GO

PRINT 'Creating procedure pjm6TaskRequestDeclineAssignment'
GO

/******************************************************************************
**		File: pjm6TaskRequestDeclineAssignment.sql
**		Name: pjm6TaskRequestDeclineAssignment
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6TaskRequestDeclineAssignment]
	@ID	TIdentifier
AS
	SET NOCOUNT ON
	DECLARE 
		@CurrentUserID TIdentifier,
		@CurrentEmployeeID TIdentifier,
		@Author TIdentifier,
		@Employee TIdentifier,
		@Supervisor TIdentifier
		
	SET @CurrentUserID = dbo.adfGetCurrentUserID()
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	
	SELECT
		@Author = [TaskRequest].[CreatedBy],
		@Employee = [TaskRequest].[EmployeeID],
		@Supervisor = [TaskRequest].[SupervisorEmployeeID] 
	FROM
		[TaskRequest]
	WHERE
		[TaskRequest].[ID] = @ID
		
	DELETE 
		[TaskRequestAssignment] 
	WHERE 
		[TaskRequestID] = @ID AND
		[EmployeeID] = @CurrentEmployeeID
	IF @@error != 0
		RETURN
		
	UPDATE
		[TaskRequestAssignmentResponse]
	SET
		[TaskRequestAssignmentResponse].[Response] = 2
	WHERE
		[TaskRequestAssignmentResponse].[TaskRequestID] = @ID AND
		[TaskRequestAssignmentResponse].[EmployeeID] = @CurrentEmployeeID
	IF @@ERROR != 0
		RETURN	
		
	IF @CurrentEmployeeID = @Employee
		EXEC pjm6TaskRequestDeclineEmployee @ID
	
	IF @CurrentUserID != @Author
		EXEC pjm6TaskRequestAssignmentDeclineNotification @ID, @Author
	IF @Supervisor IS NOT NULL
	BEGIN
		SELECT @Supervisor = [UserID] FROM [Employee] WHERE [ID] = @Supervisor
		IF @CurrentUserID != @Supervisor AND @Author != @Supervisor
			EXEC pjm6TaskRequestAssignmentDeclineNotification @ID, @Supervisor
	END
	RETURN 0
GO

GRANT EXECUTE ON [pjm6TaskRequestDeclineAssignment] TO PUBLIC
GO

  