IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskRequestDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TaskRequestDelete'
		DROP PROCEDURE [dbo].[pjm5TaskRequestDelete]
	END
GO

PRINT 'Creating procedure pjm5TaskRequestDelete'
GO

/******************************************************************************
**		File: pjm5TaskRequestDelete.sql
**		Name: pjm5TaskRequestDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    25.09.09		syv				     ManageAllTaskRequest
**		30.07.10	MAN				      
*******************************************************************************/
CREATE PROCEDURE [pjm5TaskRequestDelete]
	@ID	TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE 
			@HasAccess int,
			@CurrentUserID TIdentifier,
			@AuthorID TIdentifier
			
	SET @HasAccess = dbo.adfHasAccessRightByName('ManageAllTaskRequest')
	SET @CurrentUserID = dbo.adfGetCurrentUserID()
	SET @AuthorID = (SELECT [CreatedBy] FROM [TaskRequest] WHERE [ID] = @ID)
	
	IF (@HasAccess = 0) AND (@AuthorID != @CurrentUserID)
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF EXISTS(SELECT * FROM [SuperTimer] 
					WHERE [SuperTimer].[DocumentClass] = dbo.adfGetClassByName('Pjm5.TaskRequest') AND [SuperTimer].[DocumentID] = @ID AND 
					([SuperTimer].[State] in (1,2) OR ([SuperTimer].[State] = 3 AND [SuperTimer].[Persistent] = 1)))
	BEGIN
		RAISERROR('#CannotDeleteDocumentWithActiveTimer', 18, -1)
		RETURN 1
	END
	
	DELETE [TaskRequest] WHERE [ID] = @ID

	RETURN 0
GO

GRANT EXECUTE ON [pjm5TaskRequestDelete] TO PUBLIC
GO

  