IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CalendarEmployeeUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CalendarEmployeeUpdate'
		DROP PROCEDURE [dbo].[pjm5CalendarEmployeeUpdate]
	END
GO

PRINT 'Creating procedure pjm5CalendarEmployeeUpdate'
GO

/******************************************************************************
**		File: CalendarEmployeeUpdate.sql
**		Name: pjm5CalendarEmployeeUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 02/15/2006 15:32
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5CalendarEmployeeUpdate]
	@Xml XML
AS
	DECLARE @UserID TIdentifier
	
	SET NOCOUNT ON

	SET @UserID = dbo.adfGetCurrentUserID()
	
	BEGIN TRANSACTION
	
	DELETE [CalendarEmployee] WHERE [UserID] = @UserID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	INSERT INTO [CalendarEmployee] ([UserID], [EmployeeID])
	SELECT
		@UserID, 
		T.c.value('.[1]','int')
	FROM
		@Xml.nodes('/Employees/ID') AS T(c)
	WHERE
		T.c IS NOT NULL

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
		
	COMMIT TRANSACTION


	RETURN 0
GO

GRANT EXECUTE ON [pjm5CalendarEmployeeUpdate] TO PUBLIC
GO
   