IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TimeEntryCopy]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6TimeEntryCopy'
		DROP PROCEDURE [dbo].[pjm6TimeEntryCopy]
	END
GO

PRINT 'Creating procedure pjm6TimeEntryCopy'
GO

/******************************************************************************
**		File: pjm6TimeEntryCopy.sql
**		Name: pjm6TimeEntryCopy
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		08.10.09	syv				 Rate    
**		13.10.09	syv				 AssignmentID    
**		13.10.09	syv				        Rate
**		28.01.09	pam				  
**		20.12.12	MAB				    ,       
*******************************************************************************/
CREATE PROCEDURE [pjm6TimeEntryCopy]
	@SourceID TIdentifier,
	@ReceiveStartTime TDateTime,
	@ReceiveEndTime TDateTime,
	@ReceiveEmployeeID TIdentifier
AS
	SET NOCOUNT ON

	DECLARE
		@TimeEntryClass			TClass,
		@ReceiveID				TIdentifier,
		@State					TState,
		@rv						int,
		@RoundedDuration		TCount,
		@ProjectState			TState,
		@Rate					TMoney,
		@value					TVariant,
		@ReceiveDuration		TCount,
		@ReceiveAssignmentID	TIdentifier,
		@ProjectID				TIdentifier, 
		@SourceTaskID			TIdentifier,
		@SourceEmployeeID		TIdentifier,
		@SourceActivityTypeID	TIdentifier,
		@SourceOvertime			TBool,
		@SourceDocumentClass	TClass,
		@SourceDocumentID		TIdentifier,
		@ActivelyType			BIT

	SET @TimeEntryClass = dbo.adfGetClassByName('Pjm5.TimeEntry')

	SET @State = dbo.adfwfGetInitialState('6719512d-42ee-4848-a57e-f76500e67ee7')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	IF @ReceiveEmployeeID IS NULL
		SET @ReceiveEmployeeID = dbo.adfGetCurrentEmployeeID()

	IF @ReceiveEmployeeID IS NULL
	BEGIN
		RAISERROR('#assignmentnotfound', 18, -1)
		RETURN 1
	END

	IF @ReceiveEndTime IS NOT NULL
		SET @ReceiveDuration = DATEDIFF(minute, @ReceiveStartTime, @ReceiveEndTime)
	
	SELECT 
		@RoundedDuration				= dbo.fnPjm5RoundedDuration(@ReceiveDuration, [Project].[RoundingInterval], [Project].[RoundingMode]),
		@ProjectState					= [Project].[State],
		@ProjectID						= [TimeEntry].[ProjectID],
		@SourceTaskID					= [TimeEntry].[TaskID],
		@SourceActivityTypeID			= [TimeEntry].[ActivityTypeID],
		@SourceEmployeeID				= [TimeEntry].[EmployeeID],
		@SourceDocumentClass			= [TimeEntry].[DocumentClass],
		@SourceDocumentID				= [TimeEntry].[DocumentID],
		@SourceOvertime					= [TimeEntry].[Overtime]
	FROM
		[TimeEntry]
		INNER JOIN [Project]
			ON [Project].[ID] = [TimeEntry].[ProjectID]
	WHERE
		[TimeEntry].[ID] = @SourceID
	
	IF dbo.fnPjm5AllowCreateProjectEntry(@ProjectID, @ReceiveEmployeeID) = 0
	BEGIN
		ROLLBACK TRANSACTION
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF @ProjectID IS NOT NULL
	BEGIN
		SELECT @ReceiveAssignmentID = dbo.fnPjm5GetProjectAssignment(@ProjectID, @ReceiveEmployeeID)
		IF @ReceiveAssignmentID IS NULL
		BEGIN
			RAISERROR('#assignmentnotfound', 18, -1)
			RETURN 1
		END
		SET @Rate = dbo.fnPjm5GetEmployeeRate(@ReceiveEmployeeID, @ProjectID, @SourceOvertime, CASE @SourceDocumentClass WHEN dbo.adfGetClassByName('Pjm5.ServiceAssignment') THEN @SourceDocumentID ELSE NULL END, 0)
	END
	ELSE
	BEGIN
		SET @Rate = 0
	END

	--     " "
	DECLARE
		@AppSyncCalendars	TBool,
		@SyncTimeEntry		TBool,
		@LocalNowDateTime	TDate

	EXEC adfParameterGet @Name='ExchangeSyncCalendars', @Group='Pjm6', @Value = @value OUTPUT
	SET @AppSyncCalendars = CAST(@value as bit)
	SET @SyncTimeEntry = 0
	SET @LocalNowDateTime = dbo.fnPjm7GetLocalDate()

	IF @AppSyncCalendars = 1 AND @ReceiveStartTime > @LocalNowDateTime
	BEGIN
		DECLARE
			@UserSyncCalendars	bit,
			@TimeEntryUserID	TIdentifier

		SELECT @TimeEntryUserID = [UserID] FROM [Employee] WHERE [ID] = @ReceiveEmployeeID 	

		SELECT @value = [Value] FROM [UserParameter] WHERE [Name] = 'SyncExchangeCalendar' AND [UserID] = @TimeEntryUserID
		SET @UserSyncCalendars = ISNULL(CAST(@value AS bit), 0)

		IF @UserSyncCalendars = 1
		BEGIN
			DECLARE
				@UserSyncEntriesInFuture	int

			SELECT @value = [Value] FROM [UserParameter] WHERE [Name] = 'SyncExchangeCalendarEntriesInFuture' AND [UserID] = @TimeEntryUserID
			SET @UserSyncEntriesInFuture = ISNULL(CAST(@value AS int), 1)

			SET @SyncTimeEntry = 
				(CASE
					WHEN @UserSyncEntriesInFuture = 0 THEN 1
					WHEN @UserSyncEntriesInFuture = 1 THEN 0
					WHEN @UserSyncEntriesInFuture = 2  THEN dbo.fnPjm6ExchangeSyncActivityTypeEntry(@SourceActivityTypeID, @TimeEntryUserID)
				END)
		END
	END

	SELECT 
		@ActivelyType = [Actively] 
	FROM	
		[ProjectActivityType] 
	WHERE 
		[ActivityTypeID] = @SourceActivityTypeID 
		AND 
		[ProjectID] = @ProjectID

	BEGIN TRANSACTION
	INSERT INTO [TimeEntry]
		([State], [Flag], [FileAs], [ActivityTypeID], [EmployeeID], [AssignmentID], [ProjectID], [TaskID], 
		[StartTime], [Duration], [RoundedDuration], [Billable], 
		[Overtime], [Rate], [CurrencyCode], [VATRate], [Color],
		[Comments], [DocumentClass], [DocumentID], [DivisionID])
	SELECT
		@State,
		[TimeEntry].[Flag],
		[TimeEntry].[FileAs],
		(CASE
			WHEN @ActivelyType = 0 THEN NULL
			WHEN @ActivelyType = 1 THEN [TimeEntry].[ActivityTypeID]
		END) AS [ActivityTypeID],
		@ReceiveEmployeeID,
		@ReceiveAssignmentID,
		[TimeEntry].[ProjectID],
		[TimeEntry].[TaskID],
		
		ISNULL(@ReceiveStartTime, [TimeEntry].[StartTime]),
		ISNULL(@ReceiveDuration, [TimeEntry].[Duration]),
		ISNULL(@RoundedDuration, [TimeEntry].[RoundedDuration]),
		[TimeEntry].[Billable],
		
		[TimeEntry].[Overtime],
		@Rate,
		[TimeEntry].[CurrencyCode],
		[TimeEntry].[VATRate],
		[TimeEntry].[Color],
		
		[TimeEntry].[Comments],
		[TimeEntry].[DocumentClass],
		[TimeEntry].[DocumentID],
		[TimeEntry].[DivisionID]
	FROM
		[TimeEntry]
	WHERE
		[TimeEntry].[ID] = @SourceID
		
	IF @@error != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	SET @ReceiveID = SCOPE_IDENTITY()

		IF @ProjectID IS NOT NULL
	BEGIN
		IF @ProjectState != 2
		BEGIN
			ROLLBACK TRANSACTION
			RAISERROR('#ProjectIsNotActive', 18, -1)
			RETURN 1
		END

		IF @SourceTaskID IS NOT NULL 
		BEGIN
			IF NOT EXISTS (SELECT * FROM [Task] WHERE [ID] = @SourceTaskID AND [ProjectID] = @ProjectID)
			BEGIN
				ROLLBACK TRANSACTION
				RAISERROR('#TaskFromAnotherProject', 18, -1)
				RETURN 1
			END
			IF NOT EXISTS (SELECT * FROM [Task] WHERE [ID] = @SourceTaskID AND [State] = 2)
			BEGIN
				ROLLBACK TRANSACTION
				RAISERROR('#TaskIsDraft', 18, -1)
				RETURN 1
			END
			IF dbo.fnPjm5IsTaskAssigned(@SourceTaskID, @ReceiveEmployeeID) = 0
			BEGIN
				ROLLBACK TRANSACTION
				RAISERROR('#taskassignmentnotfound', 18, -1)
				RETURN 1
			END
			IF EXISTS(SELECT * FROM [TaskAssignment] 
						WHERE [TaskID] = @SourceTaskID AND [AssignmentID] = @ReceiveAssignmentID AND [TaskAssignment].[MsAvailable] = 0)
			BEGIN
				ROLLBACK TRANSACTION
				RAISERROR('#taskassignmentnotfound', 18, -1)
				RETURN 1
			END			
		END
	END
	
	EXEC @rv = adfDocumentUDFCopy @TimeEntryClass, @SourceID, @ReceiveID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END

	EXEC @rv = adfDocumentCategoryCopy @TimeEntryClass, @SourceID, @ReceiveID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END

	EXEC @rv = adfDocumentContactCopy @TimeEntryClass, @SourceID, @ReceiveID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	EXEC @rv = pjm7TimeEntryReminderCopy @TimeEntryClass, @SourceID, @ReceiveID, @SourceEmployeeID, @ReceiveEmployeeID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	/*EXEC @rv = pjm6TaskAssignmentRemainingUpdate @ReceiveID
	IF @rv = 1
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END*/
	
	IF @ProjectID IS NOT NULL
	BEGIN
		EXEC @rv = pjm5TimeEntryAutoApprove @ReceiveID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN @rv
		END
	END
	IF @SourceTaskID IS NOT NULL
	BEGIN
		EXEC @rv = pjm6TaskPercentUpdate @SourceTaskID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	IF @SyncTimeEntry = 1
	BEGIN
		EXEC @rv = pjm7ExchangeSyncStateUpdate @ReceiveID, @TimeEntryClass, @SyncTimeEntry, @ReceiveEmployeeID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

	END

	COMMIT TRANSACTION
	SELECT @ReceiveID
	RETURN 0
GO

GRANT EXECUTE ON [pjm6TimeEntryCopy] TO PUBLIC
GO

 