IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[TimeEntrySimpleUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure TimeEntrySimpleUpdate'
		DROP PROCEDURE [dbo].[TimeEntrySimpleUpdate]
	END
GO

PRINT 'Creating procedure TimeEntrySimpleUpdate'
GO

/******************************************************************************
**		File: TimeEntrySimpleUpdate.sql
**		Name: TimeEntrySimpleUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		12.07.11	SYV				   
**		02.03.12	PAM				   " "
**		06.12.12	SAP				  FileAs    
**		28.01.13	SAP				    @FileAs  @Comments
**		31.01.13	SAP				    BillableHour
**		19.03.13	SAP				   BillableHour
**		21.03.13	SAP				   BillableHour ()
**		29.04.13	SAP				   BillableHour -  
**									    
**		13.05.13	SAP				   BillableHour -  
**									       
*******************************************************************************/
CREATE PROCEDURE TimeEntrySimpleUpdate
	@Class		TClass,
	@ID			TIdentifier,
	@Comments	TNotes = NULL,
	@StartTime	TDatetime,
	@EndTime	TDatetime,
	@ProjectID	TIdentifier,
	@FileAs TName = NULL
AS
	DECLARE
		@rv							int,
		@EmployeeID					int,
		@MyEmployeeID				int,
		@State						TState,
		@ActivityTypeID				TIdentifier,
		@TaskID						TIdentifier,
		@Duration					TCount,
		@OldRoundedDuration			TCount,
		@Billable					TBool,
		@Overtime					TBool,
		@Rate						TMoney,
		@CurrencyCode				TCode3,
		@VATRate					TPercent,
		--@FileAs						TName,
		@Color						TColor,
		@DocumentClass				TClass,
		@DocumentID					TIdentifier,
		@ReminderState				TState,
		@ReminderInterval			TTimeSpan,
		@BillableHour				decimal(18,4),
		@RoundingInterval			TCount,
		@RoundingMode				int,
		@UpdateBillableHour			bit  
		
	SET NOCOUNT ON
	
	DECLARE @Code TCode
	
	SELECT @Code = [Code] FROM [Class] WHERE [Class] = @Class
	
	IF @Code = 'Pjm5.MeetingRequest'
	BEGIN
		EXEC @rv = pjm5MeetingRequestSimpleUpdate @ID, @StartTime, @EndTime
		RETURN @rv
	END
	
	DECLARE @CurrentUserID TIdentifier, @TimeEntryClass TClass
	SELECT
		@CurrentUserID = dbo.adfGetCurrentUserID(),
		@TimeEntryClass = dbo.adfGetClassByName('Pjm5.TimeEntry')

	SELECT 
		@FileAs = 
		CASE 
			WHEN @FileAs = NULL THEN [TimeEntry].[FileAs]
			ELSE @FileAs
		END,
		@Comments = 
		CASE
			WHEN @Comments = NULL THEN [TimeEntry].[Comments]
			ELSE @Comments
		END,
		@MyEmployeeID = dbo.adfGetCurrentEmployeeID(),
		@EmployeeID = [TimeEntry].[EmployeeID],
		@ActivityTypeID = [TimeEntry].[ActivityTypeID],
		@TaskID = [TimeEntry].[TaskID],
		@Duration = DATEDIFF(minute, @StartTime, @EndTime),
		@OldRoundedDuration = [TimeEntry].[RoundedDuration],
		@Billable = [TimeEntry].[Billable],
		@Overtime = [TimeEntry].[Overtime],
		@Rate = [TimeEntry].[Rate],
		@CurrencyCode = [TimeEntry].[CurrencyCode],
		@VATRate = [TimeEntry].[VATRate],
		@Color = [TimeEntry].[Color],
		@DocumentClass = [TimeEntry].[DocumentClass],
		@DocumentID = [TimeEntry].[DocumentID],
		@ReminderState = ISNULL([UserReminder].[State], CAST(0 as int)),
		@ReminderInterval = ISNULL([UserReminder].[OriginalInterval], dbo.fnPjm5GetReminderInterval([TimeEntry].[Class], 'ES', @CurrentUserID)),
		@State = [TimeEntry].[State]
	FROM
		[TimeEntry]
		LEFT OUTER JOIN [Reminder]
			ON ([Reminder].[DocumentClass] = [TimeEntry].[Class] AND
				[Reminder].[DocumentID] = [TimeEntry].[ID] AND
				[Reminder].[Subtype] = 'ES')
		LEFT OUTER JOIN [UserReminder]
			ON ([Reminder].[ID] = [UserReminder].[ReminderID] AND
				[UserReminder].[UserID] = @CurrentUserID)
	WHERE
		[TimeEntry].[ID] = @ID
		
	IF @EmployeeID != @MyEmployeeID AND 
		dbo.fnPjm5AllowCreateProjectEntry(@ProjectID, @EmployeeID) = 0
	BEGIN
		RAISERROR('#NotEnoughPermissionsForCreateJournalEntry', 18, -1)
		RETURN 1
	END

	BEGIN TRANSACTION

	IF @State = 5
	BEGIN
		EXEC @rv = pjm5TimeEntryChangeState @ID, 1
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	IF @DocumentID IS NULL SET @DocumentClass = NULL
	
	SELECT 
		@UpdateBillableHour = 
			CASE
				WHEN @OldRoundedDuration/60.0 = [EntryAmount].[Amount] THEN 1
				ELSE 0
			END
	FROM		
		[EntryAmount]
	WHERE
		[EntryAmount].[ID] = @ID
	
	IF @UpdateBillableHour = 0
	BEGIN
		SELECT 
			@BillableHour = [EntryAmount].[Amount]
		FROM 
			[EntryAmount]
		WHERE
			[EntryAmount].[ID] = @ID
	END
	ELSE
	BEGIN
		SELECT
			@RoundingInterval = [Project].[RoundingInterval],
			@RoundingMode = [Project].[RoundingMode]
		FROM
			[Project]

		WHERE
			[Project].[ID] = @ProjectID

		SELECT @BillableHour = [dbo].[fnPjm5RoundedDuration](@Duration,@RoundingInterval,@RoundingMode)/60.0
	END
	

	EXEC pjm5TimeEntryUpdateInternal
		@ID,
		@FileAs,
		@ActivityTypeID,
		@EmployeeID,
		@ProjectID,
		@DocumentClass,
		@DocumentID,
		@TaskID,
		@StartTime,
		@Duration,
		@Billable,
		
		@BillableHour,
		
		@Overtime,
		@CurrencyCode,
		@VATRate,
		@Color,
		@Comments,
		@EmployeeID

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	EXEC @rv = pjm7TimeEntryReminderCreate @ID,
		@StartTime, @ReminderState,	@ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	EXEC @rv = pjm6TaskPercentUpdate @TaskID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	EXEC @rv = pjm7ExchangeSyncStateUpdateNewDocument @ID, @Class, @EmployeeID, 0
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION

	EXEC TimeEntrySimpleGet @ID

	RETURN 0
GO

GRANT EXECUTE ON TimeEntrySimpleUpdate TO PUBLIC
GO
 