IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TimeEntryImportChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TimeEntryImportChangeState'
		DROP PROCEDURE [dbo].[pjm5TimeEntryImportChangeState]
	END
GO

PRINT 'Creating procedure pjm5TimeEntryImportChangeState'
GO

/******************************************************************************
**		File: pjm5TimeEntryImportChangeState.sql
**		Name: pjm5TimeEntryImportChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5TimeEntryImportChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass,
			@ProjectID TIdentifier,
			@EmployeeID TIdentifier
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [TimeEntry].[Class],
		@FromState = [TimeEntry].[State],
		@ProjectID = [ProjectID],
		@EmployeeID = [EmployeeID]
	FROM
		[TimeEntry]
	WHERE
		[TimeEntry].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE
		[TimeEntry]
	SET
		[TimeEntry].[State] = @ToState,
		[TimeEntry].[Modified] = DEFAULT,
		[TimeEntry].[ModifiedBy] = DEFAULT
	WHERE
		[TimeEntry].[ID] = @ID
	AND
		[TimeEntry].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5TimeEntryImportChangeState TO PUBLIC
GO 