 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5vwCalculationLine]') and OBJECTPROPERTY(id, N'IsView') = 1)
	BEGIN
		PRINT 'Dropping view pjm5vwCalculationLine'
		DROP VIEW [dbo].[pjm5vwCalculationLine]
	END
GO

PRINT 'Creating view pjm5vwCalculationLine'
GO

CREATE VIEW [pjm5vwCalculationLine]
AS
	SELECT
		[CalculationLine].[CalculationID],
		[CalculationLine].[ID],
		[CalculationLine].[DocumentClass],
		[CalculationLine].[DocumentID],
		[TimeEntry].[State] AS [DocumentState],
		[TimeEntry].[StartTime] AS [Date],
		[TimeEntry].[EmployeeID],
		[Assignment].[QualificationID] AS [QualificationID],
		[TimeEntry].[TaskID],
		[TimeEntry].[ActivityTypeID] AS [TypeID],
		NULL AS [CodeID],
		[CalculationLine].[Description],
		[CalculationLine].[Amount],
		[CalculationLine].[Price],
		[CalculationLine].[VATIsIncluded],
		[CalculationLine].[VAT]
	FROM
		[CalculationLine]
		INNER JOIN [TimeEntry]
			ON [TimeEntry].[Class] = [CalculationLine].[DocumentClass] AND
				[TimeEntry].[ID] = [CalculationLine].[DocumentID]
		LEFT OUTER JOIN [Assignment]
			ON [Assignment].[ID] = [TimeEntry].[AssignmentID]
	UNION
	SELECT
		[CalculationLine].[CalculationID],
		[CalculationLine].[ID],
		[CalculationLine].[DocumentClass],
		[CalculationLine].[DocumentID],
		[Expense].[State] AS [DocumentState],
		[Expense].[Date],
		[Expense].[EmployeeID],
		[Assignment].[QualificationID] AS [QualificationID],
		[Expense].[TaskID],
		[Expense].[ExpenseCodeID] AS [TypeID],
		[PhoneCall].[PhoneCallCodeID] AS [CodeID],
		[CalculationLine].[Description],
		[CalculationLine].[Amount],
		[CalculationLine].[Price],
		[CalculationLine].[VATIsIncluded],
		[CalculationLine].[VAT]
	FROM
		[CalculationLine]
		INNER JOIN [Expense]
			ON [Expense].[Class] = [CalculationLine].[DocumentClass] AND
				[Expense].[ID] = [CalculationLine].[DocumentID]
		LEFT OUTER JOIN [PhoneCall]
			ON [PhoneCall].[ExpenseID] = [Expense].[ID]
		LEFT OUTER JOIN
		(
			[Assignment]
			INNER JOIN [AssignmentEntry]
				ON [Assignment].[ID] = [AssignmentEntry].[AssignmentID]
		)
			ON	[Expense].[EmployeeID] = [AssignmentEntry].[EmployeeID]
				AND [Expense].[ProjectID] = [Assignment].[ProjectID]
	WHERE 
		[Assignment].[State] = 1 
		OR
		(
			[Assignment].[State] = 2
			AND
			-- 
			[Assignment].[Modified] = 
			(
				SELECT 
					MAX([Modified]) 
				FROM
					[Assignment]
					INNER JOIN [AssignmentEntry]
						ON [Assignment].[ID] = [AssignmentEntry].[AssignmentID]
				WHERE
					[Expense].[EmployeeID] = [AssignmentEntry].[EmployeeID]
					AND 
					[Expense].[ProjectID] = [Assignment].[ProjectID]
			) 
		)
	UNION
	SELECT
		[CalculationLine].[CalculationID],
		[CalculationLine].[ID],
		[CalculationLine].[DocumentClass],
		[CalculationLine].[DocumentID],
		CASE [ServiceRequest].[State]
			WHEN 5 THEN 6
			ELSE [ServiceRequest].[State] - 1 
		END AS [DocumentState],
		[ServiceRequest].[Date],
		[ServiceRequest].[EmployeeID],
		[Assignment].[QualificationID] AS [QualificationID],
		NULL AS [TaskID],
		NULL [TypeID],
		NULL AS [CodeID],
		[CalculationLine].[Description],
		[CalculationLine].[Amount],
		[CalculationLine].[Price],
		[CalculationLine].[VATIsIncluded],
		[CalculationLine].[VAT]
	FROM
		[CalculationLine]
		INNER JOIN [ServiceRequest]
			ON [ServiceRequest].[Class] = [CalculationLine].[DocumentClass] AND
				[ServiceRequest].[ID] = [CalculationLine].[DocumentID]
		LEFT OUTER JOIN
		(
			[Assignment]
			INNER JOIN [AssignmentEntry]
				ON [Assignment].[ID] = [AssignmentEntry].[AssignmentID]
		)
			ON [ServiceRequest].[EmployeeID] = [AssignmentEntry].[EmployeeID]
			AND [ServiceRequest].[ProjectID] = [Assignment].[ProjectID]
	WHERE 
		[Assignment].[State] = 1 
		OR
		(
			[Assignment].[State] = 2
			AND
			-- 
			[Assignment].[Modified] = 
			(
				SELECT 
					MAX([Modified]) 
				FROM
					[Assignment]
					INNER JOIN [AssignmentEntry]
						ON [Assignment].[ID] = [AssignmentEntry].[AssignmentID]
				WHERE
					[ServiceRequest].[EmployeeID] = [AssignmentEntry].[EmployeeID]
					AND 
					[ServiceRequest].[ProjectID] = [Assignment].[ProjectID]
			) 
		)
GO
   